#!perl -i_bak
#
#  dht esq. / 21.2.00
#  For replacing (e.g.) "int" with "Dgp_Int32" in source code, matching 1) on word boundaries,
#  and 2) in (parentheses) (for type casts).
#
#  Modified file foo.x is backed up as foo.x_bak.
#
#  Hash table stolen from MK's substitute.dgp file.
#

#  Hash tables for substitutions.
%no_brainers = (
	
	# Allocation

	allocators	=> 	Dgp_Allocators,
	dgp_Malloc	=>	DGP_MALLOC,
	dgp_Calloc	=>	DGP_CALLOC,
	dgp_Realloc	=>	DGP_REALLOC,
	dgp_Free	=>	DGP_FREE,
	dgp_pAllocators	=>	DGP_PALLOCATORS,

	# Error Stuff

	DgpState	=>	Dgp_State,
	dgp_pErrState	=>	DGP_PERRSTATE,

	# Dgp Types

	boolean		=>	Dgp_Bool,
	TRUE		=>	DGP_TRUE,
	FALSE		=>	DGP_FALSE,

	# List Stuff

	List		=>	DgpAdt_List,
	liNew		=>	DgpAdt_liNew,
	liAdd		=>	DgpAdt_liAdd,
	liGet		=>	DGPADT_LIGET,
	liNext		=>	DGPADT_LINEXT,
	liFirst		=>	DGPADT_LIFIRST,
	liLen		=>	DGPADT_LILEN,
	liFree		=>	DgpAdt_liFree,
	NULLLIST	=>	DGP_NULLLIST,
	foreach		=>	DGP_FOREACH,

	# image stuff

	PackedImage	=>	DgpImage_Packed,
	imNew		=>	DgpImage_new,
	IMAGE_		=>	DGPIMAGE_,
	imFree		=> 	DgpImage_free,

	# decoder
	MQDecoder	=> 	DgpEncode_MQDecoder,
	MQEncoder	=> 	DgpEncode_MQEncoder,

	# Types

	double		=>	Dgp_Float64,
	float		=>	Dgp_Float32,
);


# Edits that should happen before other edits in the next section...
# unsigned must happen before the unsigned counterparts are changed

%do_these_first = (
	'unsigned long'		=>	Dgp_UInt32,
	'unsigned int'		=>	Dgp_UInt32,
	'unsigned short'	=>	Dgp_UInt16,
	'unsigned char'		=>	Dgp_UInt8,
);


# Edits that should happen after the edits in the previous section.
%do_these_second = (
	long	=>		Dgp_Int32,
	int		=>		Dgp_Int32,
	short	=>		Dgp_Int16,
	char	=>		Dgp_Int8,
);

#  Parse...
while(<>){
	#  Match word-boundary instances of the token, as well as type casts,
	#  for each of the tables.
	$found = 0;
	foreach $key (keys %no_brainers){
		$found += s/\($key\)/\($no_brainers{$key}\)/g;
		$found += s/\b$key\b/$no_brainers{$key}/g;
		$found += s/(\W)$key(\W)/\1$no_brainers{$key}\2/g;
	}
	foreach $key (keys %do_these_first){
		$found += s/\($key\)/\($do_these_first{$key}\)/g;
		$found += s/\b$key\b/$do_these_first{$key}/g;
		$found += s/(\W)$key(\W)/\1$do_these_first{$key}\2/g;
	}
	foreach $key (keys %do_these_second){
		$found += s/\($key\)/\($do_these_second{$key}\)/g;
		$found += s/\b$key\b/$do_these_second{$key}/g;
		$found += s/(\W)$key(\W)/\1$do_these_second{$key}\2/g;
	}
		
    if($found){ 
        print STDOUT "[instance found]\t$_";
    }
	print;
}

