#!/usr/bin/env python

import os
import sys
import string
from stat import *
from win32com.client import Dispatch

# For safety, use versions of common files tested and delivered with bmk
sys.path.insert(1, os.path.join(os.environ['BMKHOME'], 'lib'))
sys.path.insert(1, os.path.join(os.environ['BMKHOME'], 'bin'))

import bmk

import minibmk.run, minibmk.score, minibmk.report, minibmk.remove, \
       minibmk.diff, minibmk.clean, \
       tdev.util.file.ini, tdev.util.os_x, tdev.err, tdev.util.prompt, \
       tdev.util.log
	
def file_size (filename):  # returns the size of a file in bytes

  out = os.stat (filename)
  return out[ST_SIZE]

def execute (command):

  pipe = os.popen (command)
  pipe.flush ()
  status = pipe.close ()

  return status

def send_mail (file, subject):

  if type(file) == type(''):
    file = open(file, 'r')
  lines = file.readlines()
  if lines == '': return
  file.close
  outbuf = string.join (lines)

  s = Dispatch("Mapi.Session")
  s.Logon("Krockenberger, Martin")

  newMsg = s.Outbox.Messages.Add (subject, outbuf)
  recip = newMsg.Recipients.Add ("Krockenberger, Martin",
                                 "SMTP:mkrocken@parc.xerox.com")

  newMsg.Send ()
  return


# imdir = "colimages/"
imdir = "base/tif/"
lossy_dir = "tcomp_lossy/tif/"
lossless_dir = "tcomp_lossless/tif/"
temp_tc = "temp.tc"

lossy = "./bin/tcomp_lossy.exe"
lossless = "./bin/tcomp_lossless.exe"
decompression = "./bin/santa_uncomp_all.exe"
  

list = os.listdir (imdir)
length = len (list)
x = 0

while x < length:
  if string.find(list[x], ".tif") != -1:

    # original file and size

    filename = imdir + list[x]
    org_size = file_size (filename)
    print list[x], org_size, 

    # lossy tokenizer

    command = lossy + " -o temp.tc " + filename
    status = execute (command)

    if status == None:

      lossy_size = file_size ("temp.tc")
      print " lossy size ", lossy_size,

      command = decompression + " -outtype TIF temp.tc"
      status = execute (command)
      if status != None:
	print "decomp failed"
      else:
	os.rename ("temp.tc.1.tif", lossy_dir + list[x])

    else:
      print " lossy failed ",

    # lossless tokenizer

    command = lossless + " -o temp.tc " + filename
    status = execute (command)
    if status == None:

      lossless_size = file_size ("temp.tc")
      print " lossless size ", lossless_size,

      command = decompression + " -outtype TIF temp.tc"
      status = execute (command)
      if status != None:
	print "decomp failed"
      else:
	os.rename ("temp.tc.1.tif", lossless_dir + list[x])

    else:
      print " lossless failed ",

    print

  x = x + 1

bmk.procSubCommand ('run', 'what.ini', '', 1)
send_mail ('d:\\scansoft\\testbed\\summary.xls', 'Midnight Test Results')

