/*

  11 April 2001 / dhtesq.

  Shunted constants and prototypes from DgpEncode_main.c to here.

*/
#include "dgp_state.h"
#include "dgp_cl.h"
#include <stdio.h>

/*
 * Default values for command line arguments.
 *
 * As of 11 April 2001, these tokenizer defaults correspond exactly to those
 * in the tclydoc api.  Should maybe unify. / dhtesq.
 *
 */
#define DEF_VERBOSE     DGP_FALSE

#define DEF_LOSSLESS	DGP_FALSE


#define DEF_FRACHAUSD   (Dgp_Float32)(0.97)
#define DEF_FRACHAUSD_STR   "0.97"

#define DEF_WIDTHDIFF   1
#define DEF_WIDTHDIFF_STR   "1"

#define DEF_HEIGHTDIFF  1
#define DEF_HEIGHTDIFF_STR  "1"

#define DEF_MAXDENSITY  3
#define DEF_MAXDENSITY_STR  "3"

#define DEF_COMMITTHRESH 10000
#define DEF_COMMITTHRESH_STR "10000"

#define DEF_FREEZEHISTTHRESH 10000
#define DEF_FREEZEHISTTHRESH_STR "10000"

#define DEF_MAKEHISTTHRESH 10
#define DEF_MAKEHISTTHRESH_STR "10"

#define DEF_RETURNHISTTHRESH 0
#define DEF_RETURNHISTTHRESH_STR "0"

#define DEF_DILATIONRADIUS 1
#define DEF_DILATIONRADIUS_STR "1"

#define DEF_SIZETHRESH  1
#define DEF_SIZETHRESH_STR  "1 (2 for color)"

#define DEF_WRITETHRESH 10
#define DEF_WRITETHRESH_STR "10"

#define DEF_NEARESTNEIGHBORS 8
#define DEF_NEARESTNEIGHBORS_STR "8"

#define DEF_XSHIFT      3
#define DEF_XSHIFT_STR      "3"

#define DEF_XSLOPECHANGE 6
#define DEF_XSLOPECHANGE_STR "6"

#define DEF_XNEWSLOPE   2.0
#define DEF_XNEWSLOPE_STR   "2.0"

#define DEF_LOWERDILATIONLIMIT	6
#define DEF_LOWERDILATIONLIMIT_STR "6"

#define DEF_NONTP       DGP_FALSE

#define DEF_INCRDICT		50
#define DEF_INCRDICT_STR    "50"

#define DEF_CLEARDICT		100
#define DEF_CLEARDICT_STR   "100"

#define DEF_BASELINEORIENT "down"

#define DEF_DESKEWACCURACY 3        /* [0...5] */
#define DEF_DESKEWACCURACY_STR "3"

#define DEF_DESKEW DGP_FALSE

#define DEF_GRAYHALFTONE DGP_FALSE

#define DEF_TOK_OUTPUT_RES      300
#define DEF_TOK_OUTPUT_RES_STR  "300"

#define DEF_JPEG_OUTPUT_RES      100
#define DEF_JPEG_OUTPUT_RES_STR  "100"

#define DEF_JPEG_QUALITY       90
#define DEF_JPEG_QUALITY_STR  "90"

#define DEF_ROTATION		0
#define DEF_ROTATION_STR	"0"

#define DEF_NODESKEW    DGP_FALSE
#define DEF_NOALIGN     DGP_FALSE
#define DEF_INSTRUMENT  DGP_FALSE
#define DEF_G4TOKENS    DGP_FALSE

#define DEF_ERRFILENAME "stderr"

#define DEF_FILENAME	"[infile].tfx"

#define DEF_MEMBOND	        -1
#define DEF_MEMBOND_STR     "-1"

#define DEF_NOERROROUT  DGP_FALSE

#define DEF_TOKENSIZELIMIT DGP_FALSE

#define DEF_REDTOKNOISE DGP_FALSE


#define DEF_JBIG2_PROFILE 2
#define DEF_JBIG2_PROFILE_STR "2"
#define DEF_JB2ONLY DGP_FALSE
#define DEF_PDFOUT DGP_FALSE

/*#define DEF_OPTIONS_FLAGS (TOK_OPT_ALIGN | TOK_OPT_RETURNOFFSET | TOK_OPT_COPYBITMAPS)*/

 /****************
 *
 * Variables to hold the values of options. These must be
 * initialized to the default values.
 */

typedef struct {
  Dgp_Bool verbose;
  Dgp_Bool lossless;
  Dgp_Float32 fracHausd;
  Dgp_Int32 widthDiff;
  Dgp_Int32 heightDiff;
  Dgp_Int32 maxDensity;
  Dgp_Int32 commitThresh;
  Dgp_Int32 freezeHistThresh;
  Dgp_Int32 makeHistThresh;
  Dgp_Int32 returnHistThresh;
  Dgp_Int32 dilationRadius;
  Dgp_Int32 sizeThresh;
  Dgp_Int32 writeThresh;
  Dgp_Int32 nearestNeighbors;
  Dgp_Int32 xShift;
  Dgp_Int32 xSlopeChange;
  Dgp_Float32 xNewSlope;
  Dgp_Int32 lowerDilationLimit;
  Dgp_Bool nontp;
  Dgp_Int32 incrementalDict;
  Dgp_Int32 clearDict;
  Dgp_Int8 *baselineOrient;
  Dgp_Bool deskew;
  Dgp_Int32 deskewAccuracy;
  Dgp_Bool grayHalftone;
  Dgp_Int32 outputTokRes;
  Dgp_Int32 jpegRes;
  Dgp_Int32 jpegQual;
  Dgp_Int32 rotation;
  Dgp_Bool tokenSizeLimit;
  Dgp_Bool noAlign;
  Dgp_Bool g4Tokens;
  Dgp_Int32 jbig2Profile;
  Dgp_Int8 *filename;
  Dgp_Int8 *err_filename;
  Dgp_Bool noe;
  Dgp_Int32 membond;
  Dgp_Bool redTokNoise;
  Dgp_Bool jb2Only;
  Dgp_Bool pdfOut;
} CLOpts;
