// PDFCompress.cpp : Implementation of CPDFCompress
#include "stdafx.h"
#include "PDFCompress.h"
#include "PDFReader.h"
#include <comutil.h>
//#pragma comment(lib, "comsupp.lib")


// CPDFCompress

STDMETHODIMP CPDFCompress::get_inFile(BSTR* pVal)
{
	if (pVal == NULL) return E_FAIL;
	*pVal = m_inFile;
	return S_OK;
}

STDMETHODIMP CPDFCompress::put_inFile(BSTR newVal)
{
	m_inFile = newVal; 
	return S_OK;
}

STDMETHODIMP CPDFCompress::get_outFile(BSTR* pVal)
{
	if (pVal == NULL) return E_FAIL;
	*pVal = m_outFile;
	return S_OK;
}

STDMETHODIMP CPDFCompress::put_outFile(BSTR newVal)
{
	if (!m_key)
	{
		m_key = new unsigned char [6];
		getMAC (m_key);
		if (!m_key) return E_FAIL;
	}

	for	(int i = 0;	i<6; i++)
		if (m_key[i] !=	key[i])
			return E_FAIL;

	m_outFile = newVal; 
	return S_OK;
}

STDMETHODIMP CPDFCompress::compress(void)
{
	// TODO: Add your implementation code here
	if (!m_inFile || !m_inFile) return E_FAIL;

	PDFReader finder ((char*)m_inFile, m_arithmetic);

    if (finder.getObjects () <= 0) return E_FAIL;
    if (finder.findAndEncodeBinaryImages () && finder.generateOutputPDF((char*)m_outFile))
		return S_OK;
    else
        return E_FAIL;
}

STDMETHODIMP CPDFCompress::toggleArithmetic(int* pVal)
{
	if (pVal == NULL) return E_FAIL;

	if (m_arithmetic == false)
	{
		m_arithmetic = true;
		*pVal = 1;
	}
	else
	{
		m_arithmetic = false;
		*pVal = 0;
	}
	return S_OK;
}
