// PDFCompress.h : Declaration of the CPDFCompress
#pragma once
#include "resource.h"       // main symbols
#include <atlctl.h>
#include <comdef.h>

// IPDFCompress
[
	object,
	uuid(B66FEC70-0043-4FD3-BB90-572C416A6D81),
	dual,
	helpstring("IPDFCompress Interface"),
	pointer_default(unique)
]
__interface IPDFCompress : public IDispatch
{
	[propget, id(1), helpstring("property m_inFile")] HRESULT inFile([out, retval] BSTR* pVal);
	[propput, id(1), helpstring("property m_inFile")] HRESULT inFile([in] BSTR newVal);
	[propget, id(2), helpstring("property m_outFile")] HRESULT outFile([out, retval] BSTR* pVal);
	[propput, id(2), helpstring("property m_outFile")] HRESULT outFile([in] BSTR newVal);
	[id(3), helpstring("method compress")] HRESULT compress(void);
	[id(4), helpstring("method enableArithmetic")] HRESULT toggleArithmetic([out, retval] int* pVal);
};


// CPDFCompress
[
	coclass,
	threading("apartment"),
	aggregatable("never"),
	vi_progid("AXC.PDFCompress"),
	progid("AXC.PDFCompress.1"),
	version(1.0),
	uuid("291D9F15-2981-4116-B303-056826F9F285"),
	helpstring("PDFCompress Class"),
	registration_script("control.rgs")
]
class ATL_NO_VTABLE CPDFCompress : 
	public IPDFCompress,
	public IPersistStreamInitImpl<CPDFCompress>,
	public IOleControlImpl<CPDFCompress>,
	public IOleObjectImpl<CPDFCompress>,
	public IOleInPlaceActiveObjectImpl<CPDFCompress>,
	public IViewObjectExImpl<CPDFCompress>,
	public IOleInPlaceObjectWindowlessImpl<CPDFCompress>,
	public CComControl<CPDFCompress>
{
public:

	CPDFCompress() : m_key(NULL), m_arithmetic (false)
	{
		key[0] = 0;
		key[1] = 6;
		key[2] = 91;
		key[3] = 221;
		key[4] = 4;
		key[5] = 154;
	}
	~CPDFCompress()
	{
		if (m_key) delete [] m_key;
	}

DECLARE_OLEMISC_STATUS(OLEMISC_RECOMPOSEONRESIZE | 
	OLEMISC_INVISIBLEATRUNTIME |
	OLEMISC_CANTLINKINSIDE | 
	OLEMISC_INSIDEOUT | 
	OLEMISC_ACTIVATEWHENVISIBLE | 
	OLEMISC_SETCLIENTSITEFIRST
)


BEGIN_PROP_MAP(CPDFCompress)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	// PROP_PAGE(CLSID_StockColorPage)
END_PROP_MAP()


BEGIN_MSG_MAP(CPDFCompress)
	CHAIN_MSG_MAP(CComControl<CPDFCompress>)
	DEFAULT_REFLECTION_HANDLER()
END_MSG_MAP()
// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);

// IViewObjectEx
	DECLARE_VIEW_STATUS(0)

// IPDFCompress
public:
		HRESULT OnDraw(ATL_DRAWINFO& di)
		{
		RECT& rc = *(RECT*)di.prcBounds;
		// Set Clip region to the rectangle specified by di.prcBounds
		HRGN hRgnOld = NULL;
		if (GetClipRgn(di.hdcDraw, hRgnOld) != 1)
			hRgnOld = NULL;
		bool bSelectOldRgn = false;

		HRGN hRgnNew = CreateRectRgn(rc.left, rc.top, rc.right, rc.bottom);

		if (hRgnNew != NULL)
		{
			bSelectOldRgn = (SelectClipRgn(di.hdcDraw, hRgnNew) != ERROR);
		}

		Rectangle(di.hdcDraw, rc.left, rc.top, rc.right, rc.bottom);
		SetTextAlign(di.hdcDraw, TA_CENTER|TA_BASELINE);
		LPCTSTR pszText = _T("ATL 7.0 : PDFCompress");
		TextOut(di.hdcDraw, 
			(rc.left + rc.right) / 2, 
			(rc.top + rc.bottom) / 2, 
			pszText, 
			lstrlen(pszText));

		if (bSelectOldRgn)
			SelectClipRgn(di.hdcDraw, hRgnOld);

		return S_OK;
	}


	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}
	
	void FinalRelease() 
	{
	}
	_bstr_t m_inFile, m_outFile;
	STDMETHOD(get_inFile)(BSTR* pVal);
	STDMETHOD(put_inFile)(BSTR newVal);
	STDMETHOD(get_outFile)(BSTR* pVal);
	STDMETHOD(put_outFile)(BSTR newVal);
	STDMETHOD(compress)(void);
private:
	void getMAC (unsigned char* mac);
	unsigned char key[6];
	unsigned char* m_key;
	bool m_arithmetic;
public:
	STDMETHOD(toggleArithmetic)(int* pVal);
};

