
#ifndef AdapterFactory_h_Included
#define AdapterFactory_h_Included

#include "ImageAdapter.h"

#include <list>

class AdapterFactory
{
public:

    AdapterFactory () : m_adapList(0) {}
    /* deletes all ImageAdapters created by this factory */
    ~AdapterFactory ();

    /* create from image buffer */
    ImageAdapter * createInstance (const ColorDepth & depth, const Asd::Rect & region, 
                                    ImageBuf * buf);

    /* create sub region of existing adapter */
    ImageAdapter * createSub (Asd::Rect & region, ImageAdapter * adapt);

private:

    std::list<ImageAdapter*> m_adapList;
};

#endif



