#ifndef IPCoreImgBuf_h_Included
#define IPCoreImgBuf_h_Included

#include "stdio.h"
#include "ImageAdapter.h"

/* IPCORE pixr */
namespace ipcore
{

#include "rcs.pub"
#include "types.pub"
#include "libutilw.pub"
#include "pixr.h"
#include "frames.pub"

const Asd::Int32 framePix = 0; /*cFrameBits; */
const Asd::Int32 pixrRes = 100;
}



/* Image Object represented by IPCore */
class IPCoreImgBuf : public ImageAdapter
{
public:
	
	/* Constructors */
	/* empty image */
	IPCoreImgBuf ();
	/* wrap a pixr around an existing ImageBuf */
	IPCoreImgBuf (Asd::UInt32 width, Asd::UInt32 height, ColorDepth depth, ImageBuf* pBuf);
    /* create a new header for the region specified by roi */
    IPCoreImgBuf (Asd::Rect & roi, ImageAdapter & buf);

    /* destructors */
    ~IPCoreImgBuf ();

	/* dimensions */
	virtual Asd::UInt32  width ( void ) const;
	virtual Asd::UInt32  height( void ) const;
	virtual Asd::Point32 size  ( void ) const;

	/* depth */
	virtual ColorDepth  depth( void ) const;

	/* data */
	virtual       Asd::UInt8 * data( void );
	virtual const Asd::UInt8 * data( void ) const;

    virtual Asd::UInt32 dataSize( void ) const;
	virtual Asd::UInt32 bpl( void ) const;

    virtual bool scaleToSize (ImageAdapter* output);

    /* state */
    ipcore::IPWState* getState () { return m_IPWState; }

    /* save for debug */
    void saveAsTiff (const char* filename,const Asd::Int32 & xRes, const Asd::Int32 & yRes);

    virtual bool save(const char *fileName, const char * ext,const Asd::Int32 & xRes, const Asd::Int32 & yRes);

    /* get PIXR */
    ipcore::PIXR* pixr () { return m_pixr; }

    /* flip byptes */
    virtual void flipBytes();
protected:

    void createState( void );

private:

    ipcore::IPWState* m_IPWState;
	ipcore::PIXR* m_pixr;
};

#endif
/*#ifndef IPCoreImgBuf_h_Included */
