/* SilxImgBuf.h: interface for the SilxImgBuf class. */
/* */
/*//////////////////////////////////////////////////////////////////// */

#ifndef __SilxImgBuf_h_Included__
#define __SilxImgBuf_h_Included__

#include "ImageAdapter.h"
#include "ImageBuf.h"

class SilxImgBuf : public ImageAdapter 
{
public:
    /* empty image */
    SilxImgBuf ();
    /* wrap an SilxImg header around an existing ImageBuf */
    SilxImgBuf (const Asd::Rect & roi, ImageAdapter & buf) ;
   
    SilxImgBuf (Asd::UInt32 width, Asd::UInt32 height, ColorDepth depth, ImageBuf* pBuf); 
    
    virtual ~SilxImgBuf();

    /* dimensions */
    virtual Asd::UInt32 width( void ) const;

    virtual Asd::UInt32 height( void ) const;
	
    virtual Asd::Point32 size( void ) const;

	/* depth */
    virtual ColorDepth depth( void ) const;

	/* data */
    virtual  Asd::UInt8 * data( void );
	
    virtual const Asd::UInt8 * data( void ) const;

    virtual Asd::UInt32 dataSize( void ) const;

	virtual Asd::UInt32 bpl( void ) const;
    
    void * getUserState(){ return dgp_state ;}

    /* IO */
    void saveAsPnm (const char* fileName);
    virtual bool save(const char *fileName, const char * ext,const Asd::Int32 & xRes, const Asd::Int32 & yRes);
    /* Imaging stuff */
    virtual bool scaleUp (const Asd::Point32& scaleFac, ImageAdapter* output) ;
    virtual bool SilxImgBuf::scaleToSize (ImageAdapter* output);

protected:
    void *dgp_state;
	/* actual data */
    void *m_image;
    /* protected function */
    void * copyImage ();



};


#endif
