#ifndef PdfOutput_h_INCLUDED
#define PdfOutput_h_INCLUDED

#include <list>
#include <vector>
#include <string>


#include <cstdio>


/* entry in pdf xref table */
struct xrefElt
{
    unsigned int obj;
    unsigned int offset;
    unsigned int version;
    int operator< (const xrefElt& other) const { return (obj < other.obj); }
};


class PdfOutput
{
public:


    PdfOutput ( void ) ;
    ~PdfOutput ( void ) {}

	/* open a Pdf file */
	bool PdfStartDoc (const char* filename); 

	/* close Pdf file and return size */
	int PdfEndDoc ();    

    void writeObj (char * data, unsigned int data_size, unsigned int objNr, int version);
    bool writeJBIG2 (char * data, unsigned int data_size, unsigned int objNr, unsigned int height, unsigned int width, unsigned int dictObj, bool mask);
    bool writeJBIG2Dict (char * data, unsigned int data_size, unsigned int maskObj);
    bool writeTrailer (unsigned int root, unsigned int info);
    bool writeG4 (char * data, unsigned int data_size, unsigned int objNr, unsigned int height, unsigned int width);

protected:
	 
    void addXref (unsigned int objId, int version = 0);

    std::vector<xrefElt> m_xRef;
    unsigned int m_arrayFill;

    FILE* m_fp;

	unsigned int m_offset;

};

#endif
