// SilxScreenCtl.cpp : Implementation of the CSilxScreenCtrl ActiveX Control class.

#include "stdafx.h"
#include <algorithm>
#include "SilxScreen.h"
#include "SilxScreenCtl.h"
#include "SilxScreenPpg.h"
#include "VersionNo.h"
#include "TifFile.h"

void Tiff2Tfx( const std::string & tiff, const std::string & tfx );

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNCREATE(CSilxScreenCtrl, COleControl)


/////////////////////////////////////////////////////////////////////////////
// Message map

BEGIN_MESSAGE_MAP(CSilxScreenCtrl, COleControl)
	//{{AFX_MSG_MAP(CSilxScreenCtrl)
	ON_WM_MOUSEWHEEL()
	//}}AFX_MSG_MAP
	ON_OLEVERB(AFX_IDS_VERB_EDIT, OnEdit)
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Dispatch map

BEGIN_DISPATCH_MAP(CSilxScreenCtrl, COleControl)
	//{{AFX_DISPATCH_MAP(CSilxScreenCtrl)
	DISP_PROPERTY_NOTIFY(CSilxScreenCtrl, "FullPageCacheThreshold", m_fullPageCacheThreshold, OnFullPageCacheThresholdChanged, VT_I4)
	DISP_PROPERTY_NOTIFY(CSilxScreenCtrl, "PageBreakSpace", m_pageBreakSpace, OnPageBreakSpaceChanged, VT_I4)
	DISP_PROPERTY_NOTIFY(CSilxScreenCtrl, "ExtraPageCacheSize", m_extraPageCacheSize, OnExtraPageCacheSizeChanged, VT_I4)
	DISP_PROPERTY_NOTIFY(CSilxScreenCtrl, "ViewMode", m_viewMode, OnViewModeChanged, VT_I4)
	DISP_PROPERTY_EX(CSilxScreenCtrl, "FileName", GetFileName, SetFileName, VT_BSTR)
	DISP_PROPERTY_EX(CSilxScreenCtrl, "ZoomFactor", GetZoomFactor, SetZoomFactor, VT_R8)
	DISP_PROPERTY_EX(CSilxScreenCtrl, "CurrentPage", GetCurrentPage, SetCurrentPage, VT_I4)
	DISP_PROPERTY_EX(CSilxScreenCtrl, "Layer", GetLayer, SetLayer, VT_I4)
	DISP_PROPERTY_EX(CSilxScreenCtrl, "isTiff", GetIsTiff, SetNotSupported, VT_BOOL)
	DISP_PROPERTY_EX(CSilxScreenCtrl, "Orientation", GetOrientation, SetOrientation, VT_I4)
	DISP_PROPERTY_EX(CSilxScreenCtrl, "IsSilx", GetIsSilx, SetNotSupported, VT_BOOL)
	DISP_FUNCTION(CSilxScreenCtrl, "FirstPage", FirstPage, VT_I4, VTS_NONE)
	DISP_FUNCTION(CSilxScreenCtrl, "LastPage", LastPage, VT_I4, VTS_NONE)
	DISP_FUNCTION(CSilxScreenCtrl, "NextPage", NextPage, VT_I4, VTS_NONE)
	DISP_FUNCTION(CSilxScreenCtrl, "PreviousPage", PreviousPage, VT_I4, VTS_NONE)
	DISP_FUNCTION(CSilxScreenCtrl, "NumPages", NumPages, VT_I4, VTS_NONE)
	DISP_FUNCTION(CSilxScreenCtrl, "SetPosition", SetPosition, VT_EMPTY, VTS_I4 VTS_I4)
	DISP_FUNCTION(CSilxScreenCtrl, "GetYPosition", GetYPosition, VT_I4, VTS_NONE)
	DISP_FUNCTION(CSilxScreenCtrl, "GetXPosition", GetXPosition, VT_I4, VTS_NONE)
	DISP_FUNCTION(CSilxScreenCtrl, "PurgeAllData", PurgeAllData, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CSilxScreenCtrl, "SetXPosition", SetXPosition, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CSilxScreenCtrl, "SetYPosition", SetYPosition, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CSilxScreenCtrl, "GetModalHeight", GetModalHeight, VT_I4, VTS_NONE)
	DISP_FUNCTION(CSilxScreenCtrl, "GetModalWidth", GetModalWidth, VT_I4, VTS_NONE)
	DISP_FUNCTION(CSilxScreenCtrl, "GetTotalHeight", GetTotalHeight, VT_I4, VTS_NONE)
	DISP_FUNCTION(CSilxScreenCtrl, "GetTotalWidth", GetTotalWidth, VT_I4, VTS_NONE)
	DISP_FUNCTION(CSilxScreenCtrl, "GetCurrentPageWidth", GetCurrentPageWidth, VT_I4, VTS_NONE)
	DISP_FUNCTION(CSilxScreenCtrl, "GetCurrentPageHeight", GetCurrentPageHeight, VT_I4, VTS_NONE)
	DISP_FUNCTION(CSilxScreenCtrl, "Pan", Pan, VT_EMPTY, VTS_I4 VTS_I4)
	DISP_FUNCTION(CSilxScreenCtrl, "GetModalXPosition", GetModalXPosition, VT_I4, VTS_NONE)
	DISP_FUNCTION(CSilxScreenCtrl, "GetModalYPosition", GetModalYPosition, VT_I4, VTS_NONE)
	DISP_FUNCTION(CSilxScreenCtrl, "SetHandCursor", SetHandCursor, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CSilxScreenCtrl, "SetGrabCursor", SetGrabCursor, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CSilxScreenCtrl, "SetDefaultCursor", SetDefaultCursor, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CSilxScreenCtrl, "SetZoomToolCursor", SetZoomToolCursor, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CSilxScreenCtrl, "CopyToClipboardTLBR", CopyToClipboardTLBR, VT_I4, VTS_I4 VTS_I4 VTS_I4 VTS_I4)
	DISP_FUNCTION(CSilxScreenCtrl, "CopyPageToClipboard", CopyPageToClipboard, VT_I4, VTS_I4)
	DISP_FUNCTION(CSilxScreenCtrl, "SetModalYPosition", SetModalYPosition, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CSilxScreenCtrl, "GetPageX", GetPageX, VT_I4, VTS_NONE)
	DISP_FUNCTION(CSilxScreenCtrl, "GetPageY", GetPageY, VT_I4, VTS_NONE)
	DISP_FUNCTION(CSilxScreenCtrl, "SetZoomAndModalPosition", SetZoomAndModalPosition, VT_EMPTY, VTS_R8 VTS_I4 VTS_I4)
	DISP_FUNCTION(CSilxScreenCtrl, "GetPageForPosition", GetPageForPosition, VT_I4, VTS_I4 VTS_I4)
	DISP_FUNCTION(CSilxScreenCtrl, "LayersOnCurrentPage", LayersOnCurrentPage, VT_I4, VTS_NONE)
	DISP_FUNCTION(CSilxScreenCtrl, "GetFileVersion", GetFileVersion, VT_BSTR, VTS_NONE)
	DISP_FUNCTION(CSilxScreenCtrl, "GetBuildDate", GetBuildDate, VT_BSTR, VTS_NONE)
	DISP_FUNCTION(CSilxScreenCtrl, "PrintLayerFromTo", PrintLayerFromTo, VT_I4, VTS_I4 VTS_I4 VTS_I4 VTS_I4)
	DISP_FUNCTION(CSilxScreenCtrl, "SavePageAsBmp", SavePageAsBmp, VT_I4, VTS_BSTR VTS_I4 VTS_I4 VTS_R8)
	DISP_FUNCTION(CSilxScreenCtrl, "LayersOnPage", LayersOnPage, VT_I4, VTS_I4)
	DISP_FUNCTION(CSilxScreenCtrl, "ConvertTiff2Tfx", ConvertTiff2Tfx, VT_I4, VTS_BSTR VTS_BSTR)
	DISP_FUNCTION(CSilxScreenCtrl, "SetOrientationAndPagePosition", SetOrientationAndPagePosition, VT_EMPTY, VTS_I2 VTS_I4 VTS_I4)
	DISP_STOCKPROP_BACKCOLOR()
	//}}AFX_DISPATCH_MAP
	DISP_FUNCTION_ID(CSilxScreenCtrl, "AboutBox", DISPID_ABOUTBOX, AboutBox, VT_EMPTY, VTS_NONE)
END_DISPATCH_MAP()


/////////////////////////////////////////////////////////////////////////////
// Event map

BEGIN_EVENT_MAP(CSilxScreenCtrl, COleControl)
	//{{AFX_EVENT_MAP(CSilxScreenCtrl)
	EVENT_CUSTOM("MouseWheel", FireMouseWheel, VTS_I4  VTS_I2  VTS_I4  VTS_I4)
	EVENT_STOCK_DBLCLICK()
	EVENT_STOCK_MOUSEDOWN()
	EVENT_STOCK_KEYDOWN()
	EVENT_STOCK_MOUSEMOVE()
	EVENT_STOCK_MOUSEUP()
	EVENT_STOCK_CLICK()
	EVENT_STOCK_KEYUP()
	EVENT_STOCK_KEYPRESS()
	//}}AFX_EVENT_MAP
END_EVENT_MAP()


/////////////////////////////////////////////////////////////////////////////
// Property pages

// TODO: Add more property pages as needed.  Remember to increase the count!
BEGIN_PROPPAGEIDS(CSilxScreenCtrl, 1)
	PROPPAGEID(CSilxScreenPropPage::guid)
END_PROPPAGEIDS(CSilxScreenCtrl)


/////////////////////////////////////////////////////////////////////////////
// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(CSilxScreenCtrl, "SILXSCREEN.SilxScreenCtrl.1",
	0x3a66cc39, 0xa665, 0x4bde, 0xa2, 0x75, 0xfc, 0xe2, 0x69, 0xdb, 0x48, 0x2d)


/////////////////////////////////////////////////////////////////////////////
// Type library ID and version

IMPLEMENT_OLETYPELIB(CSilxScreenCtrl, _tlid, _wVerMajor, _wVerMinor)


/////////////////////////////////////////////////////////////////////////////
// Interface IDs

const IID BASED_CODE IID_DSilxScreen =
		{ 0x89bb8c90, 0xf51a, 0x4598, { 0xa1, 0xff, 0xce, 0xa8, 0x72, 0xec, 0xa8, 0xe6 } };
const IID BASED_CODE IID_DSilxScreenEvents =
		{ 0x2434d2ef, 0x8157, 0x4e55, { 0xa0, 0x4e, 0x6d, 0x85, 0x6, 0x34, 0xc1, 0xf9 } };


/////////////////////////////////////////////////////////////////////////////
// Control type information

static const DWORD BASED_CODE _dwSilxScreenOleMisc =
	OLEMISC_ACTIVATEWHENVISIBLE |
	OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CSilxScreenCtrl, IDS_SILXSCREEN, _dwSilxScreenOleMisc)


/////////////////////////////////////////////////////////////////////////////
// CSilxScreenCtrl::CSilxScreenCtrlFactory::UpdateRegistry -
// Adds or removes system registry entries for CSilxScreenCtrl

BOOL CSilxScreenCtrl::CSilxScreenCtrlFactory::UpdateRegistry(BOOL bRegister)
{
	// TODO: Verify that your control follows apartment-model threading rules.
	// Refer to MFC TechNote 64 for more information.
	// If your control does not conform to the apartment-model rules, then
	// you must modify the code below, changing the 6th parameter from
	// afxRegInsertable | afxRegApartmentThreading to afxRegInsertable.

	if (bRegister)
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_SILXSCREEN,
			IDB_SILXSCREEN,
			afxRegInsertable | afxRegApartmentThreading,
			_dwSilxScreenOleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}


using namespace Asd;
using namespace AsdMath;

/////////////////////////////////////////////////////////////////////////////
// CSilxScreenCtrl::CSilxScreenCtrl - Constructor

CSilxScreenCtrl::CSilxScreenCtrl()
:
 m_file( NULL ),
 m_currentPage( 0 ),
 m_zoom( .25 ),
 m_pageBreakSpace( 10 ),
 m_fullPageCacheThreshold( 20 ),
 m_extraPageCacheSize( 10 ),
 m_viewMode( ViewContinuous ),
 m_layer( 0 ),
 m_orientation( Orient_0 )
{
	InitializeIIDs(&IID_DSilxScreen, &IID_DSilxScreenEvents);
}

/////////////////////////////////////////////////////////////////////////////
// CSilxScreenCtrl::DoPropExchange - Persistence support

void CSilxScreenCtrl::DoPropExchange(CPropExchange* pPX)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);

	// Call PX_ functions for each persistent custom property.
    // JBTODO:  Note this is a dangerous way to do this.  We should really
    // extract the properties into temporary variables and then call the
    // setting methods.  Alternatively, we can have a special method
    // for setting everything at once.
    //
    // What we do here works because SetFileName() does not step on any
    // of thsee values (other than m_fileName.)    

    PX_String( pPX, "FileName",               m_fileName               );    
    PX_ULong ( pPX, "CurrentPage",            m_currentPage            );
    PX_Long  ( pPX, "PageBreakSpace",         m_pageBreakSpace         );
    PX_Double( pPX, "ZoomFactor",             m_zoom                   );
    PX_Long  ( pPX, "FullPageCacheThreshold", m_fullPageCacheThreshold );
    PX_Long  ( pPX, "ExtraPageCacheSize",     m_extraPageCacheSize     );
    PX_Long  ( pPX, "ViewMode",               m_viewMode               );
    PX_Long  ( pPX, "Layer",                  m_layer                  );

    if( pPX->IsLoading() )
    {
        this->SetFileName( m_fileName );
    }
}

/////////////////////////////////////////////////////////////////////////////
// CSilxScreenCtrl::~CSilxScreenCtrl - Destructor

CSilxScreenCtrl::~CSilxScreenCtrl()
{
    PurgeAllData();
}


/////////////////////////////////////////////////////////////////////////////
// CSilxScreenCtrl::OnDraw - Drawing function

void CSilxScreenCtrl::
OnDraw( CDC* pdc, const CRect& rcBounds, const CRect & rcInvalid )
{
    const Rect bounds( rcBounds );
    const Rect invalid( rcInvalid );

    Draw( pdc, bounds, invalid, m_currentPage, m_position, m_zoom,
          m_orientation, true, m_layer,
          static_cast<ViewMode>(m_viewMode) );

}


/*************************************************************************

Draw is basically identical to OnDraw(), but it is written in terms of
Asd::Rect instead of RECT.  Also, it is largely independent of the
current state of the object.  Note that page, position, zoom, and layer
are arugments to this method.  Thus, you can call draw to draw things
other than the current page.  OnDraw() just passes in the current state,
of course.

The fill parameter tells Draw whether to fill in space not used by the
image with the background color.

**************************************************************************/

void CSilxScreenCtrl::
Draw( CDC* pdc, const Rect& bounds, const Rect& invalid, UInt32 page,
     const Point32 & position, Float64 zoom, Orientation orient, bool fill,
     Int32 layer, ViewMode vMode )
{
    // Maybe we should assert this?  In any case, if there is no drawing
    // context then there isn't anything to draw on.
    if( pdc )
    {
        // Is there a file?  Are there any pages?
        if( !m_file || !NumPages() )
        {            
			// If not, just fill in the background.
            FillBackRect( pdc, bounds );
        }
        else if( zoom <= 1 )
        {
            DrawZoomedOut( pdc, bounds, invalid, page, position, zoom, orient,
                           fill, layer, vMode );
        }
        else
        {
            DrawZoomedIn( pdc, bounds, invalid, page, position, zoom, orient,
                          fill, layer, vMode );
        }
    }
}

/////////////////////////////////////////////////////////////////////////////
// CSilxScreenCtrl::GetControlFlags -
// Flags to customize MFC's implementation of ActiveX controls.
//
// For information on using these flags, please see MFC technical note
// #nnn, "Optimizing an ActiveX Control".
DWORD CSilxScreenCtrl::GetControlFlags()
{
	DWORD dwFlags = COleControl::GetControlFlags();


	// The control will not be redrawn when making the transition
	// between the active and inactivate state.
	dwFlags |= noFlickerActivate;
	return dwFlags;
}


/////////////////////////////////////////////////////////////////////////////
// CSilxScreenCtrl::OnResetState - Reset control to default state

void CSilxScreenCtrl::OnResetState()
{
	COleControl::OnResetState();  // Resets defaults found in DoPropExchange

	// TODO: Reset any other control state here.
}


/////////////////////////////////////////////////////////////////////////////
// CSilxScreenCtrl::AboutBox - Display an "About" box to the user

void CSilxScreenCtrl::AboutBox()
{
	CDialog dlgAbout(IDD_ABOUTBOX_SILXSCREEN);
	dlgAbout.DoModal();
}


/*************************************************************************

Get the desired page.  If the Page object has not yet been created,
create it.  If it has already been created, fetch the existing one.
Note that this method should always return a valid Page pointer
as long as you give it a valid page.  It is an assertion failure
for you to pass in an invalid page.  There are two implications here.

1.  Make sure what you pass it is in-bounds. 
2.  You cannot safely call this method if there is no file.

Call isPageAllocated() to safefly determine if the page has already been
allocated.  Normally you will not need or want to do this, but you might
if you are doing caching.

*************************************************************************/

CSilxScreenCtrl::Page * CSilxScreenCtrl::getPage( UInt32 page )
{
    assert( page < NumPages() );

    if( !m_pgs[page] )
    {
        m_pgs[page] = new Page( page, m_file );
    }

    assert( m_pgs[page] );

    return m_pgs[page];
}

/*************************************************************************

Use isPageAllocated() to safely determine if a page has alredy been
allocated without creating a page if one has not been.

*************************************************************************/

bool CSilxScreenCtrl::isPageAllocated( Asd::UInt32 page )
{
	return (page < NumPages())?  !!m_pgs[page]  :  false;
}

Point32 CSilxScreenCtrl::
getOrientedPageSize( Asd::UInt32 page, Orientation orient )
{
    Point32 size;

    if( page < NumPages() )
    {
        if( (orient == Orient_90 ) || 
            (orient == Orient_270)   )
        {
            Point32 temp = getPage(page)->getSize();

            size = Point32( temp.getY(), temp.getX() );
        }
        else
        {
            size = getPage(page)->getSize();
        }
    }

    return size;
}


/*************************************************************************

Get rid of cached information on the given page.  Implementation
is not completely defined as caching may change.  This is more of
a suggestion than an order.  Currently, we just call Page::clear()
on the corresponding page object (assuming it exists at all.)
It would be equally valid, however, to delete said object.  (Remeber,
getPage() will create it again if we need it.)

It is an assertion failure to pass a page that is out of bounds, but
there is no need to check to see if it is allocated or not.  clearPage
checks that for you.

*************************************************************************/

void CSilxScreenCtrl::clearPage( UInt32 page )
{
    assert( page < NumPages() );

    // Note that we don't use getPage(ii) here because we don't
    // want to automatically create the page if it isn't there!
    if( isPageAllocated(page) )
    {
        // If the page has been allocated, clear it.
		getPage(page)->clear();
    }
}

/*************************************************************************

Draw something in the control so that we can see it is working. By
drawing this pleasant blue-yellow wash we know we are running.

The arguments here are the same as for OnDraw(), although no attempt
is made to fill only the invalid region.  The entire bounds area
is redrawn each time.

*************************************************************************/

void CSilxScreenCtrl::
DrawWash( CDC *pdc, const Rect & bounds, const Rect & invalid )
{
    const UInt32 size = 256;

    Point32 hw( size, size );

    DibImgBuf washImg;

    washImg.resize( hw, COLOR_24_BIT, sizeof(DWORD)  );

    UInt8 * rowPtr = washImg.data();

    for( UInt32 ii=0; ii < size; ++ii, rowPtr += washImg.bpl() )
    { 
        RgbPtr pixPtr( rowPtr );

        for( UInt32 jj=0; jj < size; ++jj, ++pixPtr )
        {          
            pixPtr.setRGB( jj, ii, ii ); 
        }
    }

    StretchDIBits( pdc->GetSafeHdc(), 
                   bounds.left(), bounds.top(),
                   bounds.width(), bounds.height(),
                   0, 0,
                   washImg.width(), washImg.height(),
                   washImg.data(), &washImg.getBmpInfo(),
                   DIB_RGB_COLORS, SRCCOPY );
}

/*************************************************************************

 Draw the specified page in the cases where zoom >= 1.
 It is an assertion failure to call this method with zoom
 < 1.

 --page is the index in our m_pgs array.  page must be in-bounds.
   That is, we assert( page < NumPages() )
 
 --topLeft is the location in raw image coodinates that should be in the
   top-left corner of the bounds rectangle.
 
 --pdc is the pointer to our drawing context object.  pdc must not
   be NULL.

 --bounds is the region we are drawing into.  Note that this may be a 
   sub area of the boudns passed to OnDraw().
 
 --invalid is the invalid rectangle.  This tells us what actually has
   to be drawn.  At present, we completely ignore ivnalid and just
   render all of bounds.

 DrawZoomedInPage() will always draw in a rectangle that starts at the top
 of bounds and is exactly as wide as bounds.  The rectangle returned
 is the remaining rectangle at the bottom that has not been drawn into
 yet.  (It may be empty.)

 Note that while we can draw at any zoomed in amount, we never actually
 render at greater than 100%.  We use StretchDIBits to acheive the final
 zoom.  This is the primary reason that we have separate functions
 for drawing zoomed in an drawing zoomed out.  We we draw zoomed out
 we render at screen resolution and use SetDIBitsToDevice.  When we draw
 zoomed in we render at 100% and use StretchDIBits.

 Note that there are a bunch of hardcoded 1's for zoom values in this
 function.  These are just the places that we are doing something at
 image resolution and not screen resolution.

*************************************************************************/

Rect CSilxScreenCtrl::
DrawZoomedInPage( CDC *pdc, const Rect & bounds, const Rect & invalid,
                  UInt32 page, const Point32 & topLeft, Float64 zoom,
				  Orientation orient, bool fill, Int32 layer, ViewMode vMode )
{
    assert( zoom > 1 );    
    assert( page < NumPages() );
    assert( pdc );

    // If the bounds are empty, then there is nothting to do.
    if( bounds.isEmpty() )
    {
        return Rect();
    }

    // This is the portion of the page that we are going to render in raw
    // image coordinates.  The -(1,1) here is to turn the size into a 
    // bottom-right corner.
    Rect region( topLeft, getOrientedPageSize(page, orient) - Point32(1,1) );

    Rect wholePage( getPage(page)->getSize() );

    //
    // Now, we want to find the porition of the image the overlaps the
    // display area.  Note that the scaling up and scaling down here
    // are not strictly inverses.  Because of integer truncation, it
    // is possible that our scaling to and from the orignal coordinate
    // system will cause one less pixel to be rendered than we want to.
    // This should not produce any first-order UI effects, because we
    // eventually do a stretch blit at the end.  That is to say, we
    // will always fill our boundary area.  However, if you slide the
    // image one pixel at a time, you could see some weird effects
    // from the stretching being slightly different.  All in all, I 
    // don't think it's really a problem.
    //

    // Change the coordiante system of the region to be the same as that of
    // bounds.
    region.scaleUp( zoom );
    const Point32 tl( region.topLeft() );
    region.offset( bounds.topLeft() - tl );

    // Clip out portions of the region that do not fit into the needed area.
    region = region.intersection( bounds );              
    
    // box represents the region in the bounds rectangle's coordinate system.
    const Rect box( region );

    // Restore the region's coordinate system to raw image pixels.
    region.offset( tl - bounds.topLeft() );    
    region.scaleDown( zoom );

    // We only need to render if there is something to draw!
    if( !region.isEmpty() )
    {
		Page * const pagePtr = getPage(page);
        assert( pagePtr );

        TfxPage * const tfxPg = pagePtr->getTfxPage();
        assert( tfxPg );
            

		DibImgBuf * const img = &(pagePtr->m_img);
        assert( img );

		// Start by assuming we need the color depth of the image.
		ColorDepth colorNeeded = tfxPg->getColorDepth();

		//  Do we have a selector?
		if( layer && !(layer % 2) )
		{			
			// If so, we will render in 1-bit color.
			colorNeeded = MONOCHROME;
		}
    
        // Find out the color depth of the drawing context.
		const int bpp = pdc->GetDeviceCaps( BITSPIXEL );
		const int nc  = pdc->GetDeviceCaps( NUMCOLORS );

		// A flag that will tell us whether we want to force a black
		// and white rendering or not.  Note that we use != instead of
		// > because the clipboard will tell us that it has 0 bits
		// per pixel.
		bool doColor = (bpp != 1);

		// Some printers will give -1 for numcolors if they are full color.
		// (bpp is then undefined.)
		doColor |= (nc == -1);

		// What follows is a serious kluge to tell if we are printing
		// to a color printer or not.  Some color pritners lie about 
		// their color depth.  However, they are also inconsistant
		// about their color depth and their number of colors.  Thus
		// we can detect this case.
		doColor |= (nc > ::pow( 2, bpp ));

		// If the printer is monochrome, then we only want monochrome
		// rendering.
		if( !doColor )
		{
			colorNeeded = MONOCHROME;
		}

        if( orient == Orient_180 )
        {
            region.rotate( orient, wholePage.width(), wholePage.height() );
        }
        else if( (orient == Orient_90 ) || 
                 (orient == Orient_270) )
        {
            Int32 fixVal = -Int32(orient);

            region.rotate( Int2Orient(fixVal), wholePage.height(), wholePage.width() );
        }

        // A flag indicating whether or not we need to render.
        bool mustRender = true;

        // If the zoom, layer, and color depth have not changed then
		// there is some hope we do not need to render.
        if( (pagePtr->m_zoom       ==           1 ) &&
			(pagePtr->m_layer      ==       layer ) &&
			(pagePtr->m_colorDepth == colorNeeded )    )
        {
            // The region we have rendered must contain the region we need.
            mustRender = !(pagePtr->m_renderedRegion.contains( region ));
        }

        // Must we render?
        if( mustRender )
        {        
            // Note what we have rendered for future optimizations.  We will
            // also use these in our actual call to render.  Note that we
			// do not set m_colorDepth here.  The reason is that in the general
			// case, we do not ask for a color depth, render gives us one.
			// Thus, we wait until after we have rendered and then get the color
			// depth from img.
            pagePtr->m_renderedRegion = region;
            pagePtr->m_zoom           = 1;
            pagePtr->m_layer          = layer;

            //
            // Now we will determine if it is beter just to render the entire
            // page.  We must find the difference in area between the two
            // options and convert this to an amount of memory.  Note that
            // for simplicity here we ignore the effect alignment of the 
            // image buffer.  Our only purpose here is to optimize for speed
            // by rendering the entire image when it's not too much more costly
            // to do so.  If our threshold isn't exact, it does not matter.
            //

            // Note that we use floating-point numbers in our memory
            // calculations.  This is because a rounding error of a
            // byte or so is irrelevant for our purposes.  However,
            // a truncation error in the division could be very significant.

            // cacheSize is in bytes.  We mulitply by 1024^2 to get from
            // megabytes to bytes.
            const Float64 cacheSize = m_fullPageCacheThreshold * (1024.0 * 1024.0);

            // If the whole page will fit into the cache then we want to render
            // the whole thing.
            if( getPage(page)->approxBytesNeeded(1, colorNeeded) < cacheSize )
            {
                pagePtr->m_renderedRegion = wholePage;
            }

            // Show the hourglass while we render.
            CWaitCursor wait;

			if( doColor )
			{
				tfxPg->render( img, pagePtr->m_renderedRegion, 1, pagePtr->m_layer );
			}
			else
			{
				tfxPg->renderBW( img, pagePtr->m_renderedRegion, 1, pagePtr->m_layer );
			}
        		
			pagePtr->m_colorDepth = img->depth();
		}

        DibImgBuf blitImg;

        if( orient != Orient_0 )
        {
            Rect crr( region.size() );

            crr.offset( region.topLeft() - pagePtr->m_renderedRegion.topLeft() );

            // copyRotate assumes the image is bottom up.
            if( img->isBottomUp() )
            {
                img->flipData();
            }

            img->copyRotate( orient, &blitImg, crr );

            region.rotate( orient, wholePage.width(), wholePage.height() );

            if( blitImg.isTopDown() && dynamic_cast<CMetaFileDC *>(pdc) )
            {
                // The second part of the above condition means that we are
                // writing to a Windows metafile.  SetDIBitsToDevice and Windows
                // metafiles seem have problems with top-down images.  Thus, we
                // flip it here.  This does not change the semantic meaning
                // of the image, so there is no need to flip it back.  Things
                // seem to work for both top-down and bottom-up bit maps in other
                // situations.  (When flipData() returns it has changed the sign
                // on the height so that the bieight as well as reflecting the
                // image about it's horiszonal axis.).
                blitImg.flipData();
            }
            
            // Blit the rendered image to the screen.  Note that our destination
            // here is box, not bounds.  box is the sub-rectangle of bounds that
            // our image actually occupies.a
            StretchDIBits( pdc->GetSafeHdc(),
                           box.left(), box.top(), box.width(), box.height(),
                           0, 0, region.width(), region.height(),
                           blitImg.data(), &(blitImg.getBmpInfo()),
                           DIB_RGB_COLORS, SRCCOPY );        
        
        }
        else
        {
            if( img->isTopDown() && dynamic_cast<CMetaFileDC *>(pdc) )
            {
                // The second part of the above condition means that we are
                // writing to a Windows metafile.  SetDIBitsToDevice and Windows
                // metafiles seem have problems with top-down images.  Thus, we
                // flip it here.  This does not change the semantic meaning
                // of the image, so there is no need to flip it back.  Things
                // seem to work for both top-down and bottom-up bit maps in other
                // situations.  (When flipData() returns it has changed the sign
                // on the height so that the bieight as well as reflecting the
                // image about it's horiszonal axis.).
                img->flipData();
            }

            const Int32 left = region.left() - pagePtr->m_renderedRegion.left();
            const Int32 top = region.top() - pagePtr->m_renderedRegion.top();
            const Int32 bottom = pagePtr->m_renderedRegion.bottom() - region.bottom();

            // Blit the rendered image to the screen.  Note that our destination
            // here is box, not bounds.  box is the sub-rectangle of bounds that
            // our image actually occupies.a
            StretchDIBits( pdc->GetSafeHdc(),
                           box.left(), box.top(), box.width(), box.height(),
                           left, bottom, region.width(), region.height(),
                           img->data(), &(img->getBmpInfo()),
                           DIB_RGB_COLORS, SRCCOPY );
        }
    }

	const Int32 shadowOffset = std::_cpp_min((long)10, (long)(m_pageBreakSpace / 3));
    const COLORREF shadowColor = RGB(24,24,24);

    const Int32 regionScrPixTop  = region.top()  * zoom;
    const Int32 regionScrPixLeft = region.left() * zoom;

    // Fill in any areas left at the right of our image.
    if( fill )
	{
        Rect fillSide( bounds );
        fillSide.setLeft( box.right() + 1 );
        fillSide.setBottom( box.bottom() );
        FillBackRect( pdc, fillSide );

        if( vMode == ViewContinuous )
        {
            fillSide.setTop( fillSide.top() + std::_cpp_max(Int32(0), shadowOffset - regionScrPixTop) );
            fillSide.setRight( std::_cpp_min(fillSide.left() + shadowOffset, bounds.right()) );
            DrawFilledRect( pdc, fillSide, shadowColor );    
        }
    }

    // Fill in the space between pages.
    if( fill )
	{
        Rect fillBottom( bounds );
        fillBottom.setTop( box.bottom() + 1 );        
        fillBottom.setBottom( std::_cpp_min(box.bottom() + m_pageBreakSpace, bounds.bottom()) );
        FillBackRect( pdc, fillBottom );

        if( vMode == ViewContinuous )
        {
            fillBottom.setBottom( std::_cpp_min(fillBottom.top() + shadowOffset, bounds.bottom()) );
            fillBottom.setLeft( fillBottom.left() + std::_cpp_max(Int32(0), shadowOffset - regionScrPixLeft) );
            fillBottom.setRight( bounds.left() + box.width() + shadowOffset );

            DrawFilledRect( pdc, fillBottom, shadowColor );    
        }
    }


    // Find the are that we have not yet touched to return.
    Rect newBounds( bounds );
    newBounds.setTop( box.bottom() + m_pageBreakSpace + 1 );

    return newBounds;
}

/*************************************************************************

 DrawZoomedIn() handles drawing for zoomFactors >= 1.  Calling this method
 when zoom < 1 causes an assertion to fail in debug mode.  In
 release mode we will fill in the background with the background color,
 (although this should never ever happen.)

 The arguments here are the same as for Draw().

*************************************************************************/

void CSilxScreenCtrl::
DrawZoomedIn( CDC* pdc, const Rect& bounds, const Rect& invalid, UInt32 page,
               const Point32 & position, Float64 zoom, Orientation orient,
               bool fill, Int32 layer, ViewMode vMode )
{
    assert( zoom > 1 );
    
    const UInt32 startPage = page;

    // We always want to draw the current page.
    Rect bds = DrawZoomedInPage( pdc, bounds, invalid, page, position, zoom,
                                 orient, fill, layer, vMode );

    // If we are in continuous mode, we may need to draw other pages as well.
    if( vMode == ViewContinuous )
    {
        // For pages after the first one we draw we always start at the top.
        const Point32 pos( position.getX(), 0 );

        for( ++page; (page < NumPages()) && !bds.isEmpty(); ++page )
        {
            bds = DrawZoomedInPage( pdc, bds, invalid, page, pos, zoom, orient,
                                    fill, layer, vMode );
        }
    }

    if( fill )
	{
		// Fill in unused space at the bottom.
		FillBackRect( pdc, bds );
	}

    // Remove all pages not on the screen from memory.
    PurgeUnneededPages( startPage, page );
}

/*************************************************************************

 Draw the specified page in the cases where zoom < 1.
 It is an assertion failure to call this method with m_zoom
 >= 1.

 --page is the index in our m_pgs array.  page must be in bounds.
   That is, we assert( page < NumPages() )
 --topLeft is the location in raw image coodinates that should be in the
   top-left corner of the bounds rectangle.
 --pdc is the pointer to our drawing context object.  pdc must not
   be NULL.
 --bounds is the region we are drawing into.  Note that this may be a 
   sub area of the boudns passed to OnDraw().
 --invalid is the invalid rectangle.  This tells us what actually has
   to be drawn.  At present we ignore invalid and just render all of bounds.

 DrawZoomedOutPage() will always draw in a rectangle that starts at the top
 of bounds and is exactly as wide as bounds.  The rectangle returned
 is the remaining rectangle at the bottom that has not been drawn into
 yet.  (It may be empty.)

*************************************************************************/

Rect CSilxScreenCtrl::
DrawZoomedOutPage( CDC *pdc, const Rect & bounds, const Rect & invalid,
                   UInt32 page, const Point32 & topLeft, Float64 zoom,
				   Orientation orient, bool fill, Int32 layer,
                   ViewMode vMode )
{
    assert( zoom <= 1 );    
    assert( page < NumPages() );
    assert( pdc );

    // If the bounds are empty, then there is nothting to do.
    if( bounds.isEmpty() )
    {
        return Rect();
    }

    const Point32 pageSize = getOrientedPageSize(page, orient);

    Rect wholePage( getPage(page)->getSize() );
    wholePage.scaleUp( zoom );

    // This is the region we will render in image raw coordinates.
    Rect region;

    // We need the -(1,1) to turn a size into a bottom-right corner.
    region = Rect( topLeft, pageSize - Point32(1,1) );

    // We need to request the region in the zoomed down coordinate system.
    // Note that since zoom <= 1, scaleUp(zoom) will make
    // region smaller.  Note that we are not being super careful about the
    // effects of rounding.  I think that for certain choices of zoomFactor
    // we will lose a pixel.  This should not really be noticeable.
    region.scaleUp( zoom );

    
    // Translate the region to the bounds coordinate system, truncate
    // unneeeded area, and then translate back.
    {
        const Point32 tl( region.topLeft() );

        region.offset( bounds.topLeft() - tl );
        region = region.intersection( bounds );              
        region.offset( tl - bounds.topLeft() );
    }

    // If the region is empty there is nothing to do.
    if( !region.isEmpty() )
    {
        Page * const pagePtr = getPage(page);
        assert( pagePtr );

        TfxPage * const tfxPg = getPage(page)->getTfxPage();
        assert( tfxPg );
            
        DibImgBuf * const img = &(pagePtr->m_img);
        assert( img );
    
		// Start by assuming we need the color depth of the image.
		ColorDepth colorNeeded = tfxPg->getColorDepth();

		//  Do we have a selector?  If so we have a monochrome image despite
		// the fact the image may be 24-bit (or something.)
		if( layer && !(layer % 2) )
		{			
			// If so, we will render in 1-bit.
			colorNeeded = MONOCHROME;
		}

		// If we are zoomed out, we actually need 8-bit color for monochrome
		// images.
		if( (colorNeeded == MONOCHROME) && (zoom != 1.0) )
		{
			colorNeeded = COLOR_8_BIT;		
		}

        // Find out the color depth of the drawing context.
        const int bpp = pdc->GetDeviceCaps( BITSPIXEL );
		const int nc  = pdc->GetDeviceCaps( NUMCOLORS );

		// A flag that will tell us whether we want to force a black
		// and white rendering or not.  Note that we use != instead of
		// > because the clipboard will tell us that it has 0 bits
		// per pixel.
		bool doColor = (bpp != 1);

		// Some printers will give -1 for numcolors if they are full color.
		// (bpp is then undefined.)
		doColor |= (nc == -1);

		// What follows is a serious kluge to tell if we are printing
		// to a color printer or not.  Some color pritners lie about 
		// their color depth.  However, they are also inconsistant
		// about their color depth and their number of colors.  Thus
		// we can detect this case.

		doColor |= (nc > ::pow( 2, bpp ));

		// If the printer is monochrome, then we only want monochrome
		// rendering.
		if( !doColor )
		{
			colorNeeded = MONOCHROME;
		}
        
        if( orient == Orient_180 )
        {
            region.rotate( orient, wholePage.width(), wholePage.height() );
        }
        else if( (orient == Orient_90 ) || 
                 (orient == Orient_270) )
        {
            Int32 fixVal = -Int32(orient);

            region.rotate( Int2Orient(fixVal), wholePage.height(), wholePage.width() );
        }

        // A flag indicating whether or not we need to render.
        bool mustRender = true;
        
        // If the zoom has not changed then there is some hope we do not need
        // to render.
        if( (pagePtr->m_zoom       ==        zoom) && 
			(pagePtr->m_layer      ==       layer) &&
			(pagePtr->m_colorDepth == colorNeeded)   )
        {
            // The region we have rendered must contain the region we need.
            mustRender = !(pagePtr->m_renderedRegion.contains( region ));
        }

        // Must we render?
        if( mustRender )
        {        
            // Note what we have rendered for future optimizations.  We will
            // also use these in our actual call to render.
            pagePtr->m_renderedRegion = region;
            pagePtr->m_zoom = zoom;
            pagePtr->m_layer = layer;

            //
            // Now we will determine if it is beter just to render the entire
            // page.  We must find the difference in area between the two
            // options and convert this to an amount of memory.  Note that
            // for simplicity here we ignore the effect alignment of the 
            // image buffer.  Our only purpose here is to optimize for speed
            // by rendering the entire image when it's not too much more costly
            // to do so.  If our threshold isn't exact, it does not matter.
            //

            // Note that we use floating-point numbers in our memory
            // calculations.  This is because a rounding error of a
            // byte or so is irrelevant for our purposes.  However,
            // a truncation error in the division could be very significant.

            // cacheSize is in bytes.  We mulitply by 1024^2 to get from
            // megabytes to bytes.
            const Float64 cacheSize = m_fullPageCacheThreshold * (1024.0 * 1024.0);

            // If the whole page will fit into the cache then we want to render
            // the whole thing.
            if( getPage(page)->approxBytesNeeded(zoom, colorNeeded) < cacheSize )
            {
                pagePtr->m_renderedRegion = wholePage;
            }

            // Show the hourglass while we render.
            CWaitCursor wait;

			if( doColor )
			{
				tfxPg->render( img, pagePtr->m_renderedRegion, 1.0/pagePtr->m_zoom, pagePtr->m_layer );
			}
			else
			{
				tfxPg->renderBW( img, pagePtr->m_renderedRegion, 1.0/pagePtr->m_zoom, pagePtr->m_layer );
			}
        
			pagePtr->m_colorDepth = img->depth();		
		}

        DibImgBuf blitImg;

        if( orient != Orient_0 )
        {
            Rect crr( region.size() );

            crr.offset( region.topLeft() - pagePtr->m_renderedRegion.topLeft() );

            // copyRotate assumes the image is bottom up.
            if( img->isBottomUp() )
            {
                img->flipData();
            }

            img->copyRotate( orient, &blitImg, crr );

            region.rotate( orient, wholePage.width(), wholePage.height() );

            if( blitImg.isTopDown() && dynamic_cast<CMetaFileDC *>(pdc) )
            {
                // The second part of the above condition means that we are
                // writing to a Windows metafile.  SetDIBitsToDevice and Windows
                // metafiles seem have problems with top-down images.  Thus, we
                // flip it here.  This does not change the semantic meaning
                // of the image, so there is no need to flip it back.  Things
                // seem to work for both top-down and bottom-up bit maps in other
                // situations.  (When flipData() returns it has changed the sign
                // on the height so that the bieight as well as reflecting the
                // image about it's horiszonal axis.).
                blitImg.flipData();
            }
            
            SetDIBitsToDevice( pdc->GetSafeHdc(),
                        bounds.left(), bounds.top(),
                        region.width(), region.height(),
                        0, 0,
                        0, blitImg.height(),
                        blitImg.data(), &(blitImg.getBmpInfo()),
                        DIB_RGB_COLORS );

        }
        else
        {
            if( img->isTopDown() && dynamic_cast<CMetaFileDC *>(pdc) )
            {
                // The second part of the above condition means that we are
                // writing to a Windows metafile.  SetDIBitsToDevice and Windows
                // metafiles seem have problems with top-down images.  Thus, we
                // flip it here.  This does not change the semantic meaning
                // of the image, so there is no need to flip it back.  Things
                // seem to work for both top-down and bottom-up bit maps in other
                // situations.  (When flipData() returns it has changed the sign
                // on the height so that the bieight as well as reflecting the
                // image about it's horiszonal axis.).
                img->flipData();
            }
        
            // We need the bottom-left corner of the portion of the portion of the
            // rendered image we are going to draw with SetDIBitsToDevice.  This is
            // just (0,0) if the entire rendered region is displayed, however it's
            // trickier if we are only displaying part of the image.  (Actually,
            // why it's (0,0) is a bit tricky, but if we never had to change it,
            // we would not care.
            //
            // The left is fairly obvious.  If our rendered region starts to
            // left of the region we must draw then we need to offset.  The value
            // of left calculated below should be intuitive.
            //
            // The bottom is a bit trickier.  To be honest, I don't competely
            // understand everything.  The interpretation of bottom appears to
            // be the distance of bottom of region we will draw from bottom of 
            // region in buffer.  If the bitmap were bottom up, this would make sense.
            // Given that it is top-down, one would expect bottom to be expressed in
            // terms of destance from the top.  Instead, however, it appears (based
            // soley on experiment) that we must give the "bottom-up" bottom value with
            // a minus sign.

            const Int32 bottom = pagePtr->m_renderedRegion.bottom() - region.bottom();
            const Int32 left = region.left() - pagePtr->m_renderedRegion.left();

            SetDIBitsToDevice( pdc->GetSafeHdc(),
                        bounds.left(), bounds.top(),
                        region.width(), region.height(),
                        left, bottom,
                        0, img->height(),
                        img->data(), &(img->getBmpInfo()),
                        DIB_RGB_COLORS );
        }
    }


    const Int32 shadowOffset = std::_cpp_min( (long)10, (long)(m_pageBreakSpace / 3));
    const COLORREF shadowColor = RGB(24,24,24);

    // Fill the area to the right of our image.
    if( fill )
	{
        Rect fillSide( bounds );
        fillSide.setLeft( bounds.left() + region.width() );
        fillSide.setBottom( bounds.top() + region.height() );
        FillBackRect( pdc, fillSide );

        if( vMode == ViewContinuous )
        {
            fillSide.setTop( fillSide.top() + std::_cpp_max(Int32(0), shadowOffset - region.top()) );
            fillSide.setRight( std::_cpp_min(fillSide.left() + shadowOffset, bounds.right()) );
            DrawFilledRect( pdc, fillSide, shadowColor );
        }
    }

    // Fill in the space between pages.
    if( fill )
	{
        Rect fillBottom( bounds );
        fillBottom.setTop( bounds.top() + region.height() );        
        fillBottom.setBottom( std::_cpp_min(bounds.top() + region.height() + m_pageBreakSpace, bounds.bottom()) );
        FillBackRect( pdc, fillBottom );

        if( vMode == ViewContinuous )
        {
            fillBottom.setBottom( std::_cpp_min(fillBottom.top() + shadowOffset, bounds.bottom()) );
            fillBottom.setLeft( fillBottom.left() + std::_cpp_max(Int32(0), shadowOffset - region.left()) );
            fillBottom.setRight( bounds.left() + region.width() + shadowOffset );

            DrawFilledRect( pdc, fillBottom, shadowColor );
        }
    }

    // Find the are that we have not yet touched to return.
    Rect newBounds( bounds );
    newBounds.setTop( bounds.top() + region.height() + m_pageBreakSpace + 1 );
    return newBounds;
}

/*************************************************************************

 DrawZoomedOut() handles drawing for zoomFactors < 1.  Calling this method
 when zoom >= 1 causes an assertion to fail in debug mode.  In
 release mode we will fill in the background with the background color,
 (although this should never ever happen.)

 The arguments here are the same as for Draw().

***************************************************************************/

void CSilxScreenCtrl::
DrawZoomedOut( CDC* pdc, const Rect& bounds, const Rect& invalid, UInt32 page,
               const Point32 & position, Float64 zoom, Orientation orient,
               bool fill, Int32 layer, ViewMode vMode )
{
    assert( zoom <= 1 );

    const UInt32 startPage = page;

    Rect bds = DrawZoomedOutPage( pdc, bounds, invalid, page, position, zoom,
		                          orient, fill, layer, vMode );

    if( vMode == ViewContinuous )
    {
        const Point32 pos( position.getX(), 0 );

        for( ++page; (page < NumPages()) && !bds.isEmpty(); ++page )
        {
            bds = DrawZoomedOutPage( pdc, bds, invalid, page, pos, zoom,
				                     orient, fill, layer, vMode );
        }
    }

    // Fill in unused space at the bottom.
    if( fill )
	{
		FillBackRect( pdc, bds );
	}

    // Now, lets remove all pages not on the screen from memory.
    PurgeUnneededPages( startPage, page );
}

/*************************************************************************

Load the file with name "fileName."  This will blow away any data related
to the old file.

*************************************************************************/

void CSilxScreenCtrl::loadFile( const std::string & fileName )
{
    // If we are about to load a new file, we may as well dump
    // the existing cached images, etc.
    PurgeAllData();

    assert( !m_file ); //Implied by PurgeAllData()
    
	// JBTODO Note that we are playing really fast an loose with TCHAR vs.
	// char here.  Unicode will probably break this.  I am using CString for
	// now because it has such nice syntactic sugar.

	// If all else fails, we assume we have been asked to open a .tfx file.
	CString extension( ".tfx" );
	CString fileCStr( fileName.c_str() );
	
	Asd::Int32 dotPos = fileCStr.ReverseFind( '.' );


	// Did the file have an extension?
	if( dotPos >= 0 )
	{
		extension = CString(fileName.c_str() + dotPos);
	}

	// File names in Windows are case-insensitive so we can simplify
	// our comparison (below) by making everything lower-case.
	extension.MakeLower();
	
	if( extension == CString(".tiff") ||
		extension == CString(".tif" )   )
	{    	
		m_file = new TifFile( fileName.c_str() );
	}
	else
	{
		m_file = new MrcFile( fileName.c_str() );
	}

	if( m_file )
    {
        // If we opened the file successfully, we must initialize
        // our m_pgs structures.
        m_pgs.resize( m_file->numPages() );

        if( m_pgs.size() )
		{
			// Set all of the pointers to NULL by default.
			for( UInt32 page = 0; page < m_pgs.size(); ++page )
			{
				m_pgs[page] = NULL;
			}
		}
		else
		{
			PurgeAllData();
		}
    }
    else
    {
        // Probably unneeded.  I just want to make sure we don't
        // leak anything.
        PurgeAllData();
    }

    InvalidateControl();
}

/*************************************************************************

PurgeUneededPages() works in conjunctin with our caching mechanism.  In
its most basic form, it just empties the caches of all pages before
"before" and after "after."  Used this way, our control would retain
only pages currently visable.  However, if m_extraPageCacheSize is set
to something other than 0, PurgeUneededPages() will allow other pages
to stick around as well.

before -- array index of first page not to be purged.
after  -- array index of last page not to be purged.

*************************************************************************/

void CSilxScreenCtrl::
PurgeUnneededPages( UInt32 before, UInt32 after )
{   
    if( before >= NumPages() )
    {
        return;
    }

    const Float64 cache = m_extraPageCacheSize * (1024.0 * 1024.0);
   
    Float64 memBefore = cache / 2;

    // First, take half of our memory and move the before page down
    // until we hit the beginning of the document or we use about
    // half of our cache.
    while( (before > 0) && (memBefore > 0) )
    {
        const UInt32 page = before - 1;

        Float64 memNeeded = 0;

        // If the page has not been allocated it clearly is not using
		// any memory.  We do not want to allocated the page just to find
		// out we do not need it!
		if( isPageAllocated(page) )
        {
            memNeeded = getPage(page)->currentBytesNeeded();
        }

        // We will fudge a little here.  If we can get more than half of the
        // page in, then we go for it.
        if( (memNeeded / 2) < memBefore )
        {
            --before;
            memBefore -= memNeeded;
        }
        else
        {
            break;
        }
    }
    
    // Note that we carry over extra memory from above or reduce our after
    // memory by the extra before memory used.
    Float64 memAfter = (cache / 2) + memBefore;

    // Now take ther rest of the memory in our cache and move the
    // after page up until we hit the end of the document or we run out
    // of cache.
    while( (after < (NumPages() - 1)) && (memAfter > 0) )
    {
        const UInt32 page = after + 1;

        Float64 memNeeded = 0;

        // If the page has not been allocated it needs no memory.  We do not
		// want to create the page just to find out we do not need it.
		if( isPageAllocated(page) )
        {
            memNeeded = getPage(page)->currentBytesNeeded();
        }

        // Here we are a bit more conservative about whether or not to
        // cached because we are hitting the end of the cache.  We
        // require that the whole page fit.  This way, the cache size
        // is a hard limit.
        if( memNeeded < memAfter )
        {
            ++after;
            memAfter -= memNeeded;
        }
        else
        {
            break;
        }
    }

    // Now, there is a chance that we did not finish using our cache.
    // This can happen near the end of the document if we hit our
    // cache limit before we hit the beginning of the document
    // in the first loop but then hit the end of the document in
    // the second loop.  Thus, we repeat the first loop with what
    // is left of our cache.
    memBefore = memAfter;

    while( (before > 0) && (memBefore > 0) )
    {
        const UInt32 page = before - 1;

        Float64 memNeeded = 0;

		// If the page has not been allocated, clearly it needs no 
		// memory.  We do not want to allocate the page just to find
		// out we do not need it.
		if( isPageAllocated(page) )
        {
            memNeeded = getPage(page)->currentBytesNeeded();
        }

        // Here we are a bit more conservative about whether or not to
        // cached because we are hitting the end of the cache.  We
        // require that the whole page fit.  This way the cache size is
        // a hard limit.
        if( memNeeded < memBefore )
        {
            --before;
            memBefore -= memNeeded;
        }
        else
        {
            break;
        }
    }

    
    // Purge the unneeded pages before the before page.
    for( UInt32 page=0; page < before; ++page )
    {
        clearPage( page );
    }

    // Purge the unneeded pages after the after page.
    for( page = after + 1; page < NumPages(); ++page )
    {
        clearPage( page );
    }
}



/*************************************************************************

  Fill the bounds rectangle with the color specified by color.  pdc can
  be NULL.  We just won't do anything.
    
*************************************************************************/

void CSilxScreenCtrl::
DrawFilledRect( CDC * pdc, const Rect & bounds, const COLORREF & color )
{
    if( pdc && !bounds.isEmpty() )
    {
        HBRUSH hBrush = CreateSolidBrush( color );

        FillRect( pdc->GetSafeHdc(), &bounds.asRECT(), hBrush );

        DeleteObject( hBrush );  hBrush = NULL;
    }
}

/*************************************************************************

  Fill the bounds rectangle with the current background color.  pdc can
  be NULL.  We just won't do anything.
    
*************************************************************************/

void CSilxScreenCtrl::FillBackRect( CDC* pdc, const Rect & bounds )
{
    if( pdc && !bounds.isEmpty() )
    {
        COLORREF fillColor = RGB( 0, 0, 0 );

        OleTranslateColor( GetBackColor(), NULL, &fillColor );

        DrawFilledRect( pdc, bounds, fillColor );
    }
}


/*************************************************************************

The input is the modal y position in screen pixels.  The return value is
the position (as in m_position) in raw image pixels.  If pageVal is non-
NULL then it is filled with the page that the position corresponds to.
  
*************************************************************************/

Int32 CSilxScreenCtrl::convertModalScreenYToY( const Int32 y, UInt32 * pageVal )
{
    const Int32 zpbs = round(Float64(m_pageBreakSpace) / m_zoom);

    Int32 modalY = 0;
    Int32 page = 0;

    if( NumPages() )
    {
        if( m_viewMode == ViewOnePage )
        {
            // In on page mode we just have to account for the zoom and force
            // y to be on the page.
            page = m_currentPage;

            const Int32 pageSizeY = getOrientedPageSize(m_currentPage, m_orientation).getY();

            modalY = round( y / m_zoom );
            modalY = std::_cpp_min( modalY, pageSizeY + zpbs );
            modalY = std::_cpp_max( modalY, 0L );

        }
        else if( m_viewMode == ViewContinuous )
        {
            // Make sure these are on the document.
            modalY = std::_cpp_max( y, 0L );

            // Find out what page we are on.

            for( page = 0;page < NumPages(); ++page )
            {
                const UInt32 pageHeight = (getOrientedPageSize(page, m_orientation).getY()*m_zoom) + m_pageBreakSpace;
    
                if( modalY < pageHeight )
                {
                    break;
                }

                modalY -= pageHeight;
            }

            // Scale y into raw image pixels.

            modalY = round( modalY / m_zoom );

            // Are we off the bottom of the document?
            if( page == NumPages() )
            {
                --page;
            }

            // Find the amount of space between pages in raw image pixels.  We have
            // to remember to include the page-break space in the page heights.
            const Int32 zpbs = round(Float64(m_pageBreakSpace) / m_zoom);

            // Now that we have found the page, make sure y is on it.
            modalY = std::_cpp_min( modalY, getOrientedPageSize(page, m_orientation).getY() + zpbs );
        
        }
        else
        {
            assert( NULL );
        }
    }


    if( pageVal )
    {
        *pageVal = page;
    }

    return modalY;
}


/*************************************************************************

Return the file name of the current file.  Note that we use the otherwise
unnused m_fileName value here.

*************************************************************************/

BSTR CSilxScreenCtrl::GetFileName() 
{
	return m_fileName.AllocSysString();
}

/*************************************************************************

Purge the existing file and load a new one.

*************************************************************************/

void CSilxScreenCtrl::SetFileName( LPCTSTR lpszNewValue )
{
    if( !lpszNewValue || !*lpszNewValue )
    {
        return;
    }

    std::string fName;

    if( sizeof( TCHAR ) == 1 )
    {
        fName = lpszNewValue;
    }
    else
    {
        // JBTODO.
        // This little exercise here is a very much non-portable way of
        // turning 16-bit chars into 8-bit chars.  
        assert( sizeof(TCHAR) == 2 );

        CString tmp( lpszNewValue );

        for( UInt32 ii=0; ii < tmp.GetLength(); ++ii )
        {
            fName += char( tmp.GetAt(ii) );
        }
    }

    loadFile( fName );

	if( m_file )
	{
		m_fileName = lpszNewValue;
	}
	else
	{
		m_fileName = CString();
	}

	SetModifiedFlag();
}

/*************************************************************************

Return the current zoom factor.  The zoom factor is the number of screen
pixels per raw image pixel.

*************************************************************************/

double CSilxScreenCtrl::GetZoomFactor() 
{
	return m_zoom;
}

/*************************************************************************

If zoom is an allowed value for m_zoom, we just return zoom.  If zoom is
negative, we assume the minus sign was a mistake and remove it.  If zoom
is out of range, we bring it to the edge of the range.

*************************************************************************/

Float64 CSilxScreenCtrl::forceZoomInBounds( Float64 zoom )
{
	// Assume that negative zooms are a mistake.  Just remove the sign.
    zoom = AsdMath::Abs( zoom );

    const Float64 ZOOM_MAX = 10.00;
    const Float64 ZOOM_MIN =  0.01;

    zoom = std::_cpp_min( ZOOM_MAX, zoom );
    zoom = std::_cpp_max( ZOOM_MIN, zoom );

    return zoom;
}

/*************************************************************************

Set the zoom to the desired value.  We will force the zoom to be in range
if it is out of range.  Note that if you ask to zoom out further than
allowed, this method will zoom out as far as it can.  (This is instead
of just doing nothing.)

*************************************************************************/

void CSilxScreenCtrl::SetZoomFactor(double newValue) 
{
    newValue = forceZoomInBounds( newValue );
    
    // Has the zoom actually changed?
    if( newValue != m_zoom )
    {
        // Set the zoom.
        m_zoom = newValue;

        // If the zoom changes, our cached images are useless.
        for( UInt32 page = 0; page < NumPages(); ++page )
        {
            clearPage( page );
        }

        SetModifiedFlag();
        InvalidateControl();
    }
}



/*************************************************************************

What page are we currently on?  Note that in the external interface we
have 1-based numbering!

*************************************************************************/

long CSilxScreenCtrl::GetCurrentPage( void ) 
{
    // Convert 0-based to 1-based.
    return NumPages()? (m_currentPage + 1) : 0;
}

void CSilxScreenCtrl::SetCurrentPage(long nNewValue) 
{
    // Convert 1-based to 0-based.
    --nNewValue;

    if( (nNewValue >= 0) && (nNewValue < NumPages()) )
    {
        if( nNewValue != m_currentPage )
        {
            m_position.setY(0);
            m_currentPage = nNewValue;
            SetModifiedFlag();
            InvalidateControl();
        }
    }
}

/*************************************************************************

Go to the first page.

*************************************************************************/

long CSilxScreenCtrl::FirstPage() 
{
    SetCurrentPage(1);
	return GetCurrentPage();
}

/*************************************************************************

Go to the last page.

*************************************************************************/

long CSilxScreenCtrl::LastPage() 
{
    SetCurrentPage( NumPages() );
	return GetCurrentPage();
}

/*************************************************************************

Go to the next page, if there is a next page.

*************************************************************************/

long CSilxScreenCtrl::NextPage() 
{ 
	// SetCurrentPage() is robust against out-of-range page numbers.
    SetCurrentPage(GetCurrentPage() + 1 );
    return GetCurrentPage();
}

/*************************************************************************

Go to the previouss page if there is one.

*************************************************************************/

long CSilxScreenCtrl::PreviousPage() 
{
	// SetCurrentPage() is robust against out-of-range page numbers.
	SetCurrentPage(GetCurrentPage() - 1 );
	return GetCurrentPage();
}

/*************************************************************************

Returns the number of pages in the curret document.  Note that the number
returned here is 1-based.  NumPages() will be zero if there is not file.

*************************************************************************/

long CSilxScreenCtrl::NumPages() 
{
	return m_pgs.size();
}

/*************************************************************************

This is very similar to set position, but it sets the position relative
to the current position.  dx and dy are in screen pixels.  This is the
correct way to implement panning.  The reason is that setting absolute
positions can be flaky for small changes.  Rounding and truncation errors
can cause Set?Position(Get?Position()) to cause motion.  Panning works
correctly for small changes.

*************************************************************************/

void CSilxScreenCtrl::Pan(long dx, long dy) 
{
    if( !NumPages() )
    {
        return;
    }

    // Store the old values so we can fine out if anything has actually
    // changed.  Because of zooming and rounding, it is possible that
    // non-zero dx and dy values produce zero change.
    const UInt32 oldPage = m_currentPage;
    const Point32 oldPos = m_position;

    // Find the amount of space between pages in raw image pixels.  We have
    // to remember to include the page-break space in the page heights.
    const Int32 zpbs = round(Float64(m_pageBreakSpace) / m_zoom);

    // Convert dx and dy to raw image coordinates.
    dx = round( dx / m_zoom );
    dy = round( dy / m_zoom );

    UInt32 newPage = m_currentPage;

    Int32 newY = m_position.getY() + dy;

    // Check to see if we have scrolled to the previous page.  We are on the
    // previous page if (newY < 0).  However, we have to watch that we don't 
    // go back to before the beginning of the document.
    while( (newY < 0) && (newPage > 0) )
    {
        --newPage;
        newY += (getOrientedPageSize(newPage, m_orientation).getY() + zpbs);
    }

	// Now we have to make sure that if we are in single page mode, we 
	// do not change pages:

	if( (m_viewMode == ViewOnePage) && (newPage != m_currentPage) )
	{
		newPage = m_currentPage;
		newY = 0;
	}

    // No matter what, the page is correct at this point, because of the
    // above loop.  However, y might still be negative.  If this is the
    // case, then y is 0 and we are at the top of the page.
    newY = std::_cpp_max( newY, Int32(0) );

    
    // Check to see if we have scrolled to the next page.  We are on 
    // the next page if y is greater than the bottom of this page.
    while( (newY > (getOrientedPageSize(newPage, m_orientation).getY() + zpbs)) && 
           (newPage < (NumPages() - 1) )              )
    {
        newY -= (getOrientedPageSize(newPage, m_orientation).getY() + zpbs);
        ++newPage;
    }

	// JBTODO : For one-page mode we should probably check to make
	// sure we have not scrolled off of the bottom of the page,
	// however this behaviour never actually happens because of the
	// pagebreak space at the bottom of the page.
    
    // After the above loop, newY will be on the page, unless newY was so
    // big we are off the end of the entire document.  In that case, we
    // put y at the very bottom of the last page.  (newPage is the last
    // page in this case.)
    newY = std::_cpp_min( newY, getOrientedPageSize(newPage, m_orientation).getY() + zpbs );

    // Now we update the page.  We need to do this before setting the x position
    // because we use the current page width to find the right edge for x-scrolling.
    m_currentPage = newPage;

    Int32 newX = m_position.getX() + dx;

    // newX must be on the page.
    newX = std::_cpp_max( newX, Int32(0) );
    newX = std::_cpp_min( newX, getOrientedPageSize(newPage, m_orientation).getX() );

    m_position.setXY( newX, newY );

    // If something has changed, we must invalidate the control.
    if( (m_currentPage != oldPage) || (m_position != oldPos) )
    {        
        SetModifiedFlag();
        InvalidateControl();
    }
}


/*************************************************************************

Set the absolute position.  Note that values here are on the whole
continuous document.  x and y are in screen pixels.  This can lead
to weirdness if you try to make small changes.  By the time all of the
rounding has happened, you may discover motions you did not expect.  Use
Pan() for small relative motions.

*************************************************************************/

void CSilxScreenCtrl::SetPosition(long x, long y) 
{
    if( !NumPages() )
    {
        return;
    }

    // All positions are non-negative.
    x = std::_cpp_max( x, 0L );
    y = std::_cpp_max( y, 0L );

    UInt32 page;

    // Find out what page we are on and adjust y accordingly.  Do this in
    // screen pixels to minimize the effects of rounding/truncation errors.
    // Note that our zooming convention is to trucate.  Thus, we get the same
    // trucation effects when we multiply by m_zoom here as we do in our
    // draw methods.
    for( page = 0;page < NumPages(); ++page )
    {
        const UInt32 pageHeight = (getOrientedPageSize(page, m_orientation).getY()*m_zoom) + m_pageBreakSpace;
        
        if( y < pageHeight )
        {
            break;
        }

        y -= pageHeight;
    }

    // Now we move y into raw image pixels.
    y = round( y / m_zoom );

    
    // Are we off the bottom of the document?
    if( page == NumPages() )
    {
        --page;
    }

    // Find the amount of space between pages in raw image pixels.  We have
    // to remember to include the page-break space in the page heights.
    const Int32 zpbs = round(Float64(m_pageBreakSpace) / m_zoom);

    // Force y to be on the page.
    y = std::_cpp_min( y, getOrientedPageSize(page,m_orientation).getY() + zpbs );

    // Scale x to raw image pixels.
    x = round( x / m_zoom );

    // For x to be on the page.
    x = std::_cpp_min( x, getOrientedPageSize(page,m_orientation).getX() );

    const Point32 newPos( x, y );

    // Only invalidate the control if something has changed.
    if( (page != m_currentPage) || (newPos != m_position) )
    {
        m_currentPage = page;
        m_position = newPos;
        SetModifiedFlag();
        InvalidateControl();
    }
}

/*************************************************************************

Set the position and the zoom.  The end result of this function is
identical to calling SetZoom( zoom ) and then SetPosition( x, y ).  The
two are put together so that the control need only be invalidated once.
This is useful for zooming either in a selected area or to keep the
image on the screen centered.

*************************************************************************/

void CSilxScreenCtrl::SetZoomAndModalPosition(double zoom, long x, long y) 
{
    if( !NumPages() )
    {
        return;
    }


    //////////////////////////////////////////////////////////////////////
    //
    // With the exception of the zoomChanged flag, this section is the
    // same as SetZoomFactor().

    bool zoomChanged = false;

    zoom = forceZoomInBounds( zoom );

    if( zoom != m_zoom )
    {
        zoomChanged = true;

        m_zoom = zoom;

        // If the zoom changes, our cached images are useless.
        for( UInt32 page = 0; page < NumPages(); ++page )
        {
            clearPage( page );
        }
    }
    // Done setting zoom.
    //
    //////////////////////////////////////////////////////////////////////

    //////////////////////////////////////////////////////////////////////
    //
    // Find the new position.

    UInt32 page = m_currentPage;

    y = this->convertModalScreenYToY( y, &page );

    // Find the amount of space between pages in raw image pixels.  We have
    // to remember to include the page-break space in the page heights.
    const Int32 zpbs = round(Float64(m_pageBreakSpace) / m_zoom);

    // JBTODO -- We should handle this in a mannor that will work properly
    // if the pages are different widths.

    x = round( x / m_zoom );
    x = std::_cpp_min( x, getOrientedPageSize(page,m_orientation).getX() + zpbs );
    x = std::_cpp_max( x, 0L );        

    const Point32 newPos( x, y );

    // Done setting position.
    //
    //////////////////////////////////////////////////////////////////////

    // If something has changed, we must invalidate the control.
    if( (page != m_currentPage) || (newPos != m_position) || zoomChanged )
    {
        m_currentPage = page;
        m_position = newPos;
        SetModifiedFlag();
        InvalidateControl();
    }
}

/*************************************************************************

Set absolute x position.  We need this in addition to SetPosition()
because rounding errors potentially mean there is no way to set x without
causing a change in y.

x is in screen pixels.

*************************************************************************/

void CSilxScreenCtrl::SetXPosition(long x) 
{
    if( !NumPages() )
    {
        return;
    }

    // x must be positive.
    x = std::_cpp_max( x, 0L );

    // Scale x to raw image pixels.
    x = round( x / m_zoom );

    // Make sure x is on the page.
    x = std::_cpp_min( x, getOrientedPageSize(m_currentPage, m_orientation).getX() );

    // If the x position has changed, invalidate the control.
    if( x != m_position.getX() )
    {
        m_position.setX(x);
        SetModifiedFlag();
        InvalidateControl();
    }
}


/*************************************************************************

Set absolute y position.  We need this in addition to SetPosition()
because rounding errors potentially mean there is no way to set y without
causing a change in x.

y is in screen pixels.

*************************************************************************/

void CSilxScreenCtrl::SetYPosition(long y) 
{
    if( !NumPages() )
    {
        return;
    }

    // Make sure these are on the document.
    y = std::_cpp_max( y, 0L );

    // Find out what page we are on.
    
    UInt32 page;

    for( page = 0;page < NumPages(); ++page )
    {
        const UInt32 pageHeight = (getOrientedPageSize(page,m_orientation).getY()*m_zoom) + m_pageBreakSpace;
        
        if( y < pageHeight )
        {
            break;
        }

        y -= pageHeight;
    }

    // Scale y into raw image pixels.

    y = round( y / m_zoom );

    // Are we off the bottom of the document?
    if( page == NumPages() )
    {
        --page;
    }

    // Find the amount of space between pages in raw image pixels.  We have
    // to remember to include the page-break space in the page heights.
    const Int32 zpbs = round(Float64(m_pageBreakSpace) / m_zoom);

    // Now that we have found the page, make sure y is on it.
    y = std::_cpp_min( y, getOrientedPageSize(page, m_orientation).getY() + zpbs );

    // If something has changed then we must invalidate the control.
    if( (page != m_currentPage) || (y != m_position.getY()) )
    {
        m_currentPage = page;
        m_position.setY(y);
        SetModifiedFlag();
        InvalidateControl();
    }
}


void CSilxScreenCtrl::SetModalYPosition(long y) 
{
    if( !NumPages() )
    {
        return;
    }

    if( m_viewMode == ViewContinuous )
    {        
        SetYPosition( y );
    }
    else //thus( m_viewMode == ViewOnePage )
    {    
        // Scale y into raw image pixels.
        y = round( y / m_zoom );

        // Find the amount of space between pages in raw image pixels.  We have
        // to remember to include the page-break space in the page heights.
        const Int32 zpbs = round(Float64(m_pageBreakSpace) / m_zoom);

        // Make sure these are on the page.
        y = std::_cpp_max( y, 0L );

        y = std::_cpp_min( y, getOrientedPageSize(m_currentPage,m_orientation).getY() + zpbs );

        // If something has changed then we must invalidate the control.
        if( y != m_position.getY() )
        {
            m_position.setY(y);
            SetModifiedFlag();
            InvalidateControl();
        }
    }

}


/*************************************************************************

Get the absolute x position in screen pixels.  The x "position" is the
x cordinate of the image that is in the upper-left-hand corner of the
viewing area.

*************************************************************************/

long CSilxScreenCtrl::GetXPosition() 
{
    return GetPageX();
}

/*************************************************************************

Get the absolute x position in screen pixels.  The y "position" is the
y cordinate of the image that is in the upper-left-hand corner of the
viewing area.

*************************************************************************/

long CSilxScreenCtrl::GetYPosition() 
{
    Int32 yPos = 0;

    for( UInt32 page = 0; page < m_currentPage; ++page )
    {
        yPos += (getOrientedPageSize(page,m_orientation).getY() * m_zoom );
    }

    yPos += (m_position.getY() * m_zoom );
    yPos += (m_currentPage * m_pageBreakSpace );

    return yPos;
}

/*************************************************************************

Returns the total width of the document.

JBTODO:  Right now this only returns the width of the current page!

*************************************************************************/

long CSilxScreenCtrl::GetTotalWidth( void )
{
    UInt32 total = 0;

    //JBTODO:  This is kluge because pages could have different widths!

    if( NumPages() )
    {
        total = getOrientedPageSize(m_currentPage,m_orientation).getX();
        total *= m_zoom;
        total += m_pageBreakSpace;
    }

	return total;
}

/*************************************************************************

  Returns the total height of the document in screen pixels.  The "total"
  includes all pages together with page break space.  This is very useful
  for scrolling.

*************************************************************************/

long CSilxScreenCtrl::GetTotalHeight( void )
{
    Int32 total = 0;

    for( UInt32 page = 0; page < NumPages(); ++page )
    {
        total += (getOrientedPageSize(page,m_orientation).getY() * m_zoom );
    }

    total += (NumPages() * m_pageBreakSpace);
    
	return total;
}

/*************************************************************************

 PurgeAllData() frees all dynamic memory associated with the control.  It
 also sets state variables to be consistent with there being no file.

*************************************************************************/

void CSilxScreenCtrl::PurgeAllData( void ) 
{
    {for( UInt32 pg=0; pg < m_pgs.size(); ++pg )
    {
        delete m_pgs[pg]; m_pgs[pg] = NULL;
    }}

    m_pgs.resize(0);

    m_fileName.Empty();
    delete m_file; m_file = NULL;

    m_currentPage = 0;
    m_position = Point32(0,0);
}

/*************************************************************************

Return the width of the current page in screen pxiels.

*************************************************************************/

long CSilxScreenCtrl::GetCurrentPageWidth( void )
{
    long width = 0;

    if( NumPages() )
    {
        width = getOrientedPageSize(m_currentPage, m_orientation).getX();
        width *= m_zoom;
    }

    return width;
}

/*************************************************************************

Return the height of the current page in screen pxiels.

*************************************************************************/

long CSilxScreenCtrl::GetCurrentPageHeight( void )
{
    long height = 0;

    if( NumPages() )
    {
        height = getOrientedPageSize(m_currentPage,m_orientation).getY();
        height *= m_zoom;
    }

    return height;
}


/*************************************************************************

Return the height of the document taking into account the current view
mode.  If we are viewing one page then this is the height of that page.
If we are viewing continuous, then this is total height.

This is very useful for writing the application layer.  There is a lot
of UI code that needs either the height of a page or the height of the
entire document, depending on the mode.  Using the modal height, modal
width, and modal postion allows many application layer functions to
be written without any conditional logic.

*************************************************************************/

long CSilxScreenCtrl::GetModalHeight( void ) 
{
    long height = 0;

    switch( m_viewMode )
    {
        case ViewContinuous: height = GetTotalHeight();       break;
        case ViewOnePage   : height = GetCurrentPageHeight(); break;
        default: break;

    }

    return height;
}

/*************************************************************************

Return the width of the document taking into account the current view
mode.  If we are viewing one page then this is the width of that page.
If we are viewing continuous, then this is total width.

*************************************************************************/

long CSilxScreenCtrl::GetModalWidth( void )
{
    long width = 0;

    switch( m_viewMode )
    {
        case ViewContinuous: width = GetTotalWidth();       break;
        case ViewOnePage   : width = GetCurrentPageWidth(); break;
        default: break;

    }

    return width;
}

/*************************************************************************

Get the x position of the upper left-hand corner of the document relative
to the current view mode.  At present, there is no difference between this
and GetXPosition().

*************************************************************************/

long CSilxScreenCtrl::GetModalXPosition() 
{
    return GetPageX();
}

/*************************************************************************

Get the y position of the upper left-hand corner of the document relative
to the current view mode.  In continuous mode, this is just the y position.
In single page mode, this is the position relative to the top of the
current page.

*************************************************************************/

long CSilxScreenCtrl::GetModalYPosition() 
{
    long yPos = 0;

    switch( m_viewMode )
    {
        case ViewContinuous:
        {
            yPos = GetYPosition();
        }
        break;
        
        case ViewOnePage: 
        {
            yPos = GetPageY();
        }
        break;
        
        default: break;
    }

    return yPos;
}



/*************************************************************************

 Although we generally avoid implementing UI within the control, it turns
 out to be very convenient to be able to set the mouse curose for the
 control from the outside application.

*************************************************************************/

void CSilxScreenCtrl::SetHandCursor()    {SetCursor(AfxGetApp()->LoadCursor(IDC_HAND));}
void CSilxScreenCtrl::SetGrabCursor()    {SetCursor(AfxGetApp()->LoadCursor(IDC_GRAB));}
void CSilxScreenCtrl::SetZoomToolCursor(){SetCursor(AfxGetApp()->LoadCursor(IDC_ZOOM));}
void CSilxScreenCtrl::SetDefaultCursor() {SetCursor(AfxGetApp()->LoadStandardCursor(IDC_ARROW));}


/*************************************************************************

m_extraPageCacheSize is in megabytes.

*************************************************************************/

void CSilxScreenCtrl::OnExtraPageCacheSizeChanged( void ) 
{
    m_extraPageCacheSize = std::_cpp_max( m_extraPageCacheSize, 0L );
    SetModifiedFlag();
}

void CSilxScreenCtrl::OnViewModeChanged( void )
{
    // Force the ViewMode to be valid.
    if( m_viewMode > MaxViewMode )
    {
        m_viewMode = ViewContinuous;
    }

    // In continuous view mode we need to look at the composite and
    // we have to have the orientation set to 0.
    if( m_viewMode != ViewOnePage )
    {
        SetLayer( 0 );
    }

    SetModifiedFlag();
    InvalidateControl();    
}

/*************************************************************************

The units of this threshold are megabytes.

*************************************************************************/

void CSilxScreenCtrl::OnFullPageCacheThresholdChanged( void )
{
    m_fullPageCacheThreshold = std::_cpp_max( m_fullPageCacheThreshold, 0L );
	SetModifiedFlag();
}

/*************************************************************************

The units of m_pageBreakSpace space are screen pixels.  It's value must
be non-negative.

*************************************************************************/

void CSilxScreenCtrl::OnPageBreakSpaceChanged( void ) 
{
    m_pageBreakSpace = std::_cpp_max( m_pageBreakSpace, 0L );  
	SetModifiedFlag();
  	InvalidateControl();
}


/*************************************************************************

Pass mouse wheel events through to the application.  This does not happen
by default, nor is there a stock event for it.

*************************************************************************/

BOOL CSilxScreenCtrl::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt) 
{
    this->FireMouseWheel( nFlags, zDelta, pt.x, pt.y );    
    
	return COleControl::OnMouseWheel(nFlags, zDelta, pt);
}


/*************************************************************************

Put the portion of the image in the specified rectangle onto the
clipboard.  top, left, bottom, and right are in screen pixels.

*************************************************************************/

long CSilxScreenCtrl::
CopyToClipboardTLBR( long top, long left, long bottom, long right )
{
    DWORD err = 0;

    // If we have no pages, there is nothing to draw.
	if( !this->NumPages() )
    {
        return err;
    }

	// If we cannot open the clibboard, something is very wrong.
    if( !this->OpenClipboard() )
    {
        assert(NULL);
    }

    // We must empty the clipboard before using it.
	if( !::EmptyClipboard() )
    {
        assert(NULL);
    }

	// This may not be the best way to do this, but it seemed the
	// easiest.  We created a windows metafile and assciated drawing
	// context.  Then we just draw to it like it was the screen.
    CMetaFileDC cMfDc;

    if( !cMfDc.CreateEnhanced( NULL, NULL, NULL, NULL ) )
    {
        assert( NULL );
    }

    // Bounds represents the region we want to fill in.  Remember that
	// bounds is translationally invariant.  The drawing functions assume
	// the upper-left corner of bounds is the origin of the window.  Thus,
	// there is no need to modify the top, left, bottom, and right values
	// that we were passed.
	Rect bounds;
    bounds.setTLBR( top, left, bottom, right );
    
    // pos is the position of the top-left corner of our box on the current
	// page in raw-image coordinates.
	Point32 pos( m_position );

    pos += Point32( left/m_zoom, top/m_zoom );

    Draw( &cMfDc, bounds, bounds, m_currentPage, pos, m_zoom,
          m_orientation, true, m_layer,
          static_cast<ViewMode>(m_viewMode) );
    
    HENHMETAFILE hMF = cMfDc.CloseEnhanced();

    assert( hMF );

    if( !SetClipboardData( CF_ENHMETAFILE, hMF ) )
    {
        assert(NULL);
    }
    
    ::CloseClipboard(); 

    ::DeleteEnhMetaFile( hMF );

    return err;
}


/*************************************************************************

Copy the entire requested page to the clipboard.

*************************************************************************/

long CSilxScreenCtrl::CopyPageToClipboard( long page )
{
    // If we have no pages, there is nothing to draw.
	if( !NumPages() )
	{
		return -1;
	}
	
	DWORD err = 0;
    
	// Convert from 1-based to zero-based.
    --page;

	// If the page is out of range, there is nothing to do.
    if( (page < 0) || (page >= NumPages()) )
    {
        return err;
    }

	// If we cannot open the clibboard, something is very wrong.
    if( !this->OpenClipboard() )
    {
        assert(NULL);
    }

    // We must empty the clipboard before using it.
    if( !::EmptyClipboard() )
    {
        assert(NULL);
    }


	// This may not be the best way to do this, but it seemed the
	// easiest.  We created a windows metafile and assciated drawing
	// context.  Then we just draw to it like it was the screen.
	CMetaFileDC cMfDc;

    if( !cMfDc.CreateEnhanced( NULL, NULL, NULL, NULL ) )
    {
        assert( NULL );
    }
    
    // Create a bounds rectangle that matches the entire page.
	Rect bounds( getOrientedPageSize(page,m_orientation) );

    bounds.scaleUp( m_zoom );
    
	Draw( &cMfDc, bounds, bounds, page, Point32(0,0), m_zoom,
          m_orientation, false, m_layer, ViewOnePage );
    
    HENHMETAFILE hMF = cMfDc.CloseEnhanced();

    assert( hMF );

    if( !SetClipboardData( CF_ENHMETAFILE, hMF ) )
    {
        assert(NULL);
    }
    
    ::CloseClipboard(); 

    ::DeleteEnhMetaFile( hMF );

    return err;
}


/*************************************************************************

 Because of the different view modes, positions sometimes have confusing
 meanings.  GetPageForPosition allows us to turn a modal position to a
 page number.

*************************************************************************/

long CSilxScreenCtrl::GetPageForPosition(long x, long y) 
{
	if( !NumPages() )
	{
		return 0;
	}

    UInt32 page = m_currentPage;
    
    if( m_viewMode == ViewContinuous )
    {
        convertModalScreenYToY( y, &page );
    }

    // Change from 0-based to 1-based paging.
	return page + 1;
}

/*************************************************************************

Get the X position relative to the current page.  This is not the same as
GetXPosition().

*************************************************************************/

long CSilxScreenCtrl::GetPageX() 
{
    Int32 xPos = 0;

    if( NumPages() )
    {
        xPos = m_position.getX();
        xPos = round(xPos * m_zoom);
    }

    return xPos;
}

/*************************************************************************

Get the Y position relative to the current page.  This is not the same as
GetYPosition().

*************************************************************************/

long CSilxScreenCtrl::GetPageY() 
{
    Int32 yPos = 0;

    if( NumPages() )
    {
        yPos = m_position.getY();
        yPos = round(yPos * m_zoom);
    }

    return yPos;
}


long CSilxScreenCtrl::GetLayer() 
{
	return NumPages()?  m_layer  :  0;
}

void CSilxScreenCtrl::SetLayer(long nNewValue) 
{
    nNewValue = std::_cpp_max( nNewValue, 0L );

    if( nNewValue != m_layer )
    {
        m_layer = nNewValue;
        SetModifiedFlag();
        InvalidateControl();
    }
}

long CSilxScreenCtrl::LayersOnCurrentPage( void ) 
{
    return LayersOnPage( GetCurrentPage() );
}

long CSilxScreenCtrl::LayersOnPage(long page) 
{
    // Change from 1-based to 0-based.
	--page;

	Int32 layers = 0;

    // page must be in-bounds.
	if( (page >= 0) && (page < NumPages()) )
    {
        layers = m_file->getPage(page)->getNumLayers();
    }

	return layers;
}


BSTR CSilxScreenCtrl::GetFileVersion( void ) 
{
	CString strResult( STRFILEVER );

	return strResult.AllocSysString();
}

BSTR CSilxScreenCtrl::GetBuildDate() 
{
	CString strResult( __DATE__ );

    strResult += " ";
    strResult += __TIME__;

	return strResult.AllocSysString();
}


long CSilxScreenCtrl::
PrintLayerFromTo( long hdc, long layer, long fromPage, long toPage ) 
{
	if( !NumPages() || !hdc )
	{
		return -1;
	}

	// Convert from 1-based to 0-based page numbers.

	--fromPage;
	--toPage;

	// For pages to be in-bounds.

	fromPage = std::_cpp_max( fromPage, 0L );
	toPage   = std::_cpp_max(   toPage, 0L );

	fromPage = std::_cpp_min( fromPage, long(NumPages() - 1) );
	toPage   = std::_cpp_min(   toPage, long(NumPages() - 1) );

	CDC cdc;
	
	cdc.Attach( reinterpret_cast<HDC>(hdc) );

	cdc.SetMapMode( MM_TEXT );

	int err = 0;

	DOCINFO di;

    di.cbSize = sizeof(DOCINFO);     
    di.lpszDocName = m_fileName;
    di.lpszOutput = NULL;     
    di.lpszDatatype = NULL; 
    di.fwType = 0;

    char vIn[] = "Xerox CEF Driver";

	// Check to see if we are talking to a tfx printer.
    if( cdc.Escape( QUERYESCSUPPORT, sizeof(vIn), vIn, 0, NULL ) )
    {
		// If so, we use our pass-through method of printing.

		err = cdc.Escape( 0xdeadbeaf, m_fileName.GetLength(), m_fileName, 0, NULL );

		if( err != 1 )
		{
			return -1;
		}
        
        err = cdc.StartDoc( &di );

		if( err < 0 )
		{
			cdc.AbortDoc();
			return err;
		}        
		
		err = cdc.EndDoc();

		if( err < 0 )
		{
			cdc.AbortDoc();
			return err;
		}    
	}
	else
	{
		// Otherwise, we use GDI.

		err = cdc.StartDoc( &di );

		if( err < 0 )
		{
			cdc.AbortDoc();
			return err;
		}
	
		Rect viewPort( cdc.GetDeviceCaps(HORZRES), cdc.GetDeviceCaps(VERTRES) );

		for( UInt32 page = fromPage; page <= toPage; ++page )
		{
			err = cdc.StartPage();

			if( err < 0 )
			{
				cdc.AbortDoc();
				return err;
			}
			
			const Float64 xZoom = Float64(viewPort.width()) / Float64(getPage(page)->getSize().getX());
			const Float64 yZoom = Float64(viewPort.height()) / Float64(getPage(page)->getSize().getY());

			Float64 zoom = std::_cpp_min(xZoom, yZoom);

			if( (zoom > 0.98) && (zoom < 1.02) )
			{
				zoom = 1;
			}

			Draw( &cdc, viewPort, viewPort, page, Point32(0,0), zoom,
                  Orient_0, false, layer, ViewOnePage );

			err = cdc.EndPage();

			if( err < 0 )
			{
				cdc.AbortDoc();
				return err;
			}
		}

		err = cdc.EndDoc();

		
		if( err < 0 )
		{
			cdc.AbortDoc();
			return err;
		}
	}

	return 0;
}

/*************************************************************************

Export the desired page and layer at zoom to the specified file as a
Windows DIB (.bmp) file.

**************************************************************************/

long CSilxScreenCtrl::
SavePageAsBmp(LPCTSTR fileName, long page, long layer, double zoom) 
{
	// Convert from 1-based to 0-based.
	--page;

	if( page >= NumPages() ) { return 0; }
	
	// Make sure zoom is legal.
	zoom = forceZoomInBounds( zoom );
	
	// In addition to the normal constraints, we do not allow exporting
	// zoomed-in.  The reason is that this is basically just a waste
	// of memory.
	zoom = std::_cpp_min( zoom, 1.0 );

	FILE * bmpFile = _tfopen( fileName, "w+b" );

	if( !bmpFile )
	{
		return -1;
	}
	
	
	// We are exporting the whole page, so make a region based on the
	// entire page.
	Rect region( getPage(page)->getSize() );

    // We need to request the region in the zoomed down coordinate system.
    // Note that since zoom <= 1, scaleUp(zoom) will make
    // region smaller.  Note that we are not being super careful about the
    // effects of rounding.  I think that for certain choices of zoomFactor
    // we will lose a pixel.  This should not really be noticeable.
    region.scaleUp( zoom );

    // If the region is empty there is nothing to do.
    if( !region.isEmpty() )
    {
        DibImgBuf img;

        TfxPage * const tfxPg = getPage(page)->getTfxPage();

        assert( tfxPg );
            
        CWaitCursor wait; // This could be a while; show the hourglass.

        // Render the page 
		tfxPg->render( &img, region, 1.0/zoom, layer );

		// We will need to write the pallette out to the .bmp file.  We must figure
		// out how big it is.  For 24-bit color, it is empty.
		Int32 palSize =  0;
		
		if( img.getBmpInfo().bmiHeader.biBitCount == 1 )
		{
			// For 1-bit color we need two colors in the pallette.
			palSize = 2 * sizeof(RGBQUAD);
		}
		else if( img.getBmpInfo().bmiHeader.biBitCount == 8 )
		{
			// For 8-bit color we need 256 colors.
			palSize = 256 * sizeof(RGBQUAD);
		}

		// Many windows apps do not like top-down bitmaps.  Flip the thing over if
		// it is top-down.
		if( img.isTopDown() )
		{
			img.flipData();
		}

		// Create the file-header for the .bmp file.
		BITMAPFILEHEADER bmfh;

		bmfh.bfType = 'MB';  // 'MB' is a magic word giving file type.
		bmfh.bfSize = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + palSize + img.dataSize();
		bmfh.bfReserved1 = 0; // Always 0.
		bmfh.bfReserved2 = 0; // Always 0.
		bmfh.bfOffBits = sizeof(BITMAPFILEHEADER)  + sizeof(BITMAPINFOHEADER) + palSize;

		// write the header.
		fwrite( &bmfh, 1, sizeof(bmfh), bmpFile );
		
		// write the pallette.
		fwrite( &(img.getBmpInfo().bmiHeader), 1, sizeof(BITMAPINFOHEADER) + palSize, bmpFile );				
		
		// write the data.
		fwrite( img.data(), 1, img.dataSize(), bmpFile );
	}

	fclose( bmpFile ); bmpFile = NULL;

	return 0;
}


long CSilxScreenCtrl::ConvertTiff2Tfx(LPCTSTR TiffFile, LPCTSTR TfxFile)
{
	CWaitCursor wait;

	Tiff2Tfx( TiffFile, TfxFile );

	return 0;
}

BOOL CSilxScreenCtrl::GetIsTiff( void )
{
	return BOOL( dynamic_cast<TifFile *>(m_file) );
}


BOOL CSilxScreenCtrl::GetIsSilx( void ) 
{
	return BOOL( dynamic_cast<MrcFile *>(m_file) );
}

long CSilxScreenCtrl::GetOrientation( void ) 
{
	return m_orientation;
}

void CSilxScreenCtrl::SetOrientation( long nNewValue ) 
{
    Orientation newOrient = Int2Orient( nNewValue );

    // Only allow orientation to be modified if the new value is
    // valid and actually different from the old one.
    if( (m_orientation != newOrient) && (OrientIsValid(newOrient)) )
    {
        m_orientation = newOrient;
        SetModifiedFlag();
        InvalidateControl();
    }
}


void CSilxScreenCtrl::
SetOrientationAndPagePosition( short orientation, long x, long y ) 
{
    if( !NumPages() )
    {
        return;
    }

    const Orientation orient = Int2Orient( orientation );

    // Only make any changes at all if the orientation is valid.
    if( OrientIsValid(orient) )
    {
        // Scale x and y to the current zoom.
        x = round( x / m_zoom );
        y = round( y / m_zoom );

        // Force x and y to be inbounds.

        x = std::_cpp_min( x, getOrientedPageSize(m_currentPage,orient).getX() + m_pageBreakSpace );
        y = std::_cpp_min( y, getOrientedPageSize(m_currentPage,orient).getY() + m_pageBreakSpace );
        
        x = std::_cpp_max( x, 0L );        
        y = std::_cpp_max( y, 0L );        

        const Point32 newPos = Point32( x, y );

        // Update position and orientation with new values if anything has changed.
        if( (m_orientation != orient) || (newPos != m_position) )
        {        
            m_position    = newPos;
            m_orientation = orient;

            SetModifiedFlag();
            InvalidateControl();
        }
    }
}


//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

CSilxScreenCtrl::Page::
Page( Asd::UInt32 pageNum, TfxFile * file )
:
m_file( file ),
m_pageNum( pageNum ),
m_zoom( 1 ),
m_colorDepth( COLOR_DEPTH_ERROR )
{
}

/*************************************************************************

Get rid of any data that has been cached.  Basically, this 
just means we get rid of the image.  This makes it possible
to keep a page object around as a proxy even if you do not
want the cached data.

*************************************************************************/

void CSilxScreenCtrl::Page::clear( void )
{
    m_img.clear();
    m_renderedRegion.setEmpty();
}

/*************************************************************************

Retrieve the TfxPage object corresponding this this page.  This
can end up being NULL, although only if the Page object was
improperly initialized.  That is, if the TfxFile passed into
the constructor is valid, and the pageNum passed is inbounds,
getTfxPage() will return a valid pointer.

*************************************************************************/

TfxPage * CSilxScreenCtrl::Page::getTfxPage( void ) const
{
    return m_file? m_file->getPage(m_pageNum) : NULL;
}

/*************************************************************************

  Returns the size of the page in pixels.

*************************************************************************/

Asd::Point32 CSilxScreenCtrl::Page::getSize( void ) const
{
    return m_file? m_file->getPageSize(m_pageNum) : Point32();
}

/*************************************************************************

Returns the number of bytes need to render the image at the lesser of its
raw color depth and the value passed in.

This is "approxBytesNeeded()" and not simply "bytesNeeded()"
because we wanted a simple function to figure out whether a
page should be cached.  approxBytesNeeded() just looks at the
zoom, height, width, and color depth.  It ignores alignment
issues.  It also uses floating point math.  We simply do not
need the extra precision.	

*************************************************************************/

Float64 CSilxScreenCtrl::Page::
approxBytesNeeded( Float64 zoom, ColorDepth cd ) const
{
    // memNeeded is in bytes.
	//
    Float64 memNeeded = 0;

    if( m_file )
    {
        memNeeded = std::_cpp_min( cd, getTfxPage()->getColorDepth() );

		// Black and white documents are rendered as grey-scale if zoom
		// is less than 1.
		if( (memNeeded == 1) && (zoom < 1) )
		{
			memNeeded = 8;
		}

        // The factor of 8 turns bits into bytes.
        memNeeded /= 8.0;

        Rect pgRect( this->getSize() );

        if( zoom < 1 )
        {
            pgRect.scaleUp( zoom );
        }

        memNeeded *= pgRect.area();
    }

    return memNeeded;
}


/*************************************************************************

The current amount of memory being used by m_img.  This
value is exact because we can just look at the array.

*************************************************************************/

Float64 CSilxScreenCtrl::Page::currentBytesNeeded( void ) const
{
    return this->m_img.dataSize();
}
