VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.MDIForm SilxScreenApp 
   AutoShowChildren=   0   'False
   BackColor       =   &H8000000C&
   Caption         =   "SilxScreen"
   ClientHeight    =   5310
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   7875
   Icon            =   "SilxScreenApp.frx":0000
   LinkTopic       =   "MDIForm1"
   OLEDropMode     =   1  'Manual
   StartUpPosition =   3  'Windows Default
   WhatsThisHelp   =   -1  'True
   Begin MSComDlg.CommonDialog CmDlg 
      Left            =   1455
      Top             =   450
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      Filter          =   "Tiff-FX (*.tfx)|*.tfx|All Files|*.*"
   End
   Begin VB.Menu menuFile 
      Caption         =   "&File"
      Begin VB.Menu menuFileOpen 
         Caption         =   "&Open..."
         Shortcut        =   ^O
      End
      Begin VB.Menu menuFileSep 
         Caption         =   "-"
      End
      Begin VB.Menu menuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu menuTools 
      Caption         =   "&Tools"
      Begin VB.Menu menuToolsConverttifftosilx 
         Caption         =   "Convert Tiff to Silx"
      End
   End
   Begin VB.Menu menuHelp 
      Caption         =   "&Help"
      Begin VB.Menu menuHelpContents 
         Caption         =   "&Contents..."
      End
      Begin VB.Menu menuHelpWhatsthis 
         Caption         =   "&What's This?"
         Shortcut        =   +{F1}
      End
      Begin VB.Menu menuHelpSep 
         Caption         =   "-"
      End
      Begin VB.Menu menuHelpAbout 
         Caption         =   "&About SilxScreen..."
      End
   End
End
Attribute VB_Name = "SilxScreenApp"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
         
' Possible values of SilxCtl.ViewMode

Const VIEW_CONTINUOUS As Integer = 0
Const VIEW_ONE_PAGE As Integer = 1

'Show the user the file open dialog box and open the file they ask for.
'
Function OpenFile()
    
    Me.CmDlg.Filter = "Silx (*.tfx)|*.tfx|TIFF(*.tif;*.tiff)|*.tif;*.tiff|All Files|*.*"
    Me.CmDlg.DefaultExt = "tfx"
    Me.CmDlg.Flags = cdlOFNFileMustExist Or cdlOFNHideReadOnly
    
    Me.CmDlg.ShowOpen

    Me.OpenFileByName Me.CmDlg.fileName
                
End Function

Function Tiff2Silx()

    Me.CmDlg.CancelError = True
    
    On Error GoTo Skip

    Dim tiff, tfx As String
    
    Me.CmDlg.Filter = "Tiff (*.tif;*.tiff)|*.tif;*.tiff|All Files (*.*)|*.*"
    Me.CmDlg.DefaultExt = "tif"
    Me.CmDlg.Flags = cdlOFNFileMustExist Or cdlOFNHideReadOnly
    
    Me.CmDlg.ShowOpen

    tiff = Me.CmDlg.fileName
    
    If (tiff = "") Then
    
        GoTo Skip
        
    End If
    
    Dim dotPos As Long
    
    dotPos = InStrRev(Me.CmDlg.fileName, ".")
    
    If (dotPos > 0) Then
    
        Me.CmDlg.fileName = Left(Me.CmDlg.fileName, dotPos - 1)
        
    End If
    
    Me.CmDlg.fileName = Me.CmDlg.fileName & ".tfx"
    
    
    Me.CmDlg.Filter = "Silx (*.tfx)|*.tfx|All Files|*.*"
    Me.CmDlg.DefaultExt = "tfx"
    Me.CmDlg.Flags = cdlOFNHideReadOnly Or cdlOFNOverwritePrompt
    
    Me.CmDlg.ShowSave
    
    tfx = Me.CmDlg.fileName

    Dim cap As String
    
    cap = Me.Caption
    
    Me.Caption = "Compressing """ & tiff & """ ... Please wait."
    
    SilxForm.SilxCtl.ConvertTiff2Tfx tiff, tfx
    
    Me.Caption = cap
    
    Me.OpenFileByName tfx
    
Skip:

End Function

'Open the file named as the argument.  Passing an empty string is a
'noop.
'
'File comes up in ViewMode = VIEW_ONE_PAGE.
'
'Files come up fit to the page width.
'
Function OpenFileByName(fileName As String)
    
    If Not (fileName = "") Then
        
        Dim dr As New SilxDoc
        
        dr.Show
        
        ' Remove any leading or trailing white space.
        '
        fileName = Trim(fileName)
        
        ' remove quotes, if any.
        '
        If (Left(fileName, 1) = """") Then
        
            fileName = Right(fileName, Len(fileName) - 1)
            
        End If
        
        If (Right(fileName, 1) = """") Then
        
            fileName = Left(fileName, Len(fileName) - 1)
            
        End If
               
        ' Attempt to open the file.
        '
        dr.SilxCtl.fileName = fileName
        
        ' We know the opening has failed if there are no pages.
        '
        If (dr.SilxCtl.NumPages() = 0) Then
                
            Unload dr
            MsgBox """" & fileName & """ is not a valid Silx file."
            
        Else
        
            dr.Caption = fileName
            dr.FitToWidth

        End If
                                                
    End If

End Function

Private Sub MDIForm_Load()

    ' This seems to me to be a kluge to make this work.  I am under the impression that
    ' I should not be having to fish for the application path to do this.  That is,
    ' HtmlHelp should look in the directory that SilxScreen.exe is in.  Apparently,
    ' however, it looks in the current directory.  Thus, in order to portably find
    ' our help file, we must find the application path dynamically.  Lucky for us,
    ' this is pretty easy.
    '
    App.HelpFile = (App.Path + "\help\SilxScreen.chm")
    
    ' Set my size to something reasonable.  There is no particular reason for
    ' my choice.
    '
    Me.Move Me.Left, Me.Top, 9000, 12600
    
    ' Open file given to us on the command line.
    
    If (Len(Command()) > 0) Then
    
        OpenFileByName Command()
    
    End If
    
End Sub

Private Sub menuFileExit_Click()

    Unload Me

End Sub

Private Sub menuFileOpen_Click()

    Me.OpenFile

End Sub

Private Sub MDIForm_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    
    If Data.GetFormat(vbCFFiles) Then
    
        Dim file As Variant
        
        For Each file In Data.Files
            
            Dim fileName As String
            Dim extension As String
            Dim dotPos As Integer
            
            fileName = file
            
            Me.OpenFileByName fileName
        
        Next file
    
    End If

End Sub

Private Sub menuHelpAbout_Click()

    AboutBox.Show 1

End Sub

Private Sub menuHelpContents_Click()
    
    Help.DisplayHelpContents

End Sub

Private Sub menuHelpWhatsthis_Click()
        
    Me.WhatsThisMode

End Sub

Private Sub menuToolsConverttifftosilx_Click()

    Me.Tiff2Silx

End Sub
