/* SilxScrLiteCtl.h : Declaration of the CSilxScrLiteCtl */

#ifndef __SILXSCRLITECTL_H_
#define __SILXSCRLITECTL_H_

#include "resource.h"       /* main symbols */
#include <atlctl.h>
#include "DibImgBuf.h"

class TfxFile;
class TfxPage;

/*/////////////////////////////////////////////////////////////////////////// */
/* CSilxScrLiteCtl */
class ATL_NO_VTABLE CSilxScrLiteCtl : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CStockPropImpl<CSilxScrLiteCtl, ISilxScrLiteCtl, &IID_ISilxScrLiteCtl, &LIBID_SILXSCREENLITELib>,
	public CComControl<CSilxScrLiteCtl>,
	public IPersistStreamInitImpl<CSilxScrLiteCtl>,
	public IOleControlImpl<CSilxScrLiteCtl>,
	public IOleObjectImpl<CSilxScrLiteCtl>,
	public IOleInPlaceActiveObjectImpl<CSilxScrLiteCtl>,
	public IViewObjectExImpl<CSilxScrLiteCtl>,
	public IOleInPlaceObjectWindowlessImpl<CSilxScrLiteCtl>,
	public ISupportErrorInfo,
	public IConnectionPointContainerImpl<CSilxScrLiteCtl>,
	public CComCoClass<CSilxScrLiteCtl, &CLSID_SilxScrLiteCtl>
{
public:

    CSilxScrLiteCtl( void );
    virtual ~CSilxScrLiteCtl( void );

DECLARE_REGISTRY_RESOURCEID(IDR_SILXSCRLITECTL)
DECLARE_NOT_AGGREGATABLE(CSilxScrLiteCtl)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CSilxScrLiteCtl)
	COM_INTERFACE_ENTRY(ISilxScrLiteCtl)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
END_COM_MAP()

BEGIN_PROP_MAP(CSilxScrLiteCtl)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
	PROP_ENTRY("FillColor", DISPID_FILLCOLOR, CLSID_StockColorPage)
	PROP_ENTRY("FillStyle", DISPID_FILLSTYLE, CLSID_NULL)
	/* Example entries */
	/* PROP_ENTRY("Property Description", dispid, clsid) */
	/* PROP_PAGE(CLSID_StockColorPage) */
END_PROP_MAP()

BEGIN_CONNECTION_POINT_MAP(CSilxScrLiteCtl)
END_CONNECTION_POINT_MAP()

BEGIN_MSG_MAP(CSilxScrLiteCtl)
	CHAIN_MSG_MAP(CComControl<CSilxScrLiteCtl>)
	DEFAULT_REFLECTION_HANDLER()
END_MSG_MAP()
/* Handler prototypes: */
/*  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled); */
/*  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled); */
/*  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled); */



/* ISupportsErrorInfo */
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid)
	{
		static const IID* arr[] = 
		{
			&IID_ISilxScrLiteCtl,
		};
		for (int i=0; i<sizeof(arr)/sizeof(arr[0]); i++)
		{
			if (InlineIsEqualGUID(*arr[i], riid))
				return S_OK;
		}
		return S_FALSE;
	}

/* IViewObjectEx */
	DECLARE_VIEW_STATUS(VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE)

/* ISilxScrLiteCtl */
public:
	STDMETHOD(get_NumPages)(/*[out, retval]*/ long *pVal);
	STDMETHOD(LastPage)();
	STDMETHOD(FirstPage)();
	STDMETHOD(PreviousPage)();
	STDMETHOD(NextPage)();
	STDMETHOD(get_CurrentPage)(/*[out, retval]*/ long *pVal);
	STDMETHOD(put_CurrentPage)(/*[in]*/ long newVal);
    STDMETHOD(get_FileName)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_FileName)(/*[in]*/ BSTR newVal);

    HRESULT OnDraw( ATL_DRAWINFO & );

	void DrawWash( ATL_DRAWINFO & );

	void DrawFit( ATL_DRAWINFO &, TfxPage *  );
    
    /* The current file name. */
	_bstr_t m_bstFileName;

    /* The current file.  This may be NULL, indicating no file */
	/* is open. */
	TfxFile * m_file;

    /* If any of the window is not covered by the image, this is the color */
	/* to fill it with. */
	OLE_COLOR m_clrFillColor;
	
	LONG m_nFillStyle; 	/* Currently unused. */

    /* This is the uncompressed image as rendered on the screen. */
	DibImgBuf m_img;

    /* Indicates whether the state of the control has changed in */
	/* such as way as to require re-rendering of the image when */
	/* OnDraw is called. */
	bool m_dirty;

	/* The current page using 0-based numbering. */
    Asd::UInt32 m_currentPage;

};

#endif /*__SILXSCRLITECTL_H_ */
