/* $Header: /project/icons/cvsroot/digipaper/src/libadt/bitfile.h,v 1.14 2000/10/11 18:47:12 dtracy Exp $ */

#ifndef BITFILE_H
#define BITFILE_H

#include <sys/types.h>
#include "util.h"
#include "dgp_state.h"

#ifdef __cplusplus
extern "C"
{
#endif

/* A structure for bit-level access to a file. */
typedef struct {
  Dgp_UInt8 buf;
  Dgp_Int32 bitsinbuf;
  Dgp_UInt8 *iobuf;
  Dgp_UInt8 *cur;
  size_t iobufleft;
  size_t buflen;
#ifdef INSTRUMENT
  Dgp_Int32 *nbits;
#endif
  Dgp_State *dgp_state;
} *DgpAdt_BitFile;

#ifdef INSTRUMENT
#define DGPADT_BFSET_NBITS(f, pnbits) do { (f)->nbits = (pnbits); } while(0)
#endif

DGP_LIBEXPORT ErrCode
DgpAdt_bfNew(DgpAdt_BitFile *f, Dgp_UInt8 *buf, size_t buflen, Dgp_State *dgp_state);

DGP_LIBEXPORT ErrCode
DgpAdt_bfWriteCode(Dgp_UInt32 code, Dgp_Int32 codelen, DgpAdt_BitFile f);

DGP_LIBEXPORT ErrCode
DgpAdt_bfFlush(DgpAdt_BitFile f);

DGP_LIBEXPORT ErrCode
DgpAdt_bfWriteValue(Dgp_UInt32 x, DgpAdt_BitFile f);

/*
 * 22.8.2000 / dhtesq.
 * Profiling indicates this is a good place for an inline.
 */
#ifdef _WIN32
DGP_LIBEXPORT 
#endif
INLINE ErrCode
DgpAdt_bfReadCode(Dgp_UInt32 *code, Dgp_Int32 codelen, DgpAdt_BitFile f);

DGP_LIBEXPORT ErrCode
DgpAdt_bfReadValue(Dgp_UInt32 *x, DgpAdt_BitFile f);

DGP_LIBEXPORT void
DgpAdt_bfFree(DgpAdt_BitFile f, size_t *buf_used);

DGP_LIBEXPORT void
DgpAdt_bfNewBuffer(DgpAdt_BitFile f, Dgp_UInt8 *new_buf, size_t new_buflen);

#ifdef __cplusplus
}
#endif

#endif
