static char rcsid[] = "@(#)$Header: /project/icons/cvsroot/digipaper/src/libadt/test-sbuf.c,v 1.4 2000/03/04 00:22:17 mkrocken Exp $";

#include "seekable_buffer.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define BUFLEN 21
#define COPIES 5

int main() {
  SeekableBuffer s2,s;

  int i;
  char data[] = "Lots of data here!\n";
  char *buffer, *buffer2;
  unsigned int buflen = BUFLEN;
  unsigned int len_written;
  int dlen;
  char *buf;
  char *blank;
  long pos;
  allocators a = {malloc,free,calloc,realloc};

  dlen = strlen(data);

  if (!(buffer = (char *)malloc(buflen))) {
    fprintf(stderr,"problem allocating buffer.\n");
    return 1;
  }

  if (!(buffer2 = (char *)malloc(buflen))) {
    fprintf(stderr,"problem allocating buffer.\n");
    return 1;
  }

  if (!(blank = (char *)malloc(1))) {
    fprintf(stderr,"problem allocating blank.\n");
    return 1;
  }

  *blank = NULL;

  if (!(s = sbNew(buffer, buflen, &a, FALSE))) {
    fprintf(stderr,"problem in sbNew()\n");
    return 1;
  }
    
  if (!(s2 = sbNew(buffer2, buflen, &a, TRUE))) {
    fprintf(stderr,"problem in sbNew()\n");
    return 0;
  }

  for (i = 0; i < COPIES; i++) {
    pos = sbTell(s);
    if (!sbWrite((void *)data,dlen,1,s))
      fprintf(stdout,"s couldn't write %d bytes at position %ld\n",
	      dlen, pos);
    else
      fprintf(stdout,"s writes %d bytes at position %ld\n",
	      dlen, pos);
    fprintf(stdout,"---------\n");

    pos = sbTell(s2);
    if (!sbWrite((void *)data,dlen,1,s2))
      fprintf(stdout,"s2 couldn't write %d bytes at position %ld\n",
	      dlen, pos);
    else
      fprintf(stdout,"s2 writes %d bytes at position %ld\n",
	      dlen, pos);
    fprintf(stdout,"---------\n");
  }

  /* write a terminating NULL character (just for fun!) */
  if (!sbWrite((void *)blank,1,1,s))
    fprintf(stdout,"s couldn't write %d bytes at position %ld\n",
	    1, sbTell(s));
  else
    fprintf(stdout,"s writes %d bytes at position %ld\n",
	    1, sbTell(s));
  fprintf(stdout,"---------\n");
  if (!sbWrite((void *)blank,1,1,s2))
    fprintf(stdout,"s2 couldn't write %d bytes at position %ld\n",
	    1, sbTell(s2));
  else
    fprintf(stdout,"s2 writes %d bytes at position %ld\n",
	    1, sbTell(s2));
  fprintf(stdout,"---------\n");

  sbGetBuffer(s,&buf,&buflen,&len_written);
  fprintf(stdout,"s's BUFFER (%d bytes allocated, %d written):\n%s:::END\n",
	  buflen,len_written,buf);

  sbGetBuffer(s2,&buf,&buflen,&len_written);
  fprintf(stdout,"s2's BUFFER (%d bytes allocated, %d written):\n%s:::END\n",
	  buflen,len_written,buf);

  return 0;
}
