/*////////////////////////////////////////////////////////////////////////// */
/* */
/*  DigiPaper Codebase */
/*     */
/*  Ranjani Ramamurthy, September 24 1997 */
/* */
/*  Filename: ascii_exts.h */
/* */
/*  Description of whats implemented in this file: */
/* */
/* */
/* */
/* */
/* */
/*///////////////////////////////////////////////////////////////////////// */
#ifndef _ASCII_EXTS_H_
#define _ASCII_EXTS_H_

#include <stdio.h>
#include <stdlib.h>
#include <assert.h> 
#include <icrpub.h> 
#include <token-compress.h>
#include <dgp_state.h>
#include "dgp_types.h"
#include "util.h"
#ifdef __cplusplus
extern "C"
{
#endif

/*#define DGP_LIBEXPORT __declspec(dllexport)  */

typedef struct{
  XDOCData *xdoc_data;
  Dgp_Int32 num_chars;
  Dgp_Int32 num_words;
  Dgp_Int32 *word_lengths;
} TextInfo;

DGP_LIBEXPORT ErrCode ZCreateAsciiExtension(Dgp_State *dgp_state, TextInfo *textInfo, Dgp_Int32* bytelen, Dgp_Int8 **_final_str);

DGP_LIBEXPORT Dgp_Bool ReadXDOCFile(TextInfo *textInfo, Dgp_Int8 *filter);

DGP_LIBEXPORT ErrCode DecodeTextExtension(Dgp_State *dgp_state, Dgp_Int32 length, void *extension, FILE *fp, FILE *fp_pos);

/* Added as textbridge seems to be compiled for some obsolete */
/* version of windows that uses far and near which are constructs */
/* for variables that are obsolete for NT. */

#ifndef far
#define far
#endif 

#include "mmcompress.h"
#ifndef _WIN32 
/* #include "undecl-stdio.h"  */
#endif 

#define DGP_INFO_SIZE    2  /*holds offset size for every token in the */
                            /* dictionary extensions */
typedef struct{ 
 
  /* the Dgp_Allocators */ 
  void * (*malloc)(size_t); 
  void (*free)(void *); 
  void * (*calloc)(size_t, size_t); 
  void * (*realloc)(void *,size_t); 
 
  /* the other variables */ 
  Dgp_Int8*   zstr; 
  Dgp_Int32     bytelen; 
  /* the next is a pointer to data allocated in asciiBuilderFunc() 
  and needs to be deallocated. It is deallocated in cleanupAsciiBuilder() 
  */ 
 
  void*  buf_to_be_freed; 
 
} *PosExtAsciiCookie; 
 
#ifdef _WIN32 
PosExtAsciiCookie CreatePosExtAsciiCookie(Dgp_Int8* zstr, 
                      Dgp_Int32 bytelen); 

#endif 

Dgp_Int32 get_bit(Dgp_Int8 val, Dgp_Int32 i); 
void print_bits(Dgp_Int8 *val); 
void assign_bit(Dgp_Int8 *bits, Dgp_Int32 pos, Dgp_Int32 value);
Dgp_Int8 get_byte(Dgp_Int32 value, Dgp_Int32 num); 
 
 
 
#ifdef _WIN32 
#define BYTEMSB    3 
#define BYTEBEFMSB 2     
#define BYTEBEFLSB 1 
#define BYTELSB    0 
#else 
#define BYTELSB    3 
#define BYTEBEFLSB 2 
#define BYTEBEFMSB 1     
#define BYTEMSB    0 
#endif 
 
#define FOURBYTES  4 
#define TWOBYTES   2 
#define ONEBYTE    1 
 
#define NUM_BITS 8 
 
#define TEXT_COMPRESS_VERSION 1 


#ifdef __cplusplus
}
#endif

#endif

/*//////////////////////////////////////////////////////////////////////// */
