/*////////////////////////////////////////////////////////////////////////// */
/* */
/*  DigiPaper Codebase */
/*     */
/*  Ranjani Ramamurthy, January 29, 1998 */
/* */
/*  Filename: dgp_icr.h */
/* */
/*  Description of whats implemented in this file: */
/* */
/* */
/* */
/* */
/* */
/*///////////////////////////////////////////////////////////////////////// */
/* far is set as follows as the icr code uses 'far' which */
/* is defunct on current versions of NT. If you dont do this */
/* you cannot compile the code and will get a 'nonstandard */
/* extension used' error  */
#ifndef _DGP_ICR_H_ 
#define _DGP_ICR_H_ 

#if (defined(_WIN32) && defined(OCR))

#define  far 

#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <string.h>

#include "icr_api.h"
#include "icr_val.h"
#include "icr_reg.h"
#include "icr_syst.h"
#include "icr_text.h"
#include "icr_io.h"
#include "icr_imag.h"
#include "icr_lang.h"
#include "icrproto.h"
#include "icr_errn.h"

#define  DGP_ICR_ERR_RET        -1
#define  DGP_ICR_NORM_RET        0
#define  DGP_ICR_READIMG_OK      1
#define  DGP_ICR_BUF_SIZE       256
#define  DGP_ICR_PERCENT_RD     100
#define  DGP_ICR_DOCOPEN         1
#define  DGP_ICR_DOCCLOSED       0
 
/*extern Dgp_Int32   */
/*ParseXDOCFile(char* filename, XDOCData **doc_data,Dgp_Int32 *arr_sz,  */
/*			  Dgp_Int32* num_words, Dgp_Int32** ret_word_len_array);  */

typedef struct {
  Dgp_Int32 some_recognition_done;
  Dgp_Int32 document_open;
} ProcessFlags;

typedef struct {
  Dgp_Int32  img_format;

  /* Need to figure out if ifname and ofname need to be here */
  /* or moved to the IcrData struct.. will decide later. */

  char*         ifname;		/* Input file name */
  char*         ofname;		/* Output file name <ifname.xdc> */
  char*         filtered_fname; /* filtered XDOC file with pertinent  */
                                /* information.  */
  char*         fp; /* file pointer for filtered_fname */
  IO_TOKEN_T    imiotok;
  IO_TOKEN_T    txtiotok;
} ImageDetails;

typedef struct {
  ICR_INIT_T    icrinit;
  ICR_H         icr_server_handle;
  /* Associated structs.. */
  ImageDetails  img_details;
  ProcessFlags  flags;
} IcrData;

#endif

#endif
