/*
 *
 * $Header: /project/icons/cvsroot/digipaper/src/libblat/blit.h,v 1.4 2000/10/11 18:44:53 dtracy Exp $
 *
 */

#ifndef	DgpBlat_H

#define	DgpBlat_H

#include "dgp_types.h"
#include "image.h"

/* minterms: src = 2, dest = 1 */
#define	DGPBLAT_OP_XOR	0x6	/* 11->0 10->1 01->1 00->0 */
#define	DGPBLAT_OP_AND	0x8	/* 11->1 10->0 01->0 00->0 */
#define	DGPBLAT_OP_XNOR	0x9	/* 11->1 10->0 01->0 00->1 */
#define	DGPBLAT_OP_REPLACE	0xc	/* 11->1 10->1 01->0 00->0 */
#define	DGPBLAT_OP_OR	0xe	/* 11->1 10->1 01->1 00->0 */
#define DGPBLAT_OP_COVER 0x12 /* 11->0 10->0 01->1 00->0 */

extern void 
DgpBlat_blitBitsNoClip(Dgp_UInt32 *dest, Dgp_Int32 destlpl,
			   Dgp_UInt32 *src, Dgp_Int32 srclpl, Dgp_Int32 srcw, Dgp_Int32 srch,
			   Dgp_Int32 xpos, Dgp_Int32 ypos, Dgp_State *dgp_state);

/*
21.8.2000 / dhtesq.
Decoder profiling suggests this is a good place for an inline...
*/
#ifdef _WIN32
DGP_LIBEXPORT
#endif
INLINE void 
DgpBlat_blitBitsClipLR(Dgp_UInt32 *dest, Dgp_Int32 destlpl,
			   Dgp_UInt32 *src, Dgp_Int32 srclpl,
			   Dgp_Int32 minx, Dgp_Int32 srcw, Dgp_Int32 srch,
			   Dgp_Int32 xpos, Dgp_Int32 ypos, Dgp_State *dgp_state);
extern void 
DgpBlat_blitBits(Dgp_UInt32 *dest, Dgp_Int32 destlpl,
		     Dgp_Int32 destminx, Dgp_Int32 destminy, Dgp_Int32 destmaxx, Dgp_Int32 destmaxy,
		     Dgp_UInt32 *src, Dgp_Int32 srclpl, Dgp_Int32 srcw, Dgp_Int32 srch,
		     Dgp_Int32 xpos, Dgp_Int32 ypos, Dgp_State *dgp_state);
extern void 
DgpBlat_blitBitsOp(Dgp_UInt32 *dest, Dgp_Int32 destlpl,
		       Dgp_Int32 destminx, Dgp_Int32 destminy, Dgp_Int32 destmaxx, Dgp_Int32 destmaxy,
		       Dgp_UInt32 *src, Dgp_Int32 srclpl, Dgp_Int32 srcw, Dgp_Int32 srch,
		       Dgp_Int32 xpos, Dgp_Int32 ypos, Dgp_Int32 blitop, Dgp_State *dgp_state);
extern void 
DgpBlat_blitPacked(DgpImage_Packed dest, DgpImage_Packed src, Dgp_Int32 xpos, Dgp_Int32 ypos);

extern void 
DgpBlat_blitPackedOp(DgpImage_Packed dest, DgpImage_Packed src,
			 Dgp_Int32 xpos, Dgp_Int32 ypos, Dgp_Int32 blitop);
extern void 
DgpBlat_blitFillPacked(DgpImage_Packed dest);

#endif
