/*
 * The following code can be used to generate the rest of this file.
 *
 * 25.8.2000 / dhtesq.
 * Added mono->grayscale table.
 */
 
#if 0
/*#include <stdlib.h> */
/*#include <stdio.h> */
/*#include "util.h" */
#include "dgp_state.h"

DGP_RCSID("@(#)$Header: /project/icons/cvsroot/digipaper/src/libblat/blitTables.c,v 1.8 2003/02/10 22:53:19 mkrocken Exp $");

static INLINE Dgp_UInt32 bitcount( Dgp_UInt32 in)
{
	Dgp_UInt32 result = 0, i;
	
	for(i=0; i<(8*sizeof(in)); i++) {
		if( (in >> i) & 0x1) {
			result++;
		}
	}
	
	return result;
}

void main(void)
{
	Dgp_UInt32 i,j;
		
	printf("#include \"endianness.h\"\n");
	printf("#include \"blitTables.h\"\n\n");
	printf("const char blat_bitcounts[256] = {\n");
	
	for(i=0; i<16; i++) {
		printf("\t");
		for(j=0; j<16; j++) {
			if( i==15 && j==15)
				printf("%d", bitcount( i * 16 + j));
			else
				printf("%d, ", bitcount( i * 16 + j));
		}
		printf("\n");
	}

	printf("};\n\n");
	
	printf( "#ifdef _LITTLE_ENDIAN\n");
	printf( "const Dgp_UInt32 monoToRGB8bit[256][6] = {\n");
	for(i=0; i<256; i++) {
		printf( "\t{0x");
		
		if(i & 0x40) printf("00");
		else printf("ff");
		if(i & 0x80) printf("000000, 0x");
		else printf("ffffff, 0x");
		if(i & 0x20) printf("0000");
		else printf("ffff");
		if(i & 0x40) printf("0000, 0x");
		else printf("ffff, 0x");
		if(i & 0x10) printf("000000");
		else printf("ffffff");
		if(i & 0x20) printf("00, 0x");
		else printf("ff, 0x");
	
		if(i & 0x04) printf("00");
		else printf("ff");
		if(i & 0x08) printf("000000, 0x");
		else printf("ffffff, 0x");
		if(i & 0x02) printf("0000");
		else printf("ffff");
		if(i & 0x04) printf("0000, 0x");
		else printf("ffff, 0x");
		if(i & 0x01) printf("000000");
		else printf("ffffff");
		if(i & 0x02) printf("00}");
		else printf("ff}");
		
		if(i!=255) printf(",");
		printf("\n");
	}
	printf("};\n\n");
	
	printf( "\n\nconst Dgp_UInt32 monoToGray8bit[256][2] = {\n");
	for(i=0; i<256; i++) {
		printf( "\t{0x");
		
		if(i & 0x10) printf("00");
		else printf("ff");
		if(i & 0x20) printf("00");
		else printf("ff");
		if(i & 0x40) printf("00");
		else printf("ff");
		if(i & 0x80) printf("00");
		else printf("ff");
		
		
		if(i & 0x01) printf(", 0x00");
		else printf(", 0xff");
		if(i & 0x02) printf("00");
		else printf("ff");
		if(i & 0x04) printf("00");
		else printf("ff");
		if(i & 0x08) printf("00}");
		else printf("ff}");
		
		if(i!=255) printf(",");
		printf("\n");
	}
	printf("};\n\n");
	
	printf("#endif /* _LITTLE_ENDIAN \n\n"); */
	printf("#ifdef _BIG_ENDIAN\n");
	printf("const Dgp_UInt32 monoToRGB8bit[256][6] = {\n");
	for(i=0; i<256; i++) {
		printf( "\t{0x");
		
		if(i & 0x80) printf("000000");
		else printf("ffffff");
		if(i & 0x40) printf("00, 0x0000");
		else printf("ff, 0xffff");
		if(i & 0x20) printf("0000, 0x00");
		else printf("ffff, 0xff");
		if(i & 0x10) printf("000000, 0x");
		else printf("ffffff, 0x");
		
		
		if(i & 0x08) printf("000000");
		else printf("ffffff");
		if(i & 0x04) printf("00, 0x0000");
		else printf("ff, 0xffff");
		if(i & 0x02) printf("0000, 0x00");
		else printf("ffff, 0xff");
		if(i & 0x01) printf("000000}");
		else printf("ffffff}");
	
		if(i!=255) printf(",");
		printf("\n");
	}
		
	printf("};\n\n");

	printf("const Dgp_UInt32 monoToGray8bit[256][2] = {\n");
	for(i=0; i<256; i++) {
		printf( "\t{0x");
		
		if(i & 0x80) printf("00");
		else printf("ff");
		if(i & 0x40) printf("00");
		else printf("ff");
		if(i & 0x20) printf("00");
		else printf("ff");
		if(i & 0x10) printf("00");
		else printf("ff");
		
		
		if(i & 0x08) printf(", 0x00");
		else printf(", 0xff");
		if(i & 0x04) printf("00");
		else printf("ff");
		if(i & 0x02) printf("00");
		else printf("ff");
		if(i & 0x01) printf("00}");
		else printf("ff}");
	
		if(i != 255) printf(",");
		printf("\n");
	}
		
	printf("};\n\n");

    printf("#endif /* _BIG_ENDIAN \n\n"); */
	exit(0);
}

#endif

#include "endianness.h"
#include "blitTables.h"

const char blat_bitcounts[256] = {
	0, 1, 1, 2, 1, 2, 2, 3, 1, 2, 2, 3, 2, 3, 3, 4, 
	1, 2, 2, 3, 2, 3, 3, 4, 2, 3, 3, 4, 3, 4, 4, 5, 
	1, 2, 2, 3, 2, 3, 3, 4, 2, 3, 3, 4, 3, 4, 4, 5, 
	2, 3, 3, 4, 3, 4, 4, 5, 3, 4, 4, 5, 4, 5, 5, 6, 
	1, 2, 2, 3, 2, 3, 3, 4, 2, 3, 3, 4, 3, 4, 4, 5, 
	2, 3, 3, 4, 3, 4, 4, 5, 3, 4, 4, 5, 4, 5, 5, 6, 
	2, 3, 3, 4, 3, 4, 4, 5, 3, 4, 4, 5, 4, 5, 5, 6, 
	3, 4, 4, 5, 4, 5, 5, 6, 4, 5, 5, 6, 5, 6, 6, 7, 
	1, 2, 2, 3, 2, 3, 3, 4, 2, 3, 3, 4, 3, 4, 4, 5, 
	2, 3, 3, 4, 3, 4, 4, 5, 3, 4, 4, 5, 4, 5, 5, 6, 
	2, 3, 3, 4, 3, 4, 4, 5, 3, 4, 4, 5, 4, 5, 5, 6, 
	3, 4, 4, 5, 4, 5, 5, 6, 4, 5, 5, 6, 5, 6, 6, 7, 
	2, 3, 3, 4, 3, 4, 4, 5, 3, 4, 4, 5, 4, 5, 5, 6, 
	3, 4, 4, 5, 4, 5, 5, 6, 4, 5, 5, 6, 5, 6, 6, 7, 
	3, 4, 4, 5, 4, 5, 5, 6, 4, 5, 5, 6, 5, 6, 6, 7, 
	4, 5, 5, 6, 5, 6, 6, 7, 5, 6, 6, 7, 6, 7, 7, 8
};

#ifdef _LITTLE_ENDIAN
const Dgp_UInt32 monoToRGB8bit[256][6] = {
	{0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
	{0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x000000ff},
	{0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x0000ffff, 0xffffff00},
	{0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x0000ffff, 0x00000000},
	{0xffffffff, 0xffffffff, 0xffffffff, 0x00ffffff, 0xffff0000, 0xffffffff},
	{0xffffffff, 0xffffffff, 0xffffffff, 0x00ffffff, 0xffff0000, 0x000000ff},
	{0xffffffff, 0xffffffff, 0xffffffff, 0x00ffffff, 0x00000000, 0xffffff00},
	{0xffffffff, 0xffffffff, 0xffffffff, 0x00ffffff, 0x00000000, 0x00000000},
	{0xffffffff, 0xffffffff, 0xffffffff, 0xff000000, 0xffffffff, 0xffffffff},
	{0xffffffff, 0xffffffff, 0xffffffff, 0xff000000, 0xffffffff, 0x000000ff},
	{0xffffffff, 0xffffffff, 0xffffffff, 0xff000000, 0x0000ffff, 0xffffff00},
	{0xffffffff, 0xffffffff, 0xffffffff, 0xff000000, 0x0000ffff, 0x00000000},
	{0xffffffff, 0xffffffff, 0xffffffff, 0x00000000, 0xffff0000, 0xffffffff},
	{0xffffffff, 0xffffffff, 0xffffffff, 0x00000000, 0xffff0000, 0x000000ff},
	{0xffffffff, 0xffffffff, 0xffffffff, 0x00000000, 0x00000000, 0xffffff00},
	{0xffffffff, 0xffffffff, 0xffffffff, 0x00000000, 0x00000000, 0x00000000},
	{0xffffffff, 0xffffffff, 0x000000ff, 0xffffffff, 0xffffffff, 0xffffffff},
	{0xffffffff, 0xffffffff, 0x000000ff, 0xffffffff, 0xffffffff, 0x000000ff},
	{0xffffffff, 0xffffffff, 0x000000ff, 0xffffffff, 0x0000ffff, 0xffffff00},
	{0xffffffff, 0xffffffff, 0x000000ff, 0xffffffff, 0x0000ffff, 0x00000000},
	{0xffffffff, 0xffffffff, 0x000000ff, 0x00ffffff, 0xffff0000, 0xffffffff},
	{0xffffffff, 0xffffffff, 0x000000ff, 0x00ffffff, 0xffff0000, 0x000000ff},
	{0xffffffff, 0xffffffff, 0x000000ff, 0x00ffffff, 0x00000000, 0xffffff00},
	{0xffffffff, 0xffffffff, 0x000000ff, 0x00ffffff, 0x00000000, 0x00000000},
	{0xffffffff, 0xffffffff, 0x000000ff, 0xff000000, 0xffffffff, 0xffffffff},
	{0xffffffff, 0xffffffff, 0x000000ff, 0xff000000, 0xffffffff, 0x000000ff},
	{0xffffffff, 0xffffffff, 0x000000ff, 0xff000000, 0x0000ffff, 0xffffff00},
	{0xffffffff, 0xffffffff, 0x000000ff, 0xff000000, 0x0000ffff, 0x00000000},
	{0xffffffff, 0xffffffff, 0x000000ff, 0x00000000, 0xffff0000, 0xffffffff},
	{0xffffffff, 0xffffffff, 0x000000ff, 0x00000000, 0xffff0000, 0x000000ff},
	{0xffffffff, 0xffffffff, 0x000000ff, 0x00000000, 0x00000000, 0xffffff00},
	{0xffffffff, 0xffffffff, 0x000000ff, 0x00000000, 0x00000000, 0x00000000},
	{0xffffffff, 0x0000ffff, 0xffffff00, 0xffffffff, 0xffffffff, 0xffffffff},
	{0xffffffff, 0x0000ffff, 0xffffff00, 0xffffffff, 0xffffffff, 0x000000ff},
	{0xffffffff, 0x0000ffff, 0xffffff00, 0xffffffff, 0x0000ffff, 0xffffff00},
	{0xffffffff, 0x0000ffff, 0xffffff00, 0xffffffff, 0x0000ffff, 0x00000000},
	{0xffffffff, 0x0000ffff, 0xffffff00, 0x00ffffff, 0xffff0000, 0xffffffff},
	{0xffffffff, 0x0000ffff, 0xffffff00, 0x00ffffff, 0xffff0000, 0x000000ff},
	{0xffffffff, 0x0000ffff, 0xffffff00, 0x00ffffff, 0x00000000, 0xffffff00},
	{0xffffffff, 0x0000ffff, 0xffffff00, 0x00ffffff, 0x00000000, 0x00000000},
	{0xffffffff, 0x0000ffff, 0xffffff00, 0xff000000, 0xffffffff, 0xffffffff},
	{0xffffffff, 0x0000ffff, 0xffffff00, 0xff000000, 0xffffffff, 0x000000ff},
	{0xffffffff, 0x0000ffff, 0xffffff00, 0xff000000, 0x0000ffff, 0xffffff00},
	{0xffffffff, 0x0000ffff, 0xffffff00, 0xff000000, 0x0000ffff, 0x00000000},
	{0xffffffff, 0x0000ffff, 0xffffff00, 0x00000000, 0xffff0000, 0xffffffff},
	{0xffffffff, 0x0000ffff, 0xffffff00, 0x00000000, 0xffff0000, 0x000000ff},
	{0xffffffff, 0x0000ffff, 0xffffff00, 0x00000000, 0x00000000, 0xffffff00},
	{0xffffffff, 0x0000ffff, 0xffffff00, 0x00000000, 0x00000000, 0x00000000},
	{0xffffffff, 0x0000ffff, 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff},
	{0xffffffff, 0x0000ffff, 0x00000000, 0xffffffff, 0xffffffff, 0x000000ff},
	{0xffffffff, 0x0000ffff, 0x00000000, 0xffffffff, 0x0000ffff, 0xffffff00},
	{0xffffffff, 0x0000ffff, 0x00000000, 0xffffffff, 0x0000ffff, 0x00000000},
	{0xffffffff, 0x0000ffff, 0x00000000, 0x00ffffff, 0xffff0000, 0xffffffff},
	{0xffffffff, 0x0000ffff, 0x00000000, 0x00ffffff, 0xffff0000, 0x000000ff},
	{0xffffffff, 0x0000ffff, 0x00000000, 0x00ffffff, 0x00000000, 0xffffff00},
	{0xffffffff, 0x0000ffff, 0x00000000, 0x00ffffff, 0x00000000, 0x00000000},
	{0xffffffff, 0x0000ffff, 0x00000000, 0xff000000, 0xffffffff, 0xffffffff},
	{0xffffffff, 0x0000ffff, 0x00000000, 0xff000000, 0xffffffff, 0x000000ff},
	{0xffffffff, 0x0000ffff, 0x00000000, 0xff000000, 0x0000ffff, 0xffffff00},
	{0xffffffff, 0x0000ffff, 0x00000000, 0xff000000, 0x0000ffff, 0x00000000},
	{0xffffffff, 0x0000ffff, 0x00000000, 0x00000000, 0xffff0000, 0xffffffff},
	{0xffffffff, 0x0000ffff, 0x00000000, 0x00000000, 0xffff0000, 0x000000ff},
	{0xffffffff, 0x0000ffff, 0x00000000, 0x00000000, 0x00000000, 0xffffff00},
	{0xffffffff, 0x0000ffff, 0x00000000, 0x00000000, 0x00000000, 0x00000000},
	{0x00ffffff, 0xffff0000, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
	{0x00ffffff, 0xffff0000, 0xffffffff, 0xffffffff, 0xffffffff, 0x000000ff},
	{0x00ffffff, 0xffff0000, 0xffffffff, 0xffffffff, 0x0000ffff, 0xffffff00},
	{0x00ffffff, 0xffff0000, 0xffffffff, 0xffffffff, 0x0000ffff, 0x00000000},
	{0x00ffffff, 0xffff0000, 0xffffffff, 0x00ffffff, 0xffff0000, 0xffffffff},
	{0x00ffffff, 0xffff0000, 0xffffffff, 0x00ffffff, 0xffff0000, 0x000000ff},
	{0x00ffffff, 0xffff0000, 0xffffffff, 0x00ffffff, 0x00000000, 0xffffff00},
	{0x00ffffff, 0xffff0000, 0xffffffff, 0x00ffffff, 0x00000000, 0x00000000},
	{0x00ffffff, 0xffff0000, 0xffffffff, 0xff000000, 0xffffffff, 0xffffffff},
	{0x00ffffff, 0xffff0000, 0xffffffff, 0xff000000, 0xffffffff, 0x000000ff},
	{0x00ffffff, 0xffff0000, 0xffffffff, 0xff000000, 0x0000ffff, 0xffffff00},
	{0x00ffffff, 0xffff0000, 0xffffffff, 0xff000000, 0x0000ffff, 0x00000000},
	{0x00ffffff, 0xffff0000, 0xffffffff, 0x00000000, 0xffff0000, 0xffffffff},
	{0x00ffffff, 0xffff0000, 0xffffffff, 0x00000000, 0xffff0000, 0x000000ff},
	{0x00ffffff, 0xffff0000, 0xffffffff, 0x00000000, 0x00000000, 0xffffff00},
	{0x00ffffff, 0xffff0000, 0xffffffff, 0x00000000, 0x00000000, 0x00000000},
	{0x00ffffff, 0xffff0000, 0x000000ff, 0xffffffff, 0xffffffff, 0xffffffff},
	{0x00ffffff, 0xffff0000, 0x000000ff, 0xffffffff, 0xffffffff, 0x000000ff},
	{0x00ffffff, 0xffff0000, 0x000000ff, 0xffffffff, 0x0000ffff, 0xffffff00},
	{0x00ffffff, 0xffff0000, 0x000000ff, 0xffffffff, 0x0000ffff, 0x00000000},
	{0x00ffffff, 0xffff0000, 0x000000ff, 0x00ffffff, 0xffff0000, 0xffffffff},
	{0x00ffffff, 0xffff0000, 0x000000ff, 0x00ffffff, 0xffff0000, 0x000000ff},
	{0x00ffffff, 0xffff0000, 0x000000ff, 0x00ffffff, 0x00000000, 0xffffff00},
	{0x00ffffff, 0xffff0000, 0x000000ff, 0x00ffffff, 0x00000000, 0x00000000},
	{0x00ffffff, 0xffff0000, 0x000000ff, 0xff000000, 0xffffffff, 0xffffffff},
	{0x00ffffff, 0xffff0000, 0x000000ff, 0xff000000, 0xffffffff, 0x000000ff},
	{0x00ffffff, 0xffff0000, 0x000000ff, 0xff000000, 0x0000ffff, 0xffffff00},
	{0x00ffffff, 0xffff0000, 0x000000ff, 0xff000000, 0x0000ffff, 0x00000000},
	{0x00ffffff, 0xffff0000, 0x000000ff, 0x00000000, 0xffff0000, 0xffffffff},
	{0x00ffffff, 0xffff0000, 0x000000ff, 0x00000000, 0xffff0000, 0x000000ff},
	{0x00ffffff, 0xffff0000, 0x000000ff, 0x00000000, 0x00000000, 0xffffff00},
	{0x00ffffff, 0xffff0000, 0x000000ff, 0x00000000, 0x00000000, 0x00000000},
	{0x00ffffff, 0x00000000, 0xffffff00, 0xffffffff, 0xffffffff, 0xffffffff},
	{0x00ffffff, 0x00000000, 0xffffff00, 0xffffffff, 0xffffffff, 0x000000ff},
	{0x00ffffff, 0x00000000, 0xffffff00, 0xffffffff, 0x0000ffff, 0xffffff00},
	{0x00ffffff, 0x00000000, 0xffffff00, 0xffffffff, 0x0000ffff, 0x00000000},
	{0x00ffffff, 0x00000000, 0xffffff00, 0x00ffffff, 0xffff0000, 0xffffffff},
	{0x00ffffff, 0x00000000, 0xffffff00, 0x00ffffff, 0xffff0000, 0x000000ff},
	{0x00ffffff, 0x00000000, 0xffffff00, 0x00ffffff, 0x00000000, 0xffffff00},
	{0x00ffffff, 0x00000000, 0xffffff00, 0x00ffffff, 0x00000000, 0x00000000},
	{0x00ffffff, 0x00000000, 0xffffff00, 0xff000000, 0xffffffff, 0xffffffff},
	{0x00ffffff, 0x00000000, 0xffffff00, 0xff000000, 0xffffffff, 0x000000ff},
	{0x00ffffff, 0x00000000, 0xffffff00, 0xff000000, 0x0000ffff, 0xffffff00},
	{0x00ffffff, 0x00000000, 0xffffff00, 0xff000000, 0x0000ffff, 0x00000000},
	{0x00ffffff, 0x00000000, 0xffffff00, 0x00000000, 0xffff0000, 0xffffffff},
	{0x00ffffff, 0x00000000, 0xffffff00, 0x00000000, 0xffff0000, 0x000000ff},
	{0x00ffffff, 0x00000000, 0xffffff00, 0x00000000, 0x00000000, 0xffffff00},
	{0x00ffffff, 0x00000000, 0xffffff00, 0x00000000, 0x00000000, 0x00000000},
	{0x00ffffff, 0x00000000, 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff},
	{0x00ffffff, 0x00000000, 0x00000000, 0xffffffff, 0xffffffff, 0x000000ff},
	{0x00ffffff, 0x00000000, 0x00000000, 0xffffffff, 0x0000ffff, 0xffffff00},
	{0x00ffffff, 0x00000000, 0x00000000, 0xffffffff, 0x0000ffff, 0x00000000},
	{0x00ffffff, 0x00000000, 0x00000000, 0x00ffffff, 0xffff0000, 0xffffffff},
	{0x00ffffff, 0x00000000, 0x00000000, 0x00ffffff, 0xffff0000, 0x000000ff},
	{0x00ffffff, 0x00000000, 0x00000000, 0x00ffffff, 0x00000000, 0xffffff00},
	{0x00ffffff, 0x00000000, 0x00000000, 0x00ffffff, 0x00000000, 0x00000000},
	{0x00ffffff, 0x00000000, 0x00000000, 0xff000000, 0xffffffff, 0xffffffff},
	{0x00ffffff, 0x00000000, 0x00000000, 0xff000000, 0xffffffff, 0x000000ff},
	{0x00ffffff, 0x00000000, 0x00000000, 0xff000000, 0x0000ffff, 0xffffff00},
	{0x00ffffff, 0x00000000, 0x00000000, 0xff000000, 0x0000ffff, 0x00000000},
	{0x00ffffff, 0x00000000, 0x00000000, 0x00000000, 0xffff0000, 0xffffffff},
	{0x00ffffff, 0x00000000, 0x00000000, 0x00000000, 0xffff0000, 0x000000ff},
	{0x00ffffff, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0xffffff00},
	{0x00ffffff, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000},
	{0xff000000, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
	{0xff000000, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0x000000ff},
	{0xff000000, 0xffffffff, 0xffffffff, 0xffffffff, 0x0000ffff, 0xffffff00},
	{0xff000000, 0xffffffff, 0xffffffff, 0xffffffff, 0x0000ffff, 0x00000000},
	{0xff000000, 0xffffffff, 0xffffffff, 0x00ffffff, 0xffff0000, 0xffffffff},
	{0xff000000, 0xffffffff, 0xffffffff, 0x00ffffff, 0xffff0000, 0x000000ff},
	{0xff000000, 0xffffffff, 0xffffffff, 0x00ffffff, 0x00000000, 0xffffff00},
	{0xff000000, 0xffffffff, 0xffffffff, 0x00ffffff, 0x00000000, 0x00000000},
	{0xff000000, 0xffffffff, 0xffffffff, 0xff000000, 0xffffffff, 0xffffffff},
	{0xff000000, 0xffffffff, 0xffffffff, 0xff000000, 0xffffffff, 0x000000ff},
	{0xff000000, 0xffffffff, 0xffffffff, 0xff000000, 0x0000ffff, 0xffffff00},
	{0xff000000, 0xffffffff, 0xffffffff, 0xff000000, 0x0000ffff, 0x00000000},
	{0xff000000, 0xffffffff, 0xffffffff, 0x00000000, 0xffff0000, 0xffffffff},
	{0xff000000, 0xffffffff, 0xffffffff, 0x00000000, 0xffff0000, 0x000000ff},
	{0xff000000, 0xffffffff, 0xffffffff, 0x00000000, 0x00000000, 0xffffff00},
	{0xff000000, 0xffffffff, 0xffffffff, 0x00000000, 0x00000000, 0x00000000},
	{0xff000000, 0xffffffff, 0x000000ff, 0xffffffff, 0xffffffff, 0xffffffff},
	{0xff000000, 0xffffffff, 0x000000ff, 0xffffffff, 0xffffffff, 0x000000ff},
	{0xff000000, 0xffffffff, 0x000000ff, 0xffffffff, 0x0000ffff, 0xffffff00},
	{0xff000000, 0xffffffff, 0x000000ff, 0xffffffff, 0x0000ffff, 0x00000000},
	{0xff000000, 0xffffffff, 0x000000ff, 0x00ffffff, 0xffff0000, 0xffffffff},
	{0xff000000, 0xffffffff, 0x000000ff, 0x00ffffff, 0xffff0000, 0x000000ff},
	{0xff000000, 0xffffffff, 0x000000ff, 0x00ffffff, 0x00000000, 0xffffff00},
	{0xff000000, 0xffffffff, 0x000000ff, 0x00ffffff, 0x00000000, 0x00000000},
	{0xff000000, 0xffffffff, 0x000000ff, 0xff000000, 0xffffffff, 0xffffffff},
	{0xff000000, 0xffffffff, 0x000000ff, 0xff000000, 0xffffffff, 0x000000ff},
	{0xff000000, 0xffffffff, 0x000000ff, 0xff000000, 0x0000ffff, 0xffffff00},
	{0xff000000, 0xffffffff, 0x000000ff, 0xff000000, 0x0000ffff, 0x00000000},
	{0xff000000, 0xffffffff, 0x000000ff, 0x00000000, 0xffff0000, 0xffffffff},
	{0xff000000, 0xffffffff, 0x000000ff, 0x00000000, 0xffff0000, 0x000000ff},
	{0xff000000, 0xffffffff, 0x000000ff, 0x00000000, 0x00000000, 0xffffff00},
	{0xff000000, 0xffffffff, 0x000000ff, 0x00000000, 0x00000000, 0x00000000},
	{0xff000000, 0x0000ffff, 0xffffff00, 0xffffffff, 0xffffffff, 0xffffffff},
	{0xff000000, 0x0000ffff, 0xffffff00, 0xffffffff, 0xffffffff, 0x000000ff},
	{0xff000000, 0x0000ffff, 0xffffff00, 0xffffffff, 0x0000ffff, 0xffffff00},
	{0xff000000, 0x0000ffff, 0xffffff00, 0xffffffff, 0x0000ffff, 0x00000000},
	{0xff000000, 0x0000ffff, 0xffffff00, 0x00ffffff, 0xffff0000, 0xffffffff},
	{0xff000000, 0x0000ffff, 0xffffff00, 0x00ffffff, 0xffff0000, 0x000000ff},
	{0xff000000, 0x0000ffff, 0xffffff00, 0x00ffffff, 0x00000000, 0xffffff00},
	{0xff000000, 0x0000ffff, 0xffffff00, 0x00ffffff, 0x00000000, 0x00000000},
	{0xff000000, 0x0000ffff, 0xffffff00, 0xff000000, 0xffffffff, 0xffffffff},
	{0xff000000, 0x0000ffff, 0xffffff00, 0xff000000, 0xffffffff, 0x000000ff},
	{0xff000000, 0x0000ffff, 0xffffff00, 0xff000000, 0x0000ffff, 0xffffff00},
	{0xff000000, 0x0000ffff, 0xffffff00, 0xff000000, 0x0000ffff, 0x00000000},
	{0xff000000, 0x0000ffff, 0xffffff00, 0x00000000, 0xffff0000, 0xffffffff},
	{0xff000000, 0x0000ffff, 0xffffff00, 0x00000000, 0xffff0000, 0x000000ff},
	{0xff000000, 0x0000ffff, 0xffffff00, 0x00000000, 0x00000000, 0xffffff00},
	{0xff000000, 0x0000ffff, 0xffffff00, 0x00000000, 0x00000000, 0x00000000},
	{0xff000000, 0x0000ffff, 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff},
	{0xff000000, 0x0000ffff, 0x00000000, 0xffffffff, 0xffffffff, 0x000000ff},
	{0xff000000, 0x0000ffff, 0x00000000, 0xffffffff, 0x0000ffff, 0xffffff00},
	{0xff000000, 0x0000ffff, 0x00000000, 0xffffffff, 0x0000ffff, 0x00000000},
	{0xff000000, 0x0000ffff, 0x00000000, 0x00ffffff, 0xffff0000, 0xffffffff},
	{0xff000000, 0x0000ffff, 0x00000000, 0x00ffffff, 0xffff0000, 0x000000ff},
	{0xff000000, 0x0000ffff, 0x00000000, 0x00ffffff, 0x00000000, 0xffffff00},
	{0xff000000, 0x0000ffff, 0x00000000, 0x00ffffff, 0x00000000, 0x00000000},
	{0xff000000, 0x0000ffff, 0x00000000, 0xff000000, 0xffffffff, 0xffffffff},
	{0xff000000, 0x0000ffff, 0x00000000, 0xff000000, 0xffffffff, 0x000000ff},
	{0xff000000, 0x0000ffff, 0x00000000, 0xff000000, 0x0000ffff, 0xffffff00},
	{0xff000000, 0x0000ffff, 0x00000000, 0xff000000, 0x0000ffff, 0x00000000},
	{0xff000000, 0x0000ffff, 0x00000000, 0x00000000, 0xffff0000, 0xffffffff},
	{0xff000000, 0x0000ffff, 0x00000000, 0x00000000, 0xffff0000, 0x000000ff},
	{0xff000000, 0x0000ffff, 0x00000000, 0x00000000, 0x00000000, 0xffffff00},
	{0xff000000, 0x0000ffff, 0x00000000, 0x00000000, 0x00000000, 0x00000000},
	{0x00000000, 0xffff0000, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
	{0x00000000, 0xffff0000, 0xffffffff, 0xffffffff, 0xffffffff, 0x000000ff},
	{0x00000000, 0xffff0000, 0xffffffff, 0xffffffff, 0x0000ffff, 0xffffff00},
	{0x00000000, 0xffff0000, 0xffffffff, 0xffffffff, 0x0000ffff, 0x00000000},
	{0x00000000, 0xffff0000, 0xffffffff, 0x00ffffff, 0xffff0000, 0xffffffff},
	{0x00000000, 0xffff0000, 0xffffffff, 0x00ffffff, 0xffff0000, 0x000000ff},
	{0x00000000, 0xffff0000, 0xffffffff, 0x00ffffff, 0x00000000, 0xffffff00},
	{0x00000000, 0xffff0000, 0xffffffff, 0x00ffffff, 0x00000000, 0x00000000},
	{0x00000000, 0xffff0000, 0xffffffff, 0xff000000, 0xffffffff, 0xffffffff},
	{0x00000000, 0xffff0000, 0xffffffff, 0xff000000, 0xffffffff, 0x000000ff},
	{0x00000000, 0xffff0000, 0xffffffff, 0xff000000, 0x0000ffff, 0xffffff00},
	{0x00000000, 0xffff0000, 0xffffffff, 0xff000000, 0x0000ffff, 0x00000000},
	{0x00000000, 0xffff0000, 0xffffffff, 0x00000000, 0xffff0000, 0xffffffff},
	{0x00000000, 0xffff0000, 0xffffffff, 0x00000000, 0xffff0000, 0x000000ff},
	{0x00000000, 0xffff0000, 0xffffffff, 0x00000000, 0x00000000, 0xffffff00},
	{0x00000000, 0xffff0000, 0xffffffff, 0x00000000, 0x00000000, 0x00000000},
	{0x00000000, 0xffff0000, 0x000000ff, 0xffffffff, 0xffffffff, 0xffffffff},
	{0x00000000, 0xffff0000, 0x000000ff, 0xffffffff, 0xffffffff, 0x000000ff},
	{0x00000000, 0xffff0000, 0x000000ff, 0xffffffff, 0x0000ffff, 0xffffff00},
	{0x00000000, 0xffff0000, 0x000000ff, 0xffffffff, 0x0000ffff, 0x00000000},
	{0x00000000, 0xffff0000, 0x000000ff, 0x00ffffff, 0xffff0000, 0xffffffff},
	{0x00000000, 0xffff0000, 0x000000ff, 0x00ffffff, 0xffff0000, 0x000000ff},
	{0x00000000, 0xffff0000, 0x000000ff, 0x00ffffff, 0x00000000, 0xffffff00},
	{0x00000000, 0xffff0000, 0x000000ff, 0x00ffffff, 0x00000000, 0x00000000},
	{0x00000000, 0xffff0000, 0x000000ff, 0xff000000, 0xffffffff, 0xffffffff},
	{0x00000000, 0xffff0000, 0x000000ff, 0xff000000, 0xffffffff, 0x000000ff},
	{0x00000000, 0xffff0000, 0x000000ff, 0xff000000, 0x0000ffff, 0xffffff00},
	{0x00000000, 0xffff0000, 0x000000ff, 0xff000000, 0x0000ffff, 0x00000000},
	{0x00000000, 0xffff0000, 0x000000ff, 0x00000000, 0xffff0000, 0xffffffff},
	{0x00000000, 0xffff0000, 0x000000ff, 0x00000000, 0xffff0000, 0x000000ff},
	{0x00000000, 0xffff0000, 0x000000ff, 0x00000000, 0x00000000, 0xffffff00},
	{0x00000000, 0xffff0000, 0x000000ff, 0x00000000, 0x00000000, 0x00000000},
	{0x00000000, 0x00000000, 0xffffff00, 0xffffffff, 0xffffffff, 0xffffffff},
	{0x00000000, 0x00000000, 0xffffff00, 0xffffffff, 0xffffffff, 0x000000ff},
	{0x00000000, 0x00000000, 0xffffff00, 0xffffffff, 0x0000ffff, 0xffffff00},
	{0x00000000, 0x00000000, 0xffffff00, 0xffffffff, 0x0000ffff, 0x00000000},
	{0x00000000, 0x00000000, 0xffffff00, 0x00ffffff, 0xffff0000, 0xffffffff},
	{0x00000000, 0x00000000, 0xffffff00, 0x00ffffff, 0xffff0000, 0x000000ff},
	{0x00000000, 0x00000000, 0xffffff00, 0x00ffffff, 0x00000000, 0xffffff00},
	{0x00000000, 0x00000000, 0xffffff00, 0x00ffffff, 0x00000000, 0x00000000},
	{0x00000000, 0x00000000, 0xffffff00, 0xff000000, 0xffffffff, 0xffffffff},
	{0x00000000, 0x00000000, 0xffffff00, 0xff000000, 0xffffffff, 0x000000ff},
	{0x00000000, 0x00000000, 0xffffff00, 0xff000000, 0x0000ffff, 0xffffff00},
	{0x00000000, 0x00000000, 0xffffff00, 0xff000000, 0x0000ffff, 0x00000000},
	{0x00000000, 0x00000000, 0xffffff00, 0x00000000, 0xffff0000, 0xffffffff},
	{0x00000000, 0x00000000, 0xffffff00, 0x00000000, 0xffff0000, 0x000000ff},
	{0x00000000, 0x00000000, 0xffffff00, 0x00000000, 0x00000000, 0xffffff00},
	{0x00000000, 0x00000000, 0xffffff00, 0x00000000, 0x00000000, 0x00000000},
	{0x00000000, 0x00000000, 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff},
	{0x00000000, 0x00000000, 0x00000000, 0xffffffff, 0xffffffff, 0x000000ff},
	{0x00000000, 0x00000000, 0x00000000, 0xffffffff, 0x0000ffff, 0xffffff00},
	{0x00000000, 0x00000000, 0x00000000, 0xffffffff, 0x0000ffff, 0x00000000},
	{0x00000000, 0x00000000, 0x00000000, 0x00ffffff, 0xffff0000, 0xffffffff},
	{0x00000000, 0x00000000, 0x00000000, 0x00ffffff, 0xffff0000, 0x000000ff},
	{0x00000000, 0x00000000, 0x00000000, 0x00ffffff, 0x00000000, 0xffffff00},
	{0x00000000, 0x00000000, 0x00000000, 0x00ffffff, 0x00000000, 0x00000000},
	{0x00000000, 0x00000000, 0x00000000, 0xff000000, 0xffffffff, 0xffffffff},
	{0x00000000, 0x00000000, 0x00000000, 0xff000000, 0xffffffff, 0x000000ff},
	{0x00000000, 0x00000000, 0x00000000, 0xff000000, 0x0000ffff, 0xffffff00},
	{0x00000000, 0x00000000, 0x00000000, 0xff000000, 0x0000ffff, 0x00000000},
	{0x00000000, 0x00000000, 0x00000000, 0x00000000, 0xffff0000, 0xffffffff},
	{0x00000000, 0x00000000, 0x00000000, 0x00000000, 0xffff0000, 0x000000ff},
	{0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0xffffff00},
	{0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000}
};

const Dgp_UInt32 monoToGray8bit[256][2] = {
	{0xffffffff, 0xffffffff},
	{0xffffffff, 0x00ffffff},
	{0xffffffff, 0xff00ffff},
	{0xffffffff, 0x0000ffff},
	{0xffffffff, 0xffff00ff},
	{0xffffffff, 0x00ff00ff},
	{0xffffffff, 0xff0000ff},
	{0xffffffff, 0x000000ff},
	{0xffffffff, 0xffffff00},
	{0xffffffff, 0x00ffff00},
	{0xffffffff, 0xff00ff00},
	{0xffffffff, 0x0000ff00},
	{0xffffffff, 0xffff0000},
	{0xffffffff, 0x00ff0000},
	{0xffffffff, 0xff000000},
	{0xffffffff, 0x00000000},
	{0x00ffffff, 0xffffffff},
	{0x00ffffff, 0x00ffffff},
	{0x00ffffff, 0xff00ffff},
	{0x00ffffff, 0x0000ffff},
	{0x00ffffff, 0xffff00ff},
	{0x00ffffff, 0x00ff00ff},
	{0x00ffffff, 0xff0000ff},
	{0x00ffffff, 0x000000ff},
	{0x00ffffff, 0xffffff00},
	{0x00ffffff, 0x00ffff00},
	{0x00ffffff, 0xff00ff00},
	{0x00ffffff, 0x0000ff00},
	{0x00ffffff, 0xffff0000},
	{0x00ffffff, 0x00ff0000},
	{0x00ffffff, 0xff000000},
	{0x00ffffff, 0x00000000},
	{0xff00ffff, 0xffffffff},
	{0xff00ffff, 0x00ffffff},
	{0xff00ffff, 0xff00ffff},
	{0xff00ffff, 0x0000ffff},
	{0xff00ffff, 0xffff00ff},
	{0xff00ffff, 0x00ff00ff},
	{0xff00ffff, 0xff0000ff},
	{0xff00ffff, 0x000000ff},
	{0xff00ffff, 0xffffff00},
	{0xff00ffff, 0x00ffff00},
	{0xff00ffff, 0xff00ff00},
	{0xff00ffff, 0x0000ff00},
	{0xff00ffff, 0xffff0000},
	{0xff00ffff, 0x00ff0000},
	{0xff00ffff, 0xff000000},
	{0xff00ffff, 0x00000000},
	{0x0000ffff, 0xffffffff},
	{0x0000ffff, 0x00ffffff},
	{0x0000ffff, 0xff00ffff},
	{0x0000ffff, 0x0000ffff},
	{0x0000ffff, 0xffff00ff},
	{0x0000ffff, 0x00ff00ff},
	{0x0000ffff, 0xff0000ff},
	{0x0000ffff, 0x000000ff},
	{0x0000ffff, 0xffffff00},
	{0x0000ffff, 0x00ffff00},
	{0x0000ffff, 0xff00ff00},
	{0x0000ffff, 0x0000ff00},
	{0x0000ffff, 0xffff0000},
	{0x0000ffff, 0x00ff0000},
	{0x0000ffff, 0xff000000},
	{0x0000ffff, 0x00000000},
	{0xffff00ff, 0xffffffff},
	{0xffff00ff, 0x00ffffff},
	{0xffff00ff, 0xff00ffff},
	{0xffff00ff, 0x0000ffff},
	{0xffff00ff, 0xffff00ff},
	{0xffff00ff, 0x00ff00ff},
	{0xffff00ff, 0xff0000ff},
	{0xffff00ff, 0x000000ff},
	{0xffff00ff, 0xffffff00},
	{0xffff00ff, 0x00ffff00},
	{0xffff00ff, 0xff00ff00},
	{0xffff00ff, 0x0000ff00},
	{0xffff00ff, 0xffff0000},
	{0xffff00ff, 0x00ff0000},
	{0xffff00ff, 0xff000000},
	{0xffff00ff, 0x00000000},
	{0x00ff00ff, 0xffffffff},
	{0x00ff00ff, 0x00ffffff},
	{0x00ff00ff, 0xff00ffff},
	{0x00ff00ff, 0x0000ffff},
	{0x00ff00ff, 0xffff00ff},
	{0x00ff00ff, 0x00ff00ff},
	{0x00ff00ff, 0xff0000ff},
	{0x00ff00ff, 0x000000ff},
	{0x00ff00ff, 0xffffff00},
	{0x00ff00ff, 0x00ffff00},
	{0x00ff00ff, 0xff00ff00},
	{0x00ff00ff, 0x0000ff00},
	{0x00ff00ff, 0xffff0000},
	{0x00ff00ff, 0x00ff0000},
	{0x00ff00ff, 0xff000000},
	{0x00ff00ff, 0x00000000},
	{0xff0000ff, 0xffffffff},
	{0xff0000ff, 0x00ffffff},
	{0xff0000ff, 0xff00ffff},
	{0xff0000ff, 0x0000ffff},
	{0xff0000ff, 0xffff00ff},
	{0xff0000ff, 0x00ff00ff},
	{0xff0000ff, 0xff0000ff},
	{0xff0000ff, 0x000000ff},
	{0xff0000ff, 0xffffff00},
	{0xff0000ff, 0x00ffff00},
	{0xff0000ff, 0xff00ff00},
	{0xff0000ff, 0x0000ff00},
	{0xff0000ff, 0xffff0000},
	{0xff0000ff, 0x00ff0000},
	{0xff0000ff, 0xff000000},
	{0xff0000ff, 0x00000000},
	{0x000000ff, 0xffffffff},
	{0x000000ff, 0x00ffffff},
	{0x000000ff, 0xff00ffff},
	{0x000000ff, 0x0000ffff},
	{0x000000ff, 0xffff00ff},
	{0x000000ff, 0x00ff00ff},
	{0x000000ff, 0xff0000ff},
	{0x000000ff, 0x000000ff},
	{0x000000ff, 0xffffff00},
	{0x000000ff, 0x00ffff00},
	{0x000000ff, 0xff00ff00},
	{0x000000ff, 0x0000ff00},
	{0x000000ff, 0xffff0000},
	{0x000000ff, 0x00ff0000},
	{0x000000ff, 0xff000000},
	{0x000000ff, 0x00000000},
	{0xffffff00, 0xffffffff},
	{0xffffff00, 0x00ffffff},
	{0xffffff00, 0xff00ffff},
	{0xffffff00, 0x0000ffff},
	{0xffffff00, 0xffff00ff},
	{0xffffff00, 0x00ff00ff},
	{0xffffff00, 0xff0000ff},
	{0xffffff00, 0x000000ff},
	{0xffffff00, 0xffffff00},
	{0xffffff00, 0x00ffff00},
	{0xffffff00, 0xff00ff00},
	{0xffffff00, 0x0000ff00},
	{0xffffff00, 0xffff0000},
	{0xffffff00, 0x00ff0000},
	{0xffffff00, 0xff000000},
	{0xffffff00, 0x00000000},
	{0x00ffff00, 0xffffffff},
	{0x00ffff00, 0x00ffffff},
	{0x00ffff00, 0xff00ffff},
	{0x00ffff00, 0x0000ffff},
	{0x00ffff00, 0xffff00ff},
	{0x00ffff00, 0x00ff00ff},
	{0x00ffff00, 0xff0000ff},
	{0x00ffff00, 0x000000ff},
	{0x00ffff00, 0xffffff00},
	{0x00ffff00, 0x00ffff00},
	{0x00ffff00, 0xff00ff00},
	{0x00ffff00, 0x0000ff00},
	{0x00ffff00, 0xffff0000},
	{0x00ffff00, 0x00ff0000},
	{0x00ffff00, 0xff000000},
	{0x00ffff00, 0x00000000},
	{0xff00ff00, 0xffffffff},
	{0xff00ff00, 0x00ffffff},
	{0xff00ff00, 0xff00ffff},
	{0xff00ff00, 0x0000ffff},
	{0xff00ff00, 0xffff00ff},
	{0xff00ff00, 0x00ff00ff},
	{0xff00ff00, 0xff0000ff},
	{0xff00ff00, 0x000000ff},
	{0xff00ff00, 0xffffff00},
	{0xff00ff00, 0x00ffff00},
	{0xff00ff00, 0xff00ff00},
	{0xff00ff00, 0x0000ff00},
	{0xff00ff00, 0xffff0000},
	{0xff00ff00, 0x00ff0000},
	{0xff00ff00, 0xff000000},
	{0xff00ff00, 0x00000000},
	{0x0000ff00, 0xffffffff},
	{0x0000ff00, 0x00ffffff},
	{0x0000ff00, 0xff00ffff},
	{0x0000ff00, 0x0000ffff},
	{0x0000ff00, 0xffff00ff},
	{0x0000ff00, 0x00ff00ff},
	{0x0000ff00, 0xff0000ff},
	{0x0000ff00, 0x000000ff},
	{0x0000ff00, 0xffffff00},
	{0x0000ff00, 0x00ffff00},
	{0x0000ff00, 0xff00ff00},
	{0x0000ff00, 0x0000ff00},
	{0x0000ff00, 0xffff0000},
	{0x0000ff00, 0x00ff0000},
	{0x0000ff00, 0xff000000},
	{0x0000ff00, 0x00000000},
	{0xffff0000, 0xffffffff},
	{0xffff0000, 0x00ffffff},
	{0xffff0000, 0xff00ffff},
	{0xffff0000, 0x0000ffff},
	{0xffff0000, 0xffff00ff},
	{0xffff0000, 0x00ff00ff},
	{0xffff0000, 0xff0000ff},
	{0xffff0000, 0x000000ff},
	{0xffff0000, 0xffffff00},
	{0xffff0000, 0x00ffff00},
	{0xffff0000, 0xff00ff00},
	{0xffff0000, 0x0000ff00},
	{0xffff0000, 0xffff0000},
	{0xffff0000, 0x00ff0000},
	{0xffff0000, 0xff000000},
	{0xffff0000, 0x00000000},
	{0x00ff0000, 0xffffffff},
	{0x00ff0000, 0x00ffffff},
	{0x00ff0000, 0xff00ffff},
	{0x00ff0000, 0x0000ffff},
	{0x00ff0000, 0xffff00ff},
	{0x00ff0000, 0x00ff00ff},
	{0x00ff0000, 0xff0000ff},
	{0x00ff0000, 0x000000ff},
	{0x00ff0000, 0xffffff00},
	{0x00ff0000, 0x00ffff00},
	{0x00ff0000, 0xff00ff00},
	{0x00ff0000, 0x0000ff00},
	{0x00ff0000, 0xffff0000},
	{0x00ff0000, 0x00ff0000},
	{0x00ff0000, 0xff000000},
	{0x00ff0000, 0x00000000},
	{0xff000000, 0xffffffff},
	{0xff000000, 0x00ffffff},
	{0xff000000, 0xff00ffff},
	{0xff000000, 0x0000ffff},
	{0xff000000, 0xffff00ff},
	{0xff000000, 0x00ff00ff},
	{0xff000000, 0xff0000ff},
	{0xff000000, 0x000000ff},
	{0xff000000, 0xffffff00},
	{0xff000000, 0x00ffff00},
	{0xff000000, 0xff00ff00},
	{0xff000000, 0x0000ff00},
	{0xff000000, 0xffff0000},
	{0xff000000, 0x00ff0000},
	{0xff000000, 0xff000000},
	{0xff000000, 0x00000000},
	{0x00000000, 0xffffffff},
	{0x00000000, 0x00ffffff},
	{0x00000000, 0xff00ffff},
	{0x00000000, 0x0000ffff},
	{0x00000000, 0xffff00ff},
	{0x00000000, 0x00ff00ff},
	{0x00000000, 0xff0000ff},
	{0x00000000, 0x000000ff},
	{0x00000000, 0xffffff00},
	{0x00000000, 0x00ffff00},
	{0x00000000, 0xff00ff00},
	{0x00000000, 0x0000ff00},
	{0x00000000, 0xffff0000},
	{0x00000000, 0x00ff0000},
	{0x00000000, 0xff000000},
	{0x00000000, 0x00000000}
};

#endif /* _LITTLE_ENDIAN  */

#ifdef _BIG_ENDIAN
const Dgp_UInt32 monoToRGB8bit[256][6] = {
	{0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
	{0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xff000000},
	{0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffff0000, 0x00ffffff},
	{0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffff0000, 0x00000000},
	{0xffffffff, 0xffffffff, 0xffffffff, 0xffffff00, 0x0000ffff, 0xffffffff},
	{0xffffffff, 0xffffffff, 0xffffffff, 0xffffff00, 0x0000ffff, 0xff000000},
	{0xffffffff, 0xffffffff, 0xffffffff, 0xffffff00, 0x00000000, 0x00ffffff},
	{0xffffffff, 0xffffffff, 0xffffffff, 0xffffff00, 0x00000000, 0x00000000},
	{0xffffffff, 0xffffffff, 0xffffffff, 0x000000ff, 0xffffffff, 0xffffffff},
	{0xffffffff, 0xffffffff, 0xffffffff, 0x000000ff, 0xffffffff, 0xff000000},
	{0xffffffff, 0xffffffff, 0xffffffff, 0x000000ff, 0xffff0000, 0x00ffffff},
	{0xffffffff, 0xffffffff, 0xffffffff, 0x000000ff, 0xffff0000, 0x00000000},
	{0xffffffff, 0xffffffff, 0xffffffff, 0x00000000, 0x0000ffff, 0xffffffff},
	{0xffffffff, 0xffffffff, 0xffffffff, 0x00000000, 0x0000ffff, 0xff000000},
	{0xffffffff, 0xffffffff, 0xffffffff, 0x00000000, 0x00000000, 0x00ffffff},
	{0xffffffff, 0xffffffff, 0xffffffff, 0x00000000, 0x00000000, 0x00000000},
	{0xffffffff, 0xffffffff, 0xff000000, 0xffffffff, 0xffffffff, 0xffffffff},
	{0xffffffff, 0xffffffff, 0xff000000, 0xffffffff, 0xffffffff, 0xff000000},
	{0xffffffff, 0xffffffff, 0xff000000, 0xffffffff, 0xffff0000, 0x00ffffff},
	{0xffffffff, 0xffffffff, 0xff000000, 0xffffffff, 0xffff0000, 0x00000000},
	{0xffffffff, 0xffffffff, 0xff000000, 0xffffff00, 0x0000ffff, 0xffffffff},
	{0xffffffff, 0xffffffff, 0xff000000, 0xffffff00, 0x0000ffff, 0xff000000},
	{0xffffffff, 0xffffffff, 0xff000000, 0xffffff00, 0x00000000, 0x00ffffff},
	{0xffffffff, 0xffffffff, 0xff000000, 0xffffff00, 0x00000000, 0x00000000},
	{0xffffffff, 0xffffffff, 0xff000000, 0x000000ff, 0xffffffff, 0xffffffff},
	{0xffffffff, 0xffffffff, 0xff000000, 0x000000ff, 0xffffffff, 0xff000000},
	{0xffffffff, 0xffffffff, 0xff000000, 0x000000ff, 0xffff0000, 0x00ffffff},
	{0xffffffff, 0xffffffff, 0xff000000, 0x000000ff, 0xffff0000, 0x00000000},
	{0xffffffff, 0xffffffff, 0xff000000, 0x00000000, 0x0000ffff, 0xffffffff},
	{0xffffffff, 0xffffffff, 0xff000000, 0x00000000, 0x0000ffff, 0xff000000},
	{0xffffffff, 0xffffffff, 0xff000000, 0x00000000, 0x00000000, 0x00ffffff},
	{0xffffffff, 0xffffffff, 0xff000000, 0x00000000, 0x00000000, 0x00000000},
	{0xffffffff, 0xffff0000, 0x00ffffff, 0xffffffff, 0xffffffff, 0xffffffff},
	{0xffffffff, 0xffff0000, 0x00ffffff, 0xffffffff, 0xffffffff, 0xff000000},
	{0xffffffff, 0xffff0000, 0x00ffffff, 0xffffffff, 0xffff0000, 0x00ffffff},
	{0xffffffff, 0xffff0000, 0x00ffffff, 0xffffffff, 0xffff0000, 0x00000000},
	{0xffffffff, 0xffff0000, 0x00ffffff, 0xffffff00, 0x0000ffff, 0xffffffff},
	{0xffffffff, 0xffff0000, 0x00ffffff, 0xffffff00, 0x0000ffff, 0xff000000},
	{0xffffffff, 0xffff0000, 0x00ffffff, 0xffffff00, 0x00000000, 0x00ffffff},
	{0xffffffff, 0xffff0000, 0x00ffffff, 0xffffff00, 0x00000000, 0x00000000},
	{0xffffffff, 0xffff0000, 0x00ffffff, 0x000000ff, 0xffffffff, 0xffffffff},
	{0xffffffff, 0xffff0000, 0x00ffffff, 0x000000ff, 0xffffffff, 0xff000000},
	{0xffffffff, 0xffff0000, 0x00ffffff, 0x000000ff, 0xffff0000, 0x00ffffff},
	{0xffffffff, 0xffff0000, 0x00ffffff, 0x000000ff, 0xffff0000, 0x00000000},
	{0xffffffff, 0xffff0000, 0x00ffffff, 0x00000000, 0x0000ffff, 0xffffffff},
	{0xffffffff, 0xffff0000, 0x00ffffff, 0x00000000, 0x0000ffff, 0xff000000},
	{0xffffffff, 0xffff0000, 0x00ffffff, 0x00000000, 0x00000000, 0x00ffffff},
	{0xffffffff, 0xffff0000, 0x00ffffff, 0x00000000, 0x00000000, 0x00000000},
	{0xffffffff, 0xffff0000, 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff},
	{0xffffffff, 0xffff0000, 0x00000000, 0xffffffff, 0xffffffff, 0xff000000},
	{0xffffffff, 0xffff0000, 0x00000000, 0xffffffff, 0xffff0000, 0x00ffffff},
	{0xffffffff, 0xffff0000, 0x00000000, 0xffffffff, 0xffff0000, 0x00000000},
	{0xffffffff, 0xffff0000, 0x00000000, 0xffffff00, 0x0000ffff, 0xffffffff},
	{0xffffffff, 0xffff0000, 0x00000000, 0xffffff00, 0x0000ffff, 0xff000000},
	{0xffffffff, 0xffff0000, 0x00000000, 0xffffff00, 0x00000000, 0x00ffffff},
	{0xffffffff, 0xffff0000, 0x00000000, 0xffffff00, 0x00000000, 0x00000000},
	{0xffffffff, 0xffff0000, 0x00000000, 0x000000ff, 0xffffffff, 0xffffffff},
	{0xffffffff, 0xffff0000, 0x00000000, 0x000000ff, 0xffffffff, 0xff000000},
	{0xffffffff, 0xffff0000, 0x00000000, 0x000000ff, 0xffff0000, 0x00ffffff},
	{0xffffffff, 0xffff0000, 0x00000000, 0x000000ff, 0xffff0000, 0x00000000},
	{0xffffffff, 0xffff0000, 0x00000000, 0x00000000, 0x0000ffff, 0xffffffff},
	{0xffffffff, 0xffff0000, 0x00000000, 0x00000000, 0x0000ffff, 0xff000000},
	{0xffffffff, 0xffff0000, 0x00000000, 0x00000000, 0x00000000, 0x00ffffff},
	{0xffffffff, 0xffff0000, 0x00000000, 0x00000000, 0x00000000, 0x00000000},
	{0xffffff00, 0x0000ffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
	{0xffffff00, 0x0000ffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xff000000},
	{0xffffff00, 0x0000ffff, 0xffffffff, 0xffffffff, 0xffff0000, 0x00ffffff},
	{0xffffff00, 0x0000ffff, 0xffffffff, 0xffffffff, 0xffff0000, 0x00000000},
	{0xffffff00, 0x0000ffff, 0xffffffff, 0xffffff00, 0x0000ffff, 0xffffffff},
	{0xffffff00, 0x0000ffff, 0xffffffff, 0xffffff00, 0x0000ffff, 0xff000000},
	{0xffffff00, 0x0000ffff, 0xffffffff, 0xffffff00, 0x00000000, 0x00ffffff},
	{0xffffff00, 0x0000ffff, 0xffffffff, 0xffffff00, 0x00000000, 0x00000000},
	{0xffffff00, 0x0000ffff, 0xffffffff, 0x000000ff, 0xffffffff, 0xffffffff},
	{0xffffff00, 0x0000ffff, 0xffffffff, 0x000000ff, 0xffffffff, 0xff000000},
	{0xffffff00, 0x0000ffff, 0xffffffff, 0x000000ff, 0xffff0000, 0x00ffffff},
	{0xffffff00, 0x0000ffff, 0xffffffff, 0x000000ff, 0xffff0000, 0x00000000},
	{0xffffff00, 0x0000ffff, 0xffffffff, 0x00000000, 0x0000ffff, 0xffffffff},
	{0xffffff00, 0x0000ffff, 0xffffffff, 0x00000000, 0x0000ffff, 0xff000000},
	{0xffffff00, 0x0000ffff, 0xffffffff, 0x00000000, 0x00000000, 0x00ffffff},
	{0xffffff00, 0x0000ffff, 0xffffffff, 0x00000000, 0x00000000, 0x00000000},
	{0xffffff00, 0x0000ffff, 0xff000000, 0xffffffff, 0xffffffff, 0xffffffff},
	{0xffffff00, 0x0000ffff, 0xff000000, 0xffffffff, 0xffffffff, 0xff000000},
	{0xffffff00, 0x0000ffff, 0xff000000, 0xffffffff, 0xffff0000, 0x00ffffff},
	{0xffffff00, 0x0000ffff, 0xff000000, 0xffffffff, 0xffff0000, 0x00000000},
	{0xffffff00, 0x0000ffff, 0xff000000, 0xffffff00, 0x0000ffff, 0xffffffff},
	{0xffffff00, 0x0000ffff, 0xff000000, 0xffffff00, 0x0000ffff, 0xff000000},
	{0xffffff00, 0x0000ffff, 0xff000000, 0xffffff00, 0x00000000, 0x00ffffff},
	{0xffffff00, 0x0000ffff, 0xff000000, 0xffffff00, 0x00000000, 0x00000000},
	{0xffffff00, 0x0000ffff, 0xff000000, 0x000000ff, 0xffffffff, 0xffffffff},
	{0xffffff00, 0x0000ffff, 0xff000000, 0x000000ff, 0xffffffff, 0xff000000},
	{0xffffff00, 0x0000ffff, 0xff000000, 0x000000ff, 0xffff0000, 0x00ffffff},
	{0xffffff00, 0x0000ffff, 0xff000000, 0x000000ff, 0xffff0000, 0x00000000},
	{0xffffff00, 0x0000ffff, 0xff000000, 0x00000000, 0x0000ffff, 0xffffffff},
	{0xffffff00, 0x0000ffff, 0xff000000, 0x00000000, 0x0000ffff, 0xff000000},
	{0xffffff00, 0x0000ffff, 0xff000000, 0x00000000, 0x00000000, 0x00ffffff},
	{0xffffff00, 0x0000ffff, 0xff000000, 0x00000000, 0x00000000, 0x00000000},
	{0xffffff00, 0x00000000, 0x00ffffff, 0xffffffff, 0xffffffff, 0xffffffff},
	{0xffffff00, 0x00000000, 0x00ffffff, 0xffffffff, 0xffffffff, 0xff000000},
	{0xffffff00, 0x00000000, 0x00ffffff, 0xffffffff, 0xffff0000, 0x00ffffff},
	{0xffffff00, 0x00000000, 0x00ffffff, 0xffffffff, 0xffff0000, 0x00000000},
	{0xffffff00, 0x00000000, 0x00ffffff, 0xffffff00, 0x0000ffff, 0xffffffff},
	{0xffffff00, 0x00000000, 0x00ffffff, 0xffffff00, 0x0000ffff, 0xff000000},
	{0xffffff00, 0x00000000, 0x00ffffff, 0xffffff00, 0x00000000, 0x00ffffff},
	{0xffffff00, 0x00000000, 0x00ffffff, 0xffffff00, 0x00000000, 0x00000000},
	{0xffffff00, 0x00000000, 0x00ffffff, 0x000000ff, 0xffffffff, 0xffffffff},
	{0xffffff00, 0x00000000, 0x00ffffff, 0x000000ff, 0xffffffff, 0xff000000},
	{0xffffff00, 0x00000000, 0x00ffffff, 0x000000ff, 0xffff0000, 0x00ffffff},
	{0xffffff00, 0x00000000, 0x00ffffff, 0x000000ff, 0xffff0000, 0x00000000},
	{0xffffff00, 0x00000000, 0x00ffffff, 0x00000000, 0x0000ffff, 0xffffffff},
	{0xffffff00, 0x00000000, 0x00ffffff, 0x00000000, 0x0000ffff, 0xff000000},
	{0xffffff00, 0x00000000, 0x00ffffff, 0x00000000, 0x00000000, 0x00ffffff},
	{0xffffff00, 0x00000000, 0x00ffffff, 0x00000000, 0x00000000, 0x00000000},
	{0xffffff00, 0x00000000, 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff},
	{0xffffff00, 0x00000000, 0x00000000, 0xffffffff, 0xffffffff, 0xff000000},
	{0xffffff00, 0x00000000, 0x00000000, 0xffffffff, 0xffff0000, 0x00ffffff},
	{0xffffff00, 0x00000000, 0x00000000, 0xffffffff, 0xffff0000, 0x00000000},
	{0xffffff00, 0x00000000, 0x00000000, 0xffffff00, 0x0000ffff, 0xffffffff},
	{0xffffff00, 0x00000000, 0x00000000, 0xffffff00, 0x0000ffff, 0xff000000},
	{0xffffff00, 0x00000000, 0x00000000, 0xffffff00, 0x00000000, 0x00ffffff},
	{0xffffff00, 0x00000000, 0x00000000, 0xffffff00, 0x00000000, 0x00000000},
	{0xffffff00, 0x00000000, 0x00000000, 0x000000ff, 0xffffffff, 0xffffffff},
	{0xffffff00, 0x00000000, 0x00000000, 0x000000ff, 0xffffffff, 0xff000000},
	{0xffffff00, 0x00000000, 0x00000000, 0x000000ff, 0xffff0000, 0x00ffffff},
	{0xffffff00, 0x00000000, 0x00000000, 0x000000ff, 0xffff0000, 0x00000000},
	{0xffffff00, 0x00000000, 0x00000000, 0x00000000, 0x0000ffff, 0xffffffff},
	{0xffffff00, 0x00000000, 0x00000000, 0x00000000, 0x0000ffff, 0xff000000},
	{0xffffff00, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00ffffff},
	{0xffffff00, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000},
	{0x000000ff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
	{0x000000ff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xff000000},
	{0x000000ff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffff0000, 0x00ffffff},
	{0x000000ff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffff0000, 0x00000000},
	{0x000000ff, 0xffffffff, 0xffffffff, 0xffffff00, 0x0000ffff, 0xffffffff},
	{0x000000ff, 0xffffffff, 0xffffffff, 0xffffff00, 0x0000ffff, 0xff000000},
	{0x000000ff, 0xffffffff, 0xffffffff, 0xffffff00, 0x00000000, 0x00ffffff},
	{0x000000ff, 0xffffffff, 0xffffffff, 0xffffff00, 0x00000000, 0x00000000},
	{0x000000ff, 0xffffffff, 0xffffffff, 0x000000ff, 0xffffffff, 0xffffffff},
	{0x000000ff, 0xffffffff, 0xffffffff, 0x000000ff, 0xffffffff, 0xff000000},
	{0x000000ff, 0xffffffff, 0xffffffff, 0x000000ff, 0xffff0000, 0x00ffffff},
	{0x000000ff, 0xffffffff, 0xffffffff, 0x000000ff, 0xffff0000, 0x00000000},
	{0x000000ff, 0xffffffff, 0xffffffff, 0x00000000, 0x0000ffff, 0xffffffff},
	{0x000000ff, 0xffffffff, 0xffffffff, 0x00000000, 0x0000ffff, 0xff000000},
	{0x000000ff, 0xffffffff, 0xffffffff, 0x00000000, 0x00000000, 0x00ffffff},
	{0x000000ff, 0xffffffff, 0xffffffff, 0x00000000, 0x00000000, 0x00000000},
	{0x000000ff, 0xffffffff, 0xff000000, 0xffffffff, 0xffffffff, 0xffffffff},
	{0x000000ff, 0xffffffff, 0xff000000, 0xffffffff, 0xffffffff, 0xff000000},
	{0x000000ff, 0xffffffff, 0xff000000, 0xffffffff, 0xffff0000, 0x00ffffff},
	{0x000000ff, 0xffffffff, 0xff000000, 0xffffffff, 0xffff0000, 0x00000000},
	{0x000000ff, 0xffffffff, 0xff000000, 0xffffff00, 0x0000ffff, 0xffffffff},
	{0x000000ff, 0xffffffff, 0xff000000, 0xffffff00, 0x0000ffff, 0xff000000},
	{0x000000ff, 0xffffffff, 0xff000000, 0xffffff00, 0x00000000, 0x00ffffff},
	{0x000000ff, 0xffffffff, 0xff000000, 0xffffff00, 0x00000000, 0x00000000},
	{0x000000ff, 0xffffffff, 0xff000000, 0x000000ff, 0xffffffff, 0xffffffff},
	{0x000000ff, 0xffffffff, 0xff000000, 0x000000ff, 0xffffffff, 0xff000000},
	{0x000000ff, 0xffffffff, 0xff000000, 0x000000ff, 0xffff0000, 0x00ffffff},
	{0x000000ff, 0xffffffff, 0xff000000, 0x000000ff, 0xffff0000, 0x00000000},
	{0x000000ff, 0xffffffff, 0xff000000, 0x00000000, 0x0000ffff, 0xffffffff},
	{0x000000ff, 0xffffffff, 0xff000000, 0x00000000, 0x0000ffff, 0xff000000},
	{0x000000ff, 0xffffffff, 0xff000000, 0x00000000, 0x00000000, 0x00ffffff},
	{0x000000ff, 0xffffffff, 0xff000000, 0x00000000, 0x00000000, 0x00000000},
	{0x000000ff, 0xffff0000, 0x00ffffff, 0xffffffff, 0xffffffff, 0xffffffff},
	{0x000000ff, 0xffff0000, 0x00ffffff, 0xffffffff, 0xffffffff, 0xff000000},
	{0x000000ff, 0xffff0000, 0x00ffffff, 0xffffffff, 0xffff0000, 0x00ffffff},
	{0x000000ff, 0xffff0000, 0x00ffffff, 0xffffffff, 0xffff0000, 0x00000000},
	{0x000000ff, 0xffff0000, 0x00ffffff, 0xffffff00, 0x0000ffff, 0xffffffff},
	{0x000000ff, 0xffff0000, 0x00ffffff, 0xffffff00, 0x0000ffff, 0xff000000},
	{0x000000ff, 0xffff0000, 0x00ffffff, 0xffffff00, 0x00000000, 0x00ffffff},
	{0x000000ff, 0xffff0000, 0x00ffffff, 0xffffff00, 0x00000000, 0x00000000},
	{0x000000ff, 0xffff0000, 0x00ffffff, 0x000000ff, 0xffffffff, 0xffffffff},
	{0x000000ff, 0xffff0000, 0x00ffffff, 0x000000ff, 0xffffffff, 0xff000000},
	{0x000000ff, 0xffff0000, 0x00ffffff, 0x000000ff, 0xffff0000, 0x00ffffff},
	{0x000000ff, 0xffff0000, 0x00ffffff, 0x000000ff, 0xffff0000, 0x00000000},
	{0x000000ff, 0xffff0000, 0x00ffffff, 0x00000000, 0x0000ffff, 0xffffffff},
	{0x000000ff, 0xffff0000, 0x00ffffff, 0x00000000, 0x0000ffff, 0xff000000},
	{0x000000ff, 0xffff0000, 0x00ffffff, 0x00000000, 0x00000000, 0x00ffffff},
	{0x000000ff, 0xffff0000, 0x00ffffff, 0x00000000, 0x00000000, 0x00000000},
	{0x000000ff, 0xffff0000, 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff},
	{0x000000ff, 0xffff0000, 0x00000000, 0xffffffff, 0xffffffff, 0xff000000},
	{0x000000ff, 0xffff0000, 0x00000000, 0xffffffff, 0xffff0000, 0x00ffffff},
	{0x000000ff, 0xffff0000, 0x00000000, 0xffffffff, 0xffff0000, 0x00000000},
	{0x000000ff, 0xffff0000, 0x00000000, 0xffffff00, 0x0000ffff, 0xffffffff},
	{0x000000ff, 0xffff0000, 0x00000000, 0xffffff00, 0x0000ffff, 0xff000000},
	{0x000000ff, 0xffff0000, 0x00000000, 0xffffff00, 0x00000000, 0x00ffffff},
	{0x000000ff, 0xffff0000, 0x00000000, 0xffffff00, 0x00000000, 0x00000000},
	{0x000000ff, 0xffff0000, 0x00000000, 0x000000ff, 0xffffffff, 0xffffffff},
	{0x000000ff, 0xffff0000, 0x00000000, 0x000000ff, 0xffffffff, 0xff000000},
	{0x000000ff, 0xffff0000, 0x00000000, 0x000000ff, 0xffff0000, 0x00ffffff},
	{0x000000ff, 0xffff0000, 0x00000000, 0x000000ff, 0xffff0000, 0x00000000},
	{0x000000ff, 0xffff0000, 0x00000000, 0x00000000, 0x0000ffff, 0xffffffff},
	{0x000000ff, 0xffff0000, 0x00000000, 0x00000000, 0x0000ffff, 0xff000000},
	{0x000000ff, 0xffff0000, 0x00000000, 0x00000000, 0x00000000, 0x00ffffff},
	{0x000000ff, 0xffff0000, 0x00000000, 0x00000000, 0x00000000, 0x00000000},
	{0x00000000, 0x0000ffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
	{0x00000000, 0x0000ffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xff000000},
	{0x00000000, 0x0000ffff, 0xffffffff, 0xffffffff, 0xffff0000, 0x00ffffff},
	{0x00000000, 0x0000ffff, 0xffffffff, 0xffffffff, 0xffff0000, 0x00000000},
	{0x00000000, 0x0000ffff, 0xffffffff, 0xffffff00, 0x0000ffff, 0xffffffff},
	{0x00000000, 0x0000ffff, 0xffffffff, 0xffffff00, 0x0000ffff, 0xff000000},
	{0x00000000, 0x0000ffff, 0xffffffff, 0xffffff00, 0x00000000, 0x00ffffff},
	{0x00000000, 0x0000ffff, 0xffffffff, 0xffffff00, 0x00000000, 0x00000000},
	{0x00000000, 0x0000ffff, 0xffffffff, 0x000000ff, 0xffffffff, 0xffffffff},
	{0x00000000, 0x0000ffff, 0xffffffff, 0x000000ff, 0xffffffff, 0xff000000},
	{0x00000000, 0x0000ffff, 0xffffffff, 0x000000ff, 0xffff0000, 0x00ffffff},
	{0x00000000, 0x0000ffff, 0xffffffff, 0x000000ff, 0xffff0000, 0x00000000},
	{0x00000000, 0x0000ffff, 0xffffffff, 0x00000000, 0x0000ffff, 0xffffffff},
	{0x00000000, 0x0000ffff, 0xffffffff, 0x00000000, 0x0000ffff, 0xff000000},
	{0x00000000, 0x0000ffff, 0xffffffff, 0x00000000, 0x00000000, 0x00ffffff},
	{0x00000000, 0x0000ffff, 0xffffffff, 0x00000000, 0x00000000, 0x00000000},
	{0x00000000, 0x0000ffff, 0xff000000, 0xffffffff, 0xffffffff, 0xffffffff},
	{0x00000000, 0x0000ffff, 0xff000000, 0xffffffff, 0xffffffff, 0xff000000},
	{0x00000000, 0x0000ffff, 0xff000000, 0xffffffff, 0xffff0000, 0x00ffffff},
	{0x00000000, 0x0000ffff, 0xff000000, 0xffffffff, 0xffff0000, 0x00000000},
	{0x00000000, 0x0000ffff, 0xff000000, 0xffffff00, 0x0000ffff, 0xffffffff},
	{0x00000000, 0x0000ffff, 0xff000000, 0xffffff00, 0x0000ffff, 0xff000000},
	{0x00000000, 0x0000ffff, 0xff000000, 0xffffff00, 0x00000000, 0x00ffffff},
	{0x00000000, 0x0000ffff, 0xff000000, 0xffffff00, 0x00000000, 0x00000000},
	{0x00000000, 0x0000ffff, 0xff000000, 0x000000ff, 0xffffffff, 0xffffffff},
	{0x00000000, 0x0000ffff, 0xff000000, 0x000000ff, 0xffffffff, 0xff000000},
	{0x00000000, 0x0000ffff, 0xff000000, 0x000000ff, 0xffff0000, 0x00ffffff},
	{0x00000000, 0x0000ffff, 0xff000000, 0x000000ff, 0xffff0000, 0x00000000},
	{0x00000000, 0x0000ffff, 0xff000000, 0x00000000, 0x0000ffff, 0xffffffff},
	{0x00000000, 0x0000ffff, 0xff000000, 0x00000000, 0x0000ffff, 0xff000000},
	{0x00000000, 0x0000ffff, 0xff000000, 0x00000000, 0x00000000, 0x00ffffff},
	{0x00000000, 0x0000ffff, 0xff000000, 0x00000000, 0x00000000, 0x00000000},
	{0x00000000, 0x00000000, 0x00ffffff, 0xffffffff, 0xffffffff, 0xffffffff},
	{0x00000000, 0x00000000, 0x00ffffff, 0xffffffff, 0xffffffff, 0xff000000},
	{0x00000000, 0x00000000, 0x00ffffff, 0xffffffff, 0xffff0000, 0x00ffffff},
	{0x00000000, 0x00000000, 0x00ffffff, 0xffffffff, 0xffff0000, 0x00000000},
	{0x00000000, 0x00000000, 0x00ffffff, 0xffffff00, 0x0000ffff, 0xffffffff},
	{0x00000000, 0x00000000, 0x00ffffff, 0xffffff00, 0x0000ffff, 0xff000000},
	{0x00000000, 0x00000000, 0x00ffffff, 0xffffff00, 0x00000000, 0x00ffffff},
	{0x00000000, 0x00000000, 0x00ffffff, 0xffffff00, 0x00000000, 0x00000000},
	{0x00000000, 0x00000000, 0x00ffffff, 0x000000ff, 0xffffffff, 0xffffffff},
	{0x00000000, 0x00000000, 0x00ffffff, 0x000000ff, 0xffffffff, 0xff000000},
	{0x00000000, 0x00000000, 0x00ffffff, 0x000000ff, 0xffff0000, 0x00ffffff},
	{0x00000000, 0x00000000, 0x00ffffff, 0x000000ff, 0xffff0000, 0x00000000},
	{0x00000000, 0x00000000, 0x00ffffff, 0x00000000, 0x0000ffff, 0xffffffff},
	{0x00000000, 0x00000000, 0x00ffffff, 0x00000000, 0x0000ffff, 0xff000000},
	{0x00000000, 0x00000000, 0x00ffffff, 0x00000000, 0x00000000, 0x00ffffff},
	{0x00000000, 0x00000000, 0x00ffffff, 0x00000000, 0x00000000, 0x00000000},
	{0x00000000, 0x00000000, 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff},
	{0x00000000, 0x00000000, 0x00000000, 0xffffffff, 0xffffffff, 0xff000000},
	{0x00000000, 0x00000000, 0x00000000, 0xffffffff, 0xffff0000, 0x00ffffff},
	{0x00000000, 0x00000000, 0x00000000, 0xffffffff, 0xffff0000, 0x00000000},
	{0x00000000, 0x00000000, 0x00000000, 0xffffff00, 0x0000ffff, 0xffffffff},
	{0x00000000, 0x00000000, 0x00000000, 0xffffff00, 0x0000ffff, 0xff000000},
	{0x00000000, 0x00000000, 0x00000000, 0xffffff00, 0x00000000, 0x00ffffff},
	{0x00000000, 0x00000000, 0x00000000, 0xffffff00, 0x00000000, 0x00000000},
	{0x00000000, 0x00000000, 0x00000000, 0x000000ff, 0xffffffff, 0xffffffff},
	{0x00000000, 0x00000000, 0x00000000, 0x000000ff, 0xffffffff, 0xff000000},
	{0x00000000, 0x00000000, 0x00000000, 0x000000ff, 0xffff0000, 0x00ffffff},
	{0x00000000, 0x00000000, 0x00000000, 0x000000ff, 0xffff0000, 0x00000000},
	{0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x0000ffff, 0xffffffff},
	{0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x0000ffff, 0xff000000},
	{0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00ffffff},
	{0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000}
};

const Dgp_UInt32 monoToGray8bit[256][2] = {
	{0xffffffff, 0xffffffff},
	{0xffffffff, 0xffffff00},
	{0xffffffff, 0xffff00ff},
	{0xffffffff, 0xffff0000},
	{0xffffffff, 0xff00ffff},
	{0xffffffff, 0xff00ff00},
	{0xffffffff, 0xff0000ff},
	{0xffffffff, 0xff000000},
	{0xffffffff, 0x00ffffff},
	{0xffffffff, 0x00ffff00},
	{0xffffffff, 0x00ff00ff},
	{0xffffffff, 0x00ff0000},
	{0xffffffff, 0x0000ffff},
	{0xffffffff, 0x0000ff00},
	{0xffffffff, 0x000000ff},
	{0xffffffff, 0x00000000},
	{0xffffff00, 0xffffffff},
	{0xffffff00, 0xffffff00},
	{0xffffff00, 0xffff00ff},
	{0xffffff00, 0xffff0000},
	{0xffffff00, 0xff00ffff},
	{0xffffff00, 0xff00ff00},
	{0xffffff00, 0xff0000ff},
	{0xffffff00, 0xff000000},
	{0xffffff00, 0x00ffffff},
	{0xffffff00, 0x00ffff00},
	{0xffffff00, 0x00ff00ff},
	{0xffffff00, 0x00ff0000},
	{0xffffff00, 0x0000ffff},
	{0xffffff00, 0x0000ff00},
	{0xffffff00, 0x000000ff},
	{0xffffff00, 0x00000000},
	{0xffff00ff, 0xffffffff},
	{0xffff00ff, 0xffffff00},
	{0xffff00ff, 0xffff00ff},
	{0xffff00ff, 0xffff0000},
	{0xffff00ff, 0xff00ffff},
	{0xffff00ff, 0xff00ff00},
	{0xffff00ff, 0xff0000ff},
	{0xffff00ff, 0xff000000},
	{0xffff00ff, 0x00ffffff},
	{0xffff00ff, 0x00ffff00},
	{0xffff00ff, 0x00ff00ff},
	{0xffff00ff, 0x00ff0000},
	{0xffff00ff, 0x0000ffff},
	{0xffff00ff, 0x0000ff00},
	{0xffff00ff, 0x000000ff},
	{0xffff00ff, 0x00000000},
	{0xffff0000, 0xffffffff},
	{0xffff0000, 0xffffff00},
	{0xffff0000, 0xffff00ff},
	{0xffff0000, 0xffff0000},
	{0xffff0000, 0xff00ffff},
	{0xffff0000, 0xff00ff00},
	{0xffff0000, 0xff0000ff},
	{0xffff0000, 0xff000000},
	{0xffff0000, 0x00ffffff},
	{0xffff0000, 0x00ffff00},
	{0xffff0000, 0x00ff00ff},
	{0xffff0000, 0x00ff0000},
	{0xffff0000, 0x0000ffff},
	{0xffff0000, 0x0000ff00},
	{0xffff0000, 0x000000ff},
	{0xffff0000, 0x00000000},
	{0xff00ffff, 0xffffffff},
	{0xff00ffff, 0xffffff00},
	{0xff00ffff, 0xffff00ff},
	{0xff00ffff, 0xffff0000},
	{0xff00ffff, 0xff00ffff},
	{0xff00ffff, 0xff00ff00},
	{0xff00ffff, 0xff0000ff},
	{0xff00ffff, 0xff000000},
	{0xff00ffff, 0x00ffffff},
	{0xff00ffff, 0x00ffff00},
	{0xff00ffff, 0x00ff00ff},
	{0xff00ffff, 0x00ff0000},
	{0xff00ffff, 0x0000ffff},
	{0xff00ffff, 0x0000ff00},
	{0xff00ffff, 0x000000ff},
	{0xff00ffff, 0x00000000},
	{0xff00ff00, 0xffffffff},
	{0xff00ff00, 0xffffff00},
	{0xff00ff00, 0xffff00ff},
	{0xff00ff00, 0xffff0000},
	{0xff00ff00, 0xff00ffff},
	{0xff00ff00, 0xff00ff00},
	{0xff00ff00, 0xff0000ff},
	{0xff00ff00, 0xff000000},
	{0xff00ff00, 0x00ffffff},
	{0xff00ff00, 0x00ffff00},
	{0xff00ff00, 0x00ff00ff},
	{0xff00ff00, 0x00ff0000},
	{0xff00ff00, 0x0000ffff},
	{0xff00ff00, 0x0000ff00},
	{0xff00ff00, 0x000000ff},
	{0xff00ff00, 0x00000000},
	{0xff0000ff, 0xffffffff},
	{0xff0000ff, 0xffffff00},
	{0xff0000ff, 0xffff00ff},
	{0xff0000ff, 0xffff0000},
	{0xff0000ff, 0xff00ffff},
	{0xff0000ff, 0xff00ff00},
	{0xff0000ff, 0xff0000ff},
	{0xff0000ff, 0xff000000},
	{0xff0000ff, 0x00ffffff},
	{0xff0000ff, 0x00ffff00},
	{0xff0000ff, 0x00ff00ff},
	{0xff0000ff, 0x00ff0000},
	{0xff0000ff, 0x0000ffff},
	{0xff0000ff, 0x0000ff00},
	{0xff0000ff, 0x000000ff},
	{0xff0000ff, 0x00000000},
	{0xff000000, 0xffffffff},
	{0xff000000, 0xffffff00},
	{0xff000000, 0xffff00ff},
	{0xff000000, 0xffff0000},
	{0xff000000, 0xff00ffff},
	{0xff000000, 0xff00ff00},
	{0xff000000, 0xff0000ff},
	{0xff000000, 0xff000000},
	{0xff000000, 0x00ffffff},
	{0xff000000, 0x00ffff00},
	{0xff000000, 0x00ff00ff},
	{0xff000000, 0x00ff0000},
	{0xff000000, 0x0000ffff},
	{0xff000000, 0x0000ff00},
	{0xff000000, 0x000000ff},
	{0xff000000, 0x00000000},
	{0x00ffffff, 0xffffffff},
	{0x00ffffff, 0xffffff00},
	{0x00ffffff, 0xffff00ff},
	{0x00ffffff, 0xffff0000},
	{0x00ffffff, 0xff00ffff},
	{0x00ffffff, 0xff00ff00},
	{0x00ffffff, 0xff0000ff},
	{0x00ffffff, 0xff000000},
	{0x00ffffff, 0x00ffffff},
	{0x00ffffff, 0x00ffff00},
	{0x00ffffff, 0x00ff00ff},
	{0x00ffffff, 0x00ff0000},
	{0x00ffffff, 0x0000ffff},
	{0x00ffffff, 0x0000ff00},
	{0x00ffffff, 0x000000ff},
	{0x00ffffff, 0x00000000},
	{0x00ffff00, 0xffffffff},
	{0x00ffff00, 0xffffff00},
	{0x00ffff00, 0xffff00ff},
	{0x00ffff00, 0xffff0000},
	{0x00ffff00, 0xff00ffff},
	{0x00ffff00, 0xff00ff00},
	{0x00ffff00, 0xff0000ff},
	{0x00ffff00, 0xff000000},
	{0x00ffff00, 0x00ffffff},
	{0x00ffff00, 0x00ffff00},
	{0x00ffff00, 0x00ff00ff},
	{0x00ffff00, 0x00ff0000},
	{0x00ffff00, 0x0000ffff},
	{0x00ffff00, 0x0000ff00},
	{0x00ffff00, 0x000000ff},
	{0x00ffff00, 0x00000000},
	{0x00ff00ff, 0xffffffff},
	{0x00ff00ff, 0xffffff00},
	{0x00ff00ff, 0xffff00ff},
	{0x00ff00ff, 0xffff0000},
	{0x00ff00ff, 0xff00ffff},
	{0x00ff00ff, 0xff00ff00},
	{0x00ff00ff, 0xff0000ff},
	{0x00ff00ff, 0xff000000},
	{0x00ff00ff, 0x00ffffff},
	{0x00ff00ff, 0x00ffff00},
	{0x00ff00ff, 0x00ff00ff},
	{0x00ff00ff, 0x00ff0000},
	{0x00ff00ff, 0x0000ffff},
	{0x00ff00ff, 0x0000ff00},
	{0x00ff00ff, 0x000000ff},
	{0x00ff00ff, 0x00000000},
	{0x00ff0000, 0xffffffff},
	{0x00ff0000, 0xffffff00},
	{0x00ff0000, 0xffff00ff},
	{0x00ff0000, 0xffff0000},
	{0x00ff0000, 0xff00ffff},
	{0x00ff0000, 0xff00ff00},
	{0x00ff0000, 0xff0000ff},
	{0x00ff0000, 0xff000000},
	{0x00ff0000, 0x00ffffff},
	{0x00ff0000, 0x00ffff00},
	{0x00ff0000, 0x00ff00ff},
	{0x00ff0000, 0x00ff0000},
	{0x00ff0000, 0x0000ffff},
	{0x00ff0000, 0x0000ff00},
	{0x00ff0000, 0x000000ff},
	{0x00ff0000, 0x00000000},
	{0x0000ffff, 0xffffffff},
	{0x0000ffff, 0xffffff00},
	{0x0000ffff, 0xffff00ff},
	{0x0000ffff, 0xffff0000},
	{0x0000ffff, 0xff00ffff},
	{0x0000ffff, 0xff00ff00},
	{0x0000ffff, 0xff0000ff},
	{0x0000ffff, 0xff000000},
	{0x0000ffff, 0x00ffffff},
	{0x0000ffff, 0x00ffff00},
	{0x0000ffff, 0x00ff00ff},
	{0x0000ffff, 0x00ff0000},
	{0x0000ffff, 0x0000ffff},
	{0x0000ffff, 0x0000ff00},
	{0x0000ffff, 0x000000ff},
	{0x0000ffff, 0x00000000},
	{0x0000ff00, 0xffffffff},
	{0x0000ff00, 0xffffff00},
	{0x0000ff00, 0xffff00ff},
	{0x0000ff00, 0xffff0000},
	{0x0000ff00, 0xff00ffff},
	{0x0000ff00, 0xff00ff00},
	{0x0000ff00, 0xff0000ff},
	{0x0000ff00, 0xff000000},
	{0x0000ff00, 0x00ffffff},
	{0x0000ff00, 0x00ffff00},
	{0x0000ff00, 0x00ff00ff},
	{0x0000ff00, 0x00ff0000},
	{0x0000ff00, 0x0000ffff},
	{0x0000ff00, 0x0000ff00},
	{0x0000ff00, 0x000000ff},
	{0x0000ff00, 0x00000000},
	{0x000000ff, 0xffffffff},
	{0x000000ff, 0xffffff00},
	{0x000000ff, 0xffff00ff},
	{0x000000ff, 0xffff0000},
	{0x000000ff, 0xff00ffff},
	{0x000000ff, 0xff00ff00},
	{0x000000ff, 0xff0000ff},
	{0x000000ff, 0xff000000},
	{0x000000ff, 0x00ffffff},
	{0x000000ff, 0x00ffff00},
	{0x000000ff, 0x00ff00ff},
	{0x000000ff, 0x00ff0000},
	{0x000000ff, 0x0000ffff},
	{0x000000ff, 0x0000ff00},
	{0x000000ff, 0x000000ff},
	{0x000000ff, 0x00000000},
	{0x00000000, 0xffffffff},
	{0x00000000, 0xffffff00},
	{0x00000000, 0xffff00ff},
	{0x00000000, 0xffff0000},
	{0x00000000, 0xff00ffff},
	{0x00000000, 0xff00ff00},
	{0x00000000, 0xff0000ff},
	{0x00000000, 0xff000000},
	{0x00000000, 0x00ffffff},
	{0x00000000, 0x00ffff00},
	{0x00000000, 0x00ff00ff},
	{0x00000000, 0x00ff0000},
	{0x00000000, 0x0000ffff},
	{0x00000000, 0x0000ff00},
	{0x00000000, 0x000000ff},
	{0x00000000, 0x00000000}
};

#endif /* _BIG_ENDIAN  */

