#ifndef BLIT_BYTE_H
#define BLIT_BYTE_H

#ifdef __cplusplus
extern "C"
{
#endif

#include "dgp_types.h"
#include "util.h"

/* blit_byte.h
   wbell 10.20.99
   rgb interleaved blitting into rgb interleaved destination
 */

/* blitSetByte()
   set a portion of a byte image to a particular value.
   will respect outside image data and will not modify
   outside the given rectangle.
   
   val - the value you want it to be set to.
   dst - pointer to the destination at dstMinX, dstMinY.
   dstBpl - bytes per line in the dest.
   dstX, dstY - where you want set, the upper left hand corner.
   dstW, dstH - how much you want cleared or set, must be positive.
*/
extern void 
DgpBlat_blitSetByte(Dgp_UInt8 val, 
		Dgp_UInt8 * dst, Dgp_Int32 dstBpl,
		Dgp_Int32 dstMinX, Dgp_Int32 dstMinY,
		Dgp_Int32 dstX, Dgp_Int32 dstY,
		Dgp_Int32 dstW, Dgp_Int32 dstH);

/*
25.8.2000 / dhtesq.
Sets a portion of an 8-bit grayscale image to the (single) passed value
at those locations where the passed source bitmap is true.

Robbed this from DgpBlat_colorBlitBinaryRGB() to blit tokens onto
cmyk separations.
*/
#ifdef _WIN32
DGP_LIBEXPORT 
#endif 
INLINE void 
DgpBlat_blitBinaryGray( Dgp_UInt32       *src,
                        Dgp_Int32        srcBpl, 
                        Dgp_Int32        srcMinX, 
                        Dgp_Int32        srcMinY,
                        Dgp_Int8         *dst, 
                        Dgp_Int32        dstBpl, 
                        Dgp_Int32        dstMinX,
                        Dgp_Int32        dstMinY,
                        Dgp_Int32        dstX,
                        Dgp_Int32        dstY,
                        Dgp_Int32        dstW, 
                        Dgp_Int32        dstH, 
                        Dgp_UInt8        value);

#ifdef __cplusplus
}
#endif
#endif
