#ifndef BLIT_RGB_H
#define BLIT_RGB_H

/* for rgb. */
#include "image.h"

#ifdef __cplusplus
extern "C"
{
#endif

/* blit_rgb.h
   wbell 10.20.99
   rgb Dgp_Int32 erleaved blitting Dgp_Int32 o rgb Dgp_Int32 erleaved destination
 */

/* blitSetRGB()
   set a portion of a rgb image to a particular value.
   will respect outside image data and will not modify
   outside the given rectangle.
   
   val - the value you want it to be set to.
   dst - poDgp_Int32 er to the destination at dstMinX, dstMinY.
   dstBpl - bytes per line in the dest.
   dstX, dstY - where you want set, the upper left hand corner.
   dstW, dstH - how much you want cleared or set, must be positive.
*/
extern void 
DgpBlat_blitSetRGB(DgpImage_RGB val, 
		DgpImage_RGB * dst, Dgp_Int32  dstBpl,
		Dgp_Int32  dstMinX, Dgp_Int32  dstMinY,
		Dgp_Int32  dstX, Dgp_Int32  dstY,
		Dgp_Int32  dstW, Dgp_Int32  dstH);

#ifdef __cplusplus
}
#endif
#endif
