/*****************************************************************
 *  Trade Secret of Xerox Corporation.                           *
 *  Copyright (c) 1991-1995, Xerox Corporation.                  *
 *  All rights reserved.                                         *
 *  Copyright protection claimed includes all forms and matters  *
 *  of copyrightable material and information now allowed by     *
 *  statutory or judicial law or hereafter granted, including    *
 *  without limitation, material generated from the software     *
 *  programs which are displayed on the screen such as icons,    *
 *  screen display looks, etc.                                   *
 *****************************************************************/

/*************************************************************************
**
**  DigiPaper Codebase
**  
**	  
**  ?;  ?
**
**  Filename:  colorBlit.h
**
**  Prototypes for colorBlit.c.
**
**	Modification history:
**	    Dillon H. Tracy esq. / March 2000
**		o  dgp types namespace issues.
**      o  extern => DGP_LIBEXPORT
**		o  Search on 'dhtesq' for some of this coder's comments & changes.
**  
**************************************************************************/

#ifndef COLOR_BLIT
#define COLOR_BLIT

#ifdef __cplusplus
extern "C"
{
#endif

/* ...for DGPIMAGE_RGB */
#include "image.h"
#include "dgp_types.h"

/*
21.8.2000 / dhtesq.
Decoder profiling suggests this is a good place for an inline...
*/
#ifdef _WIN32
DGP_LIBEXPORT 
#endif 
INLINE void 
DgpBlat_colorBlitBinaryRGB(Dgp_UInt32       *src,
                           Dgp_Int32        srcBpl, 
                           Dgp_Int32        srcMinX, 
                           Dgp_Int32        srcMinY,
                           DgpImage_RGB     *dst, 
                           Dgp_Int32        dstBpl, 
                           Dgp_Int32        dstMinX,
                           Dgp_Int32        dstMinY,
                           Dgp_Int32        dstX,
                           Dgp_Int32        dstY,
                           Dgp_Int32        dstW, 
                           Dgp_Int32        dstH, 
                           DgpImage_RGB     color);
  
#ifdef _WIN32
DGP_LIBEXPORT 
#endif
INLINE void 
DgpBlat_colorBlitRGBRGB(DgpImage_RGB        *src, 
                        Dgp_Int32           srcBpl, 
                        Dgp_Int32           srcMinX,
                        Dgp_Int32           srcMinY,
                        Dgp_UInt32          *mask, 
                        Dgp_Int32           maskBpl,
                        DgpImage_RGB        *dst,
                        Dgp_Int32           dstBpl,
                        Dgp_Int32           dstMinX, 
                        Dgp_Int32           dstMinY,
                        Dgp_Int32           dstX,
                        Dgp_Int32           dstY, 
                        Dgp_Int32           dstW, 
                        Dgp_Int32           dstH);


#ifdef __cplusplus
}
#endif

#endif
