/*
   Pedro Felzenszwalb, Summer '98.
   New color extension to position block encoder & decoder.
*/

#include "color-extension.h"
#include "PsgFix.h"

DGP_RCSID("@(#)$Header: /project/icons/cvsroot/digipaper/src/libcolcomp/color-extension.c,v 1.6 2003/01/27 21:48:29 awilliam Exp $");

ErrCode
initColors(color_cookie **_ccookie, Dgp_Bool report, Dgp_State *dgp_state) 
{
  DGP_PROLOGUE("initColors()", DGP_PERRSTATE);
  color_cookie *ccookie = NULL;

  DGP_CHECK_NULL(_ccookie);

  DGP_CHECK_ALLOC_CLEANUP(ccookie = (color_cookie *)(DGP_MALLOC)(sizeof(color_cookie)));
  ccookie->dgp_state = dgp_state;

  ccookie->colorbuf = NULL;
  ccookie->report = report;
	
  *_ccookie = ccookie;
  ccookie = NULL;

  NORMAL_RETURN;

ERR_CLEANUP:

  if(ccookie != NULL) (DGP_FREE)(ccookie);

  ERR_RETURN;
}

  
void
cleanupColors(color_cookie *ccookie) 
{
  DGP_VOID_PROLOGUE("cleanupColors()", NULL);
  Dgp_Free tmp_free;
  Dgp_Bool report = DGP_FALSE;
  
  if(ccookie == NULL) return;

  DGP_SET_ERR_STATE(ccookie->DGP_PERRSTATE);
  tmp_free = ccookie->DGP_FREE;
  report = ccookie->report;

  DGP_REPORTF0(report, "cleanupColors() begins");	
  if(ccookie->colorbuf != NULL)
	  tmp_free(ccookie->colorbuf);
  tmp_free(ccookie);
  DGP_REPORTF0(report, "cleanupColors() ends.");
}
