#include "encode-colors.h"
#ifdef VXWORKS
#include <malloc.h>
#endif
#include <stdio.h>

#define NUM_COLORS 15
#define NUM_PAGES 2

void main() {
  
  Dgp_UInt32 *all_colors[NUM_PAGES];
  Dgp_UInt32 colors0[NUM_COLORS] = { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1};
  Dgp_UInt32 colors1[NUM_COLORS] = { 1, 20000, 300, 4, 4, 6, 6, 1, 1, 20000, 11, 50, 50, 50, 50};
  Dgp_UInt32 colors2[NUM_COLORS] = { 4, 4, 4, 4, 1, 1, 20000, 11, 50, 50, 50, 50, 13, 13, 13 };
  BitArray colorflags[NUM_PAGES];
  Dgp_Bool bg_is_sampled[NUM_PAGES] = {DGP_FALSE,DGP_TRUE};
  Dgp_UInt32 bg_colors[NUM_PAGES] = { 34341, 2};
  color_cookie ccookie, ccookie_decode;
  Dgp_Int32 i;
  void **extdata[NUM_PAGES];
  void *extdata1[NUM_COLORS];
  void *extension;
  Dgp_UInt32 *colors_decode;
  Dgp_Int32 num_colors_decode, num_distinct_colors_decode;
  Dgp_UInt32 bgColor_decode;
  Dgp_Bool bg_is_sampled_decode;
  BitArray colorflags_decode;
  size_t extlen;
  tokpos_extension sorted_extdata[NUM_COLORS];

  all_colors[0] = colors0;
  all_colors[1] = colors2;  

  extdata[0] = extdata1;

  for (i = 0; i < NUM_COLORS; i++)
    extdata[0][i] = &extdata[0][i];

  colorflags[0] = baNew(NUM_COLORS);

  baSet(colorflags[0],3);
  baSet(colorflags[0],4);
  baSet(colorflags[0],5);
  baSet(colorflags[0],6);
  baSet(colorflags[0],10);
  baSet(colorflags[0],11);
  baSet(colorflags[0],12);

  colorflags[1] = baNew(NUM_COLORS);

  baSet(colorflags[1],3);
  baSet(colorflags[1],4);
  baSet(colorflags[1],5);
  baSet(colorflags[1],6);
  baSet(colorflags[1],10);
  baSet(colorflags[1],11);
  baSet(colorflags[1],12);

  ccookie = initEncodeColors(malloc,free,calloc,realloc,NUM_PAGES,
			     bg_colors, all_colors, bg_is_sampled, 
			     colorflags,extdata);
  
  fprintf(stdout,"num_colors:    %ld\n",NUM_COLORS);
  fprintf(stdout,"bgColor:       %ld\n",bg_colors[0]);
  fprintf(stdout,"bg_is_sampled: %s\n",bg_is_sampled[0]?"yes":"no");

  for (i = 0; i < NUM_COLORS; i++) {
    sorted_extdata[i].extdata = extdata[0][NUM_COLORS-(i+1)];
    fprintf(stdout,"colors[%d] = %d (%s)\n",i,all_colors[0][i],
	    (baIsSet(colorflags[0],i)?"sampled":"32-bit color"));
  }

  set_current_page(ccookie,0);
  if (!encodeColors(sorted_extdata, NUM_COLORS, ccookie, &extension,
		    &extlen)) {
    fprintf(stderr,"encodeColors failed\n");
    exit(1);
  }

  /* OK, decode our test block */
  ccookie_decode = initDecodeColors(malloc,free,calloc,realloc);
 
  if (!decodeColors(ccookie_decode,extension,extlen,&colors_decode,
		    &num_colors_decode, &num_distinct_colors_decode,
		    &bgColor_decode,&bg_is_sampled_decode,
		    &colorflags_decode)) {
    fprintf(stderr,"decodeColors failed\n");
    exit(1);
  } 
 
  fprintf(stdout,"num_colors:    %d\n",num_colors_decode);
  fprintf(stdout,"bgColor:       %ld\n",bgColor_decode);
  fprintf(stdout,"bg_is_sampled: %s\n",bg_is_sampled_decode?"yes":"no");

  for (i = 0; i < num_colors_decode; i++) {
    fprintf(stdout,"colors[%d] = %d (%s)\n",i,colors_decode[i],
	    (baIsSet(colorflags_decode,i)?"sampled":"32-bit color"));
  }

}
