#include <list.h>
#include <util.h>
#include "colorCC.h"
#include "colorCC-priv.h"
#include <dgp_state.h>
#include "dgp_utils.h"

DGP_RCSID("@(#)$Header: /project/icons/cvsroot/digipaper/src/libcomponent/colorCCcook.c,v 1.9 2000/03/04 00:22:20 mkrocken Exp $");

extern ErrCode TC_CDECL
ccc_init(Dgp_State *dgp_state, colorCC_cookie *_cookie, int width, int height, int washThreshold,
	 int minSampSize, PFNReadRun readRun)
{
  DgpAdt_ListNode retnode;
  DGPERR_INIT(ccc_init);

  ccc_cookie cookie = (ccc_cookie)*_cookie;

  if(cookie == NULL){
    DGP_SEC_MALLOC(cookie, (ccc_cookie), sizeof(ccc_state));

    DGP_ERR_PASS (DgpAdt_liNew(&cookie->ccSets, dgp_state));
  }
		
  DGP_ERR_PASS (DgpAdt_liNew(&cookie->washSets, dgp_state));

  cookie->nBlockSize = 100;
	
  DGP_SEC_CALLOC(cookie->nodeBlock, (Set *), sizeof(Set) * cookie->nBlockSize, 1);
  cookie->curNode = cookie->nodeBlock; 

  DgpAdt_liAdd(cookie->ccSets, cookie->nodeBlock, &retnode);

  cookie->readRun = readRun;
  cookie->width = width;
  cookie->height = height;
  cookie->dgp_state = dgp_state;
  cookie->minSampSize = minSampSize;

  cookie->im = rDgpImage_new(width, height, (DGP_PALLOCATORS));

  cookie->curLine = 0;
  cookie->wThresh = washThreshold;
  cookie->rCook = initReadRuns(cookie);

  *_cookie = (colorCC_cookie)cookie;

  NORMAL_RETURN;
ERR_CLEANUP:
  if(cookie != NULL){
    if(cookie->im != NULL){
      rDgpImage_free(cookie->im);
    }
    cookie->im = NULL;

    DGP_FREE(cookie);
  }

  ERR_RETURN;

}

void ccc_freeCookie(colorCC_cookie _cookie)
{
  ccc_cookie cookie = (ccc_cookie)_cookie;

  if(cookie->im != NULL){
    rDgpImage_free(cookie->im);
  }
	
  DgpAdt_liFree(cookie->ccSets);		

  cookie->DGP_FREE(cookie);

  return;
}

