#include "colorCC.h"
#include "colorCC-priv.h"

DGP_RCSID("@(#)$Header: /project/icons/cvsroot/digipaper/src/libcomponent/colorCCrim.c,v 1.4 2000/03/04 00:22:20 mkrocken Exp $");


RunImage rDgpImage_new(int width, int height, Dgp_Allocators *a)
{
  RunImage im;

  im = (RunImage) a->malloc(sizeof(*im));
	
  im->width = width;
  im->height = height;
  im->a = a;

  im->rows = (RunRow *) a->malloc(sizeof(RunRow) * (height + 1));
  if(im->rows == NULL){
    goto bailout;
  }
  im->rows[0].offset = 0;

  im->size = width * 10;
  im->runs = (Run *)a->malloc(sizeof(Run) * im->size);
  if(im->runs == NULL){
    goto bailout;
  }

  return im;

bailout:
  return NULL;
}

void rDgpImage_free(RunImage im)
{
  if(im->rows != NULL){
    im->a->free(im->rows);
  }

  if(im->runs!= NULL){
    im->a->free(im->runs);
  }

  im->a->free(im);
}
