#ifndef ORIENTATION_H
#define ORIENTATION_H

/* orientation.h
   wbell 10/12/99
   some orientation manipulation functions.
 */

#include "dgp_state.h"
#include "util.h"
#include "orientation_t.h"

#ifdef __cplusplus
extern "C"
{
#endif

#define  ISVALIDORIENT(o) \
  (((o) == ORIENT_RD) || ((o) == ORIENT_UR) || ((o) == ORIENT_RU) \
   || ((o) == ORIENT_LU) || ((o) == ORIENT_DL) || ((o) == ORIENT_DL) \
   || ((o) == ORIENT_DR) || ((o) == ORIENT_UL) || ((o) == ORIENT_LD)) 

/* determines if 2 orientations are rotated from one another (that some  */
/* series of transformations will get from one to another contains a  */
/* rotation) */
Dgp_Bool 
DgpCoord_isRotated(DgpCoord_Orientation o1, DgpCoord_Orientation o2);

/* given a two character string such as "RD", returns the orientation  */
/* associated with those chars. Will handle case. */
ErrCode
DgpCoord_strOrient(char str[2], DgpCoord_Orientation * po, Dgp_State * dgp_state);

/* given an orientation and a 2 character buffer, this will fill in those */
/* to chars, such as "RD" for ORIENT_RD */
ErrCode
DgpCoord_orientStr(DgpCoord_Orientation o, char str[2], Dgp_State * dgp_state);

#ifdef __cplusplus
}
#endif

#endif /* ORIENTATION_H */
