/*
*
* $Header: /project/icons/cvsroot/digipaper/src/libcoord/resolution_t.h,v 1.3 2000/03/04 00:22:20 mkrocken Exp $
*
*/

#ifndef RESOLUTION_T_H
#define RESOLUTION_T_H

#include "util.h"
#include "dgp_types.h"

#ifdef __cplusplus
extern "C"
{
#endif
	
/* File DgpCoord_Rat.h
wbell 6/8/98
DgpCoord_Rational type and manipulation routines.
*/

typedef struct{
	Dgp_Int32 num;
	Dgp_Int32 den;
} DgpCoord_Rat;

/* Defines two dimensional DgpCoord_Rational resolution. */

typedef struct {
	DgpCoord_Rat xRes;
	DgpCoord_Rat yRes;
} DgpCoord_Resolution;


DGP_LIBEXPORT Dgp_Int32 
DgpCoord_greatest_common_div(Dgp_Int32 m, Dgp_Int32 n);

DGP_LIBEXPORT Dgp_Int32 
DgpCoord_least_common_mul(Dgp_Int32 i, Dgp_Int32 j);

DGP_LIBEXPORT DgpCoord_Rat 
DgpCoord_eqi(Dgp_Int32 i);

DGP_LIBEXPORT DgpCoord_Rat 
DgpCoord_invert(DgpCoord_Rat r);

DGP_LIBEXPORT DgpCoord_Rat 
DgpCoord_eq(Dgp_Int32 num, Dgp_Int32 den);

DGP_LIBEXPORT void 
DgpCoord_normalize(DgpCoord_Rat *r);

DGP_LIBEXPORT DgpCoord_Rat 
DgpCoord_muli(DgpCoord_Rat r, Dgp_Int32 x);

DGP_LIBEXPORT DgpCoord_Rat 
DgpCoord_mul(DgpCoord_Rat r1, DgpCoord_Rat r2);

DGP_LIBEXPORT DgpCoord_Rat 
DgpCoord_add(DgpCoord_Rat r1, DgpCoord_Rat r2);

DGP_LIBEXPORT DgpCoord_Rat 
DgpCoord_div(DgpCoord_Rat r1, DgpCoord_Rat r2);

DGP_LIBEXPORT DgpCoord_Rat 
DgpCoord_divi(DgpCoord_Rat r, Dgp_Int32 x); 

DGP_LIBEXPORT DgpCoord_Rat 
DgpCoord_idiv(Dgp_Int32 x, DgpCoord_Rat r); 

DGP_LIBEXPORT Dgp_Int32 
DgpCoord_floor(DgpCoord_Rat r);

DGP_LIBEXPORT Dgp_Int32 
DgpCoord_ceil(DgpCoord_Rat r);

DGP_LIBEXPORT DgpCoord_Rat 
DgpCoord_sub(DgpCoord_Rat r1,DgpCoord_Rat r2);

DGP_LIBEXPORT Dgp_Bool 
DgpCoord_gei(DgpCoord_Rat r, Dgp_Int32 x);

DGP_LIBEXPORT Dgp_Bool 
DgpCoord_equal(DgpCoord_Rat r1, DgpCoord_Rat r2);

DGP_LIBEXPORT Dgp_Bool 
DgpCoord_ge(DgpCoord_Rat r1, DgpCoord_Rat r2);

DGP_LIBEXPORT Dgp_Bool 
DgpCoord_g(DgpCoord_Rat r1, DgpCoord_Rat r2);

DGP_LIBEXPORT Dgp_Bool 
DgpCoord_l(DgpCoord_Rat r1, DgpCoord_Rat r2);

DGP_LIBEXPORT Dgp_Bool 
DgpCoord_le(DgpCoord_Rat r1, DgpCoord_Rat r2);

DGP_LIBEXPORT Dgp_Float32 
DgpCoord_float(DgpCoord_Rat r);

DGP_LIBEXPORT Dgp_Float64 
DgpCoord_double(DgpCoord_Rat r);

#define DGPCOORD_RAT_ZERO DgpCoord_eq(0,1)

#ifdef __cplusplus
}
#endif

#endif /* RESOLUTION_T_H */
