/*****************************************************************
 *  Trade Secret of Xerox Corporation.                           *
 *  Copyright (c) 1991-1995, Xerox Corporation.                  *
 *  All rights reserved.                                         *
 *  Copyright protection claimed includes all forms and matters  *
 *  of copyrightable material and information now allowed by     *
 *  statutory or judicial law or hereafter granted, including    *
 *  without limitation, material generated from the software     *
 *  programs which are displayed on the screen such as icons,    *
 *  screen display looks, etc.                                   *
 *****************************************************************/


#ifndef _SILX_DECODEE_H
#define _SILX_DECODEE_H

#ifdef __cplusplus
extern "C"
{
#endif

#include "image.h"
#include "image_defs.h"

/* image type */

#define SILXPAGERGB 0
#define SILXPAGEMONOPACKED 1
#define SILXPAGECMYK 2


/*********
 * typedefs
 */

typedef struct SilxDecState *SilxDecCookie;

DGP_LIBEXPORT ErrCode silx_initDecState(Dgp_State *dgp_state, SilxDecCookie *sOpt);

DGP_LIBEXPORT ErrCode
silx_setDecState(
               Dgp_State        *dgp_state,       
               SilxDecCookie    sOpt,             
               Dgp_Bool         *forceColor,    
               Dgp_Bool         *forceMono,  
               Dgp_Int32        *rotation,
               Dgp_Int32        *startPage,
               Dgp_Int32        *stopPage,   
               Dgp_Bool         *verbose,  
               Dgp_Int32        *stripSize,   
               Dgp_Bool         *jbig2Only,  
               Dgp_Bool         *imagesOnly,    
               Dgp_Int32        *outputRes,   
               Dgp_Bool         *outToFile,  
               Dgp_Int8         **outType,  
               Dgp_Int8         **outFileName);

DGP_LIBEXPORT void
silx_cleanDecState(    Dgp_State *dgp_state,  SilxDecCookie *sOpt);

DGP_LIBEXPORT ErrCode 
silx_decDocumentHeader(Dgp_State *dgp_state, SilxDecCookie sOpt, void *fp, Dgp_Int32 *numPages); 

DGP_LIBEXPORT ErrCode 
silx_decDocumentAll( Dgp_State  *dgp_state, SilxDecCookie sOpt, void *fp);

DGP_LIBEXPORT ErrCode 
silx_decPageHeader(Dgp_State *dgp_state, SilxDecCookie sOpt, Dgp_Int32 pageNum, 
                             Dgp_Int32 *width,
                             Dgp_Int32 *height,
                             Dgp_Int32 *pageType,
                             Dgp_Float64 *res
                             ); 
DGP_LIBEXPORT ErrCode
silx_setDecStreamHandler(
                         Dgp_State *dgp_state,       
                         SilxDecCookie _sOpt,         
                         void *docUds);
DGP_LIBEXPORT ErrCode 
silx_decPage(Dgp_State *dgp_state, SilxDecCookie sOpt, void **image);

#ifdef __cplusplus
}
#endif

#endif /* _SILX_DECODE_H */
