#ifndef _SILX_DECODEE_PRIV_H
#define _SILX_DECODEE_PRIV_H
#ifdef __cplusplus
extern "C"
{
#endif

#include <math.h>
#include "dgp_err_control.h"
#include "util.h"
#include "orientation_t.h"
#include "santa.h"
#include "santa_page.h"
#include "image.h"
#include "orientation.h"
#include "image_defs.h"

typedef struct
{
    Dgp_Bool force;         /* Force output page type */
    santaPageType forceType;/* page type ( santaPageMono/ santaPageColor), only useful when force is set to TRUE. */
    Dgp_Int32 stripSize;    /* height of a strip */
    Dgp_Bool stripwise;     /* Turn on true stripwise decompositions. */
    DgpCoord_Orientation o;
    Dgp_Int32 startPageNum; /* start page number */
    Dgp_Int32 stopPageNum;  /* stop page number */
    Dgp_Bool  outToStdout;      /* output to standard output */
    Dgp_Bool  outToBuffer;      /* output to buffer */
    Dgp_Bool  outToFile;
    Dgp_Int32 outtype;
    Dgp_Int8  ext[32];
    Dgp_Int8  *outFileName;
    Dgp_Bool verbose;
    DgpCoord_Resolution output_res;
    Dgp_Bool scale_me;
    Dgp_Bool do_cmyk;       /*  cmyk (all separations at once) decodes. */
    Dgp_Bool jbig2_only;    /*  token data only. */
	Dgp_Bool images_only;	/*  image data only. */
    Dgp_Bool inited;
    uds 	 docUds;
    santaDoc    * pDoc;
    santaPage    * pPage;
    TIFF      *tiff;        /* TIFF pointer */
} SilxDecState;

ErrCode handleMonoPage( SilxDecState                *sOpt, 
                        Dgp_Int8                    *outName, 
                        Dgp_Int32                   pgXRes, 
                        Dgp_Int32                   pgYRes,
                        DgpImage_Packed             pageIm, 
                        Dgp_State                   *dgp_state,
                        TIFF                        **tiff,
                        Bool                        firstPage,
                        Bool                        lastPage);

ErrCode 
handleColorPage(         SilxDecState               *sOpt, 
                         Dgp_Int8                   *outName, 
                         Dgp_Int32                  pgXRes, 
                         Dgp_Int32                  pgYRes, 
                         DgpImage_ColorRGB          pageIm,
                         Dgp_State                  *dgp_state,
                         TIFF                       **tiff,
                         Bool                       firstPage,
                         Bool                       lastPage);
ErrCode
handleCMYKPage(          SilxDecState               *sOpt,
                         Dgp_Int8                   *outName,
                         Dgp_Int32                  pgXRes,
                         Dgp_Int32                  pgYRes,
                         void                       **pageIm,
                         Dgp_State                  *dgp_state,
                         TIFF                       **tiff,
                         Bool                       firstPage,
                         Bool                       lastPage);
#ifdef __cplusplus
}
#endif

#endif /* _SILX_DECODE_PRIV_H */

