/* $Header: /project/icons/cvsroot/digipaper/src/libdeskew/deskew_bmp.h,v 1.6 2001/05/08 00:42:54 dtracy Exp $ */

#ifndef DESKEW_BMP_H
#define DESKEW_BMP_H

#include <stdio.h>
#include "dgp_types.h"
#include "dgp_state.h"

#ifdef __cplusplus
extern "C"
{
#endif

/* deskew a bitmap given:
     ipstate --  assumed to be valid (already initialized).
     old_bmp,
     old_w,
     old_h   -- old bitmap, width and height.  The original bitmap is
                left untouched by this function.
     new_bmp,
     new_w,
     new_h,
     new_lpl -- new bitmap, width, height, and longsperline.
                NOTE: You should call scSetAllocators if you want to change
		the malloc used to create the new bitmap.  (free may also be
		used, but only if the function fails).
     skew_angle -- need i say?
     err_out -- stream to which errors should be printed, iff not NULL.
     a       -- pointer to structure as defined in dgp_allocators.h of memory
                allocators to be used.
     max_w,
     max_h   -- maximum dimensions for new bmp.
*/
extern ErrCode
DgpDeskew_bmp(Dgp_UInt32 *old_bmp, Dgp_Int32 old_w, Dgp_Int32 old_h,
	   Dgp_Int32 old_lpl, Dgp_UInt32 **new_bmp, Dgp_Int32 *new_w, Dgp_Int32 *new_h, 
	   Dgp_Int32 *new_lpl, Dgp_Float32 skew_angle, Dgp_Int32 max_w, Dgp_Int32 max_h,
     Dgp_State *dgp_state);

#ifdef __cplusplus
}
#endif

#endif /* DESKEW_BMP_H */
