#ifndef __SILX_ENCODE_PRIV_H__
#define __SILX_ENCODE_PRIV_H__

#include "tok-lossy.h"
#include "tok-lossless.h"
#include "jtokapi.h"
#include "token-compress.h"
#include "jbig2file.h"
#include "mrc2file.h"

#ifdef __cplusplus
extern "C"
{
#endif


/****************
 *
 * Define default values.
 */

/* Baseline orientations for deskewing. */
#define BO_DOWN   0
#define BO_UP     1
#define BO_LEFT   2
#define BO_RIGHT  3


#define DEF_VERBOSE     DGP_FALSE
#define DEF_LOSSLESS    DGP_FALSE
#define DEF_FRACHAUSD   (Dgp_Float32)(0.97)
#define DEF_WIDTHDIFF   1
#define DEF_HEIGHTDIFF  1
#define DEF_MAXDENSITY  3
#define DEF_COMMITTHRESH 10000
#define DEF_FREEZEHISTTHRESH 10000
#define DEF_MAKEHISTTHRESH 10
#define DEF_RETURNHISTTHRESH 0
#define DEF_DILATIONRADIUS 1
#define DEF_SIZETHRESH  1
#define DEF_WRITETHRESH 10
#define DEF_NEARESTNEIGHBORS 8
#define DEF_XSHIFT      3
#define DEF_XSLOPECHANGE 6
#define DEF_XNEWSLOPE   2.0
#define DEF_LOWERDILATIONLIMIT  6
#define DEF_NONTP       DGP_FALSE
#define DEF_INCRDICT            50
#define DEF_CLEARDICT           100
#define DEF_BASELINEORIENT BO_DOWN
#define DEF_DESKEWACCURACY 3        /* [0...5] */
#define DEF_DESKEW DGP_FALSE
#define DEF_GRAYHALFTONE  DGP_FALSE
#define DEF_FORCE_RES      -1
#define DEF_OUTPUT_RES 300
#define DEF_RES            300
#define DEF_JPEG_OUTPUT_RES      100
#define DEF_JPEG_QUALITY       90
#define DEF_ROTATION            0
#define DEF_NODESKEW    DGP_FALSE
#define DEF_NOALIGN     DGP_FALSE
#define DEF_INSTRUMENT  DGP_FALSE
#define DEF_G4TOKENS    DGP_FALSE
#define DEF_ERRFILENAME "stderr"
#define DEF_MEMBOND             -1
#define DEF_NOERROROUT  DGP_FALSE
#define DEF_TOKENSIZELIMIT DGP_TRUE
#define DEF_REDTOKNOISE DGP_FALSE
#define DEF_JBIG2_PROFILE 2
#define DEF_MEMBOND  -1
#define DEF_DESKEWACCURACY 3
#define DEF_JBIG2PROFILE 2
#define DEF_JB2ONLY DGP_FALSE

/*****************************************************
 *  Holds options and status for encoding
 */
typedef struct{
    DgpApi_Handle api_handle;
    DgpApi_Options opts;
    tokOptions tokOpt;
    LlTokOptions llTokOpt;
    Dgp_Bool no_err_out;
    DgpTdc_JpegCompInfo jpegComp;
    Dgp_Int32 jpegQual;
    Dgp_Int32 jpegRes;
    Dgp_Bool lossless;
    uds outUds;
    Dgp_Int32 incrementalDict;
    Dgp_Int32 outputRes;
    Dgp_Int32 clearDict;
    Dgp_Bool redTokNoise;
    Dgp_Bool jb2Only;
    Dgp_CompressedDocument	*pCDoc;
    DgpAdt_List pd_list;
    Dgp_Int32 page_num;
}SilxEncState;


typedef struct {
  FILE *errfile;
  FILE *rptfile;
} statusOutputFiles;

/* some function prototypes */

ErrCode
Dgp_segmentation (
          PIXR* read, 
          Dgp_CompressedPage *cPage, 
		  Dgp_Int32 jpeg_dpi,
		  Dgp_Int32 jpeg_qual,
		  Dgp_Int32 sizeThresh,
          sc_cc **text_cc, 
          Dgp_UInt32 *numccs,
          DgpImage_Gray *grayImage);


#ifdef __cplusplus
}
#endif
#endif
