/*
 *
 * $Header: /project/icons/cvsroot/digipaper/src/libencode/mqcoder.h,v 1.2 2000/11/06 22:00:17 mkrocken Exp $
 *
 */

#ifndef	MQCODER_H

#define	MQCODER_H

#include "util.h"
#include "dgp_state.h"
#include <stddef.h>
#include <sys/types.h>

/*
 * Status description of an arithmetic encoder
 */

typedef struct DgpEncode_MQEncoder {
    Dgp_UInt32 c;	/* Base of coding interval */
    Dgp_UInt16 a;   /* Size of coding interval */
    Dgp_Int32 ct;		/* Bit shift counter */
    Dgp_UInt8 b;	/* Buffer for output byte */
    Dgp_Bool (*byte_out)(Dgp_UInt8 b, void *userdata);
    				   /* compressed data output callback */
    void *userdata;                          /* parameter passed to byte_out */
	Dgp_State *dgp_state;
    enum {
	MQE_START,
	MQE_OK
	} state;
    } DgpEncode_MQEncoder;

/*
 * Status description of an arithmetic decoder
 */

typedef struct _DgpEncode_MQDecoder {
    Dgp_UInt32 c;	/* Base of coding interval */
    Dgp_UInt16 a;   /* Size of coding interval */
    Dgp_UInt8 b;	/* Buffer for input byte */
    Dgp_Int32 ct;		/* Bit shift counter */
    Dgp_UInt8 *bp;	/* pointer to next data byte */
    Dgp_UInt8 *bp_end;	/* pointer to byte after last valid byte */
    Dgp_Bool (*data_in)(Dgp_UInt8 **buffer, size_t *buflen,
		       void *userdata);	/* callback for more data */
    void *userdata;
	Dgp_State *dgp_state;
    enum {
	MQD_END,
	MQD_NODATA,
	MQD_OK
	} state;
    } DgpEncode_MQDecoder;

extern void 
DgpEncode_mqeInit(DgpEncode_MQEncoder *encoder,
		    Dgp_Bool (*byte_out)(Dgp_UInt8 b, void *userdata),
		    void *userdata, Dgp_State *dgp_state);
extern Dgp_Bool 
DgpEncode_mqeFlush(DgpEncode_MQEncoder *encoder);
extern Dgp_Bool 
DgpEncode_mqeEncode(DgpEncode_MQEncoder *encoder, Dgp_UInt8 *context, Dgp_Int32 bit);

extern void 
DgpEncode_mqdInit(DgpEncode_MQDecoder *decoder, Dgp_UInt8 *buffer, size_t buflen,
		    Dgp_Bool (*data_in)(Dgp_UInt8 **buffer, size_t *buflen,
				       void *userdata),
		    void *userdata, Dgp_State *dgp_state);
extern Dgp_Int32 
DgpEncode_mqdDecode(DgpEncode_MQDecoder *decoder, Dgp_UInt8 *context);
extern Dgp_Bool 
DgpEncode_mqdEndSeen(DgpEncode_MQDecoder *decoder);
extern Dgp_UInt8* 
DgpEncode_mqdFinish(DgpEncode_MQDecoder *decoder);

extern void 
DgpEncode_mqdInitSW(DgpEncode_MQDecoder *decoder, Dgp_UInt8 *buffer, size_t buflen,
		      Dgp_Bool (*data_in)(Dgp_UInt8 **buffer,
					 size_t *buflen,
					 void *userdata),
		      void *userdata, Dgp_State *dgp_state);
extern Dgp_Int32 
DgpEncode_mqdDecodeSW(DgpEncode_MQDecoder *decoder, Dgp_UInt8 *context);
extern Dgp_Bool 
DgpEncode_mqdEndSeenSW(DgpEncode_MQDecoder *decoder);
extern Dgp_UInt8* 
DgpEncode_mqdFinishSW(DgpEncode_MQDecoder *decoder);


#endif
