/*************************************************************************
**
**  DigiPaper Codebase
**    
**  James Ahlborn, September 1 1999
**
**  Filename: dgp_err_cotrol_priv.h
**
**  Description of what's implemented in this file:
**    macros to simplify error reporting.
**  
**************************************************************************/

/*
 * RCS Header
 *
 * $Header: /project/icons/cvsroot/digipaper/src/liberr/dgp_err_control_priv.h,v 1.13 2000/04/12 23:05:45 dtracy Exp $
 */

#ifndef __DGP_ERR_CONTROL_PRIV_H
#define __DGP_ERR_CONTROL_PRIV_H

#include "dgp_err_control.h"

#ifdef __cplusplus
extern "C"
{
#endif


/* Function to create an error state. */
ErrCode
Dgp_initDgpErrState(Dgp_ErrState **_dgp_err, Dgp_Allocators *a, 
                void *userErrCookie, Dgp_ErrPrinterType errPrinter);

/* Function to cleanup an error state */
void
Dgp_cleanupDgpErrState(Dgp_ErrState **_dgp_err, Dgp_Allocators *a);

#ifdef __cplusplus
}
#endif

#endif /* __DGP_ERR_CONTROL_PRIV_H */
