/*************************************************************************
**
**  DigiPaper Codebase
**    
**  James Ahlborn, January 1, 2000
**
**  Filename: dgp_errs.h
**
**  Description of what's implemented in this file:
**    digipaper error codes.
**  
**************************************************************************/

/*
 * RCS Header
 *
 * $Header: /project/icons/cvsroot/digipaper/src/liberr/dgp_errs.h,v 1.8 2001/12/13 19:37:13 jlin Exp $
 */

#ifndef __DGP_ERRS_H
#define __DGP_ERRS_H

#ifdef __cplusplus
extern "C"
{
#endif

/* Errors from 1 - 9999 are reserved for ipcore,
 * so, Errors from 10,000 - 10,999 are Digipaper errors
 */
#define DGP_BASE_GEN_ERR 10000
#define DGP_MAX_GEN_ERR 10999


#define cErrFileNotFound       DGP_BASE_GEN_ERR + 0 /* could not open desired file */
#define cErrIntBufOverflow     DGP_BASE_GEN_ERR + 1 /* internal buffer overflow */
#define cErrInternalIpcoreErr  DGP_BASE_GEN_ERR + 2 /* error within ipcore code */
#define cErrAssertFailure      DGP_BASE_GEN_ERR + 3 /* dgp assert failed */
#define cErrInvalidCmdLine     DGP_BASE_GEN_ERR + 4 /* invalid command line */
#define cErrInsufficientMem    DGP_BASE_GEN_ERR + 5 /* insufficient memory */
#define cErrPanic              DGP_BASE_GEN_ERR + 6 /* internal consistency check failure */

/*	Two exceptions for stack type in libadt.  Added 7.2.00 / dhtesq. */
#define cADTNullStackRequested		DGP_BASE_GEN_ERR + 7  /* libadt:  requested nonpositive stack elements. */
#define cADTSmallerStackRequested	DGP_BASE_GEN_ERR + 8  /* libadt:  requested stack reallocation w/fewer elements. */

/*  Three procedural exceptions for libscancolor.  Added 7.2.2000 / dhtesq. */
#define cSCCantScaleBackground		DGP_BASE_GEN_ERR + 9	 /* libscancolor:  xres != yres. */
#define cSCNotInStageInit			DGP_BASE_GEN_ERR + 10 /* libscancolor:  function called out of sequence. */
#define cSCNotInStageFindText		DGP_BASE_GEN_ERR + 11 /* libscancolor:  ditto. */

/* Exceptions for libjpeg. Added 3/20/2000, ranjani */
#define cJpegInternalPanicErr       DGP_BASE_GEN_ERR + 12 /*corrupt data */
#define cJpegOutOfMemoryErr         DGP_BASE_GEN_ERR + 13 /*out of memory error */
#define cJpegNotAJpegFile           DGP_BASE_GEN_ERR + 14 /*not a jpeg file at all */
#define cJpegIOErr			        DGP_BASE_GEN_ERR + 15 /*file io error */
#define cTFXDictionaryLimitErr	  DGP_BASE_GEN_ERR + 16 /*tfx dicioanry error */

/* 
 * ATTENTION: Please read the section on New Error Codes in "Error Handling.htm" 
 *  before adding your own, thanks. 
 */

#ifdef __cplusplus
}
#endif

#endif /* __DGP_ERRS_H */
