/*************************************************************************
**
**  DigiPaper Codebase
**    
**  James Ahlborn, September 1 1999
**
**  Filename: dgp_str_err.c
**
**  Description of what's implemented in this file:
**    functions for default error ouput to a string
**  
**************************************************************************/

/*
 *
 * $Header: /project/icons/cvsroot/digipaper/src/liberr/dgp_str_err.c,v 1.9 2000/11/08 17:25:24 mkrocken Exp $
 *
 */

#include "dgp_err_control.h"
#include "dgp_err_printers.h"
#include "stdio.h"

DGP_RCSID("@(#)$Header: /project/icons/cvsroot/digipaper/src/liberr/dgp_str_err.c,v 1.9 2000/11/08 17:25:24 mkrocken Exp $");

#ifdef DGP_DBUG

/* default function to output debug errors to a string */
void 
Dgp_strErrPrinter(void *cookie, const Dgp_Int8 *file_name, const Dgp_Int8 *funct_name,
                 Dgp_Int32 line_number, ErrCode error, const Dgp_Int8 *format, ...)
{
  va_list(arglist);
  Dgp_Int32 len;

  if(cookie) {
    va_start(arglist, format);
    if(error == DGP_REPORT) {
      len = sprintf((Dgp_Int8 *)cookie, "Report -- ");
    } else if(error == DGP_WARNING) {
      len = sprintf((Dgp_Int8 *)cookie, "Warning -- ");
    } else {
      len = sprintf((Dgp_Int8 *)cookie, "Error %d, \"%s\", line %d, %s -- ", (int)error, file_name, (int)line_number, funct_name);
    } 
    if(format != NULL) vsprintf(((Dgp_Int8 *)cookie + len), format, arglist);
  }
}

#else /* DGP_DBUG is not defined */

/* default function to output debug errors to a string */
void 
Dgp_strErrPrinter(void *cookie, ErrCode error, const Dgp_Int8 *format, ...)
{
  va_list(arglist);
  Dgp_Int32 len;

  if(cookie) {
    va_start(arglist, format);
    if(error == DGP_REPORT) {
      len = sprintf((Dgp_Int8 *)cookie, "Report -- ");
    } else if(error == DGP_WARNING) {
      len = sprintf((Dgp_Int8 *)cookie, "Warning -- ");
    } else {
      len = sprintf((Dgp_Int8 *)cookie, "Error %d -- ", (int)error);
    }
    if(format != NULL) vsprintf(((Dgp_Int8 *)cookie + len), format, arglist);
  }
}

#endif
