/*
 *
 * $Header: /project/icons/cvsroot/digipaper/src/liberr/dgp_w32_err_control.c,v 1.6 2000/03/18 02:04:04 jahlborn Exp $
 *
 */

#ifdef _WIN32

#include <windows.h>
#include "dgp_w32_err_control.h"

DGP_RCSID("@(#)$Header: /project/icons/cvsroot/digipaper/src/liberr/dgp_w32_err_control.c,v 1.6 2000/03/18 02:04:04 jahlborn Exp $");


#ifdef DGP_DBUG

void
Dgp_w32ErrPrinter(Dgp_ErrState *dgp_err_state, const Dgp_Int8 *file_name, const Dgp_Int8 *funct_name,
                    Dgp_Int32 line_number, ErrCode error)
{
	Dgp_Int8 *errString = NULL;
		
	FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_ALLOCATE_BUFFER,
				  NULL,		  
				  (DWORD)(error - cDgpW32),
				  0,
				  (Dgp_Int8 *)&errString,
				  1,
				  NULL);

  dgp_err_state->errPrinter(dgp_err_state->userCookie, file_name, funct_name, 
    line_number, error, errString);

	LocalFree(errString);  
}

#else /* DGP_DBUG is not defined */

void
Dgp_w32ErrPrinter(Dgp_ErrState *dgp_err_state, ErrCode error)
{
	Dgp_Int8 *errString = NULL;
		
	FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_ALLOCATE_BUFFER,
				  NULL,		  
				  (DWORD)(error - cDgpW32),
				  0,
				  (Dgp_Int8 *)&errString,
				  1,
				  NULL);

  dgp_err_state->errPrinter(dgp_err_state->userCookie, error, errString);

	LocalFree(errString);  
}

#endif /* DGP_DBUG */

#endif /* _WIN32 */
