/* $Header: /project/icons/cvsroot/digipaper/src/libg4/g3.h,v 1.1 2001/10/25 16:55:38 mkrocken Exp $ */

#ifndef __G3_H
#define __G3_H

#include <stdio.h>

#include "util.h"
#include "dgp_allocators.h"
#include "dgp_err_control.h"
#include "dgp_state.h"

#include "pixr.h"

#ifdef __cplusplus
extern "C"
{
#endif

ErrCode 
g3_1DDecode(Dgp_UInt32 *image, Dgp_Int32 width, Dgp_Int32 height,
	    Dgp_Int32 longsPerRow, Dgp_Int32 xoffset, Dgp_Int32 xmax, Dgp_Int32 ymax,
	    Dgp_UInt8 *input, size_t inlen,
	    Dgp_Bool eatEOFB, size_t *consumed,
	    Dgp_State *dgp_state);

ErrCode 
g3_1DDecodeC(void *_ed, Dgp_UInt32 *image, Dgp_Int32 width, Dgp_Int32 height,
	     Dgp_Int32 longsPerRow, Dgp_Int32 xoffset, Dgp_Int32 xmax, Dgp_Int32 ymax,
	     Dgp_UInt8 *input, size_t inlen,
	     Dgp_Bool eatEOFB, size_t *consumed);

ErrCode 
g3_2DDecode(Dgp_UInt32 *image, Dgp_Int32 width, Dgp_Int32 height,
	    Dgp_Int32 longsPerRow, Dgp_Int32 xoffset, Dgp_Int32 xmax, Dgp_Int32 ymax,
	    Dgp_UInt8 *input, size_t inlen,
	    Dgp_Bool eatEOFB, size_t *consumed,
	    Dgp_State *dgp_state);


g3_2DDecodeC(void *_ed, Dgp_UInt32 *image, Dgp_Int32 width, Dgp_Int32 height,
	     Dgp_Int32 longsPerRow, Dgp_Int32 xoffset, Dgp_Int32 xmax, Dgp_Int32 ymax,
	     Dgp_UInt8 *input, size_t inlen,
	     Dgp_Bool eatEOFB, size_t *consumed);


#ifdef __cplusplus
}
#endif

#endif /* __G3_H */


