#ifndef HALFUTIL
#define HALFUTIL
#include <util.h>
#include <tok-lossless.h>

#include "halftone.h"

#ifdef __cplusplus
extern "C"
{
#endif

boolean
DoHalftoneFinding(pHalfTokState halfTokState, DgpState *dgp_state, IPWState *ipstate, UInt8 **image,
	Int32 xSize, Int32 ySize, Int32 bpl, int xRes, int yRes, PIXR **retPixr, 
	UInt8 *cell_size, tokpos **boxes, int *numBoxes, boolean report);


boolean HammingReplace(DgpState *dgp_state, 
			   int cell_size,		/*work on tokens (SIZEFAC * cell_size) x (SIZEFAC * cell_size)  */
		       int start_hamdist,	/*the beginning hamming distance to start searching at */
		       int end_hamdist,		/*the end hamming distance  */
		       unsigned int border_usecount, /* > this goes in the tokenizer, <= potentially replaces */
		       List tokOutput,		/*token list, this gets edited to rmove gone tokens */
		       PageInfo *pages,     /* boxes, and numBoxes for page */
		       int numPgs,		/*how many pages */
		       int last_token_written,	/*<= this number tokens don't get inserted or replaced */
			   boolean report);

/*0 on success, 1 on failure */
UInt8 GoThroughHalftone(allocators *a,
			IPWState *pIPWState, 
			PIXR *pbS, 
			pHalfTokState halftokstate,
			pHALFTONEPIC pinfo,
			tokpos **tps,
			int *tpsnum);


UInt8 PaintUniqueHalftones(IPWState *pIPWState, List tokens, 
			   tokpos *positions, long numboxes, 
			   PIXR *model, int side_length);

ErrCode
makeSpiralHalftonePattern (Dgp_State *dgp_state, Dgp_UInt32 grid_size, 
                           Dgp_UInt32 range, Dgp_Bool inverse, jb2Pattern *cells);

#ifdef __cplusplus
}
#endif

#endif
