/*************************************************************************
**
**  DigiPaper Codebase
**    
**  James Ahlborn, January 1, 2000
**
**  Filename: 
**
**  Description of what's implemented in this file:
**    
**  
**************************************************************************/

/*
 * $Header: /project/icons/cvsroot/digipaper/src/libibuf/intellibuffer.h,v 1.4 2000/12/29 18:55:39 mkrocken Exp $
 */


#ifndef __INTELLIBUFFER_H
#define __INTELLIBUFFER_H

#ifdef __cplusplus
extern "C"
{
#endif

#include "dgp_state.h"
#include "dgp_utils.h"
#include "uds.h"

#define DGPIBUF_NOMEM     0
#define DGPIBUF_NOUDS     0
#define DGPIBUF_DEFAULTBLOCKSIZE 0

#define DGPIBUF_READ        0x00000001
#define DGPIBUF_WRITE       0x00000002
#define DGPIBUF_LIMITUDS    0x00000004
#define DGPIBUF_LIMITMEM    0x00000008


ErrCode
DgpIbuf_fopen(void **_stream, 
              uds *u,
              Dgp_UInt32 mem_block_size,
              Dgp_UInt32 flags, 
              Dgp_UInt32 max_mem_usage,
              Dgp_UInt32 max_disk_usage, 
              Dgp_State *dgp_state);


ErrCode
DgpIbuf_tmpfile(void **_stream, 
                Dgp_UInt32 mem_block_size,
                Dgp_UInt32 flags, 
                Dgp_UInt32 max_mem_usage,
                Dgp_UInt32 max_disk_usage, 
                Dgp_State *dgp_state);


ErrCode
DgpIbuf_mopen(void **_stream, 
	      Dgp_UInt8* buffer,
              Dgp_UInt32 buf_size,
              Dgp_UInt32 flags, 
              Dgp_State *dgp_state);


ErrCode
DgpIbuf_fclose(void **_stream);

ErrCode
DgpIbuf_mclose(void **_stream);


Dgp_Int32
DgpIbuf_fseek(void *_stream, 
              Dgp_Int32 offset, 
              Dgp_Int32 origin);


Dgp_Int32 
DgpIbuf_ftell(void *_stream);

size_t 
DgpIbuf_fread(void *buffer, 
              size_t size, 
              size_t count, 
              void *_stream);

size_t
DgpIbuf_fwrite(void *buffer, 
               size_t size, 
               size_t count, 
               void *_stream);

ErrCode
DgpIbuf_fcopy(uds *u_dst, 
              void *_stream_src);


#ifdef __cplusplus
}
#endif

#endif /* __INTELLIBUFFER_H */
