
#ifndef _DGPIMAGE_DEFS_
#define _DGPIMAGE_DEFS_

/* The number of colours per component (or total for gray images) */
#define	DGPIMG_COLDEPTH	8
#define DGPIMG_COLRNG		(1 << DGPIMG_COLDEPTH)

/* and some useful routines */
#ifndef	IMAGE_CHECKALL
#define	DGPIMG_WIDTH(i)	((i)->header.width)
#define	DGPIMG_HEIGHT(i)	((i)->header.height)
#define	DGPIMG_XBASE(i)	((i)->header.xbase)
#define	DGPIMG_YBASE(i)	((i)->header.ybase)
#define	DGPIMG_XMAX(i)	(((i)->header.xbase)+(int)((i)->header.width)-1)
#define	DGPIMG_YMAX(i)	(((i)->header.ybase)+(int)((i)->header.height)-1)
#define DGPIMG_TYPE(i)	((i)->header.tag)
#define	DGPIMG_COMMENT(i)	((i)->header.comment)
#else
#define	DGPIMG_WIDTH(i)	(eassert((i) != NULL), ((i)->header.width))
#define	DGPIMG_HEIGHT(i)	(eassert((i) != NULL), ((i)->header.height))
#define	DGPIMG_XBASE(i)	(eassert((i) != NULL), ((i)->header.xbase))
#define	DGPIMG_YBASE(i)	(eassert((i) != NULL), ((i)->header.ybase))
#define	DGPIMG_XMAX(i)	(eassert((i) != NULL), (((i)->header.xbase)+(int)((i)->header.width)-1))
#define	DGPIMG_YMAX(i)	(eassert((i) != NULL), (((i)->header.ybase)+(int)((i)->header.height)-1))
#define DGPIMG_TYPE(i)	(eassert((i) != NULL), ((i)->header.tag))
#define	DGPIMG_COMMENT(i)	(eassert((i) != NULL), ((i)->header.comment))
#endif


/* and an access routine - gives an *lvalue* */
#ifndef	IMAGE_CHECKALL
#define	DGPIMG_REF(i, x, y)	(((i)->data)[(y)][(x)])
#else
static char _PanicStr[100];
#define	DGPIMG_REF(i, x, y)	(eassert((i) != NULL), ((((int)(x) < (int)(i)->header.xbase) || ((int)(y) < (int)(i)->header.ybase) || ((int)(x) >= (int)(i)->header.xbase + (int)(i)->header.width) || ((int)(y) >= (int)(i)->header.ybase + (int)(i)->header.height)) ? ({ sprintf(_PanicStr, "bounds check fail: %d <= %d < %d, %d <= %d < %d", (int)(i)->header.xbase, (int)(x), (int)(i)->header.xbase + (int)(i)->header.width, (int)(i)->header.ybase, (int)(y), (int)(i)->header.ybase + (int)(i)->header.height); panic(_PanicStr);}), ((i)->data[0][0]) : (((i)->data)[(y)][(x)])))
#endif


/* Here come macros for increased efficiency access */
/* only useful for non-packed images, use row_width(bpl) instead of width */
#ifndef IMAGE_CHECKALL

#define DGPIMG_PIXPTR(i, x, y) (&(DGPIMG_REF((i), (x), (y))))
#define DGPIMG_PTRREF(i, pp) (*(pp))
#define DGPIMG_PTRDUP(i, pp) (pp)
#define DGPIMG_PTRUP(i, pp) ((pp) = (Dgp_UInt8 *)(pp) - (i)->header.row_width)
#define DGPIMG_PTRDOWN(i, pp) ((pp) = (Dgp_UInt8 *)(pp) + (i)->header.row_width)
#define DGPIMG_PTRLEFT(i, pp) ((pp)--)
#define DGPIMG_PTRRIGHT(i, pp) ((pp)++)
#define DGPIMG_PTRUPN(i, pp, n) ((pp) = (Dgp_UInt8 *)(pp) - (n) * (i)->header.row_width)
#define DGPIMG_PTRDOWNN(i, pp, n) ((pp) = (Dgp_UInt8 *)(pp) + (n) * (i)->header.row_width)
#define DGPIMG_PTRLEFTN(i, pp, n) ((pp) -= (n))
#define DGPIMG_PTRRIGHTN(i, pp, n) ((pp) += (n))
#define DGPIMG_PTREQ(i, pp1, pp2) ((pp1) == (pp2))

#else
/* Check a pointer against bounds; eval expr if successful */
#define __IMPCHECK(i, pp, expr) (eassert((i) != NULL), ((((pp) < (&((i)->data[(i)->header.ybase][(i)->header.xbase]))) || ((pp) > &((i)->data[(i)->header.ybase+(int)(i)->header.height-1][(i)->header.xbase+(int)(i)->header.width-1]))) ? (({ panic("PixPtr bounds check fail"); }), (expr)) : (expr)))

/* DGPIMG_REF is error-checked already, but just saying &DGPIMG_REF doesn't work
... */
#define DGPIMG_PIXPTR(i, x, y)  (eassert((i) != NULL), ((((int)(x) < (int)(i)->header.xbase) || ((int)(y) < (int)(i)->header.ybase) || ((int)(x) >= (int)(i)->header.xbase + (int)(i)->header.width) || ((int)(y) >= (int)(i)->header.ybase + (int)(i)->header.height)) ? ({ sprintf(_PanicStr, "bounds check fail: %d <= %d < %d, %d <= %d < %d", (int)(i)->header.xbase, (int)(x), (int)(i)->header.xbase + (int)(i)->header.width, (int)(i)->header.ybase, (int)(y), (int)(i)->header.ybase + (int)(i)->header.height); panic(_PanicStr);}), (&((i)->data[0][0])) : (&(((i)->data)[(y)][(x)]))))
#define DGPIMG_PTRREF(i, pp) __IMPCHECK((i), (pp), (*(pp)))
#define DGPIMG_PTRDUP(i, pp) __IMPCHECK((i), (pp), (pp))
#define DGPIMG_PTRUP(i, pp) __IMPCHECK((i), (pp), ((pp) = (Dgp_UInt8 *)(pp) - (i)->header.row_width))
#define DGPIMG_PTRDOWN(i, pp) __IMPCHECK((i), (pp), ((pp) = (Dgp_UInt8 *)(pp) + (i)->header.row_width))
#define DGPIMG_PTRLEFT(i, pp) __IMPCHECK((i), (pp), ((pp)--))
#define DGPIMG_PTRRIGHT(i, pp) __IMPCHECK((i), (pp), ((pp)++))
#define DGPIMG_PTRUPN(i, pp, n) _IMPCHECK((i), (pp), ((pp) = (Dgp_UInt8 *)(pp) - (n) * (i)->header.row_width))
#define DGPIMG_PTRDOWNN(i, pp, n) _IMPCHECK((i), (pp), ((pp) = (Dgp_UInt8 *)(pp) + (n) * (i)->header.row_width))
#define DGPIMG_PTRLEFTN(i, pp, n) _IMPCHECK((i), (pp), ((pp) -= (n)))
#define DGPIMG_PTRRIGHTN(i, pp, n) _IMPCHECK((i), (pp), ((pp) += (n)))
#define DGPIMG_PTREQ(i, pp1, pp2) __IMPCHECK((i), (pp1), __IMPCHECK((i), (pp2), ((pp1) == (pp2))))

#endif

/*
 * Some macros - need the size of an access unit.
 * This may break on some odd machines (sizeof(ulong) != 4 or 8)
 */

#define	DGP_LOG_BITS_UINT32	((DGP_BITS_UINT32==64)?6:5)

/*
 * N.B. x and y can be negative. x >> DGP_LOG_BITS_UINT32 is therefore correct,
 * and x / DGP_BITS_UINT32 incorrect.
 *
 * Since the row pointers *don't* include the xbase offset, we need to
 * incorporate it here.
 */
#define	DGPIMG_GETBIT(i, x, y)	(((i)->data[(y)][((x) - DGPIMG_XBASE(i)) >> DGP_LOG_BITS_UINT32]) & (1 << ((DGP_BITS_UINT32 - 1) - (((x) - DGPIMG_XBASE(i)) & (DGP_BITS_UINT32 - 1)))))
#define	DGPIMG_GETBIT01(i, x, y)	((((i)->data[(y)][((x) - DGPIMG_XBASE(i)) >> DGP_LOG_BITS_UINT32]) >> ((DGP_BITS_UINT32 - 1) - (((x) - DGPIMG_XBASE(i)) & (DGP_BITS_UINT32 - 1)))) & 1)
#define	DGPIMG_SETBIT(i, x, y)	(((i)->data[(y)][((x) - DGPIMG_XBASE(i)) >> DGP_LOG_BITS_UINT32]) |= (1 << ((DGP_BITS_UINT32 - 1) - (((x) - DGPIMG_XBASE(i)) & (DGP_BITS_UINT32 - 1)))))
#define	DGPIMG_CLEARBIT(i, x, y)	(((i)->data[(y)][((x) - DGPIMG_XBASE(i)) >> DGP_LOG_BITS_UINT32]) &= (~(1 << ((DGP_BITS_UINT32 - 1) - (((x) - DGPIMG_XBASE(i)) & (DGP_BITS_UINT32 - 1))))))
#define	DGPIMG_ORBIT(i, x, y, bit)	(((i)->data[(y)][((x) - DGPIMG_XBASE(i)) >> DGP_LOG_BITS_UINT32]) |= ((bit) << ((DGP_BITS_UINT32 - 1) - (((x) - DGPIMG_XBASE(i)) & (DGP_BITS_UINT32 - 1)))))
#define	DGPIMG_GETROW(i, y)		((i)->data[(y)])
#define	DGPIMG_GETROWWIDTH(i)	((i)->header.row_width)

/* How wide, in DWROD, is a row containing w bits? only useful for packed image */
#define	DGPIMG_ROWLEN(w)	((int)(sizeof(unsigned long) * ((w + (DGP_BITS_UINT32 - 1)) / DGP_BITS_UINT32)))



#endif

