/*
 *
 * $Header: /project/icons/cvsroot/digipaper/src/libimage/imconv.h,v 1.2 2000/05/16 21:25:51 jahlborn Exp $
 *
 * Copyright (c) 1990, 1991 Cornell University.  All Rights Reserved.
 *
 * Copyright (c) 1991 Xerox Corporation.  All Rights Reserved.
 *
 * Use, reproduction and preparation of derivative works of this software is
 * permitted.  Any copy of this software or of any derivative work must
 * include both the above copyright notices of Cornell University and Xerox
 * Corporation and this paragraph.  This software is made available AS IS, and
 * XEROX CORPORATION DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED, INCLUDING
 * WITHOUT LIMITATION THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE, AND NOTWITHSTANDING ANY OTHER PROVISION CONTAINED
 * HEREIN, ANY LIABILITY FOR DAMAGES RESULTING FROM THE SOFTWARE OR ITS USE IS
 * EXPRESSLY DISCLAIMED, WHETHER ARISING IN CONTRACT, TORT (INCLUDING
 * NEGLIGENCE) OR STRICT LIABILITY, EVEN IF XEROX CORPORATION IS ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGES.
 */

#ifndef IMCONV_H
#define IMCONV_H

#include "image.h"
#include "dgp_state.h"

/* image conversions */

DGP_LIBEXPORT ErrCode
DGPIMAGE_LtoG(Dgp_State *dgp_state, DgpImage_Long lim, Dgp_Int32 low, Dgp_Int32 high, DgpImage_Gray* gim);

DGP_LIBEXPORT ErrCode
DGPIMAGE_LtoGAuto(Dgp_State *dgp_state, DgpImage_Long lim, DgpImage_Gray* gim);

DGP_LIBEXPORT ErrCode
DGPIMAGE_FtoG(Dgp_State *dgp_state, DgpImage_Float fim, Dgp_Float64 low, Dgp_Float64 high, DgpImage_Gray* gim);

DGP_LIBEXPORT ErrCode
DGPIMAGE_FtoGAuto(Dgp_State *dgp_state, DgpImage_Float fim, DgpImage_Gray* gim);

DGP_LIBEXPORT ErrCode
DGPIMAGE_DtoG(Dgp_State *dgp_state, DgpImage_Double dim, Dgp_Float64 low, Dgp_Float64 high, DgpImage_Gray* gim);

DGP_LIBEXPORT ErrCode
DGPIMAGE_DtoGAuto(Dgp_State *dgp_state, DgpImage_Double dim, DgpImage_Gray* gim);

DGP_LIBEXPORT ErrCode
DGPIMAGE_RGBtoG(Dgp_State *dgp_state, DgpImage_ColorRGB rgbim, DgpImage_Gray* gim);


DGP_LIBEXPORT ErrCode
DGPIMAGE_GtoD(Dgp_State *dgp_state, DgpImage_Gray gim, DgpImage_Double *dim);

/* convolve with gaussian */
DGP_LIBEXPORT ErrCode 
DGPIMAGE_gaussConvol(DgpImage_Gray im, Dgp_Float64 sigma, DgpImage_Float *fImage);

/* find connected components */

#include "list.h"

typedef struct {
    DgpImage_Binary im;	/* The bitmap for the component itself */
    DgpImage_Point offset;	/* Where in the image (0,0) used to lie */
    Dgp_Int32 npts;		/* How many black pixels are present in the component */
    } DgpImage_Component;

extern ErrCode
DgpImage_pick_cc(DgpImage_Binary im, DgpImage_Binary dilated,
		Dgp_Bool eightconnected, DgpAdt_List *rlist);


#endif
