
#include "iowrap.h"
#include "intellibuffer.h"

Dgp_Int32 TC_CDECL
ibufRead(
    Dgp_UInt32 bufID,
    Dgp_Int8 *buffer,
    Dgp_Int32 byteCount
)
{
    void* _stream = (void *)bufID;

    return (Dgp_Int32) DgpIbuf_fread (buffer, 1, (size_t) byteCount, _stream); 
}

Dgp_Int32 TC_CDECL
ibufWrite(
    Dgp_UInt32 bufID,
    Dgp_Int8 *buffer,
    Dgp_Int32 byteCount
)
{
    void* _stream = (void *)bufID;

    return (Dgp_Int32) DgpIbuf_fwrite ((Dgp_Int8 *)buffer, 1, (size_t) byteCount, _stream); 
}

Dgp_Int32 TC_CDECL
ibufSeek(
    Dgp_UInt32 bufID,
    Dgp_Int32 offset
)
{
    void* _stream = (void *)bufID;

	if (DgpIbuf_fseek (_stream, offset, SEEK_SET) == 0)
		return offset;

	return -1;
}


Dgp_Int32 TC_CDECL
ibufTell(
    Dgp_UInt32 bufID
)
{
    void* _stream = (void *)bufID;

    return DgpIbuf_ftell (_stream);
}


Dgp_Int32 TC_CDECL
ibufFileSize(
    Dgp_UInt32 bufID
)
{
    void* _stream = (void *)bufID;
    Dgp_Int32 retval;

    retval = DgpIbuf_fseek(_stream, 0, SEEK_END);
    if (retval != 0) {
	return (Dgp_Int32)0;
    }

    return DgpIbuf_ftell(_stream);
}

