/*************************************************************************
**
**  DigiPaper Codebase
**    
**  Pedro Felzenszwalb, January 1999
** 
**  28.7.2000 / dhtesq.
**  Resurrection...  
**
**************************************************************************/

/*
 * RCS Header
 *
 * $Header: /project/icons/cvsroot/digipaper/src/libiowrap/pdf_util.h,v 1.6 2003/02/07 18:31:18 mkrocken Exp $
 */

#ifndef __PDF_UTIL_H
#define __PDF_UTIL_H

#include "dgp_types.h"
#include "uds.h"
#include "list.h"

/* entry in pdf xref table */
typedef struct {
	Dgp_Int32 obj;
	Dgp_Int32 offset;
} xrefElt;

/* keeps track of pdf file offset, objects and etc */
typedef struct {
	Dgp_Int32 offset;
	Dgp_Int32 objCount;
	Dgp_Int32 catalogObj;
	Dgp_Int32 ProcObj;
	Dgp_Int32 DictObj;
    Dgp_Int32 PagesObj;
	xrefElt *xref;
	Dgp_Int32 xrefSize;
	Dgp_Int32 xrefPos;
    Dgp_Int32 numPages;
    Dgp_Int32 pageStart;

    DgpAdt_List pageObjList;
    DgpAdt_List dictList;
} PdfCookie;

ErrCode
initPdfCookie(PdfCookie *pdfCookie, Dgp_State *dgp_state);

void
cleanupPdfCookie(PdfCookie *pdfCookie, Dgp_State *dgp_state);

void
write_pdf_prolog(uds *u, PdfCookie *pdfCookie);

ErrCode
write_pdf_catalog(PdfCookie     *pdfCookie, 
                  uds           *u,
                  Dgp_State     *dgp_state);

ErrCode
write_jbig2_page(PdfCookie     *pdfCookie,
                   Dgp_State     *dgp_state,
                   uds          *u,
                   Dgp_UInt8     *data,
                   Dgp_UInt32    dataSize,
                   Dgp_UInt32    width,
                   Dgp_UInt32    height,
                   Dgp_UInt32    pageDPI);

ErrCode
write_jbig2_global(PdfCookie     *pdfCookie,
                   Dgp_State     *dgp_state,
                   uds            *u,
                   Dgp_UInt8     *dict,
                   Dgp_UInt32    dictSize);

void
write_pdf_end(PdfCookie *pdfCookie, uds *u);

ErrCode
addXref(Dgp_Int32       obj, 
        Dgp_Int32       offset, 
        PdfCookie       *pdfCookie,
        Dgp_State       *dgp_state) ;

void
linearize_pdf_file (PdfCookie *cookie, 
                    uds *u,
                    Dgp_State *dgp_state);

#endif 


