/*
 *
 * $Header: /project/icons/cvsroot/digipaper/src/libjbig2/datasink.h,v 1.10 2002/05/30 02:42:46 jlin Exp $
 *
 */

#ifndef	DATASINK_H

#define	DATASINK_H

#include <stdlib.h>
#include "util.h"
#include "mqcoder.h"
#include "fileerr.h"
#include "dgp_state.h"

#ifdef __cplusplus
extern "C"
{
#endif


typedef struct _DataSink {
    Dgp_UInt8 *buf;	/* current buffer */
    size_t bufsize;	/* number of bytes in current buffer */
    size_t bufpos;	/* how many of them have been used up */
    size_t count;	/* running count of bytes written */
    ErrCode (*more_data)(struct _DataSink *f);
    ErrCode (*mark)(struct _DataSink *f);
    ErrCode (*fillmark)(struct _DataSink *f, size_t nbytes,
			Dgp_UInt8 *buf);
    void *userdata;
    Dgp_State *dgp_state;
    } *DataSink;

#define	dsPutc(f, c) \
	(((f)->bufpos == (f)->bufsize) ? _dsPutc((f), (c)) : \
	 ((((f)->buf)[(f)->bufpos++] = (c)), ((f)->count++), cSuccessful))

extern ErrCode _dsPutc(DataSink f, Dgp_UInt8 c);
extern ErrCode dsWrite(DataSink f, size_t nbytes, Dgp_UInt8 *buf,
		       size_t *bytes_written);
extern ErrCode dsMark(DataSink f, size_t nbytes);
extern ErrCode dsFillMark(DataSink f, size_t nbytes, Dgp_UInt8 *buf);
extern void dsResetCount(DataSink f);
extern size_t dsCount(DataSink f);
extern void dsAdjustCount(DataSink f, size_t adjust);

/* Some macros for checked IO */
#define	DSWRITE(data, nbytes, buf, pbytes_w) \
    do { \
        DGP_ERR_PASS_CLEANUP(dsWrite((data), (nbytes), (buf), (pbytes_w))); \
        if((nbytes) != *(pbytes_w)) { \
	    BADWRITE; \
	    } \
	} while (0)

#define DSPUTC(data, val) \
    do { \
        DGP_ERR_PASS_CLEANUP(dsPutc((data), (val))); \
	} while (0)


/* Utility routines for simple DataSinks */
extern ErrCode jb2SimpleDataSinkMark(DataSink f);
extern ErrCode jb2SimpleDataSinkFillmark(DataSink f, size_t nbytes,
					 Dgp_UInt8 *buf);

#ifndef	NOMQ
extern void dsInitDgpEncode_MQEncoder(DataSink f, DgpEncode_MQEncoder *mqenc);
extern ErrCode dsFinalDgpEncode_MQEncoder(DataSink f, DgpEncode_MQEncoder *mqenc);
#endif
#ifdef __cplusplus
}
#endif

#endif
