/*
 *
 * $Header: /project/icons/cvsroot/digipaper/src/libjbig2/datasource.h,v 1.9 2002/05/30 02:42:46 jlin Exp $
 *
 */

#ifndef	DATASOURCE_H

#define	DATASOURCE_H

#include <stdlib.h>
#include "util.h"
#include "fileerr.h"
#include "mqcoder.h"
#include "dgp_state.h"

#ifdef __cplusplus
extern "C"
{
#endif

typedef struct _DataSource {
    Dgp_UInt8 *buf;
    size_t bufsize;
    size_t bufpos;
    ErrCode (*more_data)(struct _DataSource *f);
    void *userdata;
    Dgp_State *dgp_state;
    } *DataSource;


extern ErrCode _dsGetc(DataSource f, Dgp_UInt8 *val);
extern ErrCode dsPeek(DataSource f, Dgp_Int32 *val);
extern ErrCode dsRead(DataSource f, size_t nbytes, Dgp_UInt8 *buf,
		      size_t *bytes_read);

#define dsGetc(f, pc) \
  (((f)->bufpos == (f)->bufsize) ? _dsGetc((f), (pc)) : \
   ((*(pc) = (f->buf)[(f)->bufpos++]), cSuccessful))

#ifndef	NOMQ
extern void dsInitDgpEncode_MQDecoder(DataSource f, DgpEncode_MQDecoder *mqdec);
extern ErrCode dsFinalDgpEncode_MQDecoder(DataSource f, DgpEncode_MQDecoder *mqdec);
#endif

/* Some macros for checked IO */
#define	DSREAD(data, nbytes, buf, pbytes_r) \
    do { \
        DGP_ERR_PASS_CLEANUP(dsRead((data), (nbytes), (buf), (pbytes_r))); \
        if((nbytes) != *(pbytes_r)) { \
          BADEOF; \
        } \
	} while (0)

#define DSGETC(data, pval) \
    do { \
        DGP_ERR_PASS_CLEANUP(dsGetc((data), (pval))); \
	} while (0)


#ifdef __cplusplus
}
#endif

#endif
