/*
 *
 * $Header: /project/icons/cvsroot/digipaper/src/libjbig2/decgenrefreg.h,v 1.5 2002/05/30 02:42:46 jlin Exp $
 *
 */

#ifndef	DECGENREFREG_H

#define	DECGENREFREG_H

#include "jb2file.h"
#include "datasource.h"
#include "segment.h"
#include "mqcoder.h"

#ifdef __cplusplus
extern "C"
{
#endif

/* Decoding generic refinement regions */
extern ErrCode jb2DecodeGenRefReg(jb2File file, DataSource data,
				  jb2Segment *segment, jb2Segment **refsegs);
extern void jb2FreeGenRefRegSegment(jb2Segment *segment, Dgp_State *dgp_state);

/* Rendering generic regions */
extern ErrCode jb2RenderGenRefReg(jb2File file, jb2Segment *segment);
extern ErrCode jb2RenderGenRefRegIntoPage(jb2File file, jb2Segment *segment,
					  DgpImage_Packed page);

/* Utility stuff */
extern ErrCode jb2DecodeRABParams(jb2File file, DataSource data,
				  arith_ref_params *params, Dgp_Int32 *bytesread);
extern size_t jb2RABContextsNeeded(arith_ref_params *params);

/* Inner routines */
#ifndef	NOMQ
extern ErrCode jb2ArithDecodeRefinement(Dgp_UInt32 *bitmap,
					Dgp_Int32 width, Dgp_Int32 height,
					Dgp_Int32 Dgp_Int32sperline,
					Dgp_UInt32 *reference,
					Dgp_Int32 refwidth, Dgp_Int32 refheight,
					Dgp_Int32 refDgp_Int32sperline,
					Dgp_Int32 refdx, Dgp_Int32 refdy,
					arith_ref_params *params,
					Dgp_UInt8 *contexts,
					jb2File file, DgpEncode_MQDecoder *dec);
#endif

#ifdef __cplusplus
}
#endif

#endif
