/*
 *
 * $Header: /project/icons/cvsroot/digipaper/src/libjbig2/decgenreg.h,v 1.11 2002/05/30 02:42:46 jlin Exp $
 *
 */

#ifndef	DECGENREG_H

#define	DECGENREG_H

#include "jb2file.h"
#include "datasource.h"
#include "segment.h"
#include "mqcoder.h"

#ifdef __cplusplus
extern "C"
{
#endif

/* Decoding generic regions */
extern ErrCode jb2DecodeGenReg(jb2File file, DataSource data,
			       jb2Segment *segment, jb2Segment **refsegs);
extern void jb2FreeGenRegSegment(jb2Segment *segment, Dgp_State *dgp_state);

/* Rendering generic regions */
extern ErrCode jb2RenderGenReg(jb2File file, jb2Segment *segment);
extern ErrCode jb2RenderGenRegIntoPage(jb2File file, jb2Segment *segment,
				       DgpImage_Packed page);

/* Utility stuff */
extern ErrCode jb2DecodeABParams(jb2File file, DataSource data,
				 arith_bitmap_params *params, Dgp_Int32 *bytesread);
extern size_t jb2ABContextsNeeded(arith_bitmap_params *params);

/* Inner routines */
extern ErrCode jb2MMRDecodeImage(Dgp_UInt32 *bitmap, Dgp_Int32 width, Dgp_Int32 height,
				 Dgp_Int32 Dgp_Int32sperline, Dgp_Int32 xoffset,
				 Dgp_Int32 xmax, Dgp_Int32 ymax,
				 jb2File file, DataSource data,
				 size_t datalen);
extern ErrCode jb2MMRDecodeImageMemory(Dgp_UInt32 *bitmap,
				       Dgp_Int32 width, Dgp_Int32 height,
				       Dgp_Int32 Dgp_Int32sperline, Dgp_Int32 xoffset,
				       Dgp_Int32 xmax, Dgp_Int32 ymax,
				       Dgp_UInt8 *data, size_t *datalen,
				       Dgp_State *dgp_state);
#ifndef	NOMQ
extern ErrCode jb2ArithDecodeImage(Dgp_UInt32 *bitmap,
				   Dgp_Int32 width, Dgp_Int32 height, Dgp_Int32 Dgp_Int32sperline,
				   arith_bitmap_params *params,
				   Dgp_UInt8 *contexts,
				   jb2File file, DgpEncode_MQDecoder *dec);
extern void jb2ArithDecodeImagePacked(DgpImage_Packed dest,
				      arith_bitmap_params *params,
				      Dgp_UInt8 *contexts, DgpEncode_MQDecoder *dec,
				      DgpImage_Packed mask);
#endif

#ifdef __cplusplus
}
#endif

#endif
