/*
 *
 * $Header: /project/icons/cvsroot/digipaper/src/libjbig2/hufftable.h,v 1.12 2002/05/30 02:42:46 jlin Exp $
 *
 */

#ifndef	HUFFTABLE_H

#define	HUFFTABLE_H

#include "util.h"
#include "jbitfile.h"

#ifdef __cplusplus
extern "C"
{
#endif

#define	JHT_MAXCODELEN	32

/*
 * This defines a Huffman table specification.  The integer encoding and
 * decoding modules take this sort of specification as parameters.
 */
typedef struct _table_line{
    Dgp_UInt32 prefix;
    Dgp_Int32 base;
    Dgp_Int8 preflen, rangelen;
    } table_line;

typedef struct _hufftable_spec{
    Dgp_Bool lower_valid, upper_valid, oob_valid;
    Dgp_Int32 nlines;
    table_line *lines;
    Dgp_Int32 minlen;
    Dgp_Bool compiled;
    Dgp_UInt32 firstcode[JHT_MAXCODELEN];
    Dgp_UInt32 lastcode[JHT_MAXCODELEN];
    void **decoded[JHT_MAXCODELEN];
    } hufftable_spec;

extern ErrCode jhtSetCodes(hufftable_spec *spec, Dgp_State *dgp_state);
extern ErrCode jhtCompile(hufftable_spec *spec, void **lines, 
			  Dgp_State *dgp_state);
extern ErrCode jhtReadCode(const hufftable_spec *spec, jbitfile f, 
			   Dgp_State *dgp_state, void **code);
extern void jhtCleanup(hufftable_spec *spec, Dgp_State *dgp_state);
extern void jhtFree(hufftable_spec *spec, Dgp_State *dgp_state);

#ifdef __cplusplus
}
#endif

#endif
