/*
 *
 * $Header: /project/icons/cvsroot/digipaper/src/libjbig2/jb2file.h,v 1.14 2002/05/30 02:42:46 jlin Exp $
 *
 */

#ifndef	JB2FILE_H

#define	JB2FILE_H

#include "dgp_state.h"
#include "params.h"
#include "datasink.h"

#ifdef __cplusplus
extern "C"
{
#endif

/*
 * A jb2File is a void *, basically; it encapsulates whatever information
 * the embedding format wants.  Eventually, it will also encapsulate some
 * callbacks, but we don't have those yet.
 */
typedef struct _jb2File *jb2File;

/* Parameters that can affect encoding into a jb2File */
typedef struct _jb2FileParams{
    /*
     * Use arithmetic coding in symbol dictionaries? Default DGP_FALSE
     */
    Dgp_Bool sdarith;		    
    /* Custom tables allowed in symbol dictionaries? Default DGP_TRUE */
    Dgp_Bool sdtables;
    /* First Huffman table only allowed? Default DGP_FALSE */
    Dgp_Bool sdfirstonly;
    /*
     * Arithmetic bitmap coding params for symbol dictionaries.
     * Default: template 2, TPON DGP_FALSE (forced), AT pixels in nominal
     * locations.
     */
    arith_bitmap_params sdabparams;

    /*
     * Use arithmetic coding in symbol regions? Default DGP_FALSE
     */
    Dgp_Bool srarith;
    /* Custom tables allowed in symbol regions? Default DGP_TRUE */
    Dgp_Bool srtables;
    /* First Huffman table only allowed? Default DGP_FALSE */
    Dgp_Bool srfirstonly;
    /* LOWERLEFT only allowed? Default DGP_FALSE */
    Dgp_Bool srllonly;
    /* Non-transposed only allowed? Default DGP_FALSE */
    Dgp_Bool srnontransonly;

    /* Use arithmetic coding in halftone dictionaries? Default DGP_FALSE */
    Dgp_Bool hdarith;
    /* Arith template used for halftone dictionaries.  Default 2 */
    Dgp_Int32 hdabtemplate;

    /* Use arithmetic coding in halftone regions? Default DGP_FALSE */
    Dgp_Bool hrarith;
    /* Arith template used for halftone regions.  Default 0 */
    Dgp_Int32 hrabtemplate;
    } jb2FileParams;

extern Dgp_Int32 jb2FileNextSegmentNumber(jb2File f);
extern DataSink jb2GetFileHeaderDataSink(jb2File f);
extern DataSink jb2GetFileDataSink(jb2File f);
ErrCode __cdecl jb2CreateFile(DataSink headersink, DataSink bodysink,
			     Dgp_State *dgp_state, jb2File *f);
extern void jb2FreeFile(jb2File f);
extern void jb2SetFileParams(jb2File f, jb2FileParams *params);
extern jb2FileParams *jb2GetFileParams(jb2File f);
extern void jb2SetFileSegnum(jb2File f, Dgp_Int32 segnum);
extern Dgp_Int32 jb2GetFileSegnum(jb2File f);
extern Dgp_State *jb2GetFileDgp_State(jb2File f);
/* macros to reference parts of jb2file dgp_state */
#define jb2_pDgp_State(f) (jb2GetFileDgp_State(f))
#define jb2_pErrState(f) (jb2GetFileDgp_State(f)->err_state)
#define jb2_Allocators(f) (jb2GetFileDgp_State(f))->a
#define jb2_pAllocators(f) (&(jb2GetFileDgp_State(f)->a))

#ifdef __cplusplus
}
#endif

#endif
