
#ifndef JBIG2APICB_H
#define JBIG2APICB_H


#include "writejbigCB.h"

#ifdef __cplusplus
extern "C"
{
#endif

/****************************************************************
 * Create a Jb2 state cookie.  initialize all the state variables.
 * The given page and dictionary counts are estimates only.
 * use MemoryDataSink stuff to hold the segments and segment headers 
 * @param stream User defined stream
 * @param dgp_state 	Dgp error handling cookie
 * @param numPgs 	Estimated number of pages
 * @param numDicts 	Estimated number of dictionaries (not used)
 * @return _jb2State	Jbig2 state cookie contains infor needed to
 *			write out Jbig2 by using the Callback interface
 * @return userData 	User defined data (not used)
 ********************************************************************/
ErrCode 
createJb2StateAPICB(         uds *stream,
                        Dgp_State *dgp_state,
			     Dgp_Int32 jbig2Profile,
                        Dgp_Int32 numPgs,
                        Dgp_Bool pdfOut,
                        void **_jb2State,
                        void **_userData);

/*****************************************************************
 * Close the Jb2State and free up memory.
 *
 * It creates and writes out and EOF segment.
 * It closes the two DataSinks, tcompress.cakes the buflists it gets back,
 * writes them out (headers then bodies), then frees them.
 * It also free the current list of segments.
 * @param _jb2State Jbig2 State cookie
 * @param _userData Not used
 *****************************************************************/
ErrCode 
closeJb2StateAPICB(
        void *_jb2State,
        void *_userData);


ErrCode
getJb2CompressedData (Jb2State *jb2State, Dgp_UInt8** buf, 
		      Dgp_UInt32* buf_size);


#ifdef __cplusplus
}
#endif

#endif








