/*
 *
 * $Header: /project/icons/cvsroot/digipaper/src/libjbig2/jbitfile.h,v 1.11 2002/05/30 02:42:46 jlin Exp $
 *
 */

#ifndef	JBITFILE_H

#define	JBITFILE_H

#include <stdlib.h>
#include "util.h"
#include "datasource.h"
#include "datasink.h"

#ifdef __cplusplus
extern "C"
{
#endif

typedef struct _jbitfile *jbitfile;
#define	NULLJBITFILE	((jbitfile)NULL)

extern ErrCode jbfOpen(Dgp_UInt8 *buf, size_t buflen,
			ErrCode (*more_data)(Dgp_UInt8 **buf,
					     size_t *buflen,
					     void *userdata),
			void *userdata, Dgp_Bool forWrite,
			Dgp_State *dgp_state, jbitfile *f);
extern ErrCode jbfOpenFromDataSource(DataSource data, jbitfile *f);
extern ErrCode jbfOpenFromDataSink(DataSink data, jbitfile *f);
extern void jbfFlushByte(jbitfile f);
extern ErrCode jbfWriteBits(jbitfile f, Dgp_UInt32 code, Dgp_Int32 codelen);
extern ErrCode jbfReadBits(jbitfile f, Dgp_Int32 codelen, Dgp_UInt32 *val);
extern ErrCode jbfPos(jbitfile f, Dgp_UInt8 **pos);
extern void jbfClose(jbitfile f);
extern ErrCode jbfCloseFromDataSource(jbitfile f);
extern ErrCode jbfCloseFromDataSink(jbitfile f);
extern ErrCode jbfSuspend(jbitfile f);
extern void jbfResume(jbitfile f);

extern Dgp_Int32 jbfPeek(jbitfile f);

#ifdef __cplusplus
}
#endif

#endif
