/* 
 * 
 * $Header: /project/icons/cvsroot/digipaper/src/libjbig2/memorydatasource.c,v 1.6 2003/01/27 21:48:37 awilliam Exp $ 
 * 
 */ 
 
#include "datasource.h" 
#include "memorydatasource.h" 
#include "PsgFix.h"
#include <stdlib.h> 
 
DGP_RCSID("@(#)$Header: /project/icons/cvsroot/digipaper/src/libjbig2/memorydatasource.c,v 1.6 2003/01/27 21:48:37 awilliam Exp $"); 
 
/* 
 * Create a DataSource that will feed this buffer 
 */ 
ErrCode 
jb2NewMemoryDataSource(Dgp_UInt8 *buf, size_t bufsize, Dgp_State *dgp_state, 
		       DataSource *_newds) 
{ 
  DGP_PROLOGUE("jb2NewMemoryDataSource()", DGP_PERRSTATE); 
  Dgp_Allocators *a = &(dgp_state->a); 
    DataSource newds = (DataSource)NULL; 
 
    *_newds = (DataSource)NULL; 
 
    newds = (DataSource)(a->malloc)(sizeof(*newds)); 
    DGP_CHECK_ALLOC_CLEANUP(newds); 
    newds->dgp_state = dgp_state; 
 
    newds->buf = buf;		/* point to the buffer */ 
    newds->bufsize = bufsize;	/* read all of it */ 
    newds->bufpos = 0;		/* none read so far */ 
    newds->more_data = (ErrCode (*)(DataSource))NULL; /* no more after this */ 
    newds->userdata = (void *)NULL; /* no state on our end */ 
 
    *_newds = newds; 
    newds = (DataSource)NULL; 
    NORMAL_RETURN; 
 
 ERR_CLEANUP: 
    ERR_RETURN; 
    } 
 
/* 
 * Free a MemoryDataSource 
 */ 
void 
jb2CloseMemoryDataSource(DataSource ds) 
{ 
  Dgp_Free tmp_free = ds->DGP_FREE; 
 
    (tmp_free)((void *)ds); 
    } 
