/*
 *
 * $Header: /project/icons/cvsroot/digipaper/src/libjbig2/symbol.h,v 1.13 2002/05/30 02:42:47 jlin Exp $
 *
 */

#ifndef	SYMBOL_H

#define	SYMBOL_H

#ifdef __cplusplus
extern "C"
{
#endif

typedef struct _jb2Symbol {
    int width, height;
    unsigned long *bits;
    int longsperline;
    struct _jb2Symbol *refsym;
    void *userdata;
    unsigned char userflags;
    } jb2Symbol;

/*
 * By convention, (xpos, ypos) refers to the location of the top left
 * corner of the bitmap.
 *
 * If refdata is not NULL, then you can ignore sym; just use the
 * bitmap pointed to by refdata.  Otherwise, the instance is a
 * straightforward instance of sym.
 */
typedef struct _jb2SymbolInstance{
    int xpos, ypos;
    jb2Symbol *sym;
    struct _jb2SymbolInstanceRefined *refdata;
    void *userdata;
    } jb2SymbolInstance;

/*
 * This is a structure that holds information about the refined version
 * of a symbol instance: basically, it's a bitmap.
 */
typedef struct _jb2SymbolInstanceRefined {
    int width, height;
    unsigned long *bits;
    int longsperline;
    } jb2SymbolInstanceRefined;
#ifdef __cplusplus
}
#endif

#endif
