#ifndef _UNCOMP_JBIG_Include_
#define _UNCOMP_JBIG_Include_

#include "jb2file.h"
#include "segment.h"
#include "symbol.h"
#include "datasource.h"
#include "datasink.h"
#include "list.h"

#ifdef __cplusplus
extern "C"
{
#endif
 
    typedef ErrCode (*AllocImage)( 
                   Dgp_State * dgp_state,
                   Dgp_Int32 width, Dgp_Int32 height,
                   DgpImage_Packed* dgpImage, void** usrImage);
    typedef ErrCode (*FreeImage)( 
                    Dgp_State* dgp_state, 
                    DgpImage_Packed* dgpImage);
    /* Info we maintain about the file */
    typedef struct _jb2info{
        jb2File f;
        DgpAdt_List activesegs;
        DgpAdt_List segs;
        int nsegs;
        Dgp_Bool sequential;
        DgpImage_Packed curpage;
        jb2PageInfoSegment pageinfo;
        Dgp_Bool dunnosize;
        DgpAdt_List regions;
        int laststripe;
        int lastregion;
        int pagenum;
        int npages;
        DataSource data;
        Dgp_Bool verbose;
        Dgp_State *dgp_state;
        Dgp_UInt8* fname;
        Dgp_Bool noout;
        Dgp_UInt8* format;
        Dgp_Bool keepAll;
        Dgp_Bool render;
        AllocImage allocImage;
        FreeImage freeImage;
        void* usrPixr;
    } jb2info;
    
    
    /* Allocate *newseg; read a header into it. */
    ErrCode
        readheader(jb2info *info, jb2Segment **newseg);
    
    /* Process a single segment */
    ErrCode processSegment(jb2Segment *segment, jb2info *info);
    
    
    ErrCode
        processDictFromData(
					   jb2info *_jb2Info, 
                       Dgp_UInt8 *data, 
                       Dgp_Int32 size);
    
    ErrCode
        processSegmentsFromData(
					   jb2info *info, 
                       Dgp_UInt8 *dictData, 
                       Dgp_Int32 dictSize,
                       void **usrImage);
    
    /* Init and Free jb2info*/
    ErrCode
        initJb2Info(
			jb2info ** info, 
			Dgp_Bool verbose,
			Dgp_UInt8* fname, 
			Dgp_UInt8* format, 
			Dgp_Bool noout,
			Dgp_Int32 numPages,
            Dgp_Bool keepAll,
            Dgp_Bool render,
            ErrCode (*allocImage)( 
                   Dgp_State * dgp_state,
                   Dgp_Int32 width, Dgp_Int32 height,
                   DgpImage_Packed* dgpImage, void** usrImage),
            ErrCode (*freeImage)(Dgp_State *dgp_state, 
                    DgpImage_Packed* dgpImage),
			Dgp_State *dgp_state);
    
    /* free info*/
    void cleanupJb2Info(jb2info ** info);
    
    /* copy activeseg from passinfo to curinfo*/
    ErrCode
        copySegmentList(jb2info* curInfo, jb2info* passInfo);
    
#ifdef __cplusplus
}
#endif


#endif

