/*************************************************************************
**  Copyright 1999-2000 Xerox Corporation.All rights reserved.
**
**  DigiPaper Codebase
**    
**  Ranjani Ramamurthy, May 2000
**
**  Filename: jpeg_mem_consts.h
**
**  Description of what's implemented in this file:
**    Constants used to estimate the amount of memory that the
**    decompressor will use
**  
**************************************************************************/

  /*Though I am loathe to put in numbers here, thats the */
  /*only way, I can plug in a memory estimate. */
  /* */
  /*Base memory = 24K is needed. Then the image is decoded */
  /*in strips. In the worst case, to hold the IDCT for  */
  /*a strip for the most common sampling factors, it is */
  /*34 bytes * image_width */
  /* */
  /*In the case of a progressive jpeg image  */
  /*a full-image DCT coefficient buffer is needed. In the */
  /*common 2*2 sampled case, it takes 3 bytes per pixel. */
  /*In the worst case, 6 bytes per pixel (for a 1*1 sampled */
  /*img). */
  /* */
  /*Finally, this only computes what is allocated by  */
  /*the alloc_large() calls - not the alloc_small() calls. */
  /*I ran the memory tests on several images and found that */
  /*if *ever* this formula erred on the lower side of memory */
  /*estimation, it was never off by more than 5%. i.e. at */
  /*the most, alloc_smalls() contributed another 5% to the  */
  /*amount of memory allocated. To be on the safe side, I */
  /*allocate 15% overhead. We should be safe with that number. */

  /*For future versions of libjpeg, look at libjpeg.doc that */
  /*comes with IJG, and tweak memory estimates if needed. */


#define  DGP_JPEG_BASE_MEMORY			24000
#define  DGP_JPEG_IDCT_STRIP            34
#define  DGP_WORST_CASE_SAMPLING        6
#define  DGP_AVERAGE_CASE_SAMPLING      3
#define  DGP_ALLOC_SMALL_OVERHEAD       0.15
