/*************************************************************************
**  Copyright 1999-2000 Xerox Corporation.All rights reserved.
**
**  DigiPaper Codebase
**    
**  Ranjani Ramamurthy, October 1999
**
**  Filename: jpeg_mem_mgr.h
**
**  Description of what's implemented in this file:
**    The digipaper jpeg source manager (UDS Source manager)
**  
**************************************************************************/

#ifndef _JPEG_MEM_MGR_H_
#define _JPEG_MEM_MGR_H_

#include <stdio.h>
#include "jinclude.h"
#include "jpeg6blib.h"
#include "jerror.h"
#include "uds.h"

typedef struct{
  struct jpeg_source_mgr pub;  /* public fields */
  JOCTET* MMapAddress;         /* source memory area */
  int     size ;               /* number of bytes in source mem area */
  int currentOffset;           /* current offset */
  const JOCTET* buffer;		   /* start of buffer */
  JOCTET eof_buffer[2];		   /* tmp buffer for eof marker */
  boolean   start_of_file;	   /* have we got any data yet? */
} DGPMemSrcMgr;

typedef struct{
  struct jpeg_source_mgr pub;  /* public fields */
  JOCTET* address;             /* source memory area */
  int     size ;               /* number of bytes in source mem area */
  int currentOffset;           /* current offset */
  JOCTET* buffer;		       /* start of buffer */
  JOCTET eof_buffer[2];		   /* tmp buffer for eof marker */
  boolean   start_of_file;	   /* have we got any data yet? */
  uds*      uds_ptr;           /* ptr to input uds struct */
} DGPUdsSrcMgr;

void
DGP_UDS_skip_input_data (j_decompress_ptr cinfo, long num_bytes);

boolean
DGP_UDS_fill_input_buffer (j_decompress_ptr cinfo);


#endif
