/* SPMG/JPEG-LS IMPLEMENTATION V.2.1
   =====================================
   These programs are Copyright (c) University of British Columbia. All rights reserved.
   They may be freely redistributed in their entirety provided that this copyright
   notice is not removed. THEY MAY NOT BE SOLD FOR PROFIT OR INCORPORATED IN
   COMMERCIAL PROGRAMS WITHOUT THE WRITTEN PERMISSION OF THE COPYRIGHT HOLDER.
   Each program is provided as is, without any express or implied warranty,
   without even the warranty of fitness for a particular purpose.

   =========================================================
   THIS SOFTWARE IS BASED ON HP's implementation of jpeg-ls:
   =========================================================

   LOCO-I/JPEG-LS IMPLEMENTATION V.0.90
   -------------------------------------------------------------------------------
   (c) COPYRIGHT HEWLETT-PACKARD COMPANY, 1995-1999.
        HEWLETT-PACKARD COMPANY ("HP") DOES NOT WARRANT THE ACCURACY OR
   COMPLETENESS OF THE INFORMATION GIVEN HERE.  ANY USE MADE OF, OR
   RELIANCE ON, SUCH INFORMATION IS ENTIRELY AT USER'S OWN RISK.
        BY DOWNLOADING THE LOCO-I/JPEG-LS COMPRESSORS/DECOMPRESSORS
   ("THE SOFTWARE") YOU AGREE TO BE BOUND BY THE TERMS AND CONDITIONS
   OF THIS LICENSING AGREEMENT.
        YOU MAY DOWNLOAD AND USE THE SOFTWARE FOR NON-COMMERCIAL PURPOSES
   FREE OF CHARGE OR FURTHER OBLIGATION.  YOU MAY NOT, DIRECTLY OR
   INDIRECTLY, DISTRIBUTE THE SOFTWARE FOR A FEE, INCORPORATE THIS
   SOFTWARE INTO ANY PRODUCT OFFERED FOR SALE, OR USE THE SOFTWARE
   TO PROVIDE A SERVICE FOR WHICH A FEE IS CHARGED.
        YOU MAY MAKE COPIES OF THE SOFTWARE AND DISTRIBUTE SUCH COPIES TO
   OTHER PERSONS PROVIDED THAT SUCH COPIES ARE ACCOMPANIED BY
   HEWLETT-PACKARD'S COPYRIGHT NOTICE AND THIS AGREEMENT AND THAT
   SUCH OTHER PERSONS AGREE TO BE BOUND BY THE TERMS OF THIS AGREEMENT.
        THE SOFTWARE IS NOT OF PRODUCT QUALITY AND MAY HAVE ERRORS OR DEFECTS.
   THE JPEG-LS STANDARD IS STILL UNDER DEVELOPMENT. THE SOFTWARE IS NOT A
   FINAL OR FULL IMPLEMENTATION OF THE STANDARD.  HP GIVES NO EXPRESS OR
   IMPLIED WARRANTY OF ANY KIND AND ANY IMPLIED WARRANTIES OF
   MERCHANTABILITY AND FITNESS FOR PURPOSE ARE DISCLAIMED.
        HP SHALL NOT BE LIABLE FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL,
   OR CONSEQUENTIAL DAMAGES ARISING OUT OF ANY USE OF THE SOFTWARE.
   -------------------------------------------------------------------------------
*/

/* bitio.h --- for I/O routines
 *
 * Initial code by Alex Jakulin,  Aug. 1995
 *
 * Modified and optimized: Gadiel Seroussi, October 1995
 *
 * Color Enhancement: Guillermo Sapiro, August 1996
 *
 * Modified and added Restart marker and input tables by:
 * David Cheng-Hsiu Chu, and Ismail R. Ismail march 1999
 *
 * 20.3.2001 / dhtesq.
 * Added to digipaper code base for evaluation purposes.
 */

#ifndef BITIO_H
#define BITIO_H

#include "dgpjpegls.h"

/* BYTE I/O variables */
#define BUFSIZE ((16 * 1024) - 4) /* Size of input BYTE buffer */

/* BIT I/O variables */

#define BITBUFSIZE (8 * sizeof(Dgp_UInt32))		/* i.e., 8 * sizeof(DgpJpegLsContext.reg) */


INLINE ErrCode
fillbuffer(DgpJpegLsContext		*context,
		   Dgp_Int32			no);

INLINE ErrCode
DgpJpegLsGetC(	DgpJpegLsContext	*context,
				Dgp_UInt8			*c);

INLINE void
DgpJpegLsUngetC(DgpJpegLsContext	*context,
				Dgp_UInt8			c);


/* Initializes the bit input routines */
ErrCode 
bitiinit(DgpJpegLsContext *context);

ErrCode
bitiflush(DgpJpegLsContext *context);

void 
bufiinit(DgpJpegLsContext *context);

/* Stubs for MISSING output routines... */
/*///////////// */
ErrCode
bitoinit(DgpJpegLsContext *c);

void
bitoflush(void);

void
put_zeros(Dgp_Int32 value);

void 
putbits(Dgp_Int32	val0,
		Dgp_Int32	val1);
/*///////////// */

/* creates the bit counting look-up table. */
ErrCode
createZeroLUT(DgpJpegLsContext	*context);


#ifdef DGPJPEGLS_IOFXNS
extern dword getbits(Dgp_Int32 no);
#	define GETBITS(n)	getbits(n)
#else
#  define GETBITS(c, x, n)\
   (x) = (c)->reg >> (32 - (n));\
   DGP_ERR_PASS(fillbuffer((c), (n)));\
 
#endif


#endif /* BITIO_H */
