/*
   @(#)$Header: /project/icons/cvsroot/digipaper/src/libmemtest/allocators_test.h,v 1.2 2000/05/17 05:46:07 jahlborn Exp $ 
*/

#ifndef __ALLOCATORS_TEST_H
#define __ALLOCATORS_TEST_H

#include <stddef.h>
#include "dgp_state.h"
#include "util.h"

#ifdef __cplusplus
extern "C"
{
#endif

/* test allocators def (to be used with Dgp_Allocators struct) */
#define DGP_TEST_ALLOCATORS {DgpMem_mallocTest, DgpMem_freeTest, \
                                DgpMem_callocTest, DgpMem_reallocTest}

/* test small allocators (to be used with Dgp_SmallAllocators struct) */
#define DGP_TEST_SMALL_ALLOCATORS {NULL, DgpMem_mallocSmall, DgpMem_freeSmall}

/* the test allocator functions */
DGP_LIBEXPORT void * 
DgpMem_mallocTest(size_t size);

DGP_LIBEXPORT void 
DgpMem_freeTest(void *ptr);

DGP_LIBEXPORT void * 
DgpMem_callocTest(size_t _nobj, 
                  size_t _size);

DGP_LIBEXPORT void * 
DgpMem_reallocTest(void *ptr, 
                   size_t size);

/* get/reset memory usage values */
DGP_LIBEXPORT Dgp_Int32
DgpMem_getCurrentMemUsage();

DGP_LIBEXPORT Dgp_Int32
DgpMem_getPeakMemUsage();

DGP_LIBEXPORT void
DgpMem_resetPeakMemUsage();

/* get/reset memory stats */
DGP_LIBEXPORT void
DgpMem_getMemStats(Dgp_Int32 *num_mallocs, 
                 Dgp_Int32 *num_callocs,
                 Dgp_Int32 *num_reallocs,
                 Dgp_Int32 *num_frees);

DGP_LIBEXPORT void
DgpMem_resetMemStats();

/* the test small allocator functions */
DGP_LIBEXPORT ErrCode
DgpMem_mallocSmall(void *small_cookie, 
                   Dgp_Int32 pool_id, 
                   void **retptr);

DGP_LIBEXPORT void
DgpMem_freeSmall(void *small_cookie,
                 Dgp_Int32 pool_id, 
                 void *ptr);

/* get/reset individual pool usage values 
   (pass in pre-allocated array(s) of Dgp_Int32's) */
DGP_LIBEXPORT void
DgpMem_getSmPoolUsage(Dgp_Int32 *cur_num_pool_els,
                  Dgp_Int32 *peak_num_pool_els,
                  Dgp_Int32 num_pools);

DGP_LIBEXPORT void
DgpMem_resetSmPoolMUsage();


/* really test that program!
   Set memory limit. (can be set to DGPMEM_NOMEMLIMIT
   for no limit, the default) */
DGP_LIBEXPORT void
DgpMem_setMemLimit(Dgp_Int32 max_mem_usage);

#define DGPMEM_NOMEMLIMIT -1

#ifdef __cplusplus
}
#endif

#endif /* __ALLOCATORS_TEST_H */
