/*****************************************************************
 *  Trade Secret of Xerox Corporation.                           *
 *  Copyright (c) 1991-2001, Xerox Corporation.                  *
 *  All rights reserved.                                         *
 *  Copyright protection claimed includes all forms and matters  *
 *  of copyrightable material and information now allowed by     *
 *  statutory or judicial law or hereafter granted, including    *
 *  without limitation, material generated from the software     *
 *  programs which are displayed on the screen such as icons,    *
 *  screen display looks, etc.                                   *
 *****************************************************************/

#if 0

#ifndef IOBUF_H_INCLUDED
#define IOBUF_H_INCLUDED

IP_RCSINFO(iobuf_hRCSInfo, "$RCSfile: iobuf.h,v $; $Revision: 1.1 $");
/* $Date: 2003/01/03 01:41:10 $ */

#ifdef __cplusplus
extern "C"
{
#endif

/*
 * INCLUDES
 */
#include "ipwcore.prv"
#include "defines.pub"
#include "geomadt.h"
#include "IO_DOC.h"

/*
 * CONSTANTS
 */

/*
 * MACROS
 */

/*
 * TYPEDEFS
 */
/* IOBuf: structure to hold a chunk of data to be queued for I/O, and free'd
 * when flushed.
 */
typedef struct IOBuf {
    struct IOBuf *prev;		/* Previous item in list */
    struct IOBuf *next;		/* Next item in list */
    UInt8 *buffer;		/* Buffer of data, can be NULL until
				 * bufferFilled is set.  Be sure to NULL this
				 * buffer when free'd. */
    UInt32 bufferLength;	/* Number of bytes in *buffer */
    Bool bufferFilled;		/* Buffer has been filled and is ready to be
				 * flushed.  Note, a previous buffer may still
				 * be unfilled. */
} IOBuf;

typedef struct IOBufList {
    struct IOBuf *first;
} IOBufList;

/*
 * ENUMS
 */

/*
 * GLOBAL VARIABLE DECLARATIONS
 */

/*
 * FUNCTION PROTOTYPES
 */
ErrCode CDECL
IO_InsertBuffer(IO_DOC *ioDoc, IOBufList *listHead, IOBuf *prev,
    UInt8 *buffer, UInt32 bufferLength);

ErrCode CDECL
IO_RemoveAndFreeBuffer(IO_DOC *ioDoc, IOBufList *listHead, IOBuf *item);

ErrCode CDECL
IO_FreeBufferList(IO_DOC *ioDoc, IOBufList *listHead);

#ifdef __cplusplus
}
#endif

#endif /* IOBUF_H_INCLUDED */
#endif
