/*****************************************************************
 *  Trade Secret of Xerox Corporation.                           *
 *  Copyright (c) 1991-2001, Xerox Corporation.                  *
 *  All rights reserved.                                         *
 *  Copyright protection claimed includes all forms and matters  *
 *  of copyrightable material and information now allowed by     *
 *  statutory or judicial law or hereafter granted, including    *
 *  without limitation, material generated from the software     *
 *  programs which are displayed on the screen such as icons,    *
 *  screen display looks, etc.                                   *
 *****************************************************************/

#ifndef IORPRIV_H_INCLUDED
#define IORPRIV_H_INCLUDED

#ifndef NOIPCORE
IP_RCSINFO(iorpriv_hRCSInfo, "$RCSfile: iorpriv.h,v $; $Revision: 1.1 $");
/* $Date: 2003/01/03 01:41:10 $ */
#endif

#ifdef __cplusplus
extern "C"
{
#endif

/*
 * INCLUDES
 */
#include "ioimage.h"

/*
 * CONSTANTS
 */

/*
 * MACROS
 */

/*
 * TYPEDEFS
 */
typedef struct IO_MemoryTally {
	UInt32 bytesAllocated;
	UInt32 peak;
} IO_MemoryTally;


/*
 * ENUMS
 */

/*
 * GLOBAL VARIABLE DECLARATIONS
 */

/*
 * FUNCTION PROTOTYPES
 */
#ifndef NOIPCORE
ErrCode CDECL
w_IODecompress(
	IPWState *pIPWState,
	IO_IMGHANDLE ioImgHandle,
	IO_COMPRESSION ioCompression,
	IO_COLORTYPE ioColorType,
	UInt32 dwFlags,
	UInt8 *pSrc,
	UInt32 dwBytesInSrc,
	UInt32 dwRowOffset,
	UInt32 dwWidth,
	UInt32 dwStripHeight,
	PIXR *pPixr,
	UInt32 *pdwRowsFilled
);

ErrCode CDECL
wp_IoIPWState(IO_DOC *ioDoc, IPWState **ppIPWState);
#endif	/* NOIPCORE */
void * CDECL
wp_IoMalloc(size_t dwBytes, Bool hasPtrs, void *clientID
#ifdef SHOWERR
	     , const char *file, const int line
#endif
	     );
void * CDECL
wp_IoCalloc(size_t nel, size_t count, Bool hasPtrs, void *clientID
#ifdef SHOWERR
	     , const char *file, const int line
#endif
	     );
void * CDECL
wp_IoRealloc(void *ptr, size_t dwBytes, Bool hasPtrs, void *clientID
#ifdef SHOWERR
	     , const char *file, const int line
#endif
	     );
void CDECL
wp_IoFree(void *buffer, size_t dwBytes, void *clientID);
UInt32 CDECL
wp_IoMemoryCheck(IO_MemoryTally *tally);
UInt32 CDECL
wp_IoAllocSize(void *buffer, void *clientID);

void CDECL
wp_IPC_AllocID(UInt32 id);
void * CDECL
wp_IO_Malloc(size_t count, Bool hasPtrs, void *thing
#ifdef SHOWERR
		, const char *file,
		const int line
#endif
		);
void * CDECL
wp_IO_Calloc(size_t nel, size_t size, Bool hasPtrs, void *thing
#ifdef SHOWERR
		, const char *file,
		const int line
#endif
		);
void * CDECL
wp_IO_Realloc(void *ptr, size_t size, Bool hasPtrs, void *thing);
void CDECL
wp_IO_Free(void *ptr, size_t size, void *thing);

ErrCode CDECL
wp_IoImgFree(IO_IMG **pIO_IMG, Int32 subsequentImagesToo);
ErrCode CDECL
wp_IoPageFree(IO_PAGE **pIO_PAGE, Int32 subsequentPagesToo);
ErrCode CDECL
wp_IoDocFree(IO_DOC **pIO_DOC);


#ifdef __cplusplus
}
#endif

#endif /* IORPRIV_H_INCLUDED */
