/*
 * Trade secret of Xerox Corporation.
 * Copyright (c) 1991-2001, Xerox Corporation.  All rights reserved.
 * Copyright protection claimed includes all forms and matters of 
 * copyrightable material and information now allowed by statutory or 
 * judicial law or hereinafter granted; including, without limitation,
 * material generated from the software programs which are displayed on 
 * the screen such as icons, screen display looks, etc.
 */

#ifndef TFXCONV_H_INCLUDED
#define TFXCONV_H_INCLUDED

#ifndef NOIPCORE
IP_RCSINFO(tfxconv_hRCSInfo, "$RCSfile: tfxconv.h,v $; $Revision: 1.1 $");
/* $Date: 2003/01/03 01:41:10 $ */
#endif

#ifdef __cplusplus
extern "C"
{
#endif

#ifdef _MSC_VER
#pragma pack(push, tfxconv_h, 1)
#endif

/* tfxconv.h
 *
 */

/*
 * INCLUDES
 */


/*
 * CONSTANTS
 */
#define TFX_CONV_INVERT		0x00000001	/* 0 = white -> 0 = black */
#define TFX_CONV_CHUNK		0x00000010	/* RGBRGBRGB -> RRR, GGG, BBB */
#define TFX_CONV_UNCHUNK	0x00000020	/* RGBRGBRGB -> RRR, GGG, BBB */
#define TFX_CONV_DWORD2BYTEORDER 0x00000100	/* Normal byte order (instead of
						 * IPCore PIXR order */
#define TFX_CONV_BYTE2DWORDORDER 0x00000200	/* Normal byte order (instead of
						 * IPCore PIXR order */
#define TFX_CONV_SRGB2CIELAB	0x00001000	/* sRGB -> CIELAB */
#define TFX_CONV_SRGB2ICCLAB	0x00002000	/* sRGB -> ICCLAB */
#define TFX_CONV_SRGB2ITULAB	0x00003000	/* sRGB -> ITULAB */
#define TFX_CONV_CIELAB2SRGB	0x00004000	/* CIELAB -> sRGB */
#define TFX_CONV_ICCLAB2SRGB	0x00005000	/* ICCLAB -> sRGB */
#define TFX_CONV_ITULAB2SRGB	0x00006000	/* ITULAB -> sRGB */
#define TFX_CONV_COLORTRANSFORM	0x0000F000	/* Mask for color transform */

/*
 * MACROS
 */

/*
 * TYPEDEFS
 */

/*
 * ENUMS
 */

/*
 * GLOBAL VARIABLE DECLARATIONS
 */

/*
 * FUNCTION PROTOTYPES
 */

#ifndef NOIPCORE
/*  Do internal image processing to convert from TIFF format to PIXR
 */
ErrCode CDECL
w_TfxConvertImage(TFX_IMG *tfxImg, PIXR *pPixr, UInt32 dwFlags,
    UInt32 rowOffset, UInt32 rowCount);

/* Convert the byte ordering of arbitrary imagery to PIXR order.
 */
ErrCode CDECL
wp_TfxPcToPixr(TFX_IMG *tfxImg, UInt8 **inImg, UInt32 inBPL, UInt8 **outImg,
    UInt32 outBPL);
#endif

/* Flip the bits (fill order)
 */
ErrCode CDECL
wp_TfxBitFlip(UInt8 *buffer, UInt32 bufSize);



#ifdef _MSC_VER
#pragma pack(pop, tfxconv_h)
#endif

#ifdef __cplusplus
}
#endif

#endif /* TFXCONV_H_INCLUDED */
