/*
 * Trade secret of Xerox Corporation.
 * Copyright (c) 1991-2001, Xerox Corporation.  All rights reserved.
 * Copyright protection claimed includes all forms and matters of 
 * copyrightable material and information now allowed by statutory or 
 * judicial law or hereinafter granted; including, without limitation,
 * material generated from the software programs which are displayed on 
 * the screen such as icons, screen display looks, etc.
 */

#ifndef TFXRJB2_H_INCLUDED
#define TFXRJB2_H_INCLUDED

#ifndef NOIPCORE
IP_RCSINFO(tfxrjb2_hRCSInfo, "$RCSfile: tfxrjb2.h,v $; $Revision: 1.1 $");
/* $Date: 2003/01/03 01:41:11 $ */
#endif

#ifdef __cplusplus
extern "C"
{
#endif

#ifdef _MSC_VER
#pragma pack(push, tfxrjb2_h, 1)
#endif

/* tfxrjb2.H
 *
 */

/*
 * INCLUDES
 */
#include "tfxtiff.h"

/*
 * CONSTANTS
 */

/* This defines the offsets of the items within the position block header */
#define cTfxTCPosPosBlockVersion	0
#define cTfxTCPosPosBlockDictCount	(cTfxTCPosPosBlockVersion + 1)
#define cTfxTCPosPosBlockDictIDs	(cTfxTCPosPosBlockDictCount + 2)
#define cTfxTCPosPosBlockSize(numDicts)		(cTfxTCPosPosBlockDictIDs + (numDicts * sizeof(long)))
#define cTfxTCPosBlockHeaderSize(numDicts)	(cTfxTCPosPosBlockSize(numDicts) + 4)

/* This defines the offsets of the items within the token dictionary header */
#define cTfxTCPosDictVersion		0
#define cTfxTCPosDictSize		(cTfxTCPosDictVersion + sizeof(char))
#define cTfxTCDictHeaderSize		(cTfxTCPosDictSize + sizeof(long))

/* Define the position block and dictionary versions currently exported */
#define cTfxTCPositionVersion		0
#define cTfxTCDictVersion		0
#define cTfxTCDictCompressionType	TFX_TIFFJBIG2

/*
 * MACROS
 */

/*
 * TYPEDEFS
 */

/*
 * ENUMS
 */

/*
 * GLOBAL VARIABLE DECLARATIONS
 */

/*
 * FUNCTION PROTOTYPES
 */
ErrCode CDECL
wp_TfxDetokenizeImage(TFX_IMG *tfxImg, UInt8 *pCmpData, UInt32 dwCmpBytes,
		   UInt8 *pImgData, UInt32 dwBytesPerRow);
ErrCode CDECL
wp_TfxReadTokenDictionary(TFX_DOC *tfxDoc, UInt32 dictNum);

ErrCode CDECL
wp_TfxCloseTokenization(
	TFX_DOC *tfxDoc
);

#ifdef _MSC_VER
#pragma pack(pop, tfxrjb2_h)
#endif

#ifdef __cplusplus
}
#endif

#endif /* TFXRJB2_H_INCLUDED */
