/*
 * Trade secret of Xerox Corporation.
 * Copyright (c) 1991-2001, Xerox Corporation.  All rights reserved.
 * Copyright protection claimed includes all forms and matters of 
 * copyrightable material and information now allowed by statutory or 
 * judicial law or hereinafter granted; including, without limitation,
 * material generated from the software programs which are displayed on 
 * the screen such as icons, screen display looks, etc.
 */

#ifndef TFXRPRIV_H_INCLUDED
#define TFXRPRIV_H_INCLUDED

#ifndef NOIPCORE
IP_RCSINFO(tfxrpriv_hRCSInfo, "$RCSfile: tfxrpriv.h,v $; $Revision: 1.1 $");
/* $Date: 2003/01/03 01:41:11 $ */
#endif

#ifdef __cplusplus
extern "C"
{
#endif

#ifdef _MSC_VER
#pragma pack(push, tfxrpriv_h, 1)
#endif

/*
 * INCLUDES
 */

/*
 * CONSTANTS
 */

/*
 * MACROS
 */

/*
 * TYPEDEFS
 */
typedef struct TfxMemoryTally {
	UInt32 bytesAllocated;
	UInt32 peak;
} TfxMemoryTally;


/*
 * ENUMS
 */

/*
 * GLOBAL VARIABLE DECLARATIONS
 */

/*
 * FUNCTION PROTOTYPES
 */
#ifndef NOIPCORE
/* IPCore stuff */
ErrCode CDECL
w_TfxShareIPWState(IO_INSTHANDLE instHandle, IPWState *pIPWState);

ErrCode CDECL
wp_TfxIPWState(TFX_DOC *tfxDoc, IPWState **ppIPWState);
ErrCode CDECL
wp_TfxClearPixrRegion(IPWState *pIPWState, PIXR *pPixr,
    Int32 dstCol, Int32 dstRow, Int32 dstWidth, Int32 dstHeight);
ErrCode CDECL
wp_TfxDecompressStripMH(TFX_IMG *tfxImg, UInt8 *pCmpData, UInt32 dwCmpBytes,
    UInt8 *pImgData, UInt32 dwBytesPerRow, UInt32 dwRowOffset,
    UInt32 dwStripHeight, UInt32 *pdwRowsFilled);
ErrCode CDECL
wp_TfxDecompressStripMR(TFX_IMG *tfxImg, UInt8 *pCmpData, UInt32 dwCmpBytes,
    UInt8 *pImgData, UInt32 dwBytesPerRow, UInt32 dwRowOffset,
    UInt32 dwStripHeight, UInt32 *pdwRowsFilled);
ErrCode CDECL
wp_TfxDecompressStripMMR(TFX_IMG *tfxImg, UInt8 *pCmpData, UInt32 dwCmpBytes,
    UInt8 *pImgData, UInt32 dwBytesPerRow, UInt32 dwRowOffset,
    UInt32 dwStripHeight, UInt32 *pdwRowsFilled);
ErrCode CDECL
wp_TfxDecompressStripLossyDither(TFX_IMG *tfxImg, UInt8 *pCmpData, UInt32 dwCmpBytes,
    UInt8 *pImgData, UInt32 dwBytesPerRow, UInt32 dwRowOffset,
    UInt32 dwStripHeight, UInt32 *pdwRowsFilled);
#else

/* Dead functions if no IPCore: */
#define wp_TfxDecompressStripMH(tfxImg, pCmpData, dwCmpBytes, pImgData, \
 dwBytesPerRow, dwRowOffset, dwStripHeight, pdwRowsFilled) IO_NOSUPPORT
#define wp_TfxDecompressStripMR(tfxImg, pCmpData, dwCmpBytes, pImgData, \
 dwBytesPerRow, dwRowOffset, dwStripHeight, pdwRowsFilled) IO_NOSUPPORT
#define wp_TfxDecompressStripMMR(tfxImg, pCmpData, dwCmpBytes, \
 pImgData, dwBytesPerRow, dwRowOffset, dwStripHeight, pdwRowsFilled) \
 IO_NOSUPPORT
#define wp_TfxDecompressStripLossyDither(tfxImg, pCmpData, dwCmpBytes, \
 pImgData, dwBytesPerRow, dwRowOffset, dwStripHeight, pdwRowsFilled) \
 IO_NOSUPPORT
#endif

/* Non-IPCore stuff */
void * CDECL
wp_TfxMalloc(size_t dwBytes, Bool hasPtrs, void *clientID
#ifdef SHOWERR
	     , const char *file, const int line
#endif
	     );
void * CDECL
wp_TfxCalloc(size_t nel, size_t size, Bool hasPtrs, void *clientID
#ifdef SHOWERR
	     , const char *file, const int line
#endif
	     );
void * CDECL
wp_TfxRealloc(void *ptr, size_t dwBytes, Bool hasPtrs, void *clientID
#ifdef SHOWERR
	     , const char *file, const int line
#endif
	     );
void CDECL
wp_TfxFree(void *buffer, size_t dwBytes, void *clientID);
UInt32 CDECL
wp_TfxMemoryCheck(TfxMemoryTally *tally);
UInt32 CDECL
wp_TfxAllocSize(void *buffer, void *clientID);
ErrCode CDECL
wp_TfxNewImg(TFX_PAGE *tfxPage, TFX_IMG **owner, Int32 ifdOffset);
ErrCode CDECL
wp_TfxIncrementImageCounts(TFX_PAGE *tfxPage, UInt32 layer,
			Int32 increment);
ErrCode CDECL
wp_TfxGetImageDesc(TFX_IMG *tfxImg);

void CDECL
wp_IPC_AllocID(UInt32 id);
void * CDECL
wp_TfxIPCMalloc(size_t count, Bool hasPtrs, void *thing);
void * CDECL
wp_TfxIPCCalloc(size_t nel, size_t size, Bool hasPtrs, void *thing);
void * CDECL
wp_TfxIPCRealloc(void *ptr, size_t size, Bool hasPtrs, void *thing);
void CDECL
wp_TfxIPCFree(void *ptr, size_t size, void *thing);

ErrCode CDECL
wp_TfxGetStripInfo(TFX_IMG *tfxImg, UInt32 rowOffset,
	UInt32 *pdwStripOffset, UInt32 *pdwStripRow, UInt32 *pdwStripHeight);


#ifdef _MSC_VER
#pragma pack(pop, tfxrpriv_h)
#endif

#ifdef __cplusplus
}
#endif

#endif /* TFXRPRIV_H_INCLUDED */
