/*
 * Trade secret of Xerox Corporation.
 * Copyright (c) 1991-2001, Xerox Corporation.  All rights reserved.
 * Copyright protection claimed includes all forms and matters of 
 * copyrightable material and information now allowed by statutory or 
 * judicial law or hereinafter granted; including, without limitation,
 * material generated from the software programs which are displayed on 
 * the screen such as icons, screen display looks, etc.
 */

#ifndef TFXRTFX_H_INCLUDED
#define TFXRTFX_H_INCLUDED

#ifndef NOIPCORE
IP_RCSINFO(tfxrtfx_hRCSInfo, "$RCSfile: tfxrtfx.h,v $; $Revision: 1.2 $");
/* $Date: 2003/02/10 22:53:32 $ */
#endif

#ifdef __cplusplus
extern "C"
{
#endif

#ifdef _MSC_VER
#pragma pack(push, tfxrtfx_h, 1)
#endif

/*
 * INCLUDES
 */


/*
 * CONSTANTS
 */

/*
 * MACROS
 */

/*
 * TYPEDEFS
 */

/*
 * ENUMS
 */

/*
 * GLOBAL VARIABLE DECLARATIONS
 */

/*
 * FUNCTION PROTOTYPES
 */
#ifndef NOIPCORE
ErrCode CDECL
wp_TfxReadStrip(TFX_IMG *tfxImg, PIXR *pPixr, UInt32 dwPixrRowOffset,
	     UInt32 dwImgRowOffset, UInt32 *rowsToRead,
	     UInt32 *totalBytesFilled);
#endif
ErrCode CDECL
wp_TfxIsTfx(TFX_FILE *pTfxFile, UInt8 *pVersion, UInt8 *pRevision, UInt32 *pFirstIFD);
ErrCode CDECL
wp_TfxImgFree(TFX_IMG **pTftfxImg, Int32 subsequentImagesToo);
ErrCode CDECL
wp_TfxPageFree(TFX_PAGE **pTfxPage, Int32 subsequentPagesToo);
ErrCode CDECL
wp_TfxDocFree(TFX_DOC **pTfxDoc);
#if 0
ErrCode CDECL
wp_TfxReadExtensions(TFX_DOC *pTfxDoc);
ErrCode CDECL
wp_TfxReadExtensionList(TFX_DOC *tfxDoc, UInt32 recursionLevel,
			Int32 fileOffset);
ErrCode CDECL
wp_TfxReadTagData(TFX_DOC *pTfxDoc);
#endif
/*ErrCode CDECL */
/*wp_TfxReadPageTable(TFX_DOC *pTfxDoc, UInt32 tableOffset, */
/*		 TFX_PAGETABLE **ppPageTable); */
ErrCode CDECL
wp_TfxGetPageIFD(TFX_DOC *tfxDoc, UInt32 pageOffset, UInt8 *pFlags,
	      Int32 *pIfdOffset);
ErrCode CDECL
wp_TfxReadResourceTable(TFX_DOC *pTfxDoc, UInt32 tableOffset,
		   TFX_RESOURCETABLE **ppSharedResourceTable);
ErrCode CDECL
wp_TfxGetResourceOffset(TFX_DOC *tfxDoc, UInt32 resourceOffset, Int32 *pdwOffset,
		      Int32 *pdwBytes, UInt16 *pwCompression,
		      UInt16 *pwLastPageUsed, UInt32 *pdwDecoderMemory);
ErrCode CDECL
wp_TfxGetCompressedSize(TFX_IMG *tfxImg, UInt32 dwImgRowOffset,
		     UInt32 *pdwOffset, UInt32 *pdwBytes);
ErrCode CDECL
wp_TfxCompressedReadStrip(TFX_IMG *tfxImg, UInt32 dwImgRowOffset,
		       UInt8 **ppCmpBuffer, UInt32 *pdwCmpBufsize,
		       UInt32 *pdwBytesFilled);
ErrCode CDECL
wp_TfxTraversePrimaryImages(TFX_DOC *tfxDoc, UInt32 dwPageOrdinal);
ErrCode CDECL
wp_TfxTraverseSubImages(TFX_IMG *parentImg);
ErrCode CDECL
wp_TfxTraverseHintsImages(TFX_IMG *parentImg);
ErrCode CDECL
wp_TfxGetAnnotTableHeader(TFX_PAGE *tfxPage);
ErrCode CDECL
wp_TfxGetAnnotTable(TFX_PAGE *tfxPage, UInt16 annotOffset,
		  TFX_ANNOTTABLE **ppAnnotPageTable);
ErrCode CDECL
wp_TfxGetAnnotData(TFX_PAGE *tfxPage, UInt16 annotOffset, UInt32 bytes,
		UInt8 *pData);
ErrCode CDECL
wp_TfxGetBaseColor(TFX_IMG *tfxImg, UInt8 *pRGB);


#ifdef _MSC_VER
#pragma pack(pop, tfxrtfx_h)
#endif

#ifdef __cplusplus
}
#endif

#endif /* TFXRTFX_H_INCLUDED */
