/*
 * Trade secret of Xerox Corporation.
 * Copyright (c) 1991-2001, Xerox Corporation.  All rights reserved.
 * Copyright protection claimed includes all forms and matters of 
 * copyrightable material and information now allowed by statutory or 
 * judicial law or hereinafter granted; including, without limitation,
 * material generated from the software programs which are displayed on 
 * the screen such as icons, screen display looks, etc.
 */

#ifndef TFXWJB2_H_INCLUDED
#define TFXWJB2_H_INCLUDED

#ifdef NOIPCORE
This file should not be included if not using IPCore
#endif

IP_RCSINFO(tfxwjb2_hRCSInfo, "$RCSfile: tfxwjb2.h,v $; $Revision: 1.1 $");
/* $Date: 2003/01/03 01:41:14 $ */

#ifdef __cplusplus
extern "C"
{
#endif

#ifdef _MSC_VER
#pragma pack(push, tfxwjb2_h, 1)
#endif

/* TFXWJB2.H
 *
 */

/*
 * INCLUDES
 */


/*
 * CONSTANTS
 */

/*
 * MACROS
 */

/*
 * TYPEDEFS
 */
typedef struct TCData {
    void *textInfo;
    TFX_IMG *img;
} TCData;


/*
 * ENUMS
 */

/*
 * GLOBAL VARIABLE DECLARATIONS
 */

/*
 * FUNCTION PROTOTYPES
 */
ErrCode CDECL
wp_TfxTokenizeImage(TFX_IMG *tfxImg, UInt8 *pImgData, Int32 dwBytesPerRow,
		    UInt32 dwFlags);
#ifdef NODGP	/* IPCore needs such a function, JBIG2 doesn't */
ErrCode CDECL
wp_TfxConsolidateTokens(TFX_DOC *tfxDoc);
#endif
ErrCode CDECL
wp_TfxWriteTokenDictionary(TFX_DOC *tfxDoc, TFX_PAGE *tfxPage);
ErrCode CDECL
wp_TfxWriteTokenImage(TFX_IMG *tfxImg);
#if 0
ErrCode CDECL
wp_TfxCompressStripLossyDither(TFX_IMG *tfxImg, UInt8 *pImgData,
			       UInt32 dwBytesPerRow, UInt32 dwRowOffset,
			       UInt32 dwStripHeight, UInt8 **ppCmpBuffer,
			       UInt32 *pdwCmpBufsize, UInt32 *pdwBytesFilled);
#endif
#if !defined(NOIPCORE) || !defined(NODGP)
Int32 CDECL
wp_TfxAssignTokenColor(IPState *pIPState, void *textInfo,
		       void *callbackData);
#endif

#ifdef _MSC_VER
#pragma pack(pop, tfxwjb2_h)
#endif

#ifdef __cplusplus
}
#endif

#endif /* TFXWJB2_H_INCLUDED */
