/*
 * Trade secret of Xerox Corporation.
 * Copyright (c) 1991-2001, Xerox Corporation.  All rights reserved.
 * Copyright protection claimed includes all forms and matters of 
 * copyrightable material and information now allowed by statutory or 
 * judicial law or hereinafter granted; including, without limitation,
 * material generated from the software programs which are displayed on 
 * the screen such as icons, screen display looks, etc.
 */

#ifndef TFXWTIFF_H_INCLUDED
#define TFXWTIFF_H_INCLUDED

#ifndef NOIPCORE
IP_RCSINFO(tfxwtiff_hRCSInfo, "$RCSfile: tfxwtiff.h,v $; $Revision: 1.2 $");
/* $Date: 2003/02/10 22:53:33 $ */
#endif

#ifdef __cplusplus
extern "C"
{
#endif

#ifdef _MSC_VER
#pragma pack(push, tfxwtiff_h, 1)
#endif

/*
 * INCLUDES
 */


/*
 * CONSTANTS
 */

/*
 * MACROS
 */

/*
 * TYPEDEFS
 */

/*
 * ENUMS
 */

/*
 * GLOBAL VARIABLE DECLARATIONS
 */

/*
 * FUNCTION PROTOTYPES
 */
ErrCode CDECL
wp_TifFXWriteHeader(TFX_FILE *pTfxFile, UInt32 dwFirstIFD);
ErrCode CDECL
wp_TifFXWriteGPIFD(TFX_IMG *tfxImg);
ErrCode CDECL
wp_TifFXWriteIFD(TFX_IMG *tfxImg);
ErrCode CDECL
wp_TifFXWriteFields(TFX_IMG *tfxImg, UInt16 *fieldCount, Bool writing);
ErrCode CDECL
wp_TifFXWriteFieldEntry(TFX_IMG *tfxImg, UInt16 tagID, UInt16 type,
		 UInt32 len, Int32 *pOffset, const void *pFieldData,
		 UInt16 *pFieldCount, Bool gpifd);
ErrCode CDECL
wp_TifFXWriteNextIFD(TFX_IMG *tfxImg, TFX_IMG *prevImg, UInt32 prevIFDOffset,
		UInt32 nextIFDOffset);
ErrCode CDECL
wp_TifFXAttachChildIFD(TFX_IMG *parentImg, TFX_IMG *tfxImg, UInt32 childIFDOffset);
ErrCode CDECL
wp_TifFXReattachIFD(TFX_IMG *tfxImg, UInt32 oldIFDOffset, UInt32 newIFDOffset);
ErrCode CDECL
wp_TifFXAddStripInfo(TFX_IMG *tfxImg, UInt32 stripRowOffset, UInt32 stripRowCount,
	UInt32 stripBytes);
ErrCode CDECL
wp_TifFXWriteStrip(TFX_IMG *tfxImg);
ErrCode CDECL
wp_TifFXWriteStripSizes(TFX_IMG *tfxImg);

/* Functions to rewrite field data */
/*ErrCode CDECL */
/*wp_TifFXUpdateILContent(TFX_IMG *tfxImg); */

/* Deletion function */
ErrCode CDECL
wp_TifFXDeleteImage(TFX_IMG *tfxImg);

/* Before closing the document */
/*ErrCode CDECL */
/*wp_TfxTestMultipageBit(IO_DOCHANDLE tfxDochandle); */
ErrCode CDECL
wp_TfxTestCodingMethods(IO_DOCHANDLE tfxDochandle);

/* Rewrite IFDs */
ErrCode CDECL
wp_TfxRewriteIFDs(IO_DOCHANDLE tfxDochandle);


#ifdef _MSC_VER
#pragma pack(pop, tfxwtiff_h)
#endif

#ifdef __cplusplus
}
#endif

#endif /* TFXWTIFF_H_INCLUDED */
