#ifndef ROT_BINARY_H
#define ROT_BINARY_H

#ifdef __cplusplus
extern "C"
{
#endif


/* rot_binary.h
   rotates binary images, only requiring 32 bit padding.
*/

/*
  rotates a block of size (srcW,srcH) at src 90 degrees clockwise into dst
  (srcH, srcW) assumes no needed padding (although the end of a line
  must be padded to 32-bits, but that's nothing unusual.)
  But no frame is needed. Assumes 32-bit packed.
*/
void
DgpRot_rotateBinary90CW(Dgp_UInt32 * src, Dgp_Int32 srcW, Dgp_Int32 srcH,
		 Dgp_Int32 srcBpl,
		 Dgp_UInt32 * dst, Dgp_Int32 dstBpl);

void
DgpRot_rotateBinary90CCW(Dgp_UInt32 * src, Dgp_Int32 srcW, Dgp_Int32 srcH, 
		  Dgp_Int32 srcBpl,
		  Dgp_UInt32 * dst, Dgp_Int32 dstBpl);

/* 
  rotates a block of size (srcW,srcH) of src 180 degrees in place
  Requires no temporary space
  Not the fastest (could be blocked), but gets the job done.
*/
void 
DgpRot_rotateBinary180InPlace(Dgp_UInt32 * src, 
			      Dgp_Int32 srcW, Dgp_Int32 srcH,
			      Dgp_Int32 srcBpl);


#ifdef __cplusplus
}
#endif


#endif

