/*
 * The tokenizer for sampled images.
 */

/* $Header: /project/icons/cvsroot/digipaper/src/libsamptok/samptok.h,v 1.9 2000/05/16 21:47:02 jahlborn Exp $ */

#ifndef	SAMPTOK_H
#define	SAMPTOK_H

#include <sys/types.h>
#include "list.h"
#include "util.h"
#include "image.h"
#include <mmcompress.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* The type of a tokeniser state cookie */
typedef void * SampTokState;

/* and the only defined value */
#define	NULLSampTokState ((SampTokState)0)

/* The options bit values */
#define	SAMPTOK_OPT_COPYTOKENS	0x01	/* Do I copy the runs? */

/* All the options the samptokeniser can take */
typedef struct {
  Dgp_UInt32 flags;	
  Dgp_State *dgp_state;
} samptokOptions;

/* the class flag values */
#define SAMPTOK_IS_RECT    0x01
#define SAMPTOK_IS_ON_TOP  0x02
#define SAMPTOK_USER_FLAG1 0x10
#define SAMPTOK_USER_FLAG2 0x20
#define SAMPTOK_USER_FLAG3 0x40
#define SAMPTOK_USER_FLAG4 0x80

/* What you get back an array of */
typedef struct _samptokClass {
  DgpImage_ColorRGB im; /* the exemplar of this class */
  Dgp_Int32 width;
  Dgp_Int32 height;
  Dgp_UInt32 samptoknum;      /* The unique number all instances of this token got */
  Dgp_UInt32 num_instances;  /* The number of instances of this token */
  Dgp_UInt32 flags;
} *samptokClass;


/* The routines */
DGP_LIBEXPORT ErrCode 
samptokInit(SampTokState *state, 
            samptokOptions *options);

DGP_LIBEXPORT ErrCode 
samptokAddToken(SampTokState state, 
                DgpImage_ColorRGB sampledIm, 
                samptokClass *newClass);

DGP_LIBEXPORT ErrCode 
samptokFinal(SampTokState *state, 
             Dgp_Int32 *num_classes, 
             samptokClass **newClasses);

DGP_LIBEXPORT void 
samptokFreeOutput(samptokClass *sampoutput, 
                  Dgp_Int32 num_classes, 
                  Dgp_State *dgp_state);

DGP_LIBEXPORT void 
samptokAbort(SampTokState *state);

DGP_LIBEXPORT Dgp_Int32 
samptokMemUsage(SampTokState state);

#ifdef __cplusplus
}
#endif

#endif
