/*
 *
 * $Header: /project/icons/cvsroot/digipaper/src/libsamptok/tokprivate.h,v 1.9 2000/05/16 21:47:02 jahlborn Exp $
 *
 */

/*
 * Internal declarations for the samptokeniser.
 */

#ifndef	TOKPRIVATE_H

#define	TOKPRIVATE_H

#include <stdlib.h>
#include "util.h"
#include "sm_image.h"
#include "list.h"
#include "samptok.h"


typedef struct _ClassTable
{
  DgpAdt_SMImage elts; 			/* Each point is a pointer to a list
					   of classes */
  Dgp_UInt32 count;			/* total number of things in elts */
} *ClassTable;

#define ClassData(classlistelt)    ((samptokClass)DGPADT_LIGET(classlistelt))
#define MemberBox(memberlistelt)   ((boxType*)DGPADT_LIGET(memberlistelt))

typedef struct {
  Dgp_UInt32 flags;
  struct _ClassTable classes;
  Dgp_Bool returned_classes;
  int memUsage;
  Dgp_State *dgp_state;
} intSampTokState;

/* small mem pool defs for samptokClass */
#define SAMPTOKCLASS_POOL_ID DGP_SMALLPOOL_MIN24

#define SAMPTOKCLASS_SEC_MALLOC(_ppsamptok) \
  DGP_ERR_PASS_CLEANUP(dgp_state->sm_a.mallocSmall(dgp_state->sm_a.smallCookie, SAMPTOKCLASS_POOL_ID, (void **)(_ppsamptok)))
#define SAMPTOKCLASS_FREE(_psamptok) \
  (dgp_state->sm_a.freeSmall(dgp_state->sm_a.smallCookie, SAMPTOKCLASS_POOL_ID, (void *)(_psamptok)))

#endif
