#ifndef PAGE_HELPERS_H
#define PAGE_HELPERS_H

#include "santa_t.h"
#include "dgp_state.h"

/* page_helpers.h 
   santaPage helper functions.
   wbell 10/16/99
 */

#ifdef __cplusplus
extern "C"
{
#endif


/* pageOpen()
   takes a previously allocated santaPage structure and fills it in with the
   initialization information for page page_num (note pages start numbering
   at 0)

   pdoc - the document already opened and initialized
   ppage - the page structure that you want initialized.
   page_num - what page do you want it initialized to? starts from 0.
*/
ErrCode
pageOpen(santaDoc * pdoc, santaPage * ppage, Dgp_Int32 page_num,
	 Dgp_State * dgp_state);


/* pageClose()
   destroys a page structure initialized with pageOpen, closes the relevent
   opened layers and images. make sure all jobs are done with this page 
   before you close it.

   pdoc - the document for this page.
   ppage - the page structure that has been initialized.
*/
ErrCode
pageClose(santaDoc * pdoc, santaPage * ppage, 
	  Dgp_State * dgp_state);
   

#ifdef __cplusplus
}
#endif
#endif

