#include "page_strip_manip.h"
#include "page_strip.h"
#include "zephimage.h"

/* File page_strip_manip.c
   wbell 6/15/98
   page strip manipulation routines.

   Updated on 10/11/99 to celebrate the millenium.
*/

/* pageStripIsImgOn()
   Determines if a specified image is on this page strip.
   pstrip - the strip
   pimg - the image.
   pon - a Dgp_Bool that is set to DGP_TRUE if the image is on the
    strip, DGP_FALSE otherwise.
*/
ErrCode
pageStripIsImgOn(pageStrip * pstrip, santaImage * pimg,
		 Dgp_Bool * pon, Dgp_State * dgp_state)
{
  Dgp_Int32 x, y, w, h;
  DGP_STATE_PROLOGUE("pageStripIsImgOn", dgp_state);
  DGP_ERR_GEN_CLEANUP(!dgp_state, cErrInvalidParm);  
  DGP_ERR_GEN_CLEANUP(!pstrip, cErrInvalidParm);
  DGP_ERR_GEN_CLEANUP(!pimg, cErrInvalidParm);
  DGP_ERR_GEN_CLEANUP(!pon, cErrInvalidParm);

  DGP_ERR_PASS_CLEANUP(zephCalcPagePosition(pimg->zephImage, &x, &y, &w, &h));

  *pon = pageStripDoesOverlap(pstrip, x, y, w, h);
  
  NORMAL_RETURN;
 ERR_CLEANUP:
  ERR_RETURN;
}








