#ifndef PAGE_STRIP_T_H
#define PAGE_STRIP_T_H

#include "rendered_image_t.h"
#include "resolution_t.h"

#ifdef __cplusplus
extern "C"
{
#endif

/* File page_strip_t.h
   wbell 6/8/98
   page strip creation/destruction routines.

   Revised for the millenium by wbell on 10/3/99
 */

typedef struct
{
  /* the PageStrip is little more than just a RenderedImage: */
  /* a portion of the page at a specified DgpCoord_Orientation / resolution. */
  /* note that the coords in the RenderImage are at */
  /* *page* resolution / DgpCoord_Orientation (RD), */
  /* which can differ from the PageStrip resolution / DgpCoord_Orientation. */
  renderedImage * pimg;
  /* is this memory cleared out? */
  Dgp_UInt8 cleared;
} pageStrip;

#ifdef __cplusplus
}
#endif

#endif

