/*****************************************************************
 *  Trade Secret of Xerox Corporation.                           *
 *  Copyright (c) 1991-1995, Xerox Corporation.                  *
 *  All rights reserved.                                         *
 *  Copyright protection claimed includes all forms and matters  *
 *  of copyrightable material and information now allowed by     *
 *  statutory or judicial law or hereafter granted, including    *
 *  without limitation, material generated from the software     *
 *  programs which are displayed on the screen such as icons,    *
 *  screen display looks, etc.                                   *
 *****************************************************************/

/*************************************************************************
**
**  DigiPaper Codebase
**  
**	  
**  Pedro Felzenszwalb, Summer 1998
**
**  File:  halftone.h
**
**  We want to produce binary output given an rgb image....Halftone!
**
**	Modification history:
**	    Dillon H. Tracy esq. / March 2000
**		o  dgp types namespace issues.
**		o  Search on 'dhtesq' for some of this coder's comments & changes.
**  3.5.2001 / dhtesq.
**	This completely disappeared with the "new" santa.  Reinstating, so we 
**  can force mono output again.
**
**************************************************************************/

#ifndef HALFTONE_H
#define HALFTONE_H

/*#include <libiow.pub> */
#include <libpixrw.pub>

#include "simple_utils.h"
#include "image.h"
#include "image_defs.h"
#include <binarize.pub>
#include <color.pub>

/* 3.5.2001 / dhtesq. */
/* This parameter is passed to an ipcore binarization routine if the user is downscaling */
/* a binary image.  As of this writing libscancolor uses the same value. */
#define SANTA_BINARIZATION_THRESHOLD 32

void
halftone3(DgpImage_ColorRGB src, Dgp_Int32 w, Dgp_Int32 h, DgpImage_Packed dst);	

/*
3.5.2001 / dhtesq.
A sort-of related function to binarize an rgb image.  Santa uses this for scaling
mono documents:  first scale to RGB, then binarize.

For convenience, I give back a pixr and a dgp image, but to clean up you have to unwrap the image
and destroy the pixr, both.
*/
ErrCode
binarizeRGBImage( Dgp_State		*dgp_state, 
				  DgpImage_ColorRGB	rgbImage, 
				  PIXR			**_binaryPixr,
				  void			**_binaryImage);

#endif
