#ifndef SANTA_LAYER_BLAT_TOKENIZED_H
#define SANTA_LAYER_BLAT_TOKENIZED_H

#include "libsupercache.h"
#include "rendered_image_t.h"
#include "memory_sentry_t.h"
#include "page_strip_order_t.h"
#include "santa_image_t.h"

#ifdef __cplusplus
extern "C"
{
#endif

/* santa_layer_blat_tokenized.h
   wbell 11.22.99
   blatting a black & white tokenized image onto a rendered image
   in various orientations and output types.
*/


/* santaLayerBlatTokenized()
   takes an tokenized image, and blats it onto the given renderedImage.
   takes care of output type dispatch, scaling, and rotation.

   pdoc - where to get the tokenized info from.
   ppage - the page this image is on.
   pimg - the zephImage that we're blatting down.
   pdst - the destination buffer, already cleared / prepared suitably.
   porder - gives information about what should / should not be cached
    for later use.
   selector - plane in structure form.  Not implemented presently for color tokenized images. / dhtesq.
   psentry - use in order to claim and release memory.
*/

ErrCode
santaLayerBlatTokenized(santaDoc * pdoc, santaPage * ppage,
			santaImage * pimg,
			renderedImage * pdst, 
			pageStripOrder * porder,
			memorySentry * psentry,
            renderedImage *selector,
			Dgp_State * dgp_state);

ErrCode
SortPositions(santaDoc       *pDoc,
              santaPage      *pInfo,
              santaImage     *pImInfo,
              Dgp_State      *dgp_state);

#ifdef __cplusplus
}
#endif
#endif

