#ifndef SANTA_LAYER_BLAT_ZEPHYR_H
#define SANTA_LAYER_BLAT_ZEPHYR_H

#include "rendered_image_t.h"
#include "memory_sentry_t.h"
#include "page_strip_order_t.h"
#include "santa_image_t.h"

#ifdef __cplusplus
extern "C"
{
#endif

/* santa_layer_blat_zephyr.h
   wbell 11.22.99
   blatting a zephyr decoded image.
*/


/* santaLayerBlatZephyr()
   takes an zephyr image, and blats it onto the given renderedImage.
   takes care of output type dispatch, scaling, and rotation.

   pimg - the zephImage that we're blatting down.
   pdst - the destination buffer, already cleared / prepared suitably.
   porder - gives information about what should / should not be cached
    for later use.
   ppage -- added to give downstream information on nominal page size / dhtesq.
   psentry - use in order to claim and release memory.
*/

ErrCode
santaLayerBlatZephyr(santaImage * pimg,
                     renderedImage * pdst, 
                     pageStripOrder * porder,
                     santaPage *ppage,
                     memorySentry * psentry,
                     Dgp_State * dgp_state);

#ifdef __cplusplus
}
#endif
#endif

