#ifndef SANTA_LAYER_T_H
#define SANTA_LAYER_T_H

#include "santa_image_t.h"
#include "rendered_image_t.h"

#ifdef __cplusplus
extern "C"
{
#endif

/* santa_layer_t.h
   wbell 10/12/99
   the santa page layer datatype.
*/

  /* the layersave renderedimage should be created with renderedimagecreate */
  /* or memory will be leaked if they are destroyed in the destructor */
typedef struct
{
  Dgp_Int32 layer_num;
  Dgp_Int32 nimages;

  /* the images that make up this layer. */
  santaImage * pimgs;

  /* as a layer, we can prepare and save certain portions of the */
  /* layer. This pointer indicated what we have saved. */
  /* layer pin lets us know if the memory purging algorithm is allowed */
  /* to purge this memory. */
  Dgp_UInt32 layerpin;
  renderedImage * playersave;
} santaLayer;

#ifdef __cplusplus
}
#endif
#endif

