#ifndef SANTA_PRIVATE_T_H
#define SANTA_PRIVATE_T_H

#include "santa_t.h"
#include "sucache_t.h"
#include "zephdocument_t.h"
#include "zephpage_t.h"
#include "page_strip_order_t.h"
#include "memory_sentry_t.h"
#include "santa_layer_t.h"
#include "uds.h"

#ifdef __cplusplus
extern "C"
{
#endif

/* santa_private_t.h
   wbell 10/12/99
   reincarnated core santa datatypes.
   invisible to the outside world.
*/

typedef struct {
  zephDocumentInfo zephDoc;
  memorySentry * memmgr;
  uds u;
  suXiffCache cache;
  /* open pages. there are npages of them. if the pointer at */
  /* pppages[i] is non-null, page i (starting from 0) and can just be */
  /* ref added when opened. */
  santaPage ** pppages;
  santaDocOptions opts;
} _santaPrivateDoc;

typedef struct {
  /* number of references to this page. */
  Dgp_Int32 nrefs;
  zephPageInfo zephPage;
  Dgp_Int32 nlayers;
  santaLayer * players;
} _santaPrivatePage;

typedef struct {
  pageStripOrder * order;
  santaJobOptions opts;
} _santaPrivateRenderJob;

#define page_private(ppage) ((_santaPrivatePage *)((ppage)->privateInfo))
#define doc_private(pdoc) ((_santaPrivateDoc *)((pdoc)->privateInfo))
#define job_private(pjob) ((_santaPrivateRenderJob *)((pjob)->privateInfo))

#ifdef __cplusplus
}
#endif
#endif

