/*****************************************************************
 *  Trade Secret of Xerox Corporation.                           *
 *  Copyright (c) 1991-1995, Xerox Corporation.                  *
 *  All rights reserved.                                         *
 *  Copyright protection claimed includes all forms and matters  *
 *  of copyrightable material and information now allowed by     *
 *  statutory or judicial law or hereafter granted, including    *
 *  without limitation, material generated from the software     *
 *  programs which are displayed on the screen such as icons,    *
 *  screen display looks, etc.                                   *
 *****************************************************************/

/*************************************************************************
**
**  DigiPaper Codebase
**  
**	  
**  wbell?  1998?
**
**  File:  tokenized_blat_color.c
**
**  ...
**
**	Modification history:
**	    dhtesq / March 2000
**		o  dgp types namespace issues.
**      o  liberr compliance issues.
**		o  Search on 'dhtesq' for some of this coder's comments & changes.
**      June 2000
**      o  Imported to new santa.  This is based on old santa's strip_blat_level.c and 
**         tokenize_blat.c...
**  
**************************************************************************/

#ifdef _WIN32
/* libipw defines cPlanes which is used in winsock2
 * so if a user include readXiff3.h and then winsock2.h they
 * get a really nasty error.  So we'll just include it first 
 * so this doesn't happen.
 */
#include <winsock2.h>
#endif

/*
#include "libpixrw.pub"
#include "strip_blat_level.h"
#include "packed_im_utils.h"

#include "strip_prim.h"
#include "strip_manip.h"
#include "tokenize_blat.h"

#include "color_blat.h"

#include "dgp_err_control.h"
#include "dgp_state.h"
#include "image.h"
#include "image_defs.h"
#include "blit.h"

#include "memory_def.h"

#include "color-extension.h"        /* For IMAGE_INDEX... */

#include "mmcompress.h"
#include "math.h"
#include "g4.h"
*/


#include "tokenized_blat_color.h"
#include "tokenized_blat_mono.h"        /* For G4 function. */
#include "memory_sentry.h"
#include "util.h"
#include "blit.h"
#include "blit_rgb.h"
#include "reorient.h"
#include "orientation.h"
#include "g4.h"

#include <math.h>

DGP_RCSID("@(#)$Header: /project/icons/cvsroot/digipaper/src/libsanta/tokenized_blat_color.c,v 1.10 2003/02/10 22:53:35 mkrocken Exp $");

/* tokenized_blat_mono.c
   wbell 11.29.99
   blatting a set of tokens down into a mono packed image; this level
   no longer deals with data structures, just a simple representation
   of the output buffer and the tokens.
*/



/* tokenizeBlatColor()
    ...adapted shamelessly from tokenizeBlatMono() (existing) and colorTokenizeBlatCroppedStrippedn() (old).

     given some jb2SymbolInstance and an output buffer at some orientation, blats
     these tokens onto the output buffer with no scaling, cropped to 
     a region inside the buffer. jb2SymbolInstance are considered to be in the
     page coordinate space, and will be cropped as such.

     pdst - a pointer to (x,y) in the destination buffer.
     bpl - number of bytes per line in one row of the dest buffer
     x, y - in the page coordinate space, what point does pdst represent
     o - what orientation is this buffer in?
     cropx, cropy, cropw, croph - in the page coordinate space, 
      what rectangle inside the destination do you want to blat with
      tokens (gives you the ability to crop)
     nboxes - how many tokens do we want to blat?
     pboxes - an array of jb2SymbolInstance, where the required dictionaries have already
      been fetched. Does not assume tokens are in the right orientation;
      will rotate to suit. 
     psentry - a memory sentry object to keep track of changes in usage
      of memory.
     pmod - did we modify any tokens?
*/
ErrCode
tokenizeBlatColor(Dgp_UInt32 *pdst, 
                  Dgp_Int32 bpl, 
                  Dgp_Int32 x, 
                  Dgp_Int32 y, 
                  DgpCoord_Orientation o, 
                  Dgp_Int32 cropx, 
                  Dgp_Int32 cropy, 
                  Dgp_Int32 cropw, 
                  Dgp_Int32 croph,
                  santaImage *pimg,
                  Dgp_Int32 nboxes, 
                  jb2SymbolInstance *pboxes, 
                  memorySentry *psentry,
                  Dgp_Bool *pmod, 
                  renderedImage *selector,
                  Dgp_State * dgp_state)
{
  Dgp_Int32 toknum;
  jb2Symbol *cur_tok;
  jb2SymbolInstance *cur_pos;
  jb2SymbolInstance **ppos = NULL;
  Dgp_Int32 curxl, curxh, curyl, curyh;
  Dgp_Int32 cur_min;
  Dgp_Bool mod = DGP_FALSE;
  Dgp_UInt32 *cur_src = NULL;
  /*Dgp_UInt32 *cur_dst = NULL; */
  Dgp_UInt32 curlpl, dstlpl;
  Dgp_UInt8 cur_clip, color_type;
  DgpImage_RGB color_value;
  
  Dgp_Int32 mem_limit = 0;
  Dgp_Int32 mem_chg = 0;
  Dgp_Int32 mem_diff = 0;

  /* crop rectangle */
  Dgp_Int32 cxl, cxh, cyl, cyh;

  DGP_STATE_PROLOGUE("tokenizeBlatColor()", dgp_state);
  /* We won't allocate image space here... */
  DGP_ERR_GEN(!pdst, cErrInvalidParm);
  DGP_ERR_GEN(!bpl, cErrInvalidParm);
  DGP_ERR_GEN(!cropw < 0, cErrInvalidParm);
  DGP_ERR_GEN(!croph < 0, cErrInvalidParm);
  DGP_ERR_GEN(nboxes != 0 && !pboxes, cErrInvalidParm);
  DGP_ERR_GEN(!psentry, cErrInvalidParm);

  /* We can't handle color tokenized layers with full-blown selectors... */
  DGP_ERR_GENF0(selector != NULL, cErrInvalidParm, 
      "tokenizeBlatColor() / I can't handle tokenized layers with real selectors or transparency masks.");

  DGP_ERR_GEN_CLEANUPF0((!pimg->zephImage->colorTokImgExt->sorted_positions),
                        cErrInvalidParm,
                        "colorTokenizeBlatCroppedStrippedV() / no sorted positions found.");

  ppos = pimg->zephImage->colorTokImgExt->sorted_positions;

  if (cropw == 0 || croph == 0 || nboxes == 0){
    NORMAL_RETURN;
  }

  /* find out the position of the rectangle in absolute inclusive */
  /* coordinates. */
  cxl = cropx;
  cyl = cropy;
  cxh = cropx + cropw - 1;
  cyh = cropy + croph - 1;

  /* Apparently destination image has to be word-aligned?... */
  /*DGP_ASSERT((bpl % sizeof(Dgp_UInt32)) == 0); */
  dstlpl = bpl / sizeof(Dgp_UInt32);

  /* Get our memory limit.  We won't check with the supercache each time we need */
  /* some memory, we'll just do it in batches, and only talk to the cache when */
  /* the batch gets bigger than this limit, or we're done. */
  DGP_ERR_PASS_CLEANUP(memorySentryGetAvailableMemory(psentry,
                                                      &mem_limit,
                                                      dgp_state));


  /* I know this is real ugly, but the cost of doing the switch
     on each token is horrible, so we duplicate the loop and the initial
     checks. Make sure to change all of them if you change any of the
     boilerplate code.
  */
  switch(o){
  case ORIENT_RD:
    for(toknum = 0 ; toknum < nboxes ; toknum++){
      cur_pos = ppos[toknum];

      DGP_ASSERT (ppos[toknum]->userdata != NULL);
        
      color_type = ((color_tag *)(ppos[toknum]->userdata))->color_type;
      color_value = ((color_tag *)(ppos[toknum]->userdata))->value.rgb_color;

      /* cur_pos = pboxes + toknum; */
      cur_tok = cur_pos->sym;
      
      DGP_ASSERT(cur_tok);
      /* First thing to check is if this is in the crop rectangle... */
      if(!((cur_pos->xpos <= cxh)
           && (cur_pos->ypos <= cyh)
           && (cxl < (cur_pos->xpos + cur_tok->width))
           && (cyl < (cur_pos->ypos + cur_tok->height)))){
        continue;
      }

      /* It's possible that this is a g4 token, which means that it's a single
         use token that's left compressed for us to uncompress.  We're going
         to uncompress it, and leave it around.  The rationale behind is that
         if it's truly a single use token, it'll be in the per page dictionary
         and will be purged once we leave this page.
      */
      /* Old santa also trapped for nonzero token width... */
      if (cur_tok->longsperline == 0){
        DGP_ERR_CHECK(tokenizeBlatDecompressG4(cur_tok, &mem_diff, dgp_state)){
          /* Just print something nasty if fails. */
          DGP_REPORTF1(DGP_TRUE, "tokenizeBlatColor() / %d token G4 decompress failed...\n", toknum);
          continue;
        }
        
        /* It now uses a different amount of memory.  Update our counter. */
        if(mem_diff){
          mem_chg += mem_diff;
          /* So this might be a little sloppy.  It could go a little over our */
          /* memory limit, but we've decided that's ok (we've already malloced */
          /* the memory anyway.) */
          if(mem_chg >= mem_limit){
            DGP_ERR_PASS_CLEANUP(memorySentryClaimMemory(psentry, mem_chg, 
                                                         dgp_state));
            DGP_ERR_PASS_CLEANUP(memorySentryGetAvailableMemory(psentry,
                                                                &mem_limit,
                                                                dgp_state));
            mem_chg = 0;
          }
          mod = DGP_TRUE;
        }
      }
      /* Rotate the token if we need to.  We store the current orientation in */
      /* userflags. So if anyone mucks with userflags,  */
      /* I'll be extremely unhappy. */
      if (cur_tok->userflags != o){
        DGP_ERR_CHECK(tokenizeBlatRotateBinaryToken(cur_tok, 
                                                    o,
                                                    &mem_diff, 
                                                    dgp_state)){
          DGP_REPORTF1(DGP_TRUE, "tokenizeBlatColor() / %d token rotation failed...\n", toknum);
          continue;
        }

        /* It now uses a different amount of memory.  Update our counter. */
        if (mem_diff){
          mem_chg += mem_diff;
          /* So this might be a little sloppy.  It could go a little over our */
          /* memory limit, but we've decided that's ok (we've already malloced */
          /* the memory anyway). */
          if (mem_chg >= mem_limit){
            DGP_ERR_PASS_CLEANUP(memorySentryClaimMemory(psentry, mem_chg, 
                                                         dgp_state));
            DGP_ERR_PASS_CLEANUP(memorySentryGetAvailableMemory(psentry,
                                                                &mem_limit,
                                                                dgp_state));
            mem_chg = 0;
          }
          mod = DGP_TRUE;
        }
      }

      cur_clip = 0;
      cur_min = 0;
      cur_src = cur_tok->bits;
      curlpl = cur_tok->longsperline;
      curyl = cur_pos->ypos;
      curyh = curyl + cur_tok->height - 1;
      curxl = cur_pos->xpos;
      curxh = curxl + cur_tok->width - 1;

      /* ORIENT_RD */
      /* Do we need to crop the top or bottom off this token? */
      if(curyl < cyl){
        cur_src += (curlpl * (cyl - curyl));
        curyl = cyl;
      }
      if (curyh > cyh){
        curyh = cyh;
      }
      /* We should have some rows, or we have an issue. */
      DGP_ASSERT((curyh - curyl) >= 0);
      
      /* Do we need to crop the left or right off this token? */
      if (curxl < cxl){
        cur_min = cxl - curxl;
        curxl = cxl;
        cur_clip = 1;
      }
      if (curxh > cxh){
        curxh = cxh;
        cur_clip = 1;
      }
      /* We should have some columns, or we have an issue. */
      DGP_ASSERT((curxh - curxl) >= 0);

      if(color_type == RGB_COLOR){
          /* Cursorily, it appears this color blitting function does crop, but */
          /* I won't swear to it.  Presently the branch does nothing. / dhtesq. */
          if(cur_clip){
            DgpBlat_colorBlitBinaryRGB(cur_src,
                             curlpl * sizeof(Dgp_UInt32),
                             curxl - x,
                             curyl - y,
                             (DgpImage_RGB *)pdst,
                             bpl,
                             0, /*x, */
                             0, /*y, */
                             curxl - x,
                             curyl - y,
                             (curxh - curxl) + 1,
                             (curyh - curyl) + 1,
                             color_value);
          } else {
            DgpBlat_colorBlitBinaryRGB(cur_src,
                             curlpl * sizeof(Dgp_UInt32),
                             curxl - x,
                             curyl - y,
                             (DgpImage_RGB *)pdst,
                             bpl,
                             0, /*x, */
                             0, /*y, */
                             curxl - x,
                             curyl - y,
                             (curxh - curxl) + 1,
                             (curyh - curyl) + 1,
                             color_value);
          }

      } else if(color_type == IMAGE_INDEX) {
        DGP_WARNF0("tokenizeBlatColor() / unhandleable color extension type...");
        /* If we run into the color tag IMAGE_INDEX, it looks like a lot more work */
        /* is involved, including rotating, "conversion", and scaling.  PIXRs... */
      }


    }
    break;
  case ORIENT_UR:

    for(toknum = 0; toknum < nboxes; toknum++){
      cur_pos = ppos[toknum];

      DGP_ASSERT (ppos[toknum]->userdata != NULL);
      color_type = ((color_tag *)(ppos[toknum]->userdata))->color_type;
      color_value = ((color_tag *)(ppos[toknum]->userdata))->value.rgb_color;
      
      /*cur_pos = pboxes + toknum; */
      cur_tok = cur_pos->sym;

      DGP_ASSERT(cur_tok);
      /* First thing to check is if this is in the crop rectangle. */
      if(!((cur_pos->xpos <= cxh)
           && (cur_pos->ypos <= cyh)
           && (cxl < (cur_pos->xpos + cur_tok->width))
           && (cyl < (cur_pos->ypos + cur_tok->height)))){
        continue;
      }


      /* It's possible that this is a g4 token, which means that it's a single
         use token that's left compressed for us to uncompress.  We're going
         to uncompress it, and leave it around.  The rationale behind is that
         if it's truly a single use token, it'll be in the per page dictionary
         and will be purged once we leave this page.
      */
      /* Old santa also trapped for nonzero token width... */
      if (cur_tok->longsperline == 0){
        DGP_ERR_CHECK(tokenizeBlatDecompressG4(cur_tok, &mem_diff, dgp_state)){
          /* Just print something nasty if fails. */
          DGP_REPORTF1(DGP_TRUE, "tokenizeBlatColor() / %d token G4 decompress failed...\n", toknum);
          continue;
        }
        
        /* It now uses a different amount of memory.  Update our counter. */
        if(mem_diff){
          mem_chg += mem_diff;
          /* So this might be a little sloppy.  It could go a little over our */
          /* memory limit, but we've decided that's ok (we've already malloced */
          /* the memory anyway.) */
          if(mem_chg >= mem_limit){
            DGP_ERR_PASS_CLEANUP(memorySentryClaimMemory(psentry, mem_chg, 
                                                         dgp_state));
            DGP_ERR_PASS_CLEANUP(memorySentryGetAvailableMemory(psentry,
                                                                &mem_limit,
                                                                dgp_state));
            mem_chg = 0;
          }
          mod = DGP_TRUE;
        }
      }

      /* Rotate the token if we need to.  We store the current orientation in */
      /* userflags. So if anyone mucks with userflags,  */
      /* I'll be extremely unhappy. */
      if (cur_tok->userflags != o){
        DGP_ERR_CHECK(tokenizeBlatRotateBinaryToken(cur_tok, 
                                                    o,
                                                    &mem_diff, 
                                                    dgp_state)){
          DGP_REPORTF1(DGP_TRUE, "tokenizeBlatColor() / %d token rotation failed...\n", toknum);
          continue;
        }

        /* It now uses a different amount of memory.  Update our counter. */
        if (mem_diff){
          mem_chg += mem_diff;
          /* So this might be a little sloppy.  It could go a little over our */
          /* memory limit, but we've decided that's ok (we've already malloced */
          /* the memory anyway). */
          if (mem_chg >= mem_limit){
            DGP_ERR_PASS_CLEANUP(memorySentryClaimMemory(psentry, mem_chg, 
                                                         dgp_state));
            DGP_ERR_PASS_CLEANUP(memorySentryGetAvailableMemory(psentry,
                                                                &mem_limit,
                                                                dgp_state));
            mem_chg = 0;
          }
          mod = DGP_TRUE;
        }
      }

      cur_clip = 0;
      cur_min = 0;
      cur_src = cur_tok->bits;
      curlpl = cur_tok->longsperline;
      curyl = cur_pos->ypos;
      curyh = curyl + cur_tok->height - 1;
      curxl = cur_pos->xpos;
      curxh = curxl + cur_tok->width - 1;

      /* ORIENT_UR */
      /* do we need to crop the top or bottom off this token? */
      if (curyl < cyl){
        curyl = cyl;
        cur_clip = 1;
      }
      if (curyh > cyh){
        cur_min = curyh - cyh;
        curyh = cyh;
        cur_clip = 1;
      }
      /* we should have some rows, or we have an issue. */
      DGP_ASSERT((curyh - curyl) >= 0);
      
      /* do we need to crop the left or right off this token? */
      if (curxl < cxl){
        cur_src += (curlpl * (cxl - curxl));
        curxl = cxl;
      }
      if (curxh > cxh){
        curxh = cxh;
      }
      /* we should have some columns, or we have an issue. */
      DGP_ASSERT((curxh - curxl) >= 0);


      if(color_type == RGB_COLOR){
          /* Cursorily, it appears this color blitting function does crop, but */
          /* I won't swear to it.  Presently the branch does nothing. / dhtesq. */
          if(cur_clip){
            DgpBlat_colorBlitBinaryRGB(cur_src,
                             curlpl * sizeof(Dgp_UInt32),
                             cyh - curyh,
                             curxl - x,
                             (DgpImage_RGB *)pdst,
                             bpl,
                             0, /*x, */
                             0, /*y, */
                             cyh - curyh,
                             curxl - x,
                             (curyh - curyl) + 1,
                             (curxh - curxl) + 1,
                             color_value);                             
          } else {
            DgpBlat_colorBlitBinaryRGB(cur_src,
                             curlpl * sizeof(Dgp_UInt32),
                             cyh - curyh,
                             curxl - x,
                             (DgpImage_RGB *)pdst,
                             bpl,
                             0, /*x, */
                             0, /*y, */
                             cyh - curyh,
                             curxl - x,
                             (curyh - curyl) + 1,
                             (curxh - curxl) + 1,
                             color_value);                             
          }
      } else if(color_type == IMAGE_INDEX) {
        DGP_WARNF0("tokenizeBlatColor() / unhandleable color extension type...");
        /* If we run into the color tag IMAGE_INDEX, it looks like a lot more work */
        /* is involved, including rotating, "conversion", and scaling.  PIXRs... */
      }
    }
    break;
  case ORIENT_RU:
    DGP_ERR_GEN(DGP_TRUE, cErrNoImpl);
    break;
  case ORIENT_LU:
    for ( toknum = 0 ; toknum < nboxes ; toknum++){
      cur_pos = ppos[toknum];

      DGP_ASSERT (ppos[toknum]->userdata != NULL);
      color_type = ((color_tag *)(ppos[toknum]->userdata))->color_type;
      color_value = ((color_tag *)(ppos[toknum]->userdata))->value.rgb_color;
      
      /*cur_pos = pboxes + toknum; */
      cur_tok = cur_pos->sym;

      DGP_ASSERT(cur_tok);
      /* first thing to check is if this is in the crop rectangle. */
      if(!((cur_pos->xpos <= cxh)
           && (cur_pos->ypos <= cyh)
           && (cxl < (cur_pos->xpos + cur_tok->width))
           && (cyl < (cur_pos->ypos + cur_tok->height)))){
        continue;
      }

      /* It's possible that this is a g4 token; which means that it's a single
         use token thats left compressed for us to uncompress. We're going
         to uncompress it, and leave it around. The rationale behind is that
         if it's truly a single use token, it'll be in the per page dictionary
         and will be purged once we leave this page.
      */
      if (cur_tok->longsperline == 0){
        DGP_ERR_CHECK(tokenizeBlatDecompressG4(cur_tok, &mem_diff, dgp_state)){
          /* just print something nasty if fails. */
          continue;
        }
        
        /* it now uses a different amount of memory. Keep update our counter. */
        if (mem_diff){
          mem_chg += mem_diff;
          /* so this might be a little sloppy, it could go a little over our */
          /* memory limit, but we've decided that's ok (we've already malloced */
          /* the memory anyways.) */
          if (mem_chg >= mem_limit){
            DGP_ERR_PASS_CLEANUP(memorySentryClaimMemory(psentry, mem_chg, 
                                                         dgp_state));
            DGP_ERR_PASS_CLEANUP(memorySentryGetAvailableMemory(psentry,
                                                                &mem_limit,
                                                                dgp_state));
            mem_chg = 0;
            
          }
          mod = DGP_TRUE;
        }
      }

      /* rotate the token if we need to. We store the current orientation in */
      /* userflags. So if anyone mucks with userflags,  */
      /* I'll be extremely unhappy. */
      if (cur_tok->userflags != o){
        DGP_ERR_CHECK(tokenizeBlatRotateBinaryToken(cur_tok, o,
                                                    &mem_diff, dgp_state)){
          /* just print something nasty if fails. */
          continue;
        }

        /* it now uses a different amount of memory. Keep update our counter. */
        if (mem_diff){
          mem_chg += mem_diff;
          /* so this might be a little sloppy, it could go a little over our */
          /* memory limit, but we've decided that's ok (we've already malloced */
          /* the memory anyways.) */
          if (mem_chg >= mem_limit){
            DGP_ERR_PASS_CLEANUP(memorySentryClaimMemory(psentry, mem_chg, 
                                                         dgp_state));
            DGP_ERR_PASS_CLEANUP(memorySentryGetAvailableMemory(psentry,
                                                                &mem_limit,
                                                                dgp_state));
            mem_chg = 0;
       
          }
          mod = DGP_TRUE;
        }
      }

      cur_clip = 0;
      cur_min = 0;
      cur_src = cur_tok->bits;
      curlpl = cur_tok->longsperline;
      curyl = cur_pos->ypos;
      curyh = curyl + cur_tok->height - 1;
      curxl = cur_pos->xpos;
      curxh = curxl + cur_tok->width - 1;
      /* ORIENT_LU */
      /* do we need to crop the top or bottom off this token? */
      if (curyl < cyl){
        curyl = cyl;
      }
      if (curyh > cyh){
        cur_src += (curlpl * (curyh - cyh));
        curyh = cyh;
      }
      /* we should have some rows, or we have an issue. */
      DGP_ASSERT((curyh - curyl) >= 0);
      
      /* do we need to crop the left or right off this token? */
      if (curxl < cxl){
        curxl = cxl;
        cur_clip = 1;
      }
      if (curxh > cxh){
        cur_min = curxh - cxh;
        curxh = cxh;
        cur_clip = 1;
      }
      /* we should have some columns, or we have an issue. */
      DGP_ASSERT((curxh - curxl) >= 0);
      
      if(color_type == RGB_COLOR){
          /* Cursorily, it appears this color blitting function does crop, but */
          /* I won't swear to it.  Presently the branch does nothing. / dhtesq. */
          if(cur_clip){
            DgpBlat_colorBlitBinaryRGB(cur_src,
                             curlpl * sizeof(Dgp_UInt32),
                             (cxh - x) - curxh,
                             cyh - curyh,
                             (DgpImage_RGB *)pdst,
                             bpl,
                             0, /*x, */
                             0, /*y, */
                             (cxh - x) - curxh,
                             cyh - curyh,
                             (curxh - curxl) + 1,
                             (curyh - curyl) + 1,
                             color_value);          
          } else {
            DgpBlat_colorBlitBinaryRGB(cur_src,
                             curlpl * sizeof(Dgp_UInt32),
                             (cxh - x) - curxh,
                             cyh - curyh,
                             (DgpImage_RGB *)pdst,
                             bpl,
                             0, /*x, */
                             0, /*y, */
                             (cxh - x) - curxh,
                             cyh - curyh,
                             (curxh - curxl) + 1,
                             (curyh - curyl) + 1,
                             color_value);          
          }

      } else if(color_type == IMAGE_INDEX) {
        DGP_WARNF0("tokenizeBlatColor() / unhandleable color extension type...");
        /* If we run into the color tag IMAGE_INDEX, it looks like a lot more work */
        /* is involved, including rotating, "conversion", and scaling.  PIXRs... */
      }
    }
    break;
  case ORIENT_DL:
    for ( toknum = 0 ; toknum < nboxes ; toknum++){
      cur_pos = ppos[toknum];

      DGP_ASSERT (ppos[toknum]->userdata != NULL);
      color_type = ((color_tag *)(ppos[toknum]->userdata))->color_type;
      color_value = ((color_tag *)(ppos[toknum]->userdata))->value.rgb_color;
      
      /*cur_pos = pboxes + toknum; */
      cur_tok = cur_pos->sym;

      DGP_ASSERT(cur_tok);
      /* first thing to check is if this is in the crop rectangle. */
      if(!((cur_pos->xpos <= cxh)
           && (cur_pos->ypos <= cyh)
           && (cxl < (cur_pos->xpos + cur_tok->width))
           && (cyl < (cur_pos->ypos + cur_tok->height)))){
        continue;
      }

      /* It's possible that this is a g4 token; which means that it's a single
         use token thats left compressed for us to uncompress. We're going
         to uncompress it, and leave it around. The rationale behind is that
         if it's truly a single use token, it'll be in the per page dictionary
         and will be purged once we leave this page.
      */
      if (cur_tok->longsperline == 0){
        DGP_ERR_CHECK(tokenizeBlatDecompressG4(cur_tok, &mem_diff, dgp_state)){
          /* just print something nasty if fails. */
          continue;
        }
        
        /* it now uses a different amount of memory. Keep update our counter. */
        if (mem_diff){
          mem_chg += mem_diff;
          /* so this might be a little sloppy, it could go a little over our */
          /* memory limit, but we've decided that's ok (we've already malloced */
          /* the memory anyways.) */
          if (mem_chg >= mem_limit){
            DGP_ERR_PASS_CLEANUP(memorySentryClaimMemory(psentry, mem_chg, 
                                                         dgp_state));
            DGP_ERR_PASS_CLEANUP(memorySentryGetAvailableMemory(psentry,
                                                                &mem_limit,
                                                                dgp_state));
            mem_chg = 0;
            
          }
          mod = DGP_TRUE;
        }
      }

      /* rotate the token if we need to. We store the current orientation in */
      /* userflags. So if anyone mucks with userflags,  */
      /* I'll be extremely unhappy. */
      if (cur_tok->userflags != o){
        DGP_ERR_CHECK(tokenizeBlatRotateBinaryToken(cur_tok, o,
                                                    &mem_diff, dgp_state)){
          /* just print something nasty if fails. */
          continue;
        }

        /* it now uses a different amount of memory. Keep update our counter. */
        if (mem_diff){
          mem_chg += mem_diff;
          /* so this might be a little sloppy, it could go a little over our */
          /* memory limit, but we've decided that's ok (we've already malloced */
          /* the memory anyways.) */
          if (mem_chg >= mem_limit){
            DGP_ERR_PASS_CLEANUP(memorySentryClaimMemory(psentry, mem_chg, 
                                                         dgp_state));
            DGP_ERR_PASS_CLEANUP(memorySentryGetAvailableMemory(psentry,
                                                                &mem_limit,
                                                                dgp_state));
            mem_chg = 0;
          }
          mod = DGP_TRUE;
        }
      }

      cur_clip = 0;
      cur_min = 0;
      cur_src = cur_tok->bits;
      curlpl = cur_tok->longsperline;
      curyl = cur_pos->ypos;
      curyh = curyl + cur_tok->height - 1;
      curxl = cur_pos->xpos;
      curxh = curxl + cur_tok->width - 1;

      /* ORIENT_DL */
      /* do we need to crop the top or bottom off this token? */
      if (curyl < cyl){
        cur_min = cyl - curyl;
        curyl = cyl;
        cur_clip = 1;
      }
      if (curyh > cyh){
        curyh = cyh;
        cur_clip = 1;
      }
      /* we should have some rows, or we have an issue. */
      DGP_ASSERT((curyh - curyl) >= 0);
      
      /* do we need to crop the left or right off this token? */
      if (curxl < cxl){
        curxl = cxl;
      }
      if (curxh > cxh){
        cur_src += (curlpl * (curxh - cxh));
        curxh = cxh;
      }
      /* we should have some columns, or we have an issue. */
      DGP_ASSERT((curxh - curxl) >= 0);

      
      if(color_type == RGB_COLOR){
          /* Cursorily, it appears this color blitting function does crop, but */
          /* I won't swear to it.  Presently the branch does nothing. / dhtesq. */
          if(cur_clip){
            DgpBlat_colorBlitBinaryRGB(cur_src,
                             curlpl * sizeof(Dgp_UInt32),
                             curyl + y,
                             cxh - curxh,
                             (DgpImage_RGB *)pdst,
                             bpl,
                             0, /*x, */
                             0, /*y, */
                             curyl + y,
                             cxh - curxh ,
                             (curyh - curyl) + 1,
                             (curxh - curxl) + 1,
                             color_value);
          } else {
            DgpBlat_colorBlitBinaryRGB(cur_src,
                             curlpl * sizeof(Dgp_UInt32),
                             curyl + y,
                             cxh - curxh,
                             (DgpImage_RGB *)pdst,
                             bpl,
                             0, /*x, */
                             0, /*y, */
                             curyl + y,
                             cxh - curxh ,
                             (curyh - curyl) + 1,
                             (curxh - curxl) + 1,
                             color_value);
          }

      } else if(color_type == IMAGE_INDEX) {
        DGP_WARNF0("tokenizeBlatColor() / unhandleable color extension type...");
        /* If we run into the color tag IMAGE_INDEX, it looks like a lot more work */
        /* is involved, including rotating, "conversion", and scaling.  PIXRs... */
      }
    }
    break;
  case ORIENT_DR:
    DGP_ERR_GEN(DGP_TRUE, cErrNoImpl);
    break;
  case ORIENT_UL:
    DGP_ERR_GEN(DGP_TRUE, cErrNoImpl);
    break;
  case ORIENT_LD:
    DGP_ERR_GEN(DGP_TRUE, cErrNoImpl);
    break;
  default:
    DGP_ERR_GEN(DGP_TRUE, cErrDecodeFailure);
    break;
  }
  
  if (mem_chg){
    if (mem_chg > 0){
      cur_min = mem_chg;
      mem_chg = 0;
      DGP_ERR_PASS_CLEANUP(memorySentryClaimMemory(psentry, cur_min, 
                                                   dgp_state));
    }
    else { /* mem_chg < 0 */
      cur_min = -mem_chg;
      mem_chg = 0;
      DGP_ERR_PASS_CLEANUP(memorySentryReleaseMemory(psentry, cur_min, 
                                                     dgp_state));
    }
  }
  
  if (pmod){
    *pmod = mod;
  }
  
  NORMAL_RETURN;
 ERR_CLEANUP:
  
  if (mem_chg){
    if (mem_chg > 0){
      cur_min = mem_chg;
      mem_chg = 0;
      memorySentryClaimMemory(psentry, cur_min, dgp_state);
    }
    else { /* mem_chg < 0 */
      cur_min = -mem_chg;
      mem_chg = 0;
      memorySentryReleaseMemory(psentry, cur_min, dgp_state);
    }
  }

  if (pmod){
    *pmod = mod;
  }

  ERR_RETURN;
}




#if 0
/*************************************************************************
**
**  Function:  static ErrCode actuallyRotateColorToken(...)
**
**  ...
**
**	Arguments:
**      o  pPos...
**      o  pColor...
**      o  wantVert...
**      o  xRatio, yRatio...
**      o  dgp_state references a prepared Dgp_State{}.
**
**	Return value:
**		o  ErrCode.
**
**	Modification history:
**      Dillon H. Tracy esq. / March 2000
**      o  Implemented liberr exception handling;  return type Dgp_Bool -> ErrCode.
**  
**/

static ErrCode
actuallyRotateColorToken(jb2SymbolInstance         *pPos,
                         color_token    *pColor,
                         Dgp_Bool       wantVert,
                         DgpCoord_Rat   xRatio,
                         DgpCoord_Rat   yRatio,
                         Dgp_State      *dgp_state){
  DGP_PROLOGUE("actuallyRotateColorToken()", DGP_PERRSTATE);
  DgpImage_ColorRGB rgbIm;
  switch(pColor->imagetype){
    case SU_COLOR_TOKEN_IMAGETYPE_PIXR:
        DGP_ERR_PASS_CLEANUP(DgpImage_new(dgp_state, DGPIMAGE_RGB, pPos->tok->height, pPos->tok->width, (void **)&rgbIm));

        BlatPIXRScaleRotate(rgbIm,
                            0,
                            0,
                            0,
                            0,
                            pPos->tok->height,
                            pPos->tok->width,
                            pColor->image.pixr,
                            0,
                            0,
                            0,
                            0,
                            xRatio,
                            yRatio,
                            DGP_PIPWSTATE);

        w_destroyPixr(DGP_PIPWSTATE, &pColor->image.pixr);
        pColor->imagetype = SU_COLOR_TOKEN_IMAGETYPE_RGBIMAGE;
        pColor->image.rgbIm = rgbIm;
        break;

    case SU_COLOR_TOKEN_IMAGETYPE_RGBIMAGE:
        DGP_ERR_GEN_CLEANUPF0(DGP_TRUE,
                              cErrInvalidParm,
                              "oops. can't rotate a color rgb token twice.\n");
    default:
        DGP_ERR_GEN_CLEANUPF0(DGP_TRUE,
                              cErrInvalidParm,
                              "actuallyRotateColorToken: can't convert image... unknown type.\n");
  }

  pColor->userflags = wantVert;
  NORMAL_RETURN;
ERR_CLEANUP:
  ERR_RETURN;
}
/*************************************************************************/


/*************************************************************************
**
**  Function:  static INLINE ErrCode rotateColorTokenIfNecessary(...)
**
**  ...
**
**	Arguments:
**      o  pPos...
**      o  pColor...
**      o  wantVert...
**      o  xRatio, yRatio...
**      o  dgp_state references a prepared Dgp_State{}.
**
**	Return value:
**		o  Passed ErrCode.
**
**	Modification history:
**      Dillon H. Tracy esq. / March 2000
**      o  Implemented liberr exception handling;  return type Dgp_Bool -> ErrCode.
**  
**/

static INLINE ErrCode
rotateColorTokenIfNecessary(jb2SymbolInstance      *pPos,
                            color_token *pColor,
                            Dgp_Bool    wantVert,
                            DgpCoord_Rat         xRatio,
                            DgpCoord_Rat         yRatio,
                            Dgp_State   *dgp_state){
  DGP_PROLOGUE("rotateColorTokenIfNecessary()", DGP_PERRSTATE);

  if(pColor->userflags == wantVert){
      return DGP_TRUE;
  }
  DGP_ERR_PASS(actuallyRotateColorToken(pPos, pColor, wantVert, xRatio, yRatio, dgp_state));
  NORMAL_RETURN;
}
/*************************************************************************/


/*************************************************************************
**
**  Function:  static ErrCode actuallyConvertColorToken(...)
**
**  ...
**
**	Arguments:
**      o  pPos...
**      o  pColor...
**      o  xRatio, yRatio...
**      o  dgp_state references a prepared Dgp_State{}.
**
**	Return value:
**		o  ErrCode.
**
**	Modification history:
**      Dillon H. Tracy esq. / March 2000
**      o  Implemented liberr exception handling;  return type Dgp_Bool -> ErrCode.
**  
**/

static ErrCode
actuallyConvertColorToken(jb2SymbolInstance            *pPos,
                          color_token       *pColor,
                          DgpCoord_Rat               xRatio,
                          DgpCoord_Rat               yRatio,
                          Dgp_State         *dgp_state){
  DGP_PROLOGUE("actuallyConvertColorToken()", DGP_PERRSTATE);
  DgpImage_ColorRGB rgbIm;
  switch(pColor->imagetype){
    case SU_COLOR_TOKEN_IMAGETYPE_PIXR:
        DGP_ERR_PASS_CLEANUP(DgpImage_new(dgp_state, DGPIMAGE_RGB, pPos->tok->width, pPos->tok->height, (void **)&rgbIm));
        
        BlatPIXRScale(rgbIm,
                      0,
                      0,
                      0,
                      0,
                      pPos->tok->width,
                      pPos->tok->height,
                      pColor->image.pixr,
                      0,
                      0,
                      0,
                      0,
                      xRatio,
                      yRatio,
                      DGP_PIPWSTATE);
        
        w_destroyPixr(DGP_PIPWSTATE, &pColor->image.pixr);
        pColor->imagetype = SU_COLOR_TOKEN_IMAGETYPE_RGBIMAGE;
        pColor->image.rgbIm = rgbIm;
        break;

    case SU_COLOR_TOKEN_IMAGETYPE_RGBIMAGE:
        DGP_ERR_GEN_CLEANUPF0(DGP_TRUE,
                              cErrInvalidParm,
                              "actuallyConvertColorToken: image already converted. duh.\n");
        break;
    default:
        DGP_ERR_GEN_CLEANUPF0(DGP_TRUE,
                              cErrInvalidParm,
                              "actuallyConvertColorToken: can't convert image... unknown type.\n");
  }
  NORMAL_RETURN;
ERR_CLEANUP:
  ERR_RETURN;
}
/*************************************************************************/


/*************************************************************************
**
**  Function:  static ErrCode convertColorTokenIfNecessary(...)
**
**  ...
**
**	Arguments:
**      o  pPos...
**      o  pColor...
**      o  xRatio, yRatio...
**      o  dgp_state references a prepared Dgp_State{}.
**
**	Return value:
**		o  Passed ErrCode.
**
**	Modification history:
**      Dillon H. Tracy esq. / March 2000
**      o  Implemented liberr exception handling;  return type Dgp_Bool -> ErrCode.
**  
**/

static INLINE ErrCode
convertColorTokenIfNecessary(jb2SymbolInstance         *pPos,
                             color_token    *pColor,
                             DgpCoord_Rat            xRatio,
                             DgpCoord_Rat            yRatio,
                             Dgp_State      *dgp_state){
  DGP_PROLOGUE("convertColorTokenIfNecessary()", DGP_PERRSTATE);

  if(pColor->imagetype == SU_COLOR_TOKEN_IMAGETYPE_RGBIMAGE){
      return DGP_TRUE;
  }
  DGP_ERR_PASS(actuallyConvertColorToken(pPos, pColor, xRatio, yRatio, dgp_state));
  NORMAL_RETURN;
}
/*************************************************************************/
#endif 0
