/*****************************************************************
 *  Trade Secret of Xerox Corporation.                           *
 *  Copyright (c) 1991-1995, Xerox Corporation.                  *
 *  All rights reserved.                                         *
 *  Copyright protection claimed includes all forms and matters  *
 *  of copyrightable material and information now allowed by     *
 *  statutory or judicial law or hereafter granted, including    *
 *  without limitation, material generated from the software     *
 *  programs which are displayed on the screen such as icons,    *
 *  screen display looks, etc.                                   *
 *****************************************************************/

/*************************************************************************
**
**  DigiPaper Codebase
**  
**	  
**  wbell?  1998?
**
**  File:  tokenized_blat_color.h
**
**  ...
**
**	Modification history:
**	    Dillon H. Tracy esq. / March 2000
**		o  dgp types namespace issues.
**      o  liberr compliance issues.
**		o  Search on 'dhtesq' for some of this coder's comments & changes.
**      June 2000
**      o  Imported to "new" santa from "old" santa's strip_blat_level.h and tokenize_blat.h
**         ...trying to get color rendering working.
**  
**************************************************************************/

#ifndef __TOKENIZED_BLAT_COLOR_H__
#define __TOKENIZED_BLAT_COLOR_H__


#include "dgp_state.h"
#include "orientation_t.h"
#include "symbol.h"
#include "memory_sentry_t.h"
#include "rendered_image_t.h"
#include "color-extension.h"
#include "colorBlit.h"
#include "santa_image_t.h"

/*////////////////////////////// */

ErrCode
tokenizeBlatColor(Dgp_UInt32 *pdst, 
                  Dgp_Int32 bpl, 
                  Dgp_Int32 x, 
                  Dgp_Int32 y, 
                  DgpCoord_Orientation o, 
                  Dgp_Int32 cropx, 
                  Dgp_Int32 cropy, 
                  Dgp_Int32 cropw, 
                  Dgp_Int32 croph,
                  santaImage *pimg,
                  Dgp_Int32 nboxes, 
                  jb2SymbolInstance *pboxes, 
                  memorySentry *psentry,
                  Dgp_Bool *pmod, 
                  renderedImage *selector,
                  Dgp_State * dgp_state);
#endif /*__TOKENIZED_BLAT_COLOR_H__ */
