/*****************************************************************
 *  Trade Secret of Xerox Corporation.                           *
 *  Copyright (c) 1991-1995, Xerox Corporation.                  *
 *  All rights reserved.                                         *
 *  Copyright protection claimed includes all forms and matters  *
 *  of copyrightable material and information now allowed by     *
 *  statutory or judicial law or hereafter granted, including    *
 *  without limitation, material generated from the software     *
 *  programs which are displayed on the screen such as icons,    *
 *  screen display looks, etc.                                   *
 *****************************************************************/
/* Trade secret boilerplate added 31.1.2000 / dhtesq. */

/*************************************************************************
**
**  DigiPaper Codebase
**  
**	  
**  Pedro Felzenszschwalb (sp?), 19nn - 1998?
**
**  Filename: ccs.h.
**
**  Types & prototypes for the connected components module.  No exports.
**
**
**	Modification history:
**		Dillon H. Tracy esq. / Jan. 2000
**		o  Implemented liberr exception handling.
**		o  Search on 'dhtesq' for some of this coder's comments and modifications.
**
**  
**************************************************************************/

#ifndef CCS_H
#define CCS_H

#include <math.h>
#include "dgp_err_control.h"
#include "list.h"

/*	Constants for the text field of ComponentInfo{}. */

/*	A non-zero entry in this field indicates the component is part of a chain. / dhtesq.	*/
#define TEXT_0 0
#define TEXT_1 1
#define TEXT_2 2

typedef struct {
	Dgp_Int32 num_pts;
	DgpImage_RGB color;
	Dgp_Int32 maxX, maxY, minX, minY;
	Dgp_Int32 centerX, centerY;
	Dgp_Int32 width, height;
	Dgp_Int32 size;
	DgpAdt_List edges;
	Dgp_Int32 complexity;
	Dgp_Int32 ccnum;
	Dgp_Int32 text;
	void *userdata;
} ComponentInfo;

Dgp_Float32
ccDistance(ComponentInfo *cc1, ComponentInfo *cc2);

ErrCode
blatComponents(Dgp_State        *dgp_state, 
               DgpImage_Long    compMap, 
               ComponentInfo    *components, 
               Dgp_Int32        cc_blat, 
               DgpImage_ColorRGB *_out);

void
blatComponent(DgpImage_ColorRGB         out, 
              DgpImage_Long             compMap, 
              ComponentInfo             *components, 
              Dgp_Int32                 bcc);

Dgp_Int32
countMarked(ComponentInfo *components, Dgp_Int32 numccs);

ErrCode
getComponents(Dgp_State             *dgp_state, 
              DgpImage_ColorRGB     colorIm, 
              DgpImage_Long         compMap, 
              Dgp_Int32             numccs, 
              ComponentInfo         **_components);

ErrCode
getProperties(Dgp_State             *dgp_state, 
              DgpImage_ColorRGB     colors, 
              DgpImage_Long         compMap, 
              ComponentInfo         *components, 
              Dgp_Int32             numccs);

#endif
