/*****************************************************************
 *  Trade Secret of Xerox Corporation.                           *
 *  Copyright (c) 1991-1995, Xerox Corporation.                  *
 *  All rights reserved.                                         *
 *  Copyright protection claimed includes all forms and matters  *
 *  of copyrightable material and information now allowed by     *
 *  statutory or judicial law or hereafter granted, including    *
 *  without limitation, material generated from the software     *
 *  programs which are displayed on the screen such as icons,    *
 *  screen display looks, etc.                                   *
 *****************************************************************/
/* Trade secret boilerplate added 2.2.2000 / dhtesq. */

/*************************************************************************
**
**  DigiPaper Codebase
**  
**	  
**  Pedro Felzenszschwalb (sp?), 19nn - 1998?
**
**  Filename:  edges.h.
**
**  Types & prototypes for creation of Voronoi regions around connected components.
**	No exports.
**
**
**	Modification history:
**		Dillon H. Tracy esq. / Feb. 2000
**		o  Implemented liberr exception handling.
**		o  Search on 'dhtesq' for some of this coder's comments and modifications.
**
**  
**************************************************************************/

#ifndef EDGES_H
#define EDGES_H

#include "dgp_err_control.h"
#include "list.h"
#include "ccs.h"

typedef struct {
	Dgp_Float32	scale;
	Dgp_Float32	sizeEpsilon;
	Dgp_Int32		colorEpsilon;
	Dgp_Int32		maxDist;
	Dgp_Int32		minSize;
	Dgp_Int32		maxSize;
} edgeOptions;

typedef struct {
	ComponentInfo	*cc;
	Dgp_Float32			dist;
} edge;


void
defaultEdgeOptions(edgeOptions *p, Dgp_Int32 xres, Dgp_Int32 yres);

ErrCode
getEdges(Dgp_State *dgp_state, DgpImage_Long compMap, ComponentInfo *components, Dgp_Int32 numccs, edgeOptions *p);

void
drawEdges(DgpImage_Binary out, ComponentInfo *components, Dgp_Int32 numccs);

ErrCode
freeEdges(Dgp_State *dgp_state, ComponentInfo *components, Dgp_Int32 numccs);

#endif
