/*****************************************************************
 *  Trade Secret of Xerox Corporation.                           *
 *  Copyright (c) 1991-1995, Xerox Corporation.                  *
 *  All rights reserved.                                         *
 *  Copyright protection claimed includes all forms and matters  *
 *  of copyrightable material and information now allowed by     *
 *  statutory or judicial law or hereafter granted, including    *
 *  without limitation, material generated from the software     *
 *  programs which are displayed on the screen such as icons,    *
 *  screen display looks, etc.                                   *
 *****************************************************************/
/* Trade secret boilerplate added 3.2.2000 / dhtesq. */

/*************************************************************************
**
**  DigiPaper Codebase
**  
**	  
**  Pedro Felzenszschwalb (sp?), 19nn - 1998?
**
**  Filename:  findCC.h
**
**
**  Types & prototypes for finding connected components.  No exports.
**
**
**	Modification history:
**		Dillon H. Tracy esq. / Feb. 2000
**		o  Implemented liberr exception handling.
**		o  Search on 'dhtesq' for some of this coder's comments and modifications.
**
**  
**************************************************************************/

#ifndef FIND_CC_H
#define FIND_CC_H

#include "image.h"
#include "libutilw.pub"
#include "libpixrw.pub"
#include "shrcc.pub"


/* Component map constants */
#define NOT_ASSIGNED -1
#define BORDER -2

/* For cc finder callback... */
typedef struct {
	Dgp_Int32 numccs;
	DgpImage_Long *compMap;
	DgpImage_Packed *image;
	Dgp_State *dgp_state;
	Dgp_Int32 connectedness;
} CCContext;

/*	These three functions do not appear in the library libscancolor... / dhtesq. */
Dgp_Int32
findCC_g(DgpImage_Gray image, Dgp_Int32 epsilon, DgpImage_Long *_compMap);

Dgp_Int32
findCC_rgb(DgpImage_ColorRGB image, Dgp_Int32 epsilon, DgpImage_Long *_compMap);

Dgp_Int32
findCC_b(DgpImage_Binary image, DgpImage_Long *_compMap);

ErrCode
findCC_pb(Dgp_State			*dgp_state, 
		  DgpImage_Packed	image, 
		  PIXR				*binaryPixr,
		  DgpImage_Long		*_compMap, 
		  Dgp_Int32			sizeThresh,
		  Dgp_Int32			*_numccs);

#endif
