/*****************************************************************
 *  Trade Secret of Xerox Corporation.                           *
 *  Copyright (c) 1991-1995, Xerox Corporation.                  *
 *  All rights reserved.                                         *
 *  Copyright protection claimed includes all forms and matters  *
 *  of copyrightable material and information now allowed by     *
 *  statutory or judicial law or hereafter granted, including    *
 *  without limitation, material generated from the software     *
 *  programs which are displayed on the screen such as icons,    *
 *  screen display looks, etc.                                   *
 *****************************************************************/
/* Trade secret boilerplate added 4.2.2000 / dhtesq. */

/*************************************************************************
**
**  DigiPaper Codebase
**  
**	  
**  Pedro Felzenszschwalb (sp?), 19nn - 1998?
**
**  Filename:  fit.h.
**
**  Types & prototypes for eigenvector fit module.  No exports;  with some
**	reworking could be generalized for other dgp use.
**
**
**	Modification history:
**		Dillon H. Tracy esq. / Feb. 2000
**		o  Search on 'dhtesq' for some of this coder's comments and modifications.
**
**  
**************************************************************************/

#ifndef FIT_H
#define FIT_H

#include "dgp_err_control.h"
#include "list.h"

Dgp_Float64 
lineDistance(Dgp_Float64 x, Dgp_Float64 y, Dgp_Float64 xbar, Dgp_Float64 ybar, Dgp_Float64 line_x, Dgp_Float64 line_y);

/* Corrected from 'eigenLineFitCM' 21.1.2000 / dhtesq. */
void 
eigenLineFitCE(DgpAdt_List ccs, Dgp_Float64 *x, Dgp_Float64 *y, Dgp_Float64 *xbar, Dgp_Float64 *ybar);

void 
eigenLineFitUL(DgpAdt_List ccs, Dgp_Float64 *x, Dgp_Float64 *y, Dgp_Float64 *xbar, Dgp_Float64 *ybar);

void 
eigenLineFitDR(DgpAdt_List ccs, Dgp_Float64 *x, Dgp_Float64 *y, Dgp_Float64 *xbar, Dgp_Float64 *ybar);

#endif
