/*****************************************************************
 *  Trade Secret of Xerox Corporation.                           *
 *  Copyright (c) 1991-1995, Xerox Corporation.                  *
 *  All rights reserved.                                         *
 *  Copyright protection claimed includes all forms and matters  *
 *  of copyrightable material and information now allowed by     *
 *  statutory or judicial law or hereafter granted, including    *
 *  without limitation, material generated from the software     *
 *  programs which are displayed on the screen such as icons,    *
 *  screen display looks, etc.                                   *
 *****************************************************************/
/* Trade secret boilerplate added 4.2.2000 / dhtesq. */

/*************************************************************************
**
**  DigiPaper Codebase
**  
**	  
**  Pedro Felzenszschwalb (sp?), 19nn - 1998?
**
**  Filename: imutil.h.
**
**  Types and prototypes for miscellaneous image utilities.  No exports.
**
**
**	Modification history:
**		Dillon H. Tracy esq. / Feb. 2000
**		o  Implemented liberr exception handling;  not much affected.
**		o  static SwapInt() introduced to simplify the drawLineX() functions.
**		o  Search on 'dhtesq' for some of this coder's comments and modifications.
**
**  
**************************************************************************/

#ifndef IMAGE_UTIL_H
#define IMAGE_UTIL_H

#include "image.h"
#include "dgp_err_control.h"
#include "pixr.h"

void
drawLineB(DgpImage_Binary out, Dgp_Int32 x1, Dgp_Int32 y1, Dgp_Int32 x2, Dgp_Int32 y2);

void
drawLineRGB(DgpImage_ColorRGB out, DgpImage_RGB *color, Dgp_Int32 x1, Dgp_Int32 y1, Dgp_Int32 x2, Dgp_Int32 y2);

void
imSetL(DgpImage_Long image, Dgp_Int32 value);

void
imSetF(DgpImage_Float image, Dgp_Float32 value);

void
imClearRGB(DgpImage_ColorRGB image);

ErrCode
pixr_to_rgb(Dgp_State *dgp_state, PIXR *pixr, DgpImage_ColorRGB *im);

ErrCode
pixr_to_rgb_gray(Dgp_State *dgp_state, PIXR *pixr, DgpImage_ColorRGB *im);

/* Added 23.3.2001 / dhtesq. */
ErrCode
pixr_to_gray(Dgp_State *dgp_state, PIXR *pixr, DgpImage_Gray *_im);

INLINE void
swapInt(Dgp_Int32 *apple, Dgp_Int32 *orange) ;
#endif
