/*****************************************************************
 *  Trade Secret of Xerox Corporation.                           *
 *  Copyright (c) 1991-1995, Xerox Corporation.                  *
 *  All rights reserved.                                         *
 *  Copyright protection claimed includes all forms and matters  *
 *  of copyrightable material and information now allowed by     *
 *  statutory or judicial law or hereafter granted, including    *
 *  without limitation, material generated from the software     *
 *  programs which are displayed on the screen such as icons,    *
 *  screen display looks, etc.                                   *
 *****************************************************************/
/* Trade secret boilerplate added 31.1.2000 / dhtesq. */

/*************************************************************************
**
**  DigiPaper Codebase
**  
**	  
**  Pedro Felzenszschwalb (sp?), 19nn - 1998?
**
**  Filename: seg.h
**
**  Types & prototypes for segmentation flow control.  No exports.
**
**	Modification history:
**		Dillon H. Tracy esq.
**		o  Interface for segment() modified for liberr compliance.
**
**  
**************************************************************************/

#ifndef SEG_H
#define SEG_H

#include "dgp_err_control.h"
#include "image.h"
#include "pixr.h"

typedef struct {
	Dgp_Int32 thresh;
	Dgp_Int32 sizeThresh;		/* Added 15.5.2001 / dhtesq. Minimum size for cc finder to pay attention. */
} segOptions;

ErrCode
segment(Dgp_State *dgp_state, PIXR *input, segOptions *p, DgpImage_Long *_compMap, Dgp_Int32 *_numccs);

void defaultSegmentOptions(segOptions *p, Dgp_Int32 xres, Dgp_Int32 yres);

#endif
