/* $Header: /project/icons/cvsroot/digipaper/src/libsupercache/binary_huffman_codes.h,v 1.8 2000/05/18 19:46:47 wbell Exp $ */

#ifndef BINARY_HUFFMAN_CODES_H
#define BINARY_HUFFMAN_CODES_H

#include "core.h"
#include "sutokdict_t.h"

/* Entry Type Code */
#define BINARY_HUFFMAN_CODES	2

/* Macro */
#define isBinaryHuffmanEntry( entry) ((entry)->type == BINARY_HUFFMAN_CODES)

/* Identifier Type */
typedef struct {
  Dgp_UInt32 *libIds;
  Dgp_UInt32 libCount;

  /* Valid only during "get". */
  zephDictionaryInfo zephDict;
} suBinaryHuffmanIdentifier;
 

/* Data Type */
typedef struct {
  suBinaryHuffmanIdentifier identifier;

  _suTokenDictionary tokDict;
  Dgp_UInt32 zephDictStateSize;
} suBinaryHuffmanCodes;

extern Dgp_Bool
compareBinaryHuffmanCodes( void *identifier, suCacheEntry entry);

extern ErrCode
getBinaryHuffmanCodes( suXiffCache xc, void *identifier, Dgp_Int32 currentPage,
        suCacheEntry *entry);

extern void
destroyBinaryHuffmanCodes( suXiffCache xc, suCacheEntry entry);

extern void
calculateBinaryHuffmanCodes( suXiffCache xc, suCacheEntry entry);

extern _suEntryOps binaryHuffmanOps;

#endif /* BINARY_HUFFMAN_CODES_H */
