

#ifndef BINARY_TOKENS_H
#define BINARY_TOKENS_H

#include "core.h"

#include "token_t.h"
#include "zephimage_t.h"
#include "extension_t.h"

/* Entry Type Code */
#define BINARY_TOKENS	1

/* Macro */
#define isBinaryTokenEntry( entry) ((entry)->type == BINARY_TOKENS)


/* Identifier Type */
typedef struct {

  Dgp_UInt32 dictId;

  /* only used in get */
  zephImageInfo imageInfo;

} suBinaryTokensIdentifier;


/* Entry Type */
typedef struct {
  suBinaryTokensIdentifier identifier;

  jb2Segment *segment;

  Dgp_UInt32 mem_usage;

} suBinaryTokens;


extern Dgp_Bool
compareBinaryTokens( void *identifier, suCacheEntry entry);

extern ErrCode
getBinaryTokens( suXiffCache xc, void *identifier, Dgp_Int32 currentPage, 
                 suCacheEntry *entry);

extern void
destroyBinaryTokens( suXiffCache xc, suCacheEntry entry);

extern void
calculateBinaryTokens( suXiffCache xc, suCacheEntry entry);

extern _suEntryOps binaryOps;


#endif /* BINARY_TOKENS_H */
