

#ifndef COLOR_DICTIONARY_H
#define COLOR_DICTIONARY_H

#include "libsupercache.h"
#include "core.h"
#include "colorpos.h"
#include "colortoken_t.h"


/* Entry Type Code */
#define COLOR_DICTIONARY	7

/* Macro */
#define isColorDictionaryEntry( entry) ((entry)->type == COLOR_DICTIONARY)

/* Entry Type */
typedef struct {
    colorDictInfo identifier;

    color_token **toks;
    Dgp_Int32 ntok;
} suColorDictionary;


extern Dgp_Bool
compareColorDictionary( void *identifier, suCacheEntry entry);

extern ErrCode
getColorDictionary( suXiffCache xc, void *identifier, Dgp_Int32 currentPage, suCacheEntry *entry);

extern void
destroyColorDictionary( suXiffCache xc, suCacheEntry entry);

extern _suEntryOps colorDictionaryOps;

#endif /* COLOR_DICTIONARY_H */
