

#ifndef COLOR_POSITION_EXTENSION_H
#define COLOR_POSITION_EXTENSION_H

#include "libsupercache.h"
#include "core.h"
#include "token_positions.h"

#include "list.h"		/* DgpAdt_List */
#include "util.h"		/* Dgp_Bool */
#include "extension_tags.h"
#include "color-extension.h"
#include "colorpos.h"


/* Entry Type Code */
#define COLOR_POSITION_EXTENSION	3

/* The EXTFLAG need to be constructed like follows: */
#define POS_EXTFLAG_COLOR		1 << (COLOR_EXT_TAG)

/* Macro */
#define isColorPositionExtensionEntry( entry) ((entry)->type == COLOR_POSITION_EXTENSION)

/* Entry Type */
typedef struct {
    suPositionExtensionIdentifier identifier;

    /* This should match the number of jb2SymbolInstance in the associated pos block. */
    Dgp_Int32 ntag;

    /* Color info. */
    color_tag *color_tags;
    colorDictInfo *color_dictinfo;

} suColorPositionExtension;


extern Dgp_Bool
compareColorPositionExtension( void *identifier, suCacheEntry entry);

extern ErrCode
getColorPositionExtension( suXiffCache xc, void *identifier, Dgp_Int32 currentPage,
        suCacheEntry *entry);

extern void
destroyColorPositionExtension( suXiffCache xc, suCacheEntry entry);

extern _suEntryOps colorPositionExtensionOps;


#endif /* COLOR_POSITION_EXTENSION_H */

