

#ifndef COLOR_TOKENS_H
#define COLOR_TOKENS_H

#include "libsupercache.h"
#include "core.h"

#include "list.h"		/* DgpAdt_List */
#include "util.h"		/* Dgp_Bool */
#include "resolution_t.h"
#include "colortoken_t.h"


/* Entry Type Code */
#define COLOR_TOKENS	6

/* Macro */
#define isColorTokenEntry( entry) ((entry)->type == COLOR_TOKENS)

typedef struct {
    Dgp_UInt32 uniqueId;

    color_token *toks;
    Dgp_Int32 ntok;
} suColorTokens;


extern Dgp_Bool
compareColorTokens( void *identifier, suCacheEntry entry);

extern ErrCode
getColorTokens( suXiffCache xc, void *identifier, Dgp_Int32 currentPage, suCacheEntry *entry);

extern void
destroyColorTokens( suXiffCache xc, suCacheEntry entry);

extern _suEntryOps colorOps;


#endif /* COLOR_TOKENS_H */
