
#ifndef PERIPHERY_H
#define PERIPHERY_H

#include "core.h"

/* Note: this file should be included only from core.c, 
 * unless you have some sort of extremely extravagant 
 * circumstances. The functionality provided by
 * core.h (the internal cache maintainence functions)
 * provides a nice wrapper for the stuff below.
 */
 
#define SU_DEFAULT_MAX_USAGE	10000000    	/* 10 MB */

/* How many "Gets" and "Releases" should pass before we
 * do a routine (passive) clean.
 */
#define SU_ROUTINE_CLEAN_PERIOD	5

/* Defines the number of types. Includes UNKNOWN. */
/*#define SU_NUMBER_OF_TYPES	8       // ...went back to 8 for color / dhtesq. */
#define SU_NUMBER_OF_TYPES	4

/* Defines operations for each of the different types of 
 * cache entries. */
extern suEntryOps su_entry_ops[ SU_NUMBER_OF_TYPES];

/* The cache valuator. When it comes time to take out the 
 * trash, this function decides what stays and what goes. */
extern suValuator su_valuator;

#endif /* PERIPHERY_H */
