

#ifndef RAW_POSITION_EXTENSION_H
#define RAW_POSITION_EXTENSION_H

#include "libsupercache.h"
#include "core.h"
#include "token_positions.h"


/* Entry Type Code */
#define RAW_POSITION_EXTENSION	4

/* Macro */
#define isRawPositionExtensionEntry( entry) ((entry)->type == RAW_POSITION_EXTENSION)

/* Entry Type */
typedef struct {
    suPositionExtensionIdentifier identifier;

    Extension ext;
} suRawPositionExtension;


extern Dgp_Bool
compareRawPositionExtension( void *identifier, suCacheEntry entry);

extern ErrCode
getRawPositionExtension( suXiffCache xc, void *identifier, Dgp_Int32 currentPage,
        suCacheEntry *entry);

extern void
destroyRawPositionExtension( suXiffCache xc, suCacheEntry entry);

extern _suEntryOps rawPositionExtensionOps;


#endif /* RAW_POSITION_EXTENSION_H */

