/* $Header: /project/icons/cvsroot/digipaper/src/libsupercache/sutokdict.h,v 1.4 2000/12/29 18:17:56 mkrocken Exp $ */

#ifndef SUTOKDICT_H
#define SUTOKDICT_H

#include "sucache.h"
#include "sutokdict_t.h"

#ifdef __cplusplus
extern "C"
{
#endif

/*
 * Obtain the union of the symbol libraries with the given ids.
 * Huffman codes will be constructed and bitmaps will become
 * available.
 *
 * Preconditions:
 *  - "xc" is a valid suXiffCache.
 *  - "currentPage" is non-negative.
 *  - "uniqueIds" is an array of unsigned longs of
 *      length "numUniqueIds".
 *
 * Postconditions:
 *  - on success, "entry" is a pointer to a cache entry containing
 *       the requested symbol library union.
 */
extern ErrCode
suGetTokenDictionary( suXiffCache xc, Dgp_Int32 currentPage,
                Dgp_UInt32 libCount, Dgp_UInt32 *libIds,
                suCacheEntry *pEntry);

extern ErrCode
suGetTokenDictionaryH( suXiffCache xc, Dgp_Int32 currentPage,
		zephDictionaryInfo zephDict, suCacheEntry *pEntry);

/*
 * Returns the Huffman codes (backend state) associated with
 * a previous call to suGetTokenDictionary. The cache
 * maintains ownership of the "dictState".
 *
 * Preconditions:
 *  - "entry" was the result of a successful call to
 *      suGetTokenDictionary.
 *
 * Postconditions:
 *  - on success, "pTokDict" is a pointer to a valid dictionary
 *      state.
 */
extern ErrCode
suExtractTokenDictionary( suCacheEntry entry, 
                          jb2Segment **segment);


#ifdef __cplusplus
}
#endif

#endif /* SU_TOKDICT_H */
