/* $Header: /project/icons/cvsroot/digipaper/src/libsupercache/token_positions.h,v 1.12 2001/01/23 22:48:12 mkrocken Exp $ */

#ifndef TOKEN_POSITIONS_H
#define TOKEN_POSITIONS_H

#include "core.h"
#include "sutokposblock.h"

#include "binary_huffman_codes.h"

/* Entry Type Code */
#define TOKEN_POSITIONS		2

#define POS_EXTFLAG_NONE	0

/* Macros */
#define isTokenPositionEntry( entry) ((entry)->type == TOKEN_POSITIONS)

/* Identifier Type */
typedef struct {
  Dgp_Int32 page;
  Dgp_Int32 layer;
  Dgp_Int32 image;

  /* Keeps track of what extensions remain in raw form. */
  Dgp_Int32 extDecoded;

  /* Not used for comparison but necessary for "get". */
  zephImageInfo zephImage;

} suPositionIdentifier;

/* Used by extensions. */
typedef struct {
  Dgp_Int32 page;
  Dgp_Int32 layer;
  Dgp_Int32 image;

  /* The desired extension. */
  Dgp_Int32 extTag;

  /* Not used for comparison but necessary for "get". */
  zephImageInfo zephImage;

} suPositionExtensionIdentifier;


/* Entry Type */
typedef struct {
  suPositionIdentifier identifier;
  
  /* Data */
  _suTokenPositionBlock posBlock; 
  Extension *exts;

} suTokenPositions;

extern Dgp_Bool
compareTokenPositions( void *identifier, suCacheEntry entry);

extern ErrCode
getTokenPositions( suXiffCache xc, void *identifier, Dgp_Int32 currentPage,
                   suCacheEntry *entry);

extern void
destroyTokenPositions( suXiffCache xc, suCacheEntry entry);

extern void
calculateTokenPositions( suXiffCache xc, suCacheEntry entry);

extern _suEntryOps tokenPositionOps;

#endif /* TOKEN_POSITIONS_H */
