/*************************************************************************
**
**  DigiPaper Codebase
**    
**  James Ahlborn, February 1 1998
**
**  Filename: cccrun_t.h
**
**  Description of what's implemented in this file:
**    color connected component run type
**  
**************************************************************************/

/*
 * $Header: /project/icons/cvsroot/digipaper/src/libsupercc/cccrun_t.h,v 1.3 2000/06/02 19:53:24 jahlborn Exp $
 */


#ifndef __CCCRUN_T_H
#define __CCCRUN_T_H

#include "image.h"

#ifdef __cplusplus
extern "C"
{
#endif

typedef struct {
  union {

    /* pointers to sampled data */
    DgpImage_RGB *rgbSamples;

    /* color value */
    Dgp_UInt32  rgbColor;

  } colorInfo;

  Dgp_UInt16 length;
  Dgp_Bool sampled;
} DgpCC_CccRun;

/* macro to convert 3 char rgb values to a Dgp_Int32 rgb value */
#define DGPCC_RGBTOLRGB(_cr, _cg, _cb) \
  ( ((((Dgp_UInt32)(_cr)) & 0x000000FF) << 16) | \
    ((((Dgp_UInt32)(_cg)) & 0x000000FF) << 8) | \
    (((Dgp_UInt32)(_cb)) & 0x000000FF) )

/* macros to pull the separate rgb values out of an lrgb value */
#define DGPCC_LRGB_R(_lrgb) (((_lrgb) >> 16) & 0x000000FF)
#define DGPCC_LRGB_G(_lrgb) (((_lrgb) >> 8) & 0x000000FF)
#define DGPCC_LRGB_B(_lrgb) ((_lrgb) & 0x000000FF)


#ifdef __cplusplus
}
#endif

#endif /* __CCCRUN_T_H */
