/***************************************************
 * ip-tiffio.h
 * $Header: /project/icons/cvsroot/digipaper/src/libtc_util/ip-tiffio.h,v 1.7 2002/02/21 01:55:28 jlin Exp $
 ***************************************************/

#ifndef IP_TIFFIO_H
#define IP_TIFFIO_H

#include "types.pub"
#include "libiow.pub"
#include "libutilw.pub"
#include "libpixrw.pub"
#include "util.h"
#include "dgp_state.h"

#ifdef __cplusplus
extern "C"
{
#endif
extern ErrCode
readTIFF(	Dgp_Int8 *name, 
		int rot, 
		Int32 *xSizePtr,
		Int32 *ySizePtr, 
		Int32 *bplPtr, 
		PIXR **readPixr, 
		Dgp_State *dgp_state);



extern ErrCode 
readTIFFEx(	Dgp_Int8 	*name, 
		Dgp_Int32   	rot, 
		Dgp_Int32	pageNum,
		Dgp_Int32 	*xSizePtr,
		Dgp_Int32 	*ySizePtr, 
		Dgp_Int32 	*bplPtr, 
		PIXR 		**readPixr, 
		Dgp_State 	*dgp_state);

#ifdef __cplusplus
}
#endif

#endif


/******************************************************
 * Running Log
 * $Log: ip-tiffio.h,v $
 * Revision 1.7  2002/02/21 01:55:28  jlin
 * add functions to handle write color tiff
 *
 * Revision 1.6  2001/04/18 23:11:10  jlin
 * initUds
 *
 * Revision 1.5  2000/04/21  22:08:50  jlin
 * Add tc_readTiffEx to support multi-page tiff read
 *
 * Revision 1.4  2000/03/04  00:22:39  mkrocken
 * merged repositories
 *
 * Revision 1.2  2000/02/23 22:23:20  mkrocken
 *
 * changes for new util libs
 *
 * Revision 1.1  2000/02/18 22:06:23  mkrocken
 * initial revision
 *
 * Revision 1.3  1999/12/29 20:12:41  jlin
 * Initial version
 *
 *****************************************************/
