/*
 * $Header: /project/icons/cvsroot/digipaper/src/libtc_util/qdr_def.h,v 1.10 2003/02/10 22:53:39 mkrocken Exp $
 */

#ifndef __QDR_DEF_H__
#define __QDR_DEF_H__

#ifdef __cplusplus
extern "C"
{
#endif

/* Qdr file flags */
#define QDR_FLAG_MASK   (0x3FFF)
#define QDR_RUN         (0x0000)
#define QDR_SAMPLE_FLAG (0x4000)
#define QDR_END_OF_LINE (0x8000)

/* Qdr2 file flags */
#define QDR2_FLAG_MASK   (0x3FFF)
#define QDR2_BACKGROUND  (0x0000)
#define QDR2_RUN         (0x4000)
#define QDR2_END_OF_LINE (0x8000)
#define QDR2_SAMPLE_FLAG (0xC000)

/* qdr color type values */
#define QDR_COLORTYPE_RGB  0x0000
#define QDR_COLORTYPE_CMYK 0x0001
#define QDR2_COLORTYPE_RGB 0x0002

#define QDR_COLORTYPE_LAST 0x0002

#define QDR2_BACKGROUND_R (0xFF)
#define QDR2_BACKGROUND_G (0xFF)
#define QDR2_BACKGROUND_B (0xFF)

#define QDR2_BACKGROUND_LRGB (0x00FFFFFF)


/* 
 * A qdr file starts with three Dgp_Int16s(the colortype, width, and height)
 * and then there is the list of runs.
 * Each run falls into three categories.  Its a solid color
 * run, its a sampled run, and its not a run at all
 * but the end of a line.
 * This is encoded in the first two bits of the length of each run.
 * 00 means solid run, 01 means sampled, and 10 means end of line.
 * Here is the encoding of each type.
 *  Solid Run: ((2-byte length) && 0x3fff) || 0x0000
 *             3(or 4)-byte color.
 *  Sampled Run: ((2-byte length) && 0x3fff) || 0x4000
 *               length number of 3(or 4)-byte colors.
 *  End of Line: ((2-byte anthing) && 0x3fff) || 0x8000
 * These encodes are streamed in the file.
*/

#ifdef __cplusplus
}
#endif

#endif /*__QDR_DEF_H__ */
