/*
   @(#)$Header: /project/icons/cvsroot/digipaper/src/libtc_util/tc-tools-exec.c,v 1.6 2000/10/11 18:47:12 dtracy Exp $ 
*/

/* tc-tools-exec.c
   
   Aaron Stump, Summer '97

   This file contains tools for use in executable programs. */

#include <stdio.h>
#include <string.h>
#include "dgp_rcs.h"

DGP_RCSID("@(#)$Header: /project/icons/cvsroot/digipaper/src/libtc_util/tc-tools-exec.c,v 1.6 2000/10/11 18:47:12 dtracy Exp $");

/* get_appropriate_stream()

   If file_name is "stdout", "stderr", or "stdin", return the corresponding
   (FILE *).  Otherwise, open the file for the given kind of access ("r","w",
   etc.) and return it.  Return NULL on error. */
FILE *
get_appropriate_stream(Dgp_Int8 *file_name, const Dgp_Int8 *access) 
{
  FILE *ret = NULL;

  if (file_name != NULL) {
    /* try to open the file for reporting what's going on */
    if (strcmp(file_name,"stdout") == 0) 
      ret = stdout;
    else if (strcmp(file_name,"stderr") == 0) 
      ret = stderr;
    else if (strcmp(file_name,"stdin") == 0) 
      ret = stdin;
    else {
      ret = fopen(file_name,access); 
    }
  }
  return ret;
}

/* close_appropriate_stream()

  If f is not "stdout", "stderr", "stdin", or NUL, close it. */
extern Dgp_Int32
close_appropriate_stream(FILE *f)
{
  if((f != NULL) && (f != stdin) && (f != stdout) && (f != stderr)) {
    return fclose(f);
  }

  return 0;
}
