/*******************************************************************
 * compress.h
 * Declarations for the page compressor.
 * $Header: /project/icons/cvsroot/digipaper/src/libtclydoc/compress.h,v 1.13 2003/02/10 22:53:39 mkrocken Exp $
 ********************************************************************/

#ifndef COMPRESS_H
#define COMPRESS_H

/* define this to use default error output printer */
#define DEF_FILE_ERROR_OUTPUT

#include "list.h"
#include "libutilw.pub"
#include "libpixrw.pub"
#include "uds.h"
#include "mmcompress.h"

#include "tclydoc.h"
#include "tclyout.h"
#include "tclypriv.h"
#include "deskew.h"

#define DGP_TINY_TOKEN_AREA     10      /* For statistics... */
typedef struct {
    tokBitmap bitmap;
    Dgp_Int32 x, y;
    token *tok;
    Dgp_Int32 pgnum;
    Dgp_Int16 *runs;
    Dgp_Int32 nruns;
    DgpImage_RGB color;
} dgplssy_cc;


/* 17.10.2000 / dhtesq.  For verifier application, found a need for a place to hang lists */
/* of sibling tokens -- i.e., the class data.  Can't add userdata to cc{} because small allocator */
/* has been optimized around structure size. */
typedef struct {
    dgplssy_cc *box;
    DgpAdt_List classSiblings;
    Dgp_Int32 xReg;
    Dgp_Int32 yReg;
    void *userdata;
} ccXref;

/* this is the small pool from which DgpCC_CC's will be allocated,
   (outliers are returned using this structure) */
#define DGPLSSY_CC_POOL_ID DGP_SMALLPOOL_MIN44
#define DGPLSSY_CC_SEC_MALLOC(_ppcc) \
  DGP_ERR_PASS_CLEANUP(dgp_state->sm_a.mallocSmall(dgp_state->sm_a.smallCookie, DGPLSSY_CC_POOL_ID, (void **)(_ppcc)))
#define DGPLSSY_CC_FREE(_pcc) \
  (dgp_state->sm_a.freeSmall(dgp_state->sm_a.smallCookie, DGPLSSY_CC_POOL_ID, (void *)(_pcc)))
/* real size is 44, need to change color stuff or create new small pool */


typedef struct {
	void *xiffState;
	void *dictstate;
	uds *stream;
	Dgp_State *dgp_state;
}fileState;

extern ErrCode
writeTokOutput(	TCLYOutCookie		toc, 
				TCLYSectionBlock	*sb,
				DgpTdc_SectionBlock *llSb,
				DeskewStruct		*deskewCookie,
				token				**_toks,
				Dgp_Bool			final);
ErrCode writeClasses(TCLYOutCookie toc, TCLYSectionBlock *sb );
#if 0
extern ErrCode writePages(	TCLYOutCookie toc, 
			  	TCLYSectionBlock *sb,
				TCLYDeskewCookie deskew_cookie);
#endif /* 0 */

extern void emptyOutputState(TCLYOutCookie toc);


#endif
