/*******************************************************
 * compressUtil.h
 * $Header: /project/icons/cvsroot/digipaper/src/libtclydoc/compressUtil.h,v 1.5 2001/04/26 22:23:45 dtracy Exp $
 *******************************************************/
#ifndef COMPRESS_UTIL_H
#define COMPRESS_UTIL_H

#include "libpixrw.pub"
#include "compress.h"

extern ErrCode
makePosArray(	DgpAdt_ListNode firstbox, 
				DgpTdc_PageInfo *llPage,
				tokpos **_pos, 
				Dgp_Int32 numBoxes,
				Dgp_Int32 *numPos, 
				Dgp_Int32 pgWidth, 
				Dgp_Int32 pgHeight, 
				Dgp_State *dgp_state);

extern ErrCode
makeTokens(	TCLYSectionBlock	*sb,
			DgpTdc_SectionBlock	*llSb,
			DeskewStruct		*deskewCookie,
			token				**_toks, 
			Dgp_Int32			*num_toks, 
			Dgp_Int32			*_llNonSingletonCount,
			Dgp_Bool			final,
			Dgp_State			*dgp_state);

extern void 
adjustCoords(DgpAdt_List tokOutput);

extern ErrCode
getResDictSize(TCLYPageInfo cpage, 
			   DgpTdc_PageInfo llPage,
			   Dgp_Int32 *_ntok,
			   Dgp_Int32 *_nLlTok);

extern ErrCode
writeResDict(	TCLYOutCookie		toc, 
				TCLYPageInfo		cpage,
				DgpTdc_PageInfo		llPage,
				DgpAdt_List			skewedTokens, 
				Dgp_Int32			ntok,
				Dgp_Int32			nLlTok,
				token				*toks, 
				Dgp_Bool			g4_toks);

extern void 
fillruns(	Dgp_UInt32 *bits, 
		Dgp_Int32 row_width,
	 	Dgp_Int16 *runs, 
		Dgp_Int32 nruns, 
		Dgp_Int32 x, 
		Dgp_Int32 y);

#endif



/*******************************************************************
 * Running Log
 * $Log: compressUtil.h,v $
 * Revision 1.5  2001/04/26 22:23:45  dtracy
 * Extensive modifications for unification with lossless tokenizer.
 *
 * Revision 1.4  2001/02/09 23:46:01  jlin
 * add halftone detection and convert to gray
 *
 * Revision 1.3  2000/10/11  18:47:12  dtracy
 * Fixed bug:  decoder was writing 8bpp b&w tiffs.
 *
 * Revision 1.2  2000/03/04 00:22:40  mkrocken
 *
 * merged repositories
 *
 * Revision 1.1  2000/02/17 22:23:18  mkrocken
 * Initial Revision
 *
 * Revision 1.1  1999/12/29 19:49:28  jlin
 * Initial version of compressUtil.h for libtclydoc
 *
 *******************************************************************/
