#if 0
static void
TCLY_getTokenStats (TCLYSectionBlock *sb);
#endif /* 0 */

/***********************************************************
* Write out a section
**********************************************************/
#if 0

DGP_LIBEXPORT ErrCode
tcly_out_writeSection(
		      TCLYOutCookie toc, 
		      TCLYDocCookie _tdc,
		      Dgp_Bool report)
{
	TCLYDocState *tdc = (TCLYDocState *)_tdc;
	Dgp_State *dgp_state = tdc->dps;
	DGPERR_INIT(tcly_out_writeSection);
	TCLYSectionBlock *sb = tdc->curBlock; 
	token *toks;
	DgpAdt_ListNode retnode;
	
	report = report;

	DGP_ERR_PASS_CLEANUP(writeTokOutput(toc,
		                                sb, 
		                                &toks));
	if ( toks != (token *)NULL) {
		DGP_ERR_PASS_CLEANUP(DgpAdt_liAdd(tdc->tokDgpAdt_List, toks, &retnode));
	}
	if (toc->writeClasses) {
		DGP_ERR_PASS_CLEANUP(writeClasses(toc,sb));
	}
	/*DGP_ERR_PASS_CLEANUP(writePages(toc, sb, tdc->deskew_cookie )); */
	if (sb->final){
      	emptyOutputState(toc);
	}
	if (toc->final)	{
		toc->callbacks->freeOutputDictblock (toc->dictState, toc->outputState, NULL);
	}
	
	NORMAL_RETURN;
	
ERR_CLEANUP:
	ERR_RETURN;
}
#endif /* 0 */
/***********************************************************************
 * Write a bunch of pages out.
 *
 * What this gets fed:
 * - toc: the output cookie 
 * - sb: section block, which hold the informate to write out
 * - deskew_cookie: info for deskewing pages.
 * It returns DGP_TRUE on success, DGP_FALSE on failure. The contents of the output
 * file on failure are undefined.
 ***********************************************************************/
#if 0
/*********************************************************************
 * Get Perpage dictionary size
 * This dictionary will include not only singletons and outliers (those
 * with no token) but also tokens that were skewed on this page. 
 *********************************************************************/
ErrCode
getResDictSize(TCLYPageInfo cpage, 
			   DgpTdc_PageInfo llPage,
			   Dgp_Int32 *_ntok,
			   Dgp_Int32 *_nLlTok)
{
  DGP_PROLOGUE("getResDictSize()", NULL);
  DgpAdt_ListNode firstbox = DGPADT_LIFIRST(cpage.boxes); 
  Dgp_Int32 numBoxes = cpage.numBoxes; 
  Dgp_Int32 numSkewedTokens = cpage.skewedTokenPerPage;
  DgpAdt_ListNode box;
  dgplssy_cc *boxcc;
  Dgp_Int32 i, ntok = 0, nLlTok = 0;

  /* Figure out how many outliers/singletons there are... */
  for (i = 0, box = firstbox; i < numBoxes; i++, box = DGPADT_LINEXT(box)) {
    DGP_VOID_ASSERT(box != DGP_NULLLISTNODE);
    boxcc = (dgplssy_cc *)DGPADT_LIGET(box);
    DGP_VOID_ASSERT(boxcc != (dgplssy_cc *)NULL);
      
    /* If it doesn't have a token then it's not in any other dictionary! */
    if( boxcc->tok == (token *)NULL) {
      ntok++;
    }
  }

  /* Count up lossless tokens too... */
  /* But that's already been done. */
  nLlTok = llPage.numToks;

  /* This dictionary will include not only singletons and outliers (those
   * with no token) but also tokens that were skewed on this page. */
  ntok += numSkewedTokens;
  *_ntok= ntok;
  *_nLlTok = nLlTok;
  NORMAL_RETURN;

}

ErrCode
writePages(TCLYOutCookie toc,
           TCLYSectionBlock *sb,
           TCLYDeskewCookie tdeskew_cookie) 
{
  DGP_PROLOGUE("writePages()", toc->DGP_PERRSTATE);
  DeskewStruct *deskew_cookie = (DeskewStruct *)tdeskew_cookie; 
  Dgp_Bool g4_toks = toc->g4_toks;
  Dgp_Int32 i, ntok;
  DgpAdt_List skewedTokens = DGP_NULLLIST, newBitmaps = DGP_NULLLIST;
  token *page_toks = (token *)NULL;
  tokpos *pos = (tokpos *)NULL;
  Dgp_UInt32 numPos;
  void *oldDictstate = (void *)NULL;
  Dgp_Allocators *a = &(toc->DGP_ALLOCATORS);
  OutputCallbacks *ocb = toc->callbacks;

  /*
   * First, run through the box lists, adjusting the coordinates
   * and tagging each box with its token.
   */
  adjustCoords(sb->classesFound);
  
  /* Get some statistics about the the tokens. */
  TCLY_getTokenStats(sb);
  DGP_REPORTF4(toc->verbose, "classes %d, good tokens %d, singletons %d, tiny %d",
      sb->stats.numClasses, sb->stats.numMulti, sb->stats.numSingleton, sb->stats.numTiny);

  /* This is a list of token structs for tokens that are deskewed.
   * Because a token is only deskewed on a per page basis, we
   * (in deskew.c) create a new token struct that holds the 
   * new bitmap, etc. Evenually, though, we need all the tokens
   * in the residual dictionary to be in a contiguous array.
   * So the bitmap/data is copied (again) from the new token
   * to one that is part of such an array. Then the new token
   * needs to throw out and so it goes here. */
  DGP_ERR_PASS_CLEANUP(DgpAdt_liNew(&skewedTokens, toc->dgp_state));
    
  /* This is a list of cc's who bitmaps need to be freed 
   * after each boxcc's page red dict has been written.
   * It currently only contains cc that below to singletons
   * that are deskewed. Because singletons are actually part
   * of a class, we encounter them in a (seemingly) random
   * order. So we can't really deskew on a per-page basis.
   * So we keep track of things here.
   */     
  DGP_ERR_PASS_CLEANUP(DgpAdt_liNew(&newBitmaps, toc->dgp_state));
        
  /* Deskew the all tokens if desired. */
  if(deskew_cookie) {
    DGP_ERR_PASS_CLEANUPF0(deskewTokens(deskew_cookie,
					newBitmaps,
					sb), 
			   "error while deskewing pages.");
  }
        
  /*
   * For each page:
   *  Deskew outliers, if desired.
   *  Find out how many tokens will be written to the per-page
   *      (residual) dictionary.
   *  If there are tokens in said dictionary, then write the
   *      dictionary.
   *  Throw out any bitmaps used only on this page (outliers, 
   *      deskewed tokens, deskewed singletons.)
   *  Write the position block and save its size and position for
   *      the IFD. 
   *  Write the residual block and save its size, position, and
   *      dimensions for the the IFD.
   *  Perform any other page cleanup.
   */
  
  for (i = 0; i < sb->numPages; i++) {
    /* Hold on to the current state of the dictionry so that
     * after we write the per-page dictionary and the page
     * position block, we can revert the dictionary state
     * to the global state. */
    oldDictstate = toc->dictState;
	
    /* Deskew the outliers on this page. */
    if(deskew_cookie) {
      DGP_ERR_PASS_CLEANUPF0(deskewOutliers( 	deskew_cookie, 
						sb->pages[i]),
			     "error while deskewing outliers.");
    }

    /* Create the residual dictionary if necessary. */
    getResDictSize( sb->pages[i], &ntok);
    if( ntok > 0) {
	/* Create array of token structs. */
	DGP_CHECK_ALLOC_CLEANUP(page_toks = (token *)
				(a->malloc)(ntok * sizeof(*page_toks)));

	DGP_ERR_PASS_CLEANUPF0(writeResDict(	toc,
						sb->pages[i],	
					    	skewedTokens, 
					    	ntok, 
						page_toks, 
						g4_toks),
			       "error while writing residual dictionary.");
      }
	
    /* Clean up the per page bitmaps. This include any bitmaps for
     * outliers on this page, as well as deskewed token classes. */
    pageCleanup( 	DGPADT_LIFIRST(sb->pages[i].outliers), 
			sb->pages[i].numOutliers, 
			DGPADT_LIFIRST( skewedTokens), 
		 	DGPADT_LIFIRST( newBitmaps), 
			sb->pages[i].pgNum, 
			toc->dgp_state);
	
    /* Now deskew the token positions. */
    if( deskew_cookie) {
      DGP_ERR_PASS_CLEANUPF0(deskewPositions( 	deskew_cookie, 
												sb->pages[i]),
			     "error while deskewing token positions.");
    }
	
    /* Finally, create the position block for this page. */
    makePosArray(	DGPADT_LIFIRST(sb->pages[i].boxes), 
			&pos, 
			sb->pages[i].numBoxes, 
			&numPos, 
			sb->pages[i].width, 
			sb->pages[i].height,
		 	toc->dgp_state);

    /* Write the position block to the file. */
    /* This part is moved into writeOutputPageDictionary callback
     * to give the user flexibily of creating page segment
     * DGP_ERR_PASS_CLEANUPF0(ocb-> newOutputPage(	toc->outputState, 
     *							DGP_FALSE,
     *							ocb->userData),
     *			   "error creating new page.");
     */
	   
    DGP_ERR_PASS_CLEANUPF0(ocb->writeOutputPosBlock(	pos, 
							numPos, 
							sb->pages[i].width,
							sb->pages[i].height,
							sb->pages[i].xRes,
							sb->pages[i].yRes,
					     		NULL, 
							0, 
							toc->dictState, 
							DGP_TRUE,
					     		toc->outputState,
							ocb->userData),
			   "error writing output position block.");


    /*
     * Since the new dictState from writeResDict() is specific to this 
     * page only, we return the dictblock to its state before we wrote
     * this page's posBlock.
     */
    if((oldDictstate != NULL) && (oldDictstate != toc->dictState)) {
      ocb->freeOutputDictblock(	toc->dictState, 
				                toc->outputState,
				                ocb->userData);
      toc->dictState = oldDictstate;
    }

    /* All done with the position array */
    (a->free)((void *)pos);
    pos = (tokpos *)NULL;
	
    /* Same goes for these tokens. They belong to outliers and
     * deskewed tokens, and so were only referenced by this page.
     * i.e. once the per-page dictionary is tossed and the position
     * block is written out, these can be tossed as well. 
     */
    (a->free)((void *)page_toks);
    page_toks = (token *)NULL;

    /*If there are halftones, write them out now as a G4 layer*/
	if (sb->pages[i].halftones) {
	  	DGP_ERR_PASS_CLEANUPF0(
			ocb->writeOutputBinaryPixr(	0, 
										0,
										SELECTOR_PLANE,
										(TCLYPIXRPtr)(sb->pages[i].halftones), 
										toc->outputState,
										ocb->userData),
										"error writing halftones.");
		w_destroyPixr(	toc->DGP_PIPWSTATE, (PIXR **)&sb->pages[i].halftones);
	}

    /* finish this page */
    DGP_ERR_PASS_CLEANUPF0(ocb->finishOutputPage(toc->outputState, ocb->userData), "error closing page.");
  }
 
  /* There should be nothing left here, it all got freed by
   * pageCleanup. */
  DGP_ASSERT( DGPADT_LILEN( skewedTokens) == 0);
  DgpAdt_liFree( skewedTokens);
  DGP_ASSERT( DGPADT_LILEN( newBitmaps) == 0);
  DgpAdt_liFree( newBitmaps);

  NORMAL_RETURN;

ERR_CLEANUP:

  if( skewedTokens != DGP_NULLLIST) {
    DgpAdt_liFree( skewedTokens);
  }
  if( newBitmaps != DGP_NULLLIST) {
    DgpAdt_liFree( newBitmaps);
  } 
  if( page_toks != (token *)NULL) {
    (a->free)((void *)page_toks);
  }
  if( pos != NULL) {
    (a->free)((void *)pos);
  }

  ERR_RETURN;
}
#endif /* 0 */

#if 0
static void
TCLY_getTokenStats (TCLYSectionBlock *sb)
{
	DgpAdt_List classesFound = sb->classesFound;
	DgpAdt_ListNode ln;
	tokClass *pClass;
	token *pToken;
	Dgp_Int32 n_memb;
	
	sb->stats.numMulti = 0;
  sb->stats.numTiny = 0;
  sb->stats.numClasses = 0;
  sb->stats.numSingleton = 0;
	
	DGPADT_FOREACH (ln, classesFound) {
		pClass = (tokClass*) ln->userdata;
		pToken = (token*) pClass->userdata;
		n_memb = pClass->members->nelt;
		if (n_memb > 1)
		{
			if (pToken->width * pToken->height < DGP_TINY_TOKEN_AREA)
				sb->stats.numTiny += n_memb;
			else
			{
				sb->stats.numMulti += (Dgp_UInt16)n_memb;
				sb->stats.numClasses++;
			}
		}
		else
		{
			sb->stats.numSingleton++;
		}
/*		if (pClass->members->nelt > 20) {
			tokOffset *pOffset;
			dgplssy_cc *pcc;
			DgpAdt_ListNode ln2;
			DGPADT_FOREACH (ln2, pClass->members) {
				pOffset = (tokOffset*) ln2->userdata;
				pcc = (cc*) pOffset->userdata;
				fprintf (stderr, "x  %d   y  %d\n", pcc->x, pcc->y);
			}
		} */
	}

}
#endif /* 0 */

#if 0
/*
 * Encode the low-order bit of ntok of the tokens starting at "tokens" into
 * buf, starting at *bufpos.  Update *bufpos.
 *
 * We get the low-order bit by looking at the exemplar bitmap and the
 * histogram.
 * For each pixel:
 *  If the exemplar bit is '1' and the normalised histogram value is <= 3/4,
 *	encode the low-order bit as '1'.
 *  If the exemplar bit is '0' and the normalised histogram value is <= 1/4,
 *	encode the low-order bit as '0'.
 * Suppose that the exemplar was generated by thresholding the histogram
 * at t, and 1/4 < t < 3/4.  The encoding is then:
 * 0 <= val <= 1/4:		00
 * 1/4 < val < t		01
 * t <= val <= 3/4		11
 * 3/4 < val <= 1		10
 * Note that this is a Gray-coding of the 2 bits; it involves fewer transitions
 * of the low-order bit on each ramp from 0 to 1.
 *
 * In fact, if 1/4 < t < 3/4, we don't need to look at the exemplar bit's
 * value at all, just the histogram's value.  t ought to be in this range
 * for any reasonable threshold.
 */
Dgp_Bool
encode2bit(tokClass **tokens, Dgp_Int32 ntok, Dgp_Int8 *buf, Dgp_Int32 *bufpos)
{
  Dgp_Int32 x, y;
  Dgp_Int32 longsperline, Dgp_Int8sperline;
  Dgp_Int32 height;
  Dgp_Int32 width;
  Dgp_Int32 i;
  Dgp_Int32 lowt, hight;
  Dgp_UInt32 *bits = (Dgp_UInt32 *)NULL;
  DgpImage_Gray bytehist;
  DgpImage_Short Dgp_Int16hist;
  Dgp_Int32 tpos;
  size_t encsize;

  if (ntok == 0) {
    return(DGP_TRUE);
  }

  height = tokens[0]->exemplar.height;
  width = 0;
  for (i = 0; i < ntok; i++) {
    width += tokens[i]->exemplar.width;
    assert(tokens[i]->exemplar.height == height);
  }
  longsperline = (width + (DGP_BITS_UINT32 - 1)) / DGP_BITS_UINT32;
  Dgp_Int8sperline = (width + (BITS_UCHAR - 1)) / BITS_UCHAR;

  /* Allocate the plonking place */
  bits = (Dgp_UInt32 *)calloc((size_t)height * longsperline,
				 sizeof(*bits));
  if (bits == (Dgp_UInt32 *)NULL) {
    goto bailout;
  }

  tpos = 0;
  for (i = 0; i < ntok; i++) {
    /*
     * Thresholds: round the lower threshold up, and the upper one
     * down, since we want to make sure 0 and maxval get represented
     * with a 0 in the low-order bit.
     */
    assert(DGPADT_LILEN(tokens[i]->members) > 1); /* No singletons please */
    lowt = (DGPADT_LILEN(tokens[i]->members) + 3) / 4;
    hight = DGPADT_LILEN(tokens[i]->members) * 3 / 4;

    /*
     * At the moment, we generate the second bit for exactly the same
     * bitmap as the high-order bit.  This isn't quite right - the
     * region where the second bit might be nonzero could extend a
     * little beyond the token's bounding box.  FIX?
     */
    if (tokens[i]->histIsByte) {
      bytehist = tokens[i]->histogram.byteHist;
      for (y = 0; y < height; y++) {
	for (x = 0; x < tokens[i]->exemplar.width; x++) {
	  if ((DGPIMG_REF(bytehist, x, y) >= lowt) &&
	      (DGPIMG_REF(bytehist, x, y) <= hight)) {
	    bits[y * longsperline + (x + tpos) / DGP_BITS_UINT32] |=
	      (1u << (DGP_BITS_UINT32 - 1 -
		      ((x + tpos) % DGP_BITS_UINT32)));
	  }
	}
      }
    }
    else {
      Dgp_Int16hist = tokens[i]->histogram.Dgp_Int16Hist;
      for (y = 0; y < height; y++) {
	for (x = 0; x < tokens[i]->exemplar.width; x++) {
	  if ((DGPIMG_REF(Dgp_Int16hist, x, y) >= lowt) &&
	      (DGPIMG_REF(Dgp_Int16hist, x, y) <= hight)) {
	    bits[y * longsperline + (x + tpos) / DGP_BITS_UINT32] |=
	      (1u << (DGP_BITS_UINT32 - 1 -
		      ((x + tpos) % DGP_BITS_UINT32)));
	  }
	}
      }
    }

    tpos += tokens[i]->exemplar.width;
  }
  assert(tpos == width);
    
  /* Now encode it. */
  /*
   * If its encoded size could be greater than 64K-1, reserve space for
   * a Dgp_Int16 and a Dgp_Int32; if it couldn't, then reserve space for a Dgp_Int16
   * only.
   */
  if (Dgp_Int8sperline * height < 65535) {
    encsize = Dgp_Int8sperline * height;
    if (!g4Encode(bits, width, height, longsperline,
		  buf + *bufpos + sizeof(Dgp_UInt16), &encsize, DGP_FALSE,
		  &local_a, NULL)) {
      /* It got bigger - store the raw bits */
      encodeShortBigEndian((Dgp_UInt16)0, buf + *bufpos);
      /* Copy each line across, fixing byteorder as we go */
      for (y = 0; y < height; y++) {
	Dgp_Int32 x2;
	Dgp_UInt32 tmp;
	Dgp_UInt32 *p;
	Dgp_UInt8 *q;

	p = bits + y * longsperline;
	q = buf + *bufpos + sizeof(Dgp_UInt16) + y * Dgp_Int8sperline;
	for (x = 0; x < longsperline - 1; x++) {
	  tmp = *p++;
	  for (x2 = 0; x2 < (Dgp_Int32)sizeof(Dgp_UInt32); x2++) {
	    *q++ = (Dgp_UInt8)(tmp >> (DGP_BITS_UINT32 - (x2+1) * BITS_UCHAR));
	  }
	}
	tmp = *p++;
	for (x2 = 0;
	     x2 < Dgp_Int8sperline - (Dgp_Int32)sizeof(Dgp_UInt32) *
	       (longsperline - 1);
	     x2++) {
	  *q++ = (Dgp_UInt8)(tmp >> (DGP_BITS_UINT32 - (x2 + 1) * BITS_UCHAR));
	}
      }
      *bufpos += sizeof(Dgp_UInt16) + Dgp_Int8sperline * height;
    }
    else {
      /* It's encoded in the right place - just put in the length */
      encodeShortBigEndian((Dgp_UInt16)encsize, buf + *bufpos);
      *bufpos += sizeof(Dgp_UInt16) + encsize;
    }
  }
  else {
    encsize = Dgp_Int8sperline * height;
    if (!g4Encode(bits, width, height, longsperline,
		  buf + *bufpos + sizeof(Dgp_UInt16) +
		  sizeof(Dgp_UInt32), &encsize, DGP_FALSE,
		  &local_a, NULL)) {
      /* It got bigger - store the raw bits */
      encodeShortBigEndian((Dgp_UInt16)65535, buf + *bufpos);
      encodeLongBigEndian((Dgp_UInt16)0,
			  buf + *bufpos + sizeof(Dgp_UInt32));
      /* Copy each line across, fixing byteorder as we go */
      for (y = 0; y < height; y++) {
	Dgp_Int32 x2;
	Dgp_UInt32 tmp;
	Dgp_UInt32 *p;
	Dgp_UInt8 *q;

	p = bits + y * longsperline;
	q = buf + *bufpos + sizeof(Dgp_UInt16) +
	  sizeof(Dgp_UInt32) + y * Dgp_Int8sperline;
	for (x = 0; x < longsperline - 1; x++) {
	  tmp = *p++;
	  for (x2 = 0; x2 < (Dgp_Int32)sizeof(Dgp_UInt32); x2++) {
	    *q++ = (Dgp_UInt8)(tmp >> (DGP_BITS_UINT32 - (x2+1) * BITS_UCHAR));
	  }
	}
	tmp = *p++;
	for (x2 = 0;
	     x2 < Dgp_Int8sperline - (Dgp_Int32)sizeof(Dgp_UInt32) *
	       (longsperline - 1);
	     x2++) {
	  *q++ = (Dgp_UInt8)(tmp >> (DGP_BITS_UINT32 - (x2 + 1) * BITS_UCHAR));
	}
      }
      *bufpos += sizeof(Dgp_UInt16) + sizeof(Dgp_UInt32) +
	Dgp_Int8sperline * height;
    }
    else {
      /* It's encoded in the right place - just put in the length */
      encodeShortBigEndian((Dgp_UInt16)65535, buf + *bufpos);
      encodeLongBigEndian((Dgp_UInt32)encsize,
			  buf + *bufpos + sizeof(Dgp_UInt16));
      *bufpos += sizeof(Dgp_UInt16) + sizeof(Dgp_UInt32) +
	encsize;
    }
  }

  free((void *)bits);

  return(DGP_TRUE);

bailout:
  if (bits != (Dgp_UInt32 *)NULL) {
    free((void *)bits);
  }

  return(DGP_FALSE);
}


/*
 * Drop the bitmap in with its UL corner at (x,y).
 */
void
blat(Dgp_UInt32 *bits, Dgp_Int32 row_width, dgplssy_cc *boxcc, Dgp_Int32 x, Dgp_Int32 y)
{
  Dgp_Int32 i, j;
  Dgp_UInt32 tmp;
  Dgp_UInt32 *p;
  Dgp_UInt32 *q;
  Dgp_Int32 Dgp_Int32pos;
  Dgp_Int32 mrow_width;
  Dgp_Int32 bitsinlastDgp_Int32;
  Dgp_Int32 xpos;

  /* How many Dgp_Int32s in the model actually contain data? */
  mrow_width = (boxcc->bitmap.width + (DGP_BITS_UINT32 - 1)) / DGP_BITS_UINT32;
  bitsinlastDgp_Int32 = DGP_BITS_UINT32 - ((mrow_width * DGP_BITS_UINT32) - 
				 boxcc->bitmap.width);

  Dgp_Int32pos = x / DGP_BITS_UINT32;
  xpos = x % DGP_BITS_UINT32;
    
  for (i = 0; i < boxcc->bitmap.height; i++) {
    p = boxcc->bitmap.bits + i * boxcc->bitmap.longsperline;
    q = bits + Dgp_Int32pos + (y + i) * row_width;

    /* Go through Dgp_Int32-by-Dgp_Int32 */
    if (xpos != 0) {
      for (j = 0; j < mrow_width - 1; j++) {
	tmp = *p++;
	*q++ |= tmp >> xpos;
	*q |= tmp << (DGP_BITS_UINT32 - xpos);
      }
      tmp = *p++;
      if (xpos + bitsinlastDgp_Int32 > DGP_BITS_UINT32) {
	*q++ |= tmp >> xpos;
	*q |= tmp << (DGP_BITS_UINT32 - xpos);
      }
      else {
	*q |= tmp >> xpos;
      }
    }
    else {
      /* No shifting - yay! */
      for (j = 0; j < mrow_width; j++) {
	*q++ |= *p++;
      }
    }
  }
}
#endif /* 0 */
#if 0
static void
encodeShortBigEndian(u_Dgp_Int16 x, Dgp_UInt8 *p)
{
  Dgp_Int32 i;

  for (i = 0; i < (Dgp_Int32)sizeof(u_Dgp_Int16); i++) {
    p[sizeof(u_Dgp_Int16) - 1 - i] = (x >> (BITS_UCHAR * i)) & 0xff;
  }
}

/*
 * Encode it in big-endian (network) order
 */
static void
encodeLongBigEndian(u_Dgp_Int32 x, Dgp_UInt8 *p)
{
  Dgp_Int32 i;

  for (i = 0; i < (Dgp_Int32)sizeof(u_Dgp_Int32); i++) {
    p[sizeof(u_Dgp_Int32)- 1 - i] = (Dgp_UInt8)((x >> (BITS_UCHAR * i)) & 0xff);
  }
}
/*
 * Remove the given class from the table.
 */
 /*
ErrCode
tcly_tokRemoveFromTable(tokClassTable classes, Dgp_Int32 pgnum, tokOptions *options)
{
    Dgp_State *dgp_state = options->dgp_state;
    DgpAdt_List curBinList = DGP_NULLLIST;
    DgpAdt_ListNode ln, ln2;
    tokCBoxType *exemplar = c->exemplar;
    Dgp_Bool isNewClass;
    toClass curClass = NULL, curNewClass = NULL;

    DGP_PROLOGUE("tcly_tokRemoveFromTable()", DGP_PERRSTATE);

    /*return if this is an empty table */
    if ((classes->elts == (DgpImage_Ptr)NULL) NORMAL_RETURN;
    
    /*create new classtable */

    /*examine each entry to see if a class is newClass */
    for (i=0; i < DGPIMG_HEIGHT(classes->elts); i++){  
        for (j=0; j < = DGPIMG_WIDTH(classes->elts); j++) {
            if (curBinList = (DgpAdt_List)tokCTRef(classes, j, i) != DGP_NULLLIST) {
                DGPADT_FOREACH (ln, curBinList) {
                    curClass = (tokCClass) ln;
                    isNewClass = DGP_TRUE;
                    curNewClass = NULL;
                    DGPADT_FOREACH (ln2, curClass->members) {
                        curMember = (dgplssy_cc *)ln2;
                        if (curMember->userdata->pgnum !=pgnum){
                           isNewClass = DGP_FALSE;
                        }else{
                            if(curNewClass == NULL)
                                /* ceate a new class and move new member over */
                            else
                                /*move this member into curNewClass members */
                        }
                    }
                    if(isNewClass = DGP_TRUE){
                        /* remove this class from the classes table */
                        free cur class
                        ln->prev->next = ln->next;
                        ln->next->prev = ln->prev;
                        ln = NULL;
                        classess->count --;
                    }
            }
	    
    }

  }


    NORMAL_RETURN;

ERR_CLEANUP:

    if (newBin != DGP_NULLLIST) {
	DgpAdt_liFree(newBin);
    }

    ERR_RETURN;
}
*/
#endif /* 0 */



