/*****************************************************************
 *  Trade Secret of Xerox Corporation.                           *
 *  Copyright (c) 1991-1995, Xerox Corporation.                  *
 *  All rights reserved.                                         *
 *  Copyright protection claimed includes all forms and matters  *
 *  of copyrightable material and information now allowed by     *
 *  statutory or judicial law or hereafter granted, including    *
 *  without limitation, material generated from the software     *
 *  programs which are displayed on the screen such as icons,    *
 *  screen display looks, etc.                                   *
 *****************************************************************/

/*************************************************************************
**
**  DigiPaper Codebase
**  
**	  
**  Pedro Felzenszschwalb? (sp?), 19nn - 1998?
**
**  Filename:  getBoxes.h
**
**  Types & prototypes for the 'boxes' module, which prepares connected component bitmaps
**	for the tokenizer.
**
**
**	Modification history:
**
**	Dillon H. Tracy esq. / Feb. 2000
**		o  Implemented liberr exception handling.
**		o  Search on 'dhtesq' for some of this coder's comments & changes.
**  
**************************************************************************/

#ifndef GET_BOXES_H
#define GET_BOXES_H

#include "dgp_err_control.h"
#include "scancolor.h"
#include "tok-lossy.h"
#include "token_t.h"

ErrCode
getColorBoxes(Dgp_State *dgp_state, sc_cc	*text_ccs, Dgp_Int32 numccs,
              Dgp_Int32 pgnum, DgpAdt_List *_list);

ErrCode
freeColorBoxList(Dgp_State *dgp_state, DgpAdt_List boxes);

#endif
