
#include "tclydoc.h"
#include "tclyout.h"
#include "compress.h"
#include "tclypriv.h"

#include "token-compress.h"
#include "token-compress-priv.h"



typedef struct {
  FILE *errfile;
  FILE *rptfile;
} statusOutputFiles;


#define DGPAPI_NO_SECTION 0
#define DGPAPI_IN_SECTION 1

typedef struct {
  Dgp_UInt8 status;
  TCLYOutState* tout;
  TCLYDocState* tdoc;

  /* 16.4.2001 / dhtesq. */
  /* Adding some lossless tokenizer state... */
  tdoc_state *llTdoc;
  Dgp_Int32 pgNum;				/* Starts with zero.  This page count is incremented as pages are added. */
  Dgp_Bool verbose;

  size_t handle_check;
  DgpAdt_List skewedTokens;
  DgpAdt_List newBitmaps;
  Dgp_UInt16 OutputPageCount;	/* This page count is incremented as position blocks are written. */
  Dgp_Bool overflow;
} DgpApi_State;

INLINE ErrCode
api_checkHandle (DgpApi_State *state);

