/****************************************************
 * tiff_cc2box.h
 * $Header: /project/icons/cvsroot/digipaper/src/libtclydoc/tiff_cc2box.h,v 1.19 2003/02/10 22:53:41 mkrocken Exp $
 ***************************************************/

#ifndef LOSSY_CC2BOX_H
#define LOSSY_CC2BOX_H

#include "list.h"
#ifdef _WIN32
#include <winsock.h>
#elif defined(VXWORKS)
#include <sys/times.h>
#else
#include <sys/time.h>
#endif
#include "libutilw.pub"
#include "libpixrw.pub"
#include "shrcc.pub"

#include "dgp_state.h"

#include "cc2box.h"

typedef struct _CCData {
  Dgp_Int32 count;
  Dgp_Int32 pgnum;
  Dgp_Int32 tokMem;  /* total memory of global tokens  */
  Dgp_Int32 pageTokMem;  /* total memory of tokens in the current page */
  DgpAdt_List boxes;
  DgpAdt_List outliers;
  Dgp_Int32 numOutliers;
  Dgp_Int32 xRes;
  Dgp_Int32 yRes;
  Dgp_Int32 maxWidth;
  Dgp_Int32 maxHeight;

  /* 16.4.2001 / dhtesq. */
  /* Adding stuff for handling losslessly-encoded tokens... */
  LlCCData  llCCData;
  Dgp_Int32 minWidth, minHeight;  
  Dgp_Int32 membond;
  Dgp_State *dgp_state;
  TokState tokstate;

  /* 2 section stuff */
  Dgp_Bool second_section;
  Dgp_Int32 sectionHeight;

  CCState *pCCState;
  Dgp_Int32 accuHeight;
} CCData;

/*
 * 16.5.2001 / dhtesq.
 * Added customizable callback for cc finder.  Defaults to the usual thing if
 * you pass NULL.
 */
DGP_LIBEXPORT ErrCode
getBoxesLossy(   
              Dgp_State *dgp_state,
              UInt8 *image,
              Dgp_Int32 pgWidth,
              Dgp_Int32 pgHeight,
              Dgp_Int32 bpl,
              Dgp_Int32 sizeThreshold,
              Dgp_Int32 halftone,
              void *deskew_cookie,
              Float32 *skewAngle,
              DgpAdt_List *halfton_images,       
              DgpAdt_List *imageInfo,
              Int32 (CDECL *rectReturnProc) (
                  IPState    *pIPState,
                  void       *,
                  Int32	x,
                  Int32	y,
                  Int32	w,
                  Int32	h,
                  Int32	m,
                  Int32	nRuns,
                  TCScanLineRun *pRuns),
              CCData *ccData,
              struct timeval *readtime,
              struct timeval *cctime);
/*
 * 16.5.2001 / dhtesq.
 * Added customizable callback for cc finder.  Defaults to the usual thing if
 * you pass NULL.
 */
ErrCode
getBoxesfromBuffer(   
              Dgp_State  *dgp_state,
              UInt8      *buffer,
              Dgp_Int32  bufferWidth,
              Dgp_Int32  bufferHeight,
              Dgp_Int32  bpl,
              Dgp_Int32  frameBits,
              Dgp_Bool   lastBuffer,
              Dgp_Int32  minWidth,
              Dgp_Int32  minHeight,
              Dgp_Int32  connectType,
              CCData *ccData);


/* 16.5.2001 / dhtesq.
 * Another callback for the cc finder -- returns list of cc's without feeding
 * tokenizer.  Used by verifator.
 */
ErrCode 
MakeModelsFromRunsWithoutTellingTokenizer(	IPState *ipwstate, 
			void *data, 
			Int32 x, 
			Int32 y,
		   	Int32 w, 
			Int32 h, 
			Int32 m, 
			Int32 nRuns,
		   	TCScanLineRun *pRuns);

#endif



