/*
 *
 * $Header: /project/icons/cvsroot/digipaper/src/libtok-lossless/tokprivate.h,v 1.11 2001/04/26 22:24:12 dtracy Exp $
 *
 */

/*
 * Internal declarations for the tokeniser.
 */

#ifndef	TOKPRIVATE_H

#define	TOKPRIVATE_H

#include <stdlib.h>
#include "util.h"
#include "sm_image.h"
#include "list.h"
#include "tok-lossless.h"

/* Options/parameters to the tokeniser */
typedef struct options {
  Dgp_UInt32 flags;	/* various flags - see tok.h */
} options;

typedef struct _ClassTable
{
  DgpAdt_SMImage elts;		/* Each point is a pointer to a list of classes */
  Dgp_UInt32 count;			/* total number of things in elts */
} *ClassTable;

#define ClassData(classlistelt)    ((LlTokClass)DGPADT_LIGET(classlistelt))
#define MemberBox(memberlistelt)   ((boxType *)DGPADT_LIGET(memberlistelt))

typedef struct {
  options options;
  struct _ClassTable classes;
  Dgp_Bool returned_classes;
  LlTokClass cachedClass;
  struct _LlTokClass dummyClass;
  Dgp_Int32 memUsage;
  Dgp_State *dgp_state;
} intTokState;


/* Small memory pool stuff. */
#define TOKCLASS_POOL_ID  DGP_SMALLPOOL_MIN28

#define TOKCLASS_SEC_MALLOC(_pptc) \
  DGP_ERR_PASS(dgp_state->sm_a.mallocSmall(dgp_state->sm_a.smallCookie, TOKCLASS_POOL_ID, (void **)(_pptc)))
#define TOKCLASS_FREE(_ptc) \
  (dgp_state->sm_a.freeSmall(dgp_state->sm_a.smallCookie, TOKCLASS_POOL_ID, (void *)(_ptc)))

#endif
