/*
 *
 * $Header: /project/icons/cvsroot/digipaper/src/libtok-lossy/miscalloc.h,v 1.11 2000/05/16 21:53:23 jahlborn Exp $
 *
 */

#ifndef	MISCALLOC_H

#define	MISCALLOC_H

#include "tokprivate.h"
#include "class.h"
#include "template.h"


extern void FreeModel(tokCModelInfo *model, tokOptions *opt);
extern void FreeImage(tokCImageInfo *i, tokOptions *opt);
extern void PixelSumFree(tokCPixelSum *ps, tokOptions *opt);
extern void ClassFree(tokCClass c, tokOptions *opt);
extern void FreeExemplar(tokCClass class, tokOptions *opt);
extern void FreeBox(tokCBoxType *box, tokOptions *opt);


#define TOKMDL_POOL_ID    DGP_SMALLPOOL_MIN24
#define TOKIMG_POOL_ID    DGP_SMALLPOOL_MIN20
#define TOKPXL_POOL_ID    DGP_SMALLPOOL_MIN20
#define TOKCLASS_POOL_ID  DGP_SMALLPOOL_MIN20
#define TOKBOX_POOL_ID    DGP_SMALLPOOL_MIN28

#define TOKMDL_SEC_MALLOC(_pptm) \
  DGP_ERR_PASS(dgp_state->sm_a.mallocSmall(dgp_state->sm_a.smallCookie, TOKMDL_POOL_ID, (void **)(_pptm)))
#define TOKMDL_FREE(_ptm) \
  (dgp_state->sm_a.freeSmall(dgp_state->sm_a.smallCookie, TOKMDL_POOL_ID, (void *)(_ptm)))

#define TOKIMG_SEC_MALLOC(_pptim) \
  DGP_ERR_PASS(dgp_state->sm_a.mallocSmall(dgp_state->sm_a.smallCookie, TOKIMG_POOL_ID, (void **)(_pptim)))
#define TOKIMG_FREE(_ptim) \
  (dgp_state->sm_a.freeSmall(dgp_state->sm_a.smallCookie, TOKIMG_POOL_ID, (void *)(_ptim)))

#define TOKPXL_SEC_MALLOC(_pptpxl) \
  DGP_ERR_PASS(dgp_state->sm_a.mallocSmall(dgp_state->sm_a.smallCookie, TOKPXL_POOL_ID, (void **)(_pptpxl)))
#define TOKPXL_FREE(_ptpxl) \
  (dgp_state->sm_a.freeSmall(dgp_state->sm_a.smallCookie, TOKPXL_POOL_ID, (void *)(_ptpxl)))

#define TOKCLASS_SEC_MALLOC(_pptc) \
  DGP_ERR_PASS(dgp_state->sm_a.mallocSmall(dgp_state->sm_a.smallCookie, TOKCLASS_POOL_ID, (void **)(_pptc)))
#define TOKCLASS_FREE(_ptc) \
  (dgp_state->sm_a.freeSmall(dgp_state->sm_a.smallCookie, TOKCLASS_POOL_ID, (void *)(_ptc)))

#define TOKBOX_SEC_MALLOC(_pptbox) \
  DGP_ERR_PASS(dgp_state->sm_a.mallocSmall(dgp_state->sm_a.smallCookie, TOKBOX_POOL_ID, (void **)(_pptbox)))
#define TOKBOX_FREE(_ptbox) \
  (dgp_state->sm_a.freeSmall(dgp_state->sm_a.smallCookie, TOKBOX_POOL_ID, (void *)(_ptbox)))


#endif
