/*
 *
 * $Header: /project/icons/cvsroot/digipaper/src/libtok-lossy/testdil.c,v 1.6 2000/03/04 00:30:08 mkrocken Exp $
 *
 */

#include "util.h"
#include "image.h"
#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
#include <sys/resource.h>
#include "shrpatt.pub"

DGP_RCSID("@(#)$Header: /project/icons/cvsroot/digipaper/src/libtok-lossy/testdil.c,v 1.6 2000/03/04 00:30:08 mkrocken Exp $");

int
main(int argc, Dgp_Int8 **argv)
{
    DgpImage_Packed im;
    DgpImage_Packed dil;
    struct rusage old, new;

    getrusage(RUSAGE_SELF, &old);
    im = imLoad(DGPIMAGE_PACKED, argv[1]);
    getrusage(RUSAGE_SELF, &new);
    fprintf(stderr, "Loading took %.3fs\n",
	    (new.ru_utime.tv_sec + new.ru_utime.tv_usec / 1e6) -
	    (old.ru_utime.tv_sec + old.ru_utime.tv_usec / 1e6));

    getrusage(RUSAGE_SELF, &old);
    dil = DgpImage_new(DGPIMAGE_PACKED | DGPIMAGE_DONTCLEAR, DGPIMG_WIDTH(im) + atoi(argv[2]), DGPIMG_HEIGHT(im));
    getrusage(RUSAGE_SELF, &new);
    fprintf(stderr, "Allocation took %.3fs\n",
	    (new.ru_utime.tv_sec + new.ru_utime.tv_usec / 1e6) -
	    (old.ru_utime.tv_sec + old.ru_utime.tv_usec / 1e6));

    getrusage(RUSAGE_SELF, &old);
    /* Compensate for the frame offset their routine tacks on */
    i_topologyPreserveDilate(DGPIMG_GETROW(dil, 0) - 32 * DGPIMG_GETROWWIDTH(dil) - 4,
			     DGPIMG_GETROW(im, 0) - 32 * DGPIMG_GETROWWIDTH(im) - 4,
			     DGPIMG_WIDTH(im) - atoi(argv[3]), DGPIMG_HEIGHT(im),
			     DGPIMG_GETROWWIDTH(dil), DGPIMG_GETROWWIDTH(im));
    getrusage(RUSAGE_SELF, &new);
    fprintf(stderr, "Dilation took %.3fs\n",
	    (new.ru_utime.tv_sec + new.ru_utime.tv_usec / 1e6) -
	    (old.ru_utime.tv_sec + old.ru_utime.tv_usec / 1e6));

    getrusage(RUSAGE_SELF, &old);
    imSave(dil, "/tmp/dil.pbm");
    getrusage(RUSAGE_SELF, &new);
    fprintf(stderr, "Saving took %.3fs\n",
	    (new.ru_utime.tv_sec + new.ru_utime.tv_usec / 1e6) -
	    (old.ru_utime.tv_sec + old.ru_utime.tv_usec / 1e6));

    getrusage(RUSAGE_SELF, &old);
    DgpImage_free(im);
    DgpImage_free(dil);
    getrusage(RUSAGE_SELF, &new);
    fprintf(stderr, "Freeing took %.3fs\n",
	    (new.ru_utime.tv_sec + new.ru_utime.tv_usec / 1e6) -
	    (old.ru_utime.tv_sec + old.ru_utime.tv_usec / 1e6));
    return(0);
    }
