/* $Header: /project/icons/cvsroot/digipaper/src/libzephyr/nop.c,v 1.1 2000/04/26 04:41:53 wbell Exp $ */

#include "nop.h"

DGP_RCSID("@(#)$Header: /project/icons/cvsroot/digipaper/src/libzephyr/nop.c,v 1.1 2000/04/26 04:41:53 wbell Exp $");


ErrCode
zephNopOpen( Dgp_State *dgp_state,
             uds *u, Dgp_UInt32 offset, 
             Dgp_UInt32 compSize,
             Dgp_Int32 srcW, Dgp_Int32 srcH,
             DgpCoord_Resolution *srcRes, 
             void **decodeState)
{
  u = u; 
  offset = offset;
  compSize = compSize;
  srcW = srcW; srcH = srcH;
  srcRes = srcRes;
  
  *decodeState = (void *)dgp_state;

  return cSuccessful;
}

Dgp_UInt32
zephNopUsage( void *decodeState)
{
  decodeState = decodeState;

  return 0;
}

ErrCode
zephNopAbilities( void *decodeState,
                  Dgp_Int32 dstMinX, Dgp_Int32 dstMinY,
                  zephReadType *type,
                  DgpCoord_Orientation *orient,
                  DgpCoord_Resolution *dstRes,
                  Dgp_Int32 *dstX, Dgp_Int32 *dstY,
                  Dgp_Int32 *dstW, Dgp_Int32 *dstH,
                  Dgp_UInt32 *maxMemRequired,
                  Dgp_Int32 srcOriginX, Dgp_Int32 srcOriginY,
                  Dgp_UInt8 *cantDo)
     
{
  decodeState = decodeState;
  dstMinX = dstMinX; dstMinY = dstMinY;
  type = type;
  orient = orient;
  dstRes = dstRes;
  dstX = dstX; dstY = dstY;
  dstW = dstW; dstH = dstH;
  maxMemRequired = maxMemRequired;
  srcOriginX = srcOriginX; 
  srcOriginY = srcOriginY;
  cantDo = cantDo;
 
  return cSuccessful;
}

ErrCode
zephNopRead( void *decodeState, 
             void *dst, Dgp_Int32 dstBpl,
             Dgp_Int32 dstMinX, Dgp_Int32 dstMinY,
             zephReadType type,
             DgpCoord_Orientation orient,
             DgpCoord_Resolution *dstRes,
             Dgp_Int32 dstX, Dgp_Int32 dstY,
             Dgp_Int32 dstW, Dgp_Int32 dstH,
             Dgp_UInt32 *maxMemRequired,
             Dgp_Int32 srcOriginX, Dgp_Int32 srcOriginY)
{
DGP_STATE_PROLOGUE( "zephNopRead()", (Dgp_State *)decodeState);

  dst = dst; dstBpl = dstBpl;
  dstMinX = dstMinX; dstMinY = dstMinY;
  type = type;
  orient = orient;
  dstRes = dstRes;
  dstX = dstX; dstY = dstY;
  dstW = dstW; dstH = dstH;
  maxMemRequired = maxMemRequired;
  srcOriginX = srcOriginX; 
  srcOriginY = srcOriginY;

  DGP_WARNF0( "Attempt to decode an unsupported image type.");
  DGP_WARNF0( "Recompile with different ZEPH_INCLUDE options for support.");

  NORMAL_RETURN;
}


ErrCode 
zephNopClose( void *decodeState)
{
  decodeState = (void *)NULL; 

  return cSuccessful;
}
