/* $Header: /project/icons/cvsroot/digipaper/src/libzephyr/zephdictionary.h,v 1.3 2000/11/08 00:07:43 mkrocken Exp $ */

#ifndef ZEPHDICTIONARY_H
#define ZEPHDICTIONARY_H

#include "zephdocument_t.h"
#include "zephdictionary_t.h"
#include "dgp_err_control.h"

#ifdef __cplusplus
extern "C"
{
#endif


extern ErrCode
zephOpenDictionary( zephDocumentInfo docInfo, Dgp_UInt32 libCount,
                     Dgp_UInt32 *libIds, zephDictionaryInfo *pDictInfo);

extern ErrCode
zephSplitDictionary( zephDictionaryInfo dictInfo, Dgp_UInt32 which,
                     zephDictionaryInfo *pDictInfo);

/* 
 * Returns the union of dictionaries.
 * 
 * Each zephDictionaryInfo in "dictInfos" is automatically closed and freed.
 *
 * If an error occurs then all "dictInfos" will be closed and freed and
 * any memory associated with the new dictionary will also be freed.
 */
extern ErrCode
zephMergeDictionaries( zephDocumentInfo docInfo,
                       Dgp_UInt32 dictInfoCount,
                       zephDictionaryInfo *dictInfos,
                       zephDictionaryInfo *pDictInfo);

extern ErrCode
zephCloseDictionary( zephDictionaryInfo *pDictInfo);

extern Dgp_UInt32
zephGetDictionaryMemoryUsage( zephDictionaryInfo dictInfo);


#ifdef __cplusplus
}
#endif


#endif /* ZEPHDICTIONARY_H */

