/* $Header: /project/icons/cvsroot/digipaper/src/libzephyr/zephimage_t.h,v 1.6 2001/03/24 01:44:54 mkrocken Exp $ */

#ifndef ZEPHIMAGE_T_H
#define ZEPHIMAGE_T_H

#include "resolution_t.h"
#include "dgp_state.h"
#include "iomrc.h"
#include "libxiff3_ext.h"

#ifdef __cplusplus
extern "C"
{
#endif

typedef struct _zephPrivateImageInfo * zephPrivateImageInfo;

typedef struct _zephImageInfo {
  Dgp_UInt32 layerNum, imageNum;
  Dgp_UInt32 width, height;
  DgpCoord_Resolution res;
  Dgp_UInt32 xPos, yPos;
  Dgp_UInt32 stripHeight;
  struct _zephImageInfo *maskInfo;
  
  IO_COMPRESSION compType;
  IO_COLORTYPE colorType;
  Dgp_UInt32 compSize;

  /* Dictionary info for tokenized images. */
  Dgp_UInt32 libCount;
  Dgp_UInt32 *libId;
  Dgp_UInt32 *libSize;

  ColorTokenizedImageAddition *colorTokImgExt;
  
  Dgp_UInt8  userFlags;
  zephPrivateImageInfo privateInfo;
} *zephImageInfo;


#ifdef __cplusplus
}
#endif


#endif /* ZEPHIMAGE_T_H */
