
#ifndef DGP_TYPE_H
#define DGP_TYPE_H

#ifdef __cplusplus
extern "C"
{
#endif

/* typedefs for all common built in data types. This is to make sure that
   we have the same number of bytes on any platform */

typedef unsigned char  Dgp_UInt8;
typedef unsigned short Dgp_UInt16;
typedef unsigned long  Dgp_UInt32;
#ifdef VXWORKS
  typedef signed char    Dgp_Int8;          /* VxWorks cross-compilers treat a straight char as unsigned... 23.5.2000 / dhtesq. */
#else
  typedef char           Dgp_Int8;
#endif /* VXWORKS */
typedef short          Dgp_Int16;
typedef long           Dgp_Int32;
typedef float          Dgp_Float32;
typedef double         Dgp_Float64;

/* C does not have a boolean data type. Digipaper needs one ... */

typedef Dgp_UInt8 Dgp_Bool;
#define DGP_TRUE	((Dgp_Bool)1)
#define DGP_FALSE	((Dgp_Bool)0)

/* This seems obvious ... 
   It is there because we did not want to edit a lot of code */

#define DGP_BITS_UINT8   8
#define DGP_BITS_UINT32 32

#ifdef __cplusplus
}
#endif

#endif
