/*
 *
 * $Header: /project/icons/cvsroot/digipaper/src/shared/endianness.h,v 1.6 2003/02/10 22:53:47 mkrocken Exp $
 *
 */

#ifndef	ENDIAN_H
#define	ENDIAN_H

/* This file defines _BIG_ENDIAN or _LITTLE_ENDIAN */

#if	defined(_WIN32) || defined(i386) || defined(EQUATOR_CA_ENV)
/* NT is little-endian by definition; so's any Intel x86 */
#define	_LITTLE_ENDIAN

/* We need to rummage through a few places to find the right definitions. */
#elif defined(__SVR4) && !defined(VXWORKS)
#include <sys/byteorder.h>

#elif defined(VXWORKS)
/* Endianness for sparc_vxworks will of course be the same as sparc_solaris, but we get it from */
/* a different place.  / dhtesq. */
#include <vxWorks.h>
/* We now have _BIG_ENDIAN and _LITTLE_ENDIAN both defined, and _BYTE_ORDER defined as one of them. */
#if (_BYTE_ORDER == _LITTLE_ENDIAN)
#undef _BIG_ENDIAN
#else
#undef _LITTLE_ENDIAN
#endif
/*#define __BYTE_ORDER__ _BYTE_ORDER ? */
/*#define BYTE_ORDER _BYTE_ORDER ? */

#else
#include <sys/types.h>
#include <arpa/nameser.h>
#define	__BYTE_ORDER__	BYTE_ORDER
#define	__LITTLE_ENDIAN__	LITTLE_ENDIAN
#define	__BIG_ENDIAN__	BIG_ENDIAN
#endif

#if (defined(__GNUC__) || defined(__GNUG__) || defined(_SGI_SOURCE)) && !defined(VXWORKS)

/* The GCC version of byteorder.h defines __BYTE_ORDER__ */
#if	(__BYTE_ORDER__ == __LITTLE_ENDIAN__)
#define	_LITTLE_ENDIAN
#undef	_BIG_ENDIAN
#else
#define	_BIG_ENDIAN
#undef _LITTLE_ENDIAN
/* ignore PDP-endianness possibility */
#endif  /* (__BYTE_ORDER__ == ...) */

#else
/* The Solaris version of byteorder.h does the right thing */
#endif  /* (defined(__GUNC__) || ...) */

#if defined(_LITTLE_ENDIAN) && defined(_BIG_ENDIAN)
#error "Big & little endian *both* defined..."
#endif
#if !defined(_LITTLE_ENDIAN) && !defined(_BIG_ENDIAN)
#error "*Neither* big nor little endian defined..."
#endif

#endif  /* (ENDIAN_H) */
