#ifndef IOSTRUCTURES_H
#define IOSTRUCTURES_H

#include <stdio.h>
#include "mmcompress.h"
#include "uds.h"
#include "libipw.pub"
#include "dgp_allocators.h"
#include "color-extension.h"
#include "colorpos.h"
#include "annotation.h" 

#ifdef __cplusplus
extern "C"
{
#endif

#define FOREGROUND_PLANE 3
#define SELECTOR_PLANE 2
#define BACKGROUND_PLANE 1

typedef ErrCode (*DictExtBuilder)(token **sorted_tokens,
                                  Dgp_Int32 ntok,
                                  void *extcookie,
                                  void **extension,
                                  size_t *extlen,
                                  Dgp_State *dgp_state);

typedef ErrCode (*PosExtBuilder)(tokpos **sorted_tokpos,
                                 Dgp_Int32 ntok,
                                 void *extcookie,
                                 void **extension,
                                 size_t *extlen,
                                 Dgp_State *dgp_state);
 
typedef struct {
  DictExtBuilder builder;
  void **extdata;
  size_t extlen;
  void *cookie;
  Dgp_UInt32 tag;
} DictExtension;
 
typedef struct {
  PosExtBuilder builder;
  void **extdata;
  size_t extlen;
  void *cookie;
  Dgp_UInt32 tag;
} PosExtension;


#ifdef __cplusplus
}
#endif

#endif
