/*
 *
 * $Header: /project/icons/cvsroot/digipaper/src/shared/util.h,v 1.4 2002/07/23 23:29:56 mkrocken Exp $
 *
 *
 * A bunch of very useful declarations that just about everything uses.
 *
 */

#ifndef	WJR_UTIL_H

#define	WJR_UTIL_H

/* We don't need those anymore, because we are now using 
   DGP_UInt32 etc. 

#define	DGP_BITS_UCHAR	8
#define	DGP_BITS_ULONG	((int)(DGP_BITS_UCHAR * sizeof(unsigned long))) */

/* define a macro to round a float/double to the nearest int */
#define	DGP_NINT(x)		((int)(((x) < 0) ? ((x) - 0.5) : ((x) + 0.5)))


#ifndef __GNUC__

#ifndef MAX
#define MAX(x, y) (((x) > (y)) ? (x) : (y))
#endif

#ifndef MIN
#define MIN(x, y) (((x) < (y)) ? (x) : (y))
#endif

#ifndef ABS
#define ABS(x) (((x) < 0) ? -(x) : (x))
#endif

#define	DGP_NBMIN(x,y)	MIN((x),(y))
#define	DGP_NBMAX(x,y)	MAX((x),(y))

#else

/* GCC allows new scopes inside expressions; use to get better MAX and MIN */

#ifndef MAX
#define MAX(a,b) \
    ({typedef _tamax = (a), _tbmax = (b);  \
	  _tamax _a = (a); _tbmax _b = (b);     \
	      _a > _b ? _a : _b; })
#endif

#ifndef MIN
#define MIN(a,b) \
    ({typedef _tamin = (a), _tbmin = (b);  \
	  _tamin _a = (a); _tbmin _b = (b);     \
	      _a < _b ? _a : _b; })
#endif

#ifndef ABS
#define ABS(a) \
    ({typedef _taabs = (a); \
	  _taabs _a = (a); \
	      _a < 0 ? -_a : _a; })
#endif

/*
 * Here's a nice hack-macro: give the max of a and b, but do it in a
 * branchless manner. How it works:
 * _d is >=0 iff a >= b.
 * _d >> 31 is 0 if a >= b, ~0 if a < b.
 * _d & ~(_d >> 31) is therefore a-b if a >= b, 0 if a < b.
 * _d & ~(_d >> 31) + b is a if a >= b, b if a < b.
 *
 * This relies pretty heavily on the properties of two's complement arithmetic.
 * It's also word-size dependent, and works only on integer quantities.
 * It also will break if a or b are too close to the limits of the range of
 * integers.
 */
#define	DGP_NBMAX(a, b)	({int _a = (a), _b = (b), _d = _a - _b; _d &= ~(_d >> 31); _d + _b;})

/*
 * Similarly for min.
 * _d is >=0 iff a >= b.
 * _d >> 31 is 0 if a >= b, ~0 if a < b.
 * _d & (_d >> 31) is therefore 0 if a >= b, a-b if a < b.
 * _d & (_d >> 31) + b is b if a >= b, a if a < b.
 */
#define	DGP_NBMIN(a, b)	({int _a = (a), _b = (b), _d = _a - _b; _d &= (_d >> 31); _d + _b;})

#endif

/* The following definition will make porting to NT under MSDEV much easier */
#ifdef _WIN32
#define DGP_LIBEXPORT extern __declspec(dllexport)
#else
#define DGP_LIBEXPORT extern
#endif

/* It's useful to have a definition for inlining that works on lots of compilers */
#ifndef INLINE
#ifdef _MSC_VER
#define INLINE __inline
#endif
#ifdef __SUNPRO_C
#define INLINE __inline__
#endif
#ifdef __GNUC__
#define INLINE __inline__
#endif
#endif

/* Tornado's ppc cross-compiler biffs inlines... / dhtesq. */
#ifdef CPU
#if CPU == PPC603
#undef INLINE
#define INLINE
#endif
#endif

/* Equator needs some inline fix ... */
#ifdef EQUATOR_CA_ENV
#undef INLINE
#define INLINE
#endif

/* This is what malloc returns on error, and is also a null pointer */
#ifndef NULL
#define NULL    0
#endif

#endif
