#include "StdAfx.h"

#ifdef _WIN32
// Warning 4786 appears to be benign, and we get tons of them,
// so we disabled it.
#pragma warning(disable:4786)
#endif

#include "Jbig2Dict.h"
#include "AsdSilx.h"

namespace AsdSilx{
#include "../libjbig2/uncomp-jbig.h"
#include "dgp_err_printers.h"
};

using namespace AsdSilx;

void DictInfo::setInfo(Asd::Int32 libCount, Asd::UInt32* libSizes, Asd::UInt32* libIds){
		m_libCount = libCount;
		if(m_libSizes) delete m_libSizes;
		if(m_libIds) delete m_libIds;
		if(libCount > 0){
			m_libIds =   new Asd::UInt32 [libCount];
			m_libSizes = new Asd::UInt32 [libCount];       
			for(int i = 0; i < libCount; i++) {
				m_libIds[i] = libIds[i]; 
				m_libSizes[i] = libSizes[i];
			}
		}
	}

Jbig2Dict::	~Jbig2Dict(){
	if (! m_dictBufList.empty()){
		DictBufList::const_iterator iter;
		for ( iter = m_dictBufList.begin(); iter != m_dictBufList.end(); ++iter ) {
			delete(iter->second);
		} // for
	} // if
	if(m_jb2Info) 	cleanupJb2Info((jb2info **)(&m_jb2Info));
	if(m_state)	Dgp_cleanupDgpState((Dgp_State **)(&m_state));
}


Jbig2Dict::Jbig2Dict(Asd::Int32 numPages) : m_jb2Info(NULL),m_state(NULL){

	Dgp_Int32 ret = cSuccessful;
	ret = Dgp_initDgpState((Dgp_State **)(&m_state), 
                            NULL, NULL, 
                            stderr, Dgp_fileErrPrinter, 
                            DGP_TRUE, DGP_TRUE);
    if(ret != cSuccessful) {
		if(m_state)		Dgp_cleanupDgpState((Dgp_State **)(&m_state));
	}
	ret = initJb2Info(  (jb2info **)(&m_jb2Info),
                        DGP_FALSE, NULL, NULL, DGP_TRUE, 
                        numPages, DGP_TRUE, DGP_FALSE,
                        NULL, NULL,//use default alloc function
                        (Dgp_State*)m_state);
    if(ret != cSuccessful) {
		if(m_state)	Dgp_cleanupDgpState((Dgp_State **)(&m_state));
		if(m_jb2Info) 	cleanupJb2Info((jb2info **)(&m_jb2Info));
	}
}

