#ifndef Jbig2Dict_h_Included
#define Jbig2Dict_h_Included

#ifdef _WIN32
/* Warning 4786 appears to be benign, and we get tons of them, */
/* so we disabled it. */
#pragma warning(disable:4786)
#endif

#include <map>

typedef std::map<Asd::Int32, Asd::UInt8*> DictBufList;

class DictInfo{
public:
	DictInfo(Asd::Int32 libCount, Asd::UInt32* libSizes, Asd::UInt32* libIds):
	  m_libCount(0), m_libSizes(NULL), m_libIds(NULL){
		setInfo( libCount, libSizes, libIds);
	}
      DictInfo(DictInfo& dictInfo):m_libCount(0), m_libSizes(NULL), m_libIds(NULL){
		setInfo(dictInfo.getLibCount(), dictInfo.getLibSizes(), dictInfo.getLibIds());
	}
	DictInfo() : m_libCount(0), m_libSizes(NULL), m_libIds(NULL){}
	~DictInfo(){
		if(m_libSizes) delete m_libSizes;
		if(m_libIds) delete m_libIds;
	}
	void setInfo(Asd::Int32 libCount, Asd::UInt32* libSizes, Asd::UInt32* libIds);
	Asd::Int32  getLibCount(){ return m_libCount;}
	Asd::UInt32* getLibSizes(){ return m_libSizes;}
	Asd::UInt32* getLibIds(){ return m_libIds;}
protected:
    Asd::Int32  m_libCount;
    Asd::UInt32* m_libSizes;
    Asd::UInt32* m_libIds;
};

class Jbig2Dict{
public:
	Jbig2Dict(Asd::Int32 numPages);
	~Jbig2Dict();
	void* getJb2Info(){ return m_jb2Info;}
	DictBufList& getDictBufList(){ return m_dictBufList;}
protected:
	DictBufList m_dictBufList;
	void *m_jb2Info;
	void *m_state;

};


#endif
/*#ifndef Jbig2Dict_h_Included */
