#ifndef TifFile_h_Included
#define TifFile_h_Included


#include <vector>

#include "TfxFile.h"
#include "TifPage.h"

namespace ipcore
{
#include "dgp_state.h"
#include "tiffio.h"
typedef struct tiff TIFF;
};


/*************************************************************************
 

*************************************************************************/

class TifFile : public TfxFile
{
    friend class TifPage;

public:

    TifFile( const char* file );

    virtual ~TifFile( void );

    virtual Asd::UInt32 numPages( void )
	{
		return m_pages.size();
	}

    virtual TfxPage * getPage( Asd::UInt32 page )
	{
		return getTifPage(page);
	}

    TifPage * getTifPage( Asd::UInt32 page )
    {
        return m_pages[page];
    }

    virtual void loadPage( Asd::UInt32 page ) { assert( page == 0 ); }

    /* If the current page is loaded, free up the resources associated */
    /* with it. */
    void purgePage( Asd::UInt32 page ) { delete m_pages[page]; m_pages[page] = NULL; }

    virtual void purgeAllPages( void );

    virtual Asd::Point32 getPageSize( Asd::UInt32 page );

    ColorDepth getPageColorDepth( Asd::UInt32 page );

protected:
private:
	
	std::vector<TifPage *> m_pages;
	std::string m_fileName;

	/* Note this variable has to be called dgp_state so that various macros will */
	/* work. */
	ipcore::Dgp_State * m_dgpState;

	ipcore::TIFF * m_tiff;
};


#endif
/*#ifndef TifFile_h_Included */
