#ifndef TifPage_h_Included
#define TifPage_h_Included

#include "TfxPage.h"
#include "ImageBuf.h"
#include "SimpImgBuf.h"


namespace ipcore
{
#include "dgp_state.h"
};


/*************************************************************************

  Since a Tiff file is a valid tiff-fx file, we need a way of dealing
  with Tiff Images.  I am not going to flush this out here, but it
  should be implimented using libtiff or something.

*************************************************************************/

class TifPage : public TfxPage
{
    friend class TifFile;

public:

    TifPage( TifFile * file, Asd::UInt32 page );

    virtual ~TifPage( void );

    virtual ColorDepth getColorDepth( void );

    virtual bool render  ( ImageBuf * buf, const Asd::Rect & region, Asd::Float64 zoom, Asd::Int32 layer = 0);
    virtual bool renderBW( ImageBuf * buf, const Asd::Rect & region, Asd::Float64 zoom, Asd::Int32 layer = 0);
    
    virtual Asd::UInt32 getNumLayers( void ) const { return 1; }

    virtual Asd::Point32 getSize( void ) const;

protected:
private:

    TifPage( const TifPage & ); /* disabled. */
    TifPage & operator=( const TifPage & ); /* disabled. */
    
    /* The TifFile that owns us.  (We do not own it!) */
    TifFile * m_tifFile;

    Asd::UInt32 m_pageNum;

    SimpImgBuf m_img;
};

#endif
/*#ifndef TifPage_h_Included */
