/*
 *
 * $Header: /project/icons/cvsroot/digipaper/tools/libjbig2.help/compile-stdhuff.c,v 1.5 2002/10/17 22:43:32 jlin Exp $
 *
 */

#include "stdhuff.h"
#include "hufftable.h"
#include <stdio.h>
#include <stdlib.h>

DGP_RCSID("@(#)$Header: /project/icons/cvsroot/digipaper/tools/libjbig2.help/compile-stdhuff.c,v 1.5 2002/10/17 22:43:32 jlin Exp $");


hufftable_spec *tables[] = {
    &stdhuffA, &stdhuffDW1, &stdhuffDW2, &stdhuffDH1, &stdhuffDH2,
    &stdhuffFS1, &stdhuffFS2, &stdhuffDS1, &stdhuffDS2, &stdhuffDS3,
    &stdhuffDT1, &stdhuffDT2, &stdhuffDT3, &stdhuffDT3_neg,
    &stdhuffRD1 ,&stdhuffRD2
    };
char *table_names[] = {
    "stdhuffA", "stdhuffDW1", "stdhuffDW2", "stdhuffDH1", "stdhuffDH2", 
    "stdhuffFS1", "stdhuffFS2", "stdhuffDS1", "stdhuffDS2", "stdhuffDS3", 
    "stdhuffDT1", "stdhuffDT2", "stdhuffDT3", "stdhuffDT3_neg",
    "stdhuffRD1", "stdhuffRD2"
    };

#define	NTABLES	((int)(sizeof(tables) / sizeof(tables[0])))



int
main(int argc, char **argv)
{
    int i, j;
    void **lineptrs;
    Dgp_State *dgp_state = NULL;


    /* whine, whine */
    (void)argc;
    (void)argv;

    (void)Dgp_initDgpState(&dgp_state, NULL, NULL, NULL, NULL, DGP_FALSE, DGP_FALSE);

    /* Header info */
    printf("/*\n * JBIG2 standard Huffman tables built by $Header: /project/icons/cvsroot/digipaper/tools/libjbig2.help/compile-stdhuff.c,v 1.5 2002/10/17 22:43:32 jlin Exp $\n */\n");
    printf("#include \"util.h\"\n");
    printf("#include \"hufftable.h\"\n");
    printf("DGP_RCSID(\"@(#)JBIG2 standard Huffman tables built by $Header: /project/icons/cvsroot/digipaper/tools/libjbig2.help/compile-stdhuff.c,v 1.5 2002/10/17 22:43:32 jlin Exp $\");\n");

    /* Compile and write out each table */
    for (i = 0; i < NTABLES; i++) {
	lineptrs = (void **)(DGP_MALLOC)(tables[i]->nlines * sizeof(*lineptrs));

	for (j = 0; j < tables[i]->nlines; j++) {
	    lineptrs[j] = &tables[i]->lines[j];
	    }

	(void)jhtSetCodes(tables[i], dgp_state);
	(void)jhtCompile(tables[i], lineptrs, dgp_state);

	/* The table lines */
	printf("static table_line %s_lines[%ld] = {\n",
	       table_names[i], tables[i]->nlines);
	for (j = 0; j < tables[i]->nlines; j++) {
	    printf("    { %#05lx, %5ld, %2d, %2d }%c\n",
		   tables[i]->lines[j].prefix, tables[i]->lines[j].base,
		   tables[i]->lines[j].preflen, tables[i]->lines[j].rangelen,
		   (j == tables[i]->nlines - 1) ? ' ' : ',');
	    /*
	     * Add a sanity check.  If this is a normal line, then check that
	     * its base matches the previous line's base+range.
	     */
	    if ((j > 0) && (tables[i]->lines[j].rangelen != 32) &&
		(!((j == tables[i]->nlines - 1) && (tables[i]->oob_valid)))) {
		if (tables[i]->lines[j].base !=
		    tables[i]->lines[j-1].base + (1 << tables[i]->lines[j-1].rangelen)) {
		    fprintf(stderr, "problem in line %d of table %s\n", j,
			    table_names[i]);
		    }
		}
		
	    }
	printf("    };\n");

	/* The pointers to the table lines */
	printf("static void * %s_lineptrs[%ld] = {\n    ",
	       table_names[i], tables[i]->nlines);
	for (j = 0; j < tables[i]->nlines; j++) {
	    printf("(void *)&%s_lines[%d]%s", table_names[i],
		   ((table_line *)tables[i]->decoded[0][j]) - tables[i]->lines,
		   (j == tables[i]->nlines - 1) ? "\n" :
		   ((j % 2 == 1) ? ",\n    " : ", "));
	    }
	printf("    };\n");

	/* The table itself */
	printf("hufftable_spec %s = {\n", table_names[i]);
	printf("    %s, %s, %s,\n",
	       tables[i]->lower_valid ? "DGP_TRUE" : "DGP_FALSE",
	       tables[i]->upper_valid ? "DGP_TRUE" : "DGP_FALSE",
	       tables[i]->oob_valid ? "DGP_TRUE" : "DGP_FALSE");
	printf("    %ld, %s_lines, %ld, DGP_TRUE,\n", tables[i]->nlines,
	       table_names[i], tables[i]->minlen);
	printf("    {\n\t");
	for (j = 0; j < JHT_MAXCODELEN; j++) {
	    printf("%#10lx%s", tables[i]->firstcode[j],
		   (j == JHT_MAXCODELEN - 1) ? "\n" :
		   ((j % 4 == 3) ? ",\n\t" : ", "));
	    }
	printf("\t},\n");
	printf("    {\n\t");
	for (j = 0; j < JHT_MAXCODELEN; j++) {
	    printf("%#10lx%s", tables[i]->lastcode[j],
		   (j == JHT_MAXCODELEN - 1) ? "\n" :
		   ((j % 4 == 3) ? ",\n\t" : ", "));
	    }
	printf("\t},\n");
	printf("    {\n\t");
	for (j = 0; j < JHT_MAXCODELEN; j++) {
	    printf("&%s_lineptrs[%d]%s", table_names[i],
		   tables[i]->decoded[j] - tables[i]->decoded[0],
		   (j == JHT_MAXCODELEN - 1) ? "\n" :
		   ((j % 2 == 1) ? ",\n\t" : ", "));
	    }
	printf("\t}\n");
	printf("    };\n\n");

	(DGP_FREE)((void *)lineptrs);
	}

    Dgp_cleanupDgpState(&dgp_state);
    dgp_state = NULL;
    
    return(0);
    }
