@echo off

setlocal

REM This suite runs a test suite on jpeg6bcreate
REM It is invoked as : comprun <buffername>
REM ------------------------------------------------


set BaseDir=%JPEG_REGRESSION_DIR%\
set OutputDir=%BaseDir%
set JpegCompressor=
set DiffProg=
set CompTestDir=%BaseDir%\compressiontest
set BaseJpegs=%CompTestDir%\basejpgs
set BufDir=%CompTestDir%\rawbuffers
set DiffLog=%BaseDir%\compdiff.nt.out

set DataFileName=0
set BufferName=0

if NOT "%1"=="" set BufferName=%1& shift
set DataFileName=%BufferName%.data

REM echo *** Datafilename is %DataFileName%***********
REM echo *** BufferName is %BufferName% *******

echo "==========Running test for datafile %DataFileName%

pushd %CompTestDir%

REM Now actually run jpegcreate
REM --------------------------------------------------------------
REM -- first delete the old .jpg files created in a previous run
REM --------------------------------------------------------------

if EXIST %BufferName%.nt.jpg erase /F /Q %BufferName%.nt.jpg
REM echo ** going to run %JpegCompressor% -defaults %DataFileName% -inbuf %BufDir%\%BufferName%
%JpegCompressor% -defaults %DataFileName% -inbuf %BufDir%\%BufferName% -outfile %BufferName%.nt.jpg

echo ******* %DataFileName% *********** >> %DiffLog%

if NOT EXIST %BufferName%.nt.jpg echo **%BufferName%.nt.jpg does not exist >> %DiffLog%
if NOT EXIST %BaseJpegs%\%BufferName%.jpg echo **%BaseJpegs%\%BufferName%.jpg does not exist >> %DiffLog%
 
%DiffProg% %BaseJpegs%\%BufferName%.jpg %BufferName%.nt.jpg >> %DiffLog%

popd

:quit
endlocal




