@echo off

setlocal

REM This script runs a test suite on Jpeg6btester
REM Invoked as: driverrun suite_name testfilename 
REM ----------------------------------------------------------------------


set SuiteDir=%JPEG_REGRESSION_DIR%\
set OutputDir=%SuiteDir%
set JpegTester=
set DiffProg=
set BaseImageDir=%SuiteDir%images\base
set SuiteName=0
set TestName=0
if NOT "%1"=="" set SuiteName=%1& shift
if NOT "%1"=="" set TestName=%1& shift

if %SuiteName%==0 echo Invoked as: driverrun test_name & goto quit
if %TestName%==0 echo Invoked as: driverrun test_name & goto quit

REM echo "========Running test %TestName%======"
REM echo "========Suitedir\Suitename is %SuiteDir%\%SuiteName%=============="

pushd %SuiteDir%\%SuiteName%

REM Now actually run jpegtester.
REM ----------------------------------------------------------------------
REM -- first delete the output files from previous runs
REM ----------------------------------------------------------------------

if EXIST %TestName%.cmyk.nt.out.bmp erase /F /Q %TestName%.cmyk.nt.out.bmp
if EXIST %TestName%.rgb.nt.out.bmp erase /F /Q %TestName%.rgb.nt.out.bmp

%JpegTester% -bmp -defaults %TestName%.rgb.data -outfile %TestName%.rgb.nt.out.bmp %BaseImageDir%\%TestName%.jpg
%JpegTester% -bmp -defaults %TestName%.cmyk.data -outfile %TestName%.cmyk.nt.out.bmp %BaseImageDir%\%TestName%.jpg

echo **** %SuiteName%:%TestName%:rgb***************************** >> %DIFFLOG%

if NOT EXIST %TestName%.rgb.bmp echo ***%TestName%.rgb.bmp does not exist >> %DIFFLOG%
if NOT EXIST %TestName%.rgb.nt.out.bmp echo ***%TestName%.rgb.nt.out.bmp does not exist >> %DIFFLOG%

%DiffProg% %TestName%.rgb.bmp %TestName%.rgb.nt.out.bmp >> %DIFFLOG%

echo **** %SuiteName%:%TestName%:cmyk***************************** >> %DIFFLOG%

if NOT EXIST %TestName%.cmyk.bmp echo ***%TestName%.cmyk.bmp does not exist >> %DIFFLOG%
if NOT EXIST %TestName%.cmyk.nt.out.bmp echo ***%TestName%.cmyk.nt.out.bmp does not exist >> %DIFFLOG%

%DiffProg% %TestName%.cmyk.bmp %TestName%.cmyk.nt.out.bmp >> %DIFFLOG%

popd

:quit
endlocal
