#include <stdlib.h>
#include <stdio.h>

static char rcsid[] = "@(#)$Header: /project/icons/cvsroot/digipaper/tools/libsanta.help/generate_tables.c,v 1.1 2000/02/24 19:49:13 jahlborn Exp $";

static unsigned short swap(unsigned short in){
  unsigned short out=0;
  unsigned short x,y,i;
  for(i=0; i<=8; i++)
    {
      x=in & (1<<i);
      y=in & (1<<(15-i));
      
      out|=((x >> i) << (15-i));
      out|=((y >> (15-i)) << i);
      
    }
  return out;
}

static unsigned int gen1s(unsigned long num1s){
  unsigned int out=0;
  unsigned int i=0;
  
  for(i=0; i<num1s; i++)
    out|=(1<<i);
  
  return out;
}

void main(void)
{
  unsigned int i;
  
  // generate the table of 1's, where oneMask[i] is a dword that the lower 
  // i digits are all 1, the rest 0.
  printf("unsigned long onesMask[]=\n{\n");
  for(i=0; i<=32; i++)
    printf("\t0x%.08X, /* onesMask[%d] */\n",gen1s(i),i);
  printf("};\n\n");
  
  // generate a table of horizontally flipped words, that is where 
  // flippedWord[i] is the horizontal reflection of the word (note 16-bit) 
  printf("unsigned short flippedWord[]=\n{\n");
  for(i=0; i<=65535; i++){
    printf("0x%.04hX, /* flippedWord[%d] */\n",
	   swap((unsigned short)i),i);
  }
  printf("};\n\n");
  
  exit(0);
}

