/*
 *
 * $Header: /project/icons/cvsroot/digipaper/tools/libtok-lossy.util/testdil.c,v 1.1 2000/02/24 21:37:20 jahlborn Exp $
 *
 */

#include "util.h"
#include "image.h"
#include "packedim.h"
#include <stdio.h>
#include <stdlib.h>
#ifndef _WIN32
#include <sys/time.h>
#include <sys/resource.h>
#endif
#include "dgp_rcs.h"
#include "shrpatt.pub"

DGP_RCSID("@(#)$Header: /project/icons/cvsroot/digipaper/tools/libtok-lossy.util/testdil.c,v 1.1 2000/02/24 21:37:20 jahlborn Exp $");

int
main(int argc, char **argv)
{
    PackedImage im;
    PackedImage dil;
#ifndef _WIN32
    struct rusage old, new;
#endif
    IPState *ipstate = NULL;

#ifndef _WIN32
    getrusage(RUSAGE_SELF, &old);
#endif
    im = imLoad(IMAGE_PACKED, argv[1]);

#ifndef _WIN32
    getrusage(RUSAGE_SELF, &new);
    fprintf(stderr, "Loading took %.3fs\n",
	    (new.ru_utime.tv_sec + new.ru_utime.tv_usec / 1e6) -
	    (old.ru_utime.tv_sec + old.ru_utime.tv_usec / 1e6));

    getrusage(RUSAGE_SELF, &old);
#endif
    dil = imNew(IMAGE_PACKED | IMAGE_DONTCLEAR, imGetWidth(im) + atoi(argv[2]), imGetHeight(im));
#ifndef _WIN32
    getrusage(RUSAGE_SELF, &new);
    fprintf(stderr, "Allocation took %.3fs\n",
	    (new.ru_utime.tv_sec + new.ru_utime.tv_usec / 1e6) -
	    (old.ru_utime.tv_sec + old.ru_utime.tv_usec / 1e6));

    getrusage(RUSAGE_SELF, &old);
#endif
    /* Compensate for the frame offset their routine tacks on */
    i_topologyPreserveDilate(ipstate,
			     pimGetRow(dil, 0) - 32 * pimGetRowWidth(dil) - 4,
			     pimGetRow(im, 0) - 32 * pimGetRowWidth(im) - 4,
			     imGetWidth(im) - atoi(argv[3]), imGetHeight(im),
			     pimGetRowWidth(dil), pimGetRowWidth(im));

#ifndef _WIN32
    getrusage(RUSAGE_SELF, &new);
    fprintf(stderr, "Dilation took %.3fs\n",
	    (new.ru_utime.tv_sec + new.ru_utime.tv_usec / 1e6) -
	    (old.ru_utime.tv_sec + old.ru_utime.tv_usec / 1e6));

    getrusage(RUSAGE_SELF, &old);
#endif
    imSave(dil, "/tmp/dil.pbm");

#ifndef _WIN32
    getrusage(RUSAGE_SELF, &new);
    fprintf(stderr, "Saving took %.3fs\n",
	    (new.ru_utime.tv_sec + new.ru_utime.tv_usec / 1e6) -
	    (old.ru_utime.tv_sec + old.ru_utime.tv_usec / 1e6));

    getrusage(RUSAGE_SELF, &old);
#endif

    imFree(im);
    imFree(dil);

#ifndef _WIN32
    getrusage(RUSAGE_SELF, &new);
    fprintf(stderr, "Freeing took %.3fs\n",
	    (new.ru_utime.tv_sec + new.ru_utime.tv_usec / 1e6) -
	    (old.ru_utime.tv_sec + old.ru_utime.tv_usec / 1e6));
#endif
    return(0);
    }

